this["cv-1_2_init"] = function(pPackMgr){
	var vPack = new PackBase("cv-1_2");
	var vModel;

	
	vModel = new ModelRes(
		"sfile_zip",
		"chrome://cv-1_2/content/sfile_zip", 
		"Archive ZIP", 
		"chrome://cv-1_2/content/sfile_zip/mainView.xul",
		"",
		null,
		["application/zip"]
		);
	vPack.registerModel(vModel);

	vModel = new ModelRes(
		"sfile_pdf",
		"chrome://cv-1_2/content/sfile_pdf", 
		"Document PDF", 
		"chrome://cv-1_2/content/sfile_pdf/mainView.xul",
		"",
		null,
		["application/pdf"]
		);
	vPack.registerModel(vModel);

	vModel = new ModelRes(
		"sfile_odt",
		"chrome://cv-1_2/content/sfile_odt", 
		"Texte OpenDocument", 
		"chrome://cv-1_2/content/sfile_odt/mainView.xul",
		"",
		null,
		["application/vnd.oasis.opendocument.text"]
		);
	vPack.registerModel(vModel);

	vModel = new ModelRes(
		"sfile_odp",
		"chrome://cv-1_2/content/sfile_odp", 
		"Présentation OpenDocument", 
		"chrome://cv-1_2/content/sfile_odp/mainView.xul",
		"",
		null,
		["application/vnd.oasis.opendocument.presentation"]
		);
	vPack.registerModel(vModel);

	vModel = new ModelRes(
		"sfile_ppt_pps_pptx_ppsx",
		"chrome://cv-1_2/content/sfile_ppt_pps_pptx_ppsx", 
		"Présentation Microsoft Powerpoint", 
		"chrome://cv-1_2/content/sfile_ppt_pps_pptx_ppsx/mainView.xul",
		"",
		null,
		null, [{regExpExt:/.*\.ppt|.*.pps/i, ext:["application/vnd.ms-powerpoint"]}, {regExpExt:/.*\.pptx/i, ext:["application/vnd.openxmlformats-officedocument.presentationml.presentation"]}, {regExpExt:/.*\.ppsx/i, ext:["application/vnd.openxmlformats-officedocument.presentationml.slideshow"]}]
		);
	vPack.registerModel(vModel);

	vModel = new ModelRes(
		"sfile_xls_xlsx",
		"chrome://cv-1_2/content/sfile_xls_xlsx", 
		"Classeur Microsoft Excel", 
		"chrome://cv-1_2/content/sfile_xls_xlsx/mainView.xul",
		"",
		null,
		null, [{regExpExt:/.*\.xls/i, ext:["application/vnd.ms-excel"]}, {regExpExt:/.*\.xlsx/i, ext:["application/vnd.openxmlformats-officedocument.spreadsheetml.sheet"]}]
		);
	vPack.registerModel(vModel);

	vModel = new ModelRes(
		"sfile_rtf",
		"chrome://cv-1_2/content/sfile_rtf", 
		"Document RTF", 
		"chrome://cv-1_2/content/sfile_rtf/mainView.xul",
		"",
		null,
		["application/rtf"]
		);
	vPack.registerModel(vModel);

	vModel = new ModelRes(
		"sfile_doc_docx",
		"chrome://cv-1_2/content/sfile_doc_docx", 
		"Document Microsoft Word", 
		"chrome://cv-1_2/content/sfile_doc_docx/mainView.xul",
		"",
		null,
		null, [{regExpExt:/.*\.doc/i, ext:["application/msword"]}, {regExpExt:/.*\.docx/i, ext:["application/vnd.openxmlformats-officedocument.wordprocessingml.document"]}]
		);
	vPack.registerModel(vModel);

	vModel = new ModelBase(
		"of_mediaWeb",
		"chrome://cv-1_2/content/of_mediaWeb", 
		"Module web distant", 
		"chrome://cv-1_2/content/of_mediaWeb/mainView.xul",
		"",
		null,
		false
		);
	vPack.registerModel(vModel);

	vModel = new ModelRes(
		"sfile_odf",
		"chrome://cv-1_2/content/sfile_odf", 
		"Equation mathématique OpenDocument", 
		"chrome://cv-1_2/content/sfile_odf/mainView.xul",
		"chrome://cv-1_2/content/sfile_odf/preview.xul",
		"transform=od2img&amp;outType=PNG&sizeRules=Px(ScSCS(fontPt\'10\')Bounds(maxW\'360\'maxH\'160\'))",
		["application/vnd.oasis.opendocument.formula"]
		);
	vPack.registerModel(vModel);

	vModel = new ModelRes(
		"sfile_png",
		"chrome://cv-1_2/content/sfile_png", 
		"Image PNG", 
		"chrome://cv-1_2/content/sfile_png/mainView.xul",
		"chrome://cv-1_2/content/sfile_png/preview.xul",
		"transform=img2img&outType=PNG&sizeRules=Px(ScSCS(fontPt'10')Bounds(maxW'360'maxH'160'))",
		["image/png"]
		);
	vPack.registerModel(vModel);

	vModel = new ModelRes(
		"sfile_jpg_jpeg",
		"chrome://cv-1_2/content/sfile_jpg_jpeg", 
		"Image JPEG", 
		"chrome://cv-1_2/content/sfile_jpg_jpeg/mainView.xul",
		"chrome://cv-1_2/content/sfile_jpg_jpeg/preview.xul",
		"transform=img2img&outType=JPEG&sizeRules=Px(ScSCS(fontPt'10')Bounds(maxW'360'maxH'160'))",
		["image/jpeg"]
		);
	vPack.registerModel(vModel);

	vModel = new ModelRes(
		"sfile_gif",
		"chrome://cv-1_2/content/sfile_gif", 
		"Image GIF", 
		"chrome://cv-1_2/content/sfile_gif/mainView.xul",
		"chrome://cv-1_2/content/sfile_gif/preview.xul",
		"transform=img2img&outType=GIF&sizeRules=Px(ScSCS(fontPt'10')Bounds(maxW'360'maxH'160'))",
		["image/gif"]
		);
	vPack.registerModel(vModel);

	vModel = new ModelBase(
		"sfile_eWeb",
		"chrome://cv-1_2/content/sfile_eWeb", 
		"Site web embarqué", 
		"chrome://cv-1_2/content/sfile_eWeb/mainView.xul"
		);
				
	vModel.getIcon = function(pUriRes){
		if(pUriRes=="/meta.xml") return "chrome://cv-1_2/content/models/sc_folderPrim/meta";
		if(!pUriRes || pUriRes == "/") {
			return this.fIcon;
		} else if(pUriRes.charAt(pUriRes.length - 1) == "/"){
			return "chrome://scenaricms/content/icon/icfolder";
		}
		return "chrome://scenaricms/content/icon/icres";
	}
	vModel.getIconOpen = function(pUriRes){
		if(pUriRes=="/meta.xml") return "chrome://cv-1_2/content/models/sc_folderPrim/meta";
		if(!pUriRes || pUriRes == "/") {
			return this.fIcon;
		} else if(pUriRes.charAt(pUriRes.length - 1) == "/"){
			return "chrome://scenaricms/content/icon/icfolderOpen";
		}
		return "chrome://scenaricms/content/icon/icres";
	}
	vPack.registerModel(vModel);

	vModel = new ModelRes(
		"sfile_mp3",
		"chrome://cv-1_2/content/sfile_mp3", 
		"Audio MP3", 
		"chrome://cv-1_2/content/sfile_mp3/mainView.xul",
		"chrome://cv-1_2/content/sfile_mp3/preview.mini.xul",
		null,
		["audio/mpeg"]
		);
	vPack.registerModel(vModel);

	vModel = new ModelRes(
		"sfile_flv",
		"chrome://cv-1_2/content/sfile_flv", 
		"Vidéo FLV", 
		"chrome://cv-1_2/content/sfile_flv/mainView.xul",
		"chrome://cv-1_2/content/sfile_flv/preview.mini.xul",
		null,
		["video/x-flv"]
		);
	vPack.registerModel(vModel);

	vModel = new ModelRes(
		"sfile_swf",
		"chrome://cv-1_2/content/sfile_swf", 
		"Animation Flash", 
		"chrome://cv-1_2/content/sfile_swf/mainView.xul",
		"chrome://cv-1_2/content/sfile_swf/preview.xul",
		null,
		["application/x-shockwave-flash"]
		);
	vPack.registerModel(vModel);

	vModel = new ModelRes(
		"sfile_odg",
		"chrome://cv-1_2/content/sfile_odg", 
		"Graphique OpenDocument", 
		"chrome://cv-1_2/content/sfile_odg/mainView.xul",
		"chrome://cv-1_2/content/sfile_odg/preview.xul",
		"transform=od2img&amp;outType=PNG&sizeRules=Px(ScSCS(fontPt\'10\')Bounds(maxW\'360\'maxH\'160\'))",
		["application/vnd.oasis.opendocument.graphics"]
		);
	vPack.registerModel(vModel);

	vModel = new ModelRes(
		"sfile_ods",
		"chrome://cv-1_2/content/sfile_ods", 
		"Classeur OpenDocument", 
		"chrome://cv-1_2/content/sfile_ods/mainView.xul",
		"chrome://cv-1_2/content/sfile_ods/preview.xul",
		"transform=od2img&amp;outType=PNG&sizeRules=Px(ScSCS(fontPt\'10\')Bounds(maxW\'360\'maxH\'160\'))",
		["application/vnd.oasis.opendocument.spreadsheet"]
		);
	vPack.registerModel(vModel);

	vModel = new ModelBase(
		"of_libre",
		"chrome://cv-1_2/content/of_libre", 
		"CV libre", 
		"chrome://cv-1_2/content/of_libre/mainView.xul",
		"",
		null,
		true
		);
	vPack.registerModel(vModel);

	vModel = new ModelBase(
		"of_cv",
		"chrome://cv-1_2/content/of_cv", 
		"CV guidé", 
		"chrome://cv-1_2/content/of_cv/mainView.xul",
		"",
		null,
		true
		);
	vPack.registerModel(vModel);

				vModel = new ModelBase(
					"sfile_xml",
					"chrome://cv-1_2/content/sfile_xml", 
					"Item indéfini de type Xml", 
					"chrome://cv-1_2/content/sfile_xml/mainView.xul"
					);
				vPack.registerModel(vModel);

				vModel = new ModelBase(
					"sfileany_und",
					"chrome://cv-1_2/content/sfileany_und", 
					"Item indéfini", 
					"chrome://cv-1_2/content/sfileany_und/mainView.xul"
					);
				vPack.registerModel(vModel);

	
	
					vPack.fFoldN6 = new CreatorItemFolder("0001", "Publications", null, null, 1,null)

			
					vPack.fFoldN8 = new CreatorItemFolder("0001", "CV", null, null, 1,null)

				
				
			
		
					vPack.fFoldN4a = new CreatorItemFolder("0002", "Ressources", null, null, 1,null)

			
					vPack.fFoldN4c = new CreatorItemFolder("0001", "Images", null, null, 1,false)

				
				
				
			
			
					vPack.fFoldN55 = new CreatorItemFolder("0002", "Tableaux, Schémas, Équations", null, null, 1,false)

				
				
				
			
			
					vPack.fFoldN5e = new CreatorItemFolder("0003", "Animations multimédias", null, null, 1,false)

				
				
				
				
				
				
				
			
			
					vPack.fFoldN6f = new CreatorItemFolder("0004", "Fichiers bureautique", null, null, 1,false)

				
				
				
				
				
				
				
				
			
		
vPack.addCreatorItem = function(pModel, pCreatorItemMgr){		
	var vCreator;
	var vCreatorList;
	var vSortKey;
	switch(pModel){

			
					
		case "of_cv" : {

	vCreator = new CreatorItem3(
			this,
			"of_cv",
			"of_cv",
			"CV guidé",
			"chrome://cv-1_2/content/of_cv/icovalid.png",
			null,
			".cv",
			"string",
			'<?xml version="1.0" encoding="UTF-8"?><sc:item xmlns:sc="http://www.utc.fr/ics/scenari/v3/core" xmlns:of="scpf.org:office"><of:cv/></sc:item>',
			""
		);
			
			vSortKey = "0001";
pCreatorItemMgr.gotoChildFolder(this.fFoldN6);
pCreatorItemMgr.gotoChildFolder(this.fFoldN8);
break;
		}
					
		case "of_libre" : {

	vCreator = new CreatorItem3(
			this,
			"of_libre",
			"of_libre",
			"CV libre",
			"chrome://cv-1_2/content/of_libre/icovalid.png",
			null,
			".cv",
			"string",
			'<?xml version="1.0" encoding="UTF-8"?><sc:item xmlns:sc="http://www.utc.fr/ics/scenari/v3/core" xmlns:of="scpf.org:office"><of:libre/></sc:item>',
			""
		);
			
			vSortKey = "0002";
pCreatorItemMgr.gotoChildFolder(this.fFoldN6);
pCreatorItemMgr.gotoChildFolder(this.fFoldN8);
break;
		}
			
		
			
					
		case "sfile_jpg_jpeg" : {


					var vCreatorList = new Array();



							var vTmpCreator = new CreatorItem3(

								this,

								"sfile_jpg_jpeg",

								"sfile_jpg_jpeg",

								"Image JPEG (.jpg)",

								"chrome://cv-1_2/content/sfile_jpg_jpeg/icovalid.png",

								null,

								".jpg",

								"string","",

								"image{optionalCounter}"

							);

							vCreatorList.push(vTmpCreator);



							var vTmpCreator = new CreatorItem3(

								this,

								"sfile_jpg_jpeg",

								"sfile_jpg_jpeg",

								"Image JPEG (.jpeg)",

								"chrome://cv-1_2/content/sfile_jpg_jpeg/icovalid.png",

								null,

								".jpeg",

								"string","",

								"image{optionalCounter}"

							);

							vCreatorList.push(vTmpCreator);


			vSortKey = "0001";
pCreatorItemMgr.gotoChildFolder(this.fFoldN4a);
pCreatorItemMgr.gotoChildFolder(this.fFoldN4c);
break;
		}
					
		case "sfile_png" : {


					var vCreatorList = new Array();



							var vTmpCreator = new CreatorItem3(

								this,

								"sfile_png",

								"sfile_png",

								"Image PNG",

								"chrome://cv-1_2/content/sfile_png/icovalid.png",

								null,

								".png",

								"string","",

								"image{optionalCounter}"

							);

							vCreatorList.push(vTmpCreator);


			vSortKey = "0002";
pCreatorItemMgr.gotoChildFolder(this.fFoldN4a);
pCreatorItemMgr.gotoChildFolder(this.fFoldN4c);
break;
		}
					
		case "sfile_gif" : {


					var vCreatorList = new Array();



							var vTmpCreator = new CreatorItem3(

								this,

								"sfile_gif",

								"sfile_gif",

								"Image GIF",

								"chrome://cv-1_2/content/sfile_gif/icovalid.png",

								null,

								".gif",

								"string","",

								"image{optionalCounter}"

							);

							vCreatorList.push(vTmpCreator);


			vSortKey = "0003";
pCreatorItemMgr.gotoChildFolder(this.fFoldN4a);
pCreatorItemMgr.gotoChildFolder(this.fFoldN4c);
break;
		}
			
			
					
		case "sfile_odf" : {


	var vCreatorList = new Array();



	var vTmpCreator = new CreatorItem3(

		this,

		"sfile_odf",

		"sfile_odf",

		"Equation mathématique OpenDocument",

		"chrome://cv-1_2/content/sfile_odf/icovalid.png",

		null,

		".odf",

"url", "chrome://cv-1_2/content/sfile_odf/emptyFile",

		"res{optionalCounter}",

		"binary"

	);

	vCreatorList.push(vTmpCreator);


			vSortKey = "0001";
pCreatorItemMgr.gotoChildFolder(this.fFoldN4a);
pCreatorItemMgr.gotoChildFolder(this.fFoldN55);
break;
		}
					
		case "sfile_ods" : {


	var vCreatorList = new Array();



	var vTmpCreator = new CreatorItem3(

		this,

		"sfile_ods",

		"sfile_ods",

		"Classeur OpenDocument",

		"chrome://cv-1_2/content/sfile_ods/icovalid.png",

		null,

		".ods",

"url", "chrome://cv-1_2/content/sfile_ods/emptyFile",

		"res{optionalCounter}",

		"binary"

	);

	vCreatorList.push(vTmpCreator);


			vSortKey = "0002";
pCreatorItemMgr.gotoChildFolder(this.fFoldN4a);
pCreatorItemMgr.gotoChildFolder(this.fFoldN55);
break;
		}
					
		case "sfile_odg" : {


	var vCreatorList = new Array();



	var vTmpCreator = new CreatorItem3(

		this,

		"sfile_odg",

		"sfile_odg",

		"Graphique OpenDocument",

		"chrome://cv-1_2/content/sfile_odg/icovalid.png",

		null,

		".odg",

"url", "chrome://cv-1_2/content/sfile_odg/emptyFile",

		"res{optionalCounter}",

		"binary"

	);

	vCreatorList.push(vTmpCreator);


			vSortKey = "0003";
pCreatorItemMgr.gotoChildFolder(this.fFoldN4a);
pCreatorItemMgr.gotoChildFolder(this.fFoldN55);
break;
		}
			
			
					
		case "sfile_swf" : {


	var vCreatorList = new Array();



	var vTmpCreator = new CreatorItem3(

		this,

		"sfile_swf",

		"sfile_swf",

		"Animation Flash",

		"chrome://cv-1_2/content/sfile_swf/icovalid.png",

		null,

		".swf",

"string","",

		"anim{optionalCounter}",

		"binary"

	);

	vCreatorList.push(vTmpCreator);


			vSortKey = "0001";
pCreatorItemMgr.gotoChildFolder(this.fFoldN4a);
pCreatorItemMgr.gotoChildFolder(this.fFoldN5e);
break;
		}
					
		case "sfile_flv" : {


					var vCreatorList = new Array();



							var vTmpCreator = new CreatorItem3(

								this,

								"sfile_flv",

								"sfile_flv",

								"Vidéo FLV",

								"chrome://cv-1_2/content/sfile_flv/icovalid.png",

								null,

								".flv",

								"string","",

								"video{optionalCounter}"

							);

							vCreatorList.push(vTmpCreator);


			vSortKey = "0002";
pCreatorItemMgr.gotoChildFolder(this.fFoldN4a);
pCreatorItemMgr.gotoChildFolder(this.fFoldN5e);
break;
		}
					
		case "sfile_mp3" : {


					var vCreatorList = new Array();



							var vTmpCreator = new CreatorItem3(

								this,

								"sfile_mp3",

								"sfile_mp3",

								"Audio MP3",

								"chrome://cv-1_2/content/sfile_mp3/icovalid.png",

								null,

								".mp3",

								"string","",

								"audio{optionalCounter}"

							);

							vCreatorList.push(vTmpCreator);


			vSortKey = "0003";
pCreatorItemMgr.gotoChildFolder(this.fFoldN4a);
pCreatorItemMgr.gotoChildFolder(this.fFoldN5e);
break;
		}
				
				
					
		case "sfile_eWeb" : {


					var vCreatorList = new Array();



						var vTmpCreator = new CreatorItem3(

							this,

							"sfile_eWeb",

							"sfile_eWeb",

							"Site web embarqué",

							"chrome://cv-1_2/content/sfile_eWeb/icovalid.png",

							null,

							".eWeb",

"string","",

							"media{optionalCounter}"

						);

						vTmpCreator.fIsMultiRes = true;

						vCreatorList.push(vTmpCreator);


			vSortKey = "0004";
pCreatorItemMgr.gotoChildFolder(this.fFoldN4a);
pCreatorItemMgr.gotoChildFolder(this.fFoldN5e);
break;
		}
					
		case "of_mediaWeb" : {

	vCreator = new CreatorItem3(
			this,
			"of_mediaWeb",
			"of_mediaWeb",
			"Module web distant",
			"chrome://cv-1_2/content/of_mediaWeb/icovalid.png",
			null,
			".mWeb",
			"string",
			'<?xml version="1.0" encoding="UTF-8"?><sc:item xmlns:sc="http://www.utc.fr/ics/scenari/v3/core" xmlns:of="scpf.org:office"><of:mediaWeb/></sc:item>',
			"web{optionalCounter}"
		);
			
			vSortKey = "0005";
pCreatorItemMgr.gotoChildFolder(this.fFoldN4a);
pCreatorItemMgr.gotoChildFolder(this.fFoldN5e);
break;
		}
			
			
					
		case "sfile_doc_docx" : {


	var vCreatorList = new Array();



	var vTmpCreator = new CreatorItem3(

		this,

		"sfile_doc_docx",

		"sfile_doc_docx",

		"Document Microsoft Word (.doc)",

		"chrome://cv-1_2/content/sfile_doc_docx/icovalid.png",

		null,

		".doc",

"url", "chrome://cv-1_2/content/sfile_doc_docx/emptyFile",

		"res{optionalCounter}",

		"binary"

	);

	vCreatorList.push(vTmpCreator);



	var vTmpCreator = new CreatorItem3(

		this,

		"sfile_doc_docx",

		"sfile_doc_docx",

		"Document Microsoft Word (.docx)",

		"chrome://cv-1_2/content/sfile_doc_docx/icovalid.png",

		null,

		".docx",

"url", "chrome://cv-1_2/content/sfile_doc_docx/emptyFile.docx",

		"res{optionalCounter}",

		"binary"

	);

	vCreatorList.push(vTmpCreator);


			vSortKey = "0001";
pCreatorItemMgr.gotoChildFolder(this.fFoldN4a);
pCreatorItemMgr.gotoChildFolder(this.fFoldN6f);
break;
		}
					
		case "sfile_rtf" : {


	var vCreatorList = new Array();



	var vTmpCreator = new CreatorItem3(

		this,

		"sfile_rtf",

		"sfile_rtf",

		"Document RTF",

		"chrome://cv-1_2/content/sfile_rtf/icovalid.png",

		null,

		".rtf",

"url", "chrome://cv-1_2/content/sfile_rtf/emptyFile",

		"res{optionalCounter}",

		"binary"

	);

	vCreatorList.push(vTmpCreator);


			vSortKey = "0002";
pCreatorItemMgr.gotoChildFolder(this.fFoldN4a);
pCreatorItemMgr.gotoChildFolder(this.fFoldN6f);
break;
		}
					
		case "sfile_xls_xlsx" : {


	var vCreatorList = new Array();



	var vTmpCreator = new CreatorItem3(

		this,

		"sfile_xls_xlsx",

		"sfile_xls_xlsx",

		"Classeur Microsoft Excel (.xls)",

		"chrome://cv-1_2/content/sfile_xls_xlsx/icovalid.png",

		null,

		".xls",

"url", "chrome://cv-1_2/content/sfile_xls_xlsx/emptyFile.xls",

		"res{optionalCounter}",

		"binary"

	);

	vCreatorList.push(vTmpCreator);



	var vTmpCreator = new CreatorItem3(

		this,

		"sfile_xls_xlsx",

		"sfile_xls_xlsx",

		"Classeur Microsoft Excel (.xlsx)",

		"chrome://cv-1_2/content/sfile_xls_xlsx/icovalid.png",

		null,

		".xlsx",

"url", "chrome://cv-1_2/content/sfile_xls_xlsx/emptyFile.xlsx",

		"res{optionalCounter}",

		"binary"

	);

	vCreatorList.push(vTmpCreator);


			vSortKey = "0003";
pCreatorItemMgr.gotoChildFolder(this.fFoldN4a);
pCreatorItemMgr.gotoChildFolder(this.fFoldN6f);
break;
		}
					
		case "sfile_ppt_pps_pptx_ppsx" : {


	var vCreatorList = new Array();



	var vTmpCreator = new CreatorItem3(

		this,

		"sfile_ppt_pps_pptx_ppsx",

		"sfile_ppt_pps_pptx_ppsx",

		"Présentation Microsoft Powerpoint (.ppt)",

		"chrome://cv-1_2/content/sfile_ppt_pps_pptx_ppsx/icovalid.png",

		null,

		".ppt",

"url", "chrome://cv-1_2/content/sfile_ppt_pps_pptx_ppsx/emptyFile.ppt",

		"res{optionalCounter}",

		"binary"

	);

	vCreatorList.push(vTmpCreator);



	var vTmpCreator = new CreatorItem3(

		this,

		"sfile_ppt_pps_pptx_ppsx",

		"sfile_ppt_pps_pptx_ppsx",

		"Présentation Microsoft Powerpoint (.pps)",

		"chrome://cv-1_2/content/sfile_ppt_pps_pptx_ppsx/icovalid.png",

		null,

		".pps",

"url", "chrome://cv-1_2/content/sfile_ppt_pps_pptx_ppsx/emptyFile.pps",

		"res{optionalCounter}",

		"binary"

	);

	vCreatorList.push(vTmpCreator);



	var vTmpCreator = new CreatorItem3(

		this,

		"sfile_ppt_pps_pptx_ppsx",

		"sfile_ppt_pps_pptx_ppsx",

		"Présentation Microsoft Powerpoint (.pptx)",

		"chrome://cv-1_2/content/sfile_ppt_pps_pptx_ppsx/icovalid.png",

		null,

		".pptx",

"url", "chrome://cv-1_2/content/sfile_ppt_pps_pptx_ppsx/emptyFile.pptx",

		"res{optionalCounter}",

		"binary"

	);

	vCreatorList.push(vTmpCreator);



	var vTmpCreator = new CreatorItem3(

		this,

		"sfile_ppt_pps_pptx_ppsx",

		"sfile_ppt_pps_pptx_ppsx",

		"Présentation Microsoft Powerpoint (.ppsx)",

		"chrome://cv-1_2/content/sfile_ppt_pps_pptx_ppsx/icovalid.png",

		null,

		".ppsx",

"url", "chrome://cv-1_2/content/sfile_ppt_pps_pptx_ppsx/emptyFile.ppsx",

		"res{optionalCounter}",

		"binary"

	);

	vCreatorList.push(vTmpCreator);


			vSortKey = "0004";
pCreatorItemMgr.gotoChildFolder(this.fFoldN4a);
pCreatorItemMgr.gotoChildFolder(this.fFoldN6f);
break;
		}
					
		case "sfile_odp" : {


	var vCreatorList = new Array();



	var vTmpCreator = new CreatorItem3(

		this,

		"sfile_odp",

		"sfile_odp",

		"Présentation OpenDocument",

		"chrome://cv-1_2/content/sfile_odp/icovalid.png",

		null,

		".odp",

"url", "chrome://cv-1_2/content/sfile_odp/emptyFile",

		"res{optionalCounter}",

		"binary"

	);

	vCreatorList.push(vTmpCreator);


			vSortKey = "0005";
pCreatorItemMgr.gotoChildFolder(this.fFoldN4a);
pCreatorItemMgr.gotoChildFolder(this.fFoldN6f);
break;
		}
					
		case "sfile_odt" : {


	var vCreatorList = new Array();



	var vTmpCreator = new CreatorItem3(

		this,

		"sfile_odt",

		"sfile_odt",

		"Texte OpenDocument",

		"chrome://cv-1_2/content/sfile_odt/icovalid.png",

		null,

		".odt",

"url", "chrome://cv-1_2/content/sfile_odt/emptyFile",

		"res{optionalCounter}",

		"binary"

	);

	vCreatorList.push(vTmpCreator);


			vSortKey = "0006";
pCreatorItemMgr.gotoChildFolder(this.fFoldN4a);
pCreatorItemMgr.gotoChildFolder(this.fFoldN6f);
break;
		}
					
		case "sfile_pdf" : {


	var vCreatorList = new Array();



	var vTmpCreator = new CreatorItem3(

		this,

		"sfile_pdf",

		"sfile_pdf",

		"Document PDF",

		"chrome://cv-1_2/content/sfile_pdf/icovalid.png",

		null,

		".pdf",

"string","",

		"res{optionalCounter}",

		"binary"

	);

	vCreatorList.push(vTmpCreator);


			vSortKey = "0007";
pCreatorItemMgr.gotoChildFolder(this.fFoldN4a);
pCreatorItemMgr.gotoChildFolder(this.fFoldN6f);
break;
		}
					
		case "sfile_zip" : {


	var vCreatorList = new Array();



	var vTmpCreator = new CreatorItem3(

		this,

		"sfile_zip",

		"sfile_zip",

		"Archive ZIP",

		"chrome://cv-1_2/content/sfile_zip/icovalid.png",

		null,

		".zip",

"string","",

		"res{optionalCounter}",

		"binary"

	);

	vCreatorList.push(vTmpCreator);


			vSortKey = "0008";
pCreatorItemMgr.gotoChildFolder(this.fFoldN4a);
pCreatorItemMgr.gotoChildFolder(this.fFoldN6f);
break;
		}
			
			
		case "sfileany_und" : {

			vSortKey = "0003";
break;
		}	
		case "sfile_xml" : {

			vSortKey = "0004";
break;
		}
	}
	if(vCreator) {
		vCreator.fSortKey = vSortKey;
		pCreatorItemMgr.addCreatorItem(vCreator);
	}
	if(vCreatorList) {
		for(var ii=0;ii<vCreatorList.length;ii++){
			vCreatorList[ii].fSortKey = vSortKey;
			pCreatorItemMgr.addCreatorItem(vCreatorList[ii]);
		}
	}
}


	pPackMgr.registerPack(vPack);
}