

var desk = {};




desk.deskType = "Wsp";


desk.isReadOnly = function(){
	return (this.fCurrentWsp && this.fCurrentWsp.rights) ? !this.fCurrentWsp.rights.rWrite : false;
}


desk.canUnloadCurrentView = function(pSilentMode) {
	var vCanUnload = true;
	try{vCanUnload = this.fCurrentMainView.contentWindow.canUnload(pSilentMode);}catch(e){}
	return vCanUnload;
}


desk.canUnloadView = function(pView, pSilentMode) {
	var vCanUnload = true;
	try{vCanUnload = pView.contentWindow.canUnload(pSilentMode);}catch(e){}
	return vCanUnload;
}


desk.fPoolRequest = [];
desk.requestForCurrentView = function(pRequest, pKeepIfViewUnvailable) {
	try{

		if( !this.fCurrentMainView.hasAttribute("currenturl")) throw "unloading";

		if(this.fPoolRequest.length > 0) {
			for each (var vReq in this.fPoolRequest) this.fCurrentMainView.contentWindow.handleRequest(vReq);
			this.fPoolRequest.length = 0;
		}

		return this.fCurrentMainView.contentWindow.handleRequest(pRequest);
	}catch(e){
		if(pKeepIfViewUnvailable) this.fPoolRequest.push(pRequest);
	}
}


desk.canUnloadAllViews = function(pSilentMode) {
	return this.canCloseDesk(pSilentMode);
}


desk.closeAllViews = function(pSilentMode) {
	try{

		while(this.onCloseTab(pSilentMode));
		return this.canUnloadCurrentView(true);
	}catch(e){ut.debug("desk.closeAllViews::"+e);}
	return false;
}


desk.closeAllTabs = function(pExceptThisTab) {
	try{

		var vTab = desk.fMainViewTabs.firstChild;
		while(vTab) {
			if(vTab.nodeType==1 && vTab.localName=="tab" && pExceptThisTab != vTab) {
				desk.fMainViewTabs.selectedItem = vTab;
				if( ! desk.onCloseTab(false)) return false;
				if(desk.fMainViewTabs.firstChild) {

					window.setTimeout(desk.closeAllTabs, 50, pExceptThisTab);
					return;
				}
			} else {
				vTab = vTab.nextSibling;
			}
		}
	}catch(e){ut.debug("desk.closeAllTabs::"+e);}
	return true;
}


desk.saveAll = function() {
	try{

		var vCurTab = this.fMainViewTabs.selectedItem;
		var vTab = this.fMainViewTabs.firstChild;
		var vPanel = this.fMainViewPanels.firstChild;
		while(vTab) {
			if(vTab.nodeType==1 && vTab.localName=="tab") {
				if(vPanel.fUriObject) {
					if( ! this.canUnloadView(vPanel, true)) {

						try {
							this.fMainViewTabs.selectedItem = vTab;
							this.fCurrentMainView.contentWindow.handleRequest({request:'save'});
						}catch(e){}
					}
				}
				vPanel = vPanel.nextSibling;
			}
			vTab = vTab.nextSibling;
		}

		this.fMainViewTabs.selectedItem = vCurTab;
		return true;
	}catch(e){ut.debug("desk.saveAll::"+e);}
}

desk.saveAllViews = function(pCdWsp) {
	try{

		var vCurTab = this.fMainViewTabs.selectedItem;
		var vTab = this.fMainViewTabs.firstChild;
		var vPanel = this.fMainViewPanels.firstChild;
		while(vTab) {
			if(vTab.nodeType==1 && vTab.localName=="tab") {
				if(vPanel.fUriObject && ut.getWspFromUri(vPanel.fUriObject.getUri()) == pCdWsp) {
					if( ! this.canUnloadView(vPanel, true)) {

						this.fMainViewTabs.selectedItem = vTab;
						if( ! this.canUnloadCurrentView(false)) return false;

						desk.activateUriObject(ut.createUriObjectByUri(vPanel.fUriObject.getDataProvider(), vPanel.fUriObject.getUri()));
					}
				}
				vPanel = vPanel.nextSibling;
			}
			vTab = vTab.nextSibling;
		}

		this.fMainViewTabs.selectedItem = vCurTab;
		return true;
	}catch(e){ut.debug("desk.saveAllViews::"+e);}
	return false;
}


desk.saveViewForUri = function(pUri) {
	try{

		var vCurTab = this.fMainViewTabs.selectedItem;
		var vTab = this.fMainViewTabs.firstChild;
		var vPanel = this.fMainViewPanels.firstChild;
		while(vTab) {
			if(vTab.nodeType==1 && vTab.localName=="tab") {
				if(vPanel.fUriObject && vPanel.fUriObject.getUri() == pUri) {
					if( ! this.canUnloadView(vPanel, true)) {

						this.fMainViewTabs.selectedItem = vTab;
						if( ! this.canUnloadCurrentView(false)) return false;

						desk.activateUriObject(ut.createUriObjectByUri(vPanel.fUriObject.getDataProvider(), vPanel.fUriObject.getUri()));
					}
				}
				vPanel = vPanel.nextSibling;
			}
			vTab = vTab.nextSibling;
		}

		this.fMainViewTabs.selectedItem = vCurTab;
		return true;
	}catch(e){ut.debug("desk.saveViewForUri::"+e);}
	return false;
}


desk.closeThisTab = function(pTab) {
	this.fMainViewTabs.selectedItem = pTab;
	if( ! this.onCloseTab(false)) return false;
	return true;
}


desk.reloadTab = function() {
	var vUriObject = this.fCurrentMainView.fUriObject;
	if(vUriObject) {
		if( ! desk.canUnloadCurrentView()) return;
		desk.activateUriObject(ut.createUriObjectByUri(vUriObject.getDataProvider(), vUriObject.fUri));
	}
}


desk.loadUriObjectByUri = function (pDataProvider, pUri, pOptions){
	pOptions = pOptions || "";
	if(pOptions.indexOf(";newwindow;")>=0) {

		return;
	}
	if(pOptions.indexOf(";itemnet;")>=0) {
		try{

			var vServer = pDataProvider;
			var vCdWsp = ut.getWspFromUri(pUri);
			
			function execItemnet() {
				desk.xResetRightPanel();
				desk.fRightPanelDeck.selectedIndex = 0;
				desk.fItemnetMgrDesc = new ItemnetMgr();
				desk.fItemnetMgrAsc = new ItemnetMgr();
				desk.fItemnetMgrDesc.init(vServer, pUri, null, false);
				vServer.addItemsListener(desk.fItemnetMgrAsc);
				desk.fItemnetMgrAsc.init(vServer, pUri, null, true);
				vServer.addItemsListener(desk.fItemnetMgrDesc);
				desk.fItemNetTree.init(desk.fItemnetMgrDesc, desk.fItemnetMgrAsc);
				desk.fRightPanel.collapsed = false;
				document.getElementById("oSplitterRightPanel").collapsed = false;

			}
			var vReload = false;
			var vStatusReloadDom = vServer.getDomFromService("/u/adminWsp?cdaction=StatusLoadedAllItems&param="+vCdWsp);
			var vStatusReload = vStatusReloadDom ? vStatusReloadDom.documentElement.getAttribute("status") : null;
			if(vStatusReload=="no" && ! ("fDontAskRelaodItems" in this)) {





				vReload = true;
			}
			if(vReload) {
				var vWin = ut.openWindowWait("", "Chargement en cours", "Chargement préalable de l\'atelier...");
				function cbLoadItems(pEvent){
					ut.closeWindowWait(vWin);
					execItemnet();
				}
				vServer.dialogAsynchWithService("/u/adminWsp?cdaction=ActivateModeLoadAllItems&param="+vCdWsp, "GET", null, null, cbLoadItems, cbLoadItems);
			} else {
				execItemnet();
			}
		}catch(e){ut.debug(e);}
		return;
	}
	if(pOptions.indexOf(";outline;")>=0) {
		try {
			this.xResetRightPanel();
			this.fRightPanelDeck.selectedIndex = 1;
			this.fRightPanel.collapsed = false;
			document.getElementById("oSplitterRightPanel").collapsed = false;
			pDataProvider.addItemsListener(this.fOutlineView.fUriListener);
			this.fOutlineView.init(pDataProvider, pUri);
			var vCurrUri = desk.getCurrentUriObject();
			if(vCurrUri && vCurrUri.fDataProvider == pDataProvider) this.fOutlineView.selectUri(vCurrUri.getUri());
		}catch(e){ut.debug(e);}
		return;
	}

	scMaxBlockNormalize(document);

	var vMainView = this.fCurrentMainView;
	if(pUri == null) {
		if(this.canUnloadCurrentView()) {
			vMainView.webNavigation.loadURI("chrome://scenaricms/content/deskwsp/blank.xul", 0, null, null, null);
			this.fMainViewTabs.selectedItem.setAttribute("label", "");
		}
		return;
	}

	var vIdx = desk.getTabIdxWithUri(pUri, pDataProvider);
	if(vIdx >= 0) {
		if(pOptions.indexOf(";newtabBehind;")<0) this.fMainViewTabs.selectedIndex = vIdx;
		return;
	}
	if(pOptions.indexOf(";newtab")>=0) {
		vMainView = this.addTab(pOptions.indexOf(";newtabBehind;")<0);
	} else if(pOptions.indexOf(";replace;")>=0) {
		if( ! this.canUnloadCurrentView()){
			return;
		}
	} else {
		if( ! this.canUnloadCurrentView(true)) vMainView = this.addTab(true);
	}
	var vCdWsp = pUri;
	var vSlash = pUri.indexOf("/");
	if(vSlash>0) vCdWsp = pUri.substr(0, vSlash);
	var vWsp = this.getWsp(pDataProvider, vCdWsp);
	if(vWsp != null){
		this.selWsp(vWsp);
		var vUriObject = ut.createUriObjectByUri(pDataProvider, pUri);
		if(vUriObject == null) vUriObject = new UriObjectWsp(vCdWsp, pDataProvider);
		this.activateUriObject(vUriObject, vMainView);
	}
}


desk.isLoadUriObjectOptionAvailable = function (pOption){
	return (pOption=="newtab" || pOption=="replace" || pOption=="itemnet" || pOption=="outline");
}




desk.fCurrentWsp = null;

desk.fCurrentMainView = null;


desk.fListServer = [];


desk.fMainViewPanels = null;

desk.fMainViewTabs = null;

desk.fRootWsps = null;


desk.fHisto = null;


desk.fIsInit = false;
desk.initDesk = function (){
	if(!this.fIsInit) {
		
		try {
			var vPackRegistryService = Components.classes["@scenari.com/packregistryservice;1"].getService(Components.interfaces.scIPackRegistryService);
			vPackRegistryService.getWspType("aa");
			
			var vChromeService = Components.classes["@mozilla.org/chrome/chrome-registry;1"].getService(Components.interfaces.nsIXULChromeRegistry);

		}catch(e){ut.debug(e);}
		
		window.addEventListener("DOMWindowClose", function(pEvent){if( ! desk.canCloseDesk()) {pEvent.preventDefault(); return false;}}, true);
		
		this.fCurrentMainView = document.getElementById("oMainView");
		this.fRightPanel = document.getElementById("oRightPanel");
		this.fRightPanelDeck = document.getElementById("oRightPanelDeck");
		this.fItemNetTree = document.getElementById("oItemNetTree");
		this.fOutlineView = document.getElementById("oOutlineView");
		this.fRootWsps = document.getElementById("oWsps");
		this.fAppName = "SCENARI";
		try{this.fAppName = ut.fPrefs.getCharPref("app.name")}catch(e){ut.debug("La préférence 'app.name' n'a pas été renseignée.")};
		
		this.fMainViewTabs = document.getElementById("oMainViewTabs");

		document.getAnonymousElementByAttribute(this.fMainViewTabs, "class", "tabs-right").setAttribute("flex", "100");
		
		this.fMainViewPanels = document.getElementById("oMainViewPanels");
		this.fMainViewPanels.addEventListener("XEDStatusDirty", desk.onXEDStatusDirty, false);
		this.fMainViewPanels.addEventListener("XEDStatusNotDirty", desk.XEDStatusNotDirty, false);
		

		document.addEventListener(SCMAXIMIZEBLOCK_EVENT, scMaxBlockOnMaximize, false);
		document.addEventListener(SCNORMALIZEBLOCK_EVENT, scMaxBlockOnNormalize, false);
		

		this.fRootWsps.addEventListener("reloadItem", deskWspViewOnReloadItem, false);
		

		var oMenusOutilsFileAppliExt = document.getElementById('oMenusOutilsFileAppliExt');
		if (!wspUt._CanCreateServerLocal && oMenusOutilsFileAppliExt) oMenusOutilsFileAppliExt.collapsed=true; // les applications externes enrichissent le coté serveur
		

		if(ut.isMac){
			var vListElementsToMask = document.getElementsByAttribute("maskInMac", "true");
			for(var ii=0; ii<vListElementsToMask.length;ii++) vListElementsToMask[ii].hidden=true;

			if (document.getElementById('oMenusHelpFilePopup').childNodes.length <= 1) document.getElementById('oMenusHelpFile').hidden=true;
		}else if(ut.isUnix){
			var vListElementsToMask = document.getElementsByAttribute("maskInLin", "true");
			for(var ii=0; ii<vListElementsToMask.length;ii++) vListElementsToMask[ii].hidden=true;
		}else{
			var vListElementsToMask = document.getElementsByAttribute("maskInWin", "true");
			for(var ii=0; ii<vListElementsToMask.length;ii++) vListElementsToMask[ii].hidden=true;
		}


		var vReloadMode = false;
		try{vReloadMode = ut.fPrefs.getBoolPref("scenari.ui.reload"); } catch(e){}
		if( ! vReloadMode && ut.fPrefs.getPrefType("scenari.tips.displayOnLoad")==Components.interfaces.nsIPrefBranch.PREF_BOOL && ut.fPrefs.getBoolPref("scenari.tips.displayOnLoad")) this.showTipsScreen();
		if(vReloadMode) ut.fPrefs.setBoolPref("scenari.ui.reload", false);
		
		this.showWspConfigScreen();
		
		this.initHisto();
		this.fIsInit = true;
		window.setTimeout(desk.xWsp_xInitWsps, 0);
	}
}
desk.onXEDStatusDirty = function(pEvent){
	desk.fMainViewTabs.selectedItem.setAttribute("dirty", "true");
}
desk.XEDStatusNotDirty = function(pEvent){
	desk.fMainViewTabs.selectedItem.removeAttribute("dirty");
}

desk.xResetRightPanel = function(){
	if(this.fItemnetMgrDesc) try{this.fItemnetMgrDesc.fDataProvider.removeItemsListener(this.fItemnetMgrDesc);}catch(e){ut.debug(e);}
	if(this.fItemnetMgrAsc) try{this.fItemnetMgrAsc.fDataProvider.removeItemsListener(this.fItemnetMgrAsc);}catch(e){ut.debug(e);}
	if(this.fOutlineView.fDataProvider) {
		try{this.fOutlineView.fDataProvider.removeItemsListener(this.fOutlineView.fUriListener);}catch(e){ut.debug(e);}
		this.fOutlineView.reset();
	}
	this.fItemnetMgrDesc = null;
	this.fItemnetMgrAsc = null;
}

desk.xResetBottomPanel = function(){
	search.resetSearchPanel();
}

desk.xCreateWsp = function(pWspRegistered){
	var vBlock = document.createElementNS("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul", "wspBlock");
	vBlock.setAttribute("wspCode", pWspRegistered.getCode());
	if( ! pWspRegistered.getDataProvider().isLocal()) {
		vBlock.setAttribute("serverTitle", pWspRegistered.getTitleServer());
	}
	var vComment = pWspRegistered.getComment();
	if(vComment) vBlock.setAttribute("wspComment", vComment);
	vBlock.setAttribute("wspIsLocal", pWspRegistered.getDataProvider().isLocal());
	vBlock.fWspRegistered = pWspRegistered;
	return vBlock;
}

desk.xAddWsp = function(pWspRegistered){
	var vWspNode = this.xCreateWsp(pWspRegistered);
	var vBlock = this.fRootWsps.firstChild;

	this.showWelcomeScreen(false);
	while(vBlock && this.xSortWsps(vBlock, vWspNode) < 0) {
		vBlock = vBlock.nextSibling;
	}
	this.fRootWsps.insertBefore(vWspNode, vBlock);

	this.selWsp(vWspNode);
	this.loadUriObjectByUri(this.fCurrentWsp.fWspView.fDataProvider, desk.fCurrentWsp.getAttribute("wspCode"));
}



desk.xSortWsps = function(pWsp1, pWsp2){
	var vS1 = pWsp1.getAttribute("serverTitle") || "";
	var vS2 = pWsp2.getAttribute("serverTitle") || "";
	var vResSever = vS1.localeCompare(vS2);
	if(vResSever == 0) {
		return pWsp1.getAttribute("wspCode").localeCompare(pWsp2.getAttribute("wspCode"));
	}
	return vResSever;
}


desk.xRemoveWsp = function(pWspNode){
	try{
		var vServerId = pWspNode.fWspRegistered.getIdServer();

		this.removeTabOfWsp(vServerId, pWspNode.getAttribute("wspCode"));
		

		var vWspNode = this.fRootWsps.firstChild;
		while(vWspNode) {
			if(pWspNode != vWspNode) {
				if(vWspNode.fWspRegistered.getIdServer() == vServerId) break;
			}
			vWspNode = vWspNode.nextSibling;
		}
		if(vWspNode == null) {

			for (var i = 0; i < this.fListServer.length; i++) {
				if(this.fListServer[i].getWspServer().getId() == vServerId) {
					this.fListServer[i].removeItemsListener(this);
					this.fListServer.splice(i,1);
					break;
				}
			}
		}

		if(this.fItemnetMgrDesc && this.fItemnetMgrDesc.fDataProvider.getWspServer().getId() == vServerId && this.fItemnetMgrDesc.fWsp == pWspNode.getAttribute("wspCode")) {
			this.onCloseRightPanel();
		} else if(this.fOutlineView.fDataProvider && vServerId == this.fOutlineView.fDataProvider.getWspServer().getId()) {
			this.onCloseRightPanel();
		}

		pWspNode.parentNode.removeChild(pWspNode);
		if(this.fCurrentWsp == pWspNode) {

			this.selWsp();

			if(this.fCurrentWsp) desk.loadUriObjectByUri(this.fCurrentWsp.fWspView.fDataProvider, desk.fCurrentWsp.fWspView.getUri() || desk.fCurrentWsp.getAttribute("wspCode"));
		}
		

		if(this.fCurrentWsp == null) this.showWelcomeScreen(desk.fWspRegistry.getDisabledWsps().Count()==0);
	} catch(e){
		ut.debug("deskwsp.js > xRemoveWsp : " + e);
		return false;
	}
}


desk.destroyDesk = function (){
	this.saveSession();
	if (this.fWspRegistry) this.fWspRegistry.removeWspRegListener(this);
	for (var i = 0; i < this.fListServer.length; i++) {
		this.fListServer[i].removeItemsListener(this);
	}
	this.xResetRightPanel();
	this.xResetBottomPanel();
	document.removeEventListener(SCMAXIMIZEBLOCK_EVENT, scMaxBlockOnMaximize, false);
	document.removeEventListener(SCNORMALIZEBLOCK_EVENT, scMaxBlockOnNormalize, false);
	this.fRootWsps.removeEventListener("reloadItem", deskWspViewOnReloadItem, false);
	this.fMainViewPanels.removeEventListener("XEDStatusDirty", desk.onXEDStatusDirty, false);
	this.fMainViewPanels.removeEventListener("XEDStatusNotDirty", desk.XEDStatusNotDirty, false);
}

desk.saveSession = function (){
	ut.fPrefs.setCharPref("scenari.deskWsp.currentWsp", (this.fCurrentWsp) ? this.fCurrentWsp.getAttribute("wspCode") : "");
	var vUriTabs = "";
	var vReloadMode = false;
	try{vReloadMode = ut.fPrefs.getBoolPref("scenari.ui.reload"); } catch(e){}
	if(vReloadMode) {

		var vMainView = this.fMainViewPanels.firstChild;
		while(vMainView){
			if(vMainView.fUriObject) {

				if(this.fCurrentMainView == vMainView) vUriTabs += "*";
				vUriTabs += vMainView.fUriObject.getUri() + "|" + vMainView.fUriObject.getDataProvider().getIniUrl() + ";";
			}
			vMainView = vMainView.nextSibling;
		}
	}
	ut.fPrefs.setCharPref("scenari.deskWsp.currentTabs", vUriTabs);
}

desk.viewHelp = function(pUrl, pTitle){
	var vUrl = pUrl ? pUrl : "chrome://scenarihelp/content/index.html";
	var vTitle = pTitle ? pTitle : "Aide";
	window.openDialog("chrome://scenaricms/content/util/browser/browser.xul", "", "centerscreen, resizable=yes, dialog=no, width=800px, height=600px", vUrl, vTitle);
}
desk.showAbout = function(){
	window.openDialog("chrome://scenaricms/content/about/about.xul", "", "chrome, centerscreen, modal, resizable=false"+(ut.isMac?", dialog=no":""));
}
desk.showPreferences = function(paneID){
	var vPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch(null);
	var vInstantApply = vPrefs.getBoolPref("browser.preferences.instantApply", false);
	var vPrefWindow = window.openDialog("chrome://scenaricms/content/preferences/preferences.xul", "scenari:preferences", "chrome,centerscreen,titlebar,toolbar,alwaysRaised" + (vInstantApply ? ",dialog=no" : ""), paneID);
	vPrefWindow.focus();
	
}
desk.openConfig = function(){
	window.openDialog("chrome://scenaricms/content/util/browser/browser.xul", "", "centerscreen, resizable=yes, dialog=no, width=800px, height=600px", "about:config", "Configuration avancée");
}
desk.showDownloadMgr = function(){
	try{
		ut.openUniqueDialog("Download:Manager", "chrome://mozapps/content/downloads/downloads.xul", "Gestionnaire de téléchargement", "chrome,dialog=no,resizable");                
	}catch(e){
		ut.debug("desk.showDownloadMgr : "+e);
	}
}


desk.doInstallElement = function(pFile){
	var vParam = null;
	if(pFile){
		vParam = new Object();
		vParam.packPath = pFile;
	}
	window.openDialog("chrome://scenaricms/content/installmgr/installmgr.xul", "", "chrome, centerscreen,  modal, resizable = yes"+(ut.isMac?", dialog=no":""), vParam);
}

desk.doCloseWin = function(){
	if(this.canCloseDesk()) window.close();
}

desk.doCloseApp = function(){
	Components.classes["@mozilla.org/toolkit/app-startup;1"].getService(Components.interfaces.nsIAppStartup).quit(Components.interfaces.nsIAppStartup.eAttemptQuit);
}

desk.reloadUi = function() {
	if(ut.isUnix) {
		window.setTimeout(function(){ut.appRestart(true);}, 1000);
	} else {
		ut.appRestart(true);
	}
}


desk.doRefreshWin = function(){
	if(this.canCloseDesk()) {

		Components.classes["@scenari.com/sharedres;1"].getService(Components.interfaces.scISharedRes).reset();
		if(ut.isMac){
			/* Horrid hack to work around xulrunner bug under MacOSX: The menubar will crash xulrunner after a window.location.reload() */
			ut.appRestart(true);
		} else {
			window.location.reload();
		}
	}
}

desk.doMgrWsp = function(){
	ut.openUniqueDialog("scenari:wspmgr", "chrome://scenaricms/content/wspmgr/wspmgr.xul", "", "chrome,centerscreen,modal,resizable=yes"+(ut.isMac?",dialog=no":""));
}

desk.doAddWsp = function(){
	window.openDialog("chrome://scenaricms/content/wspmgr/wspcreate/create.xul", "", "chrome,centerscreen,modal,resizable=yes"+(ut.isMac?",dialog=no":""));
}


desk.showTipsScreen = function(pWinParams){
	window.openDialog("chrome://scenaricms/content/deskwsp/tips/tips.xul", "", "chrome,centerscreen,alwaysRaised,resizable=no"+pWinParams);	
}


desk.showWspConfigScreen = function(){
	var vLastKeyOptionListInstalled = "";
	var vNewWspOptionKeyTab = [];
	try { 
		if(ut.fPrefs.prefHasUserValue("scenari.deskWsp.lastOptionListInstalled")){
			try{vLastKeyOptionListInstalled = ut.fPrefs.getCharPref("scenari.deskWsp.lastOptionListInstalled");}catch(e){};

			var vLastStateTab = vLastKeyOptionListInstalled.split(";");
			var vLastStateObj = {};
			for(var ii = 0; ii < vLastStateTab.length; ii++) vLastStateObj[vLastStateTab[ii]] = true;
			var vPackRegSvc = Components.classes["@scenari.com/packregistryservice;1"].getService(Components.interfaces.scIPackRegistryService);
			var vWspTypeOptionList = vPackRegSvc.getWspOptionUiList();
			if(vWspTypeOptionList){
				for(var ii = 0; ii < vWspTypeOptionList.Count(); ii++) {
					var vWspOptionUi = vWspTypeOptionList.GetElementAt(ii).QueryInterface(Components.interfaces.scIWspOptionUi);

					if(! (vWspOptionUi.getUri() in vLastStateObj)) vNewWspOptionKeyTab.push(vWspOptionUi.getUri());
				}
			}

			if(vNewWspOptionKeyTab.length > 0) window.openDialog("chrome://scenaricms/content/wspmgr/wspconfig/mConfigAllWsp.xul", "", "chrome,centerscreen,alwaysRaised,resizable", vNewWspOptionKeyTab);
			ut.fPrefs.clearUserPref("scenari.deskWsp.lastOptionListInstalled");
		}
	}catch(e){
		ut.debug("desk.showWspConfigScreen : " + e);
	}
}



desk.showWelcomeScreen = function(pShow){
	document.getElementById("oWelcome").collapsed = ! pShow;
	document.getElementById("oContent").collapsed = pShow;
	document.getElementById("oReloadUi").collapsed = pShow;
	document.getElementById("oBackButton").collapsed = pShow;
	document.getElementById("oForwardButton").collapsed = pShow;
}

desk.clickWsp = function(pWspBlock, pEvent){
	if(this.fCurrentWsp != pWspBlock) {
		desk.loadUriObjectByUri(pWspBlock.fDataProvider, pWspBlock.getAttribute("wspCode"), pEvent && ut.isAccelPress(pEvent) ? ";newtab;" : "");
	} else if(pEvent && ut.isAccelPress(pEvent)){
		desk.addTab(true);
		this.activateUriObject(new UriObjectWsp(pWspBlock.getAttribute("wspCode"), pWspBlock.fDataProvider));
	} else {
		if(this.canUnloadCurrentView()) {
			this.activateUriObject(new UriObjectWsp(pWspBlock.getAttribute("wspCode"), pWspBlock.fDataProvider));
		}
	}
}

desk.selWsp = function(pWspBlock){
	try{
		if(pWspBlock == null) {
			pWspBlock = this.fRootWsps.firstChild;

		}
		if(!pWspBlock) {
			this.fCurrentWsp = null;

			this.onCloseTab(true);
			return;
		}
		if(pWspBlock == this.fCurrentWsp) {
			return;
		}
		if(this.fCurrentWsp != null) this.fCurrentWsp.expand = false;
		this.fCurrentWsp = pWspBlock;
		if(pWspBlock != null) {
			pWspBlock.expand = true;
			var vNewServer = pWspBlock.fWspView.fDataProvider;
			var vIsAlreadyDeclared = false;
			for each(var vCurrSrv in this.fListServer) {
				if(vCurrSrv == vNewServer) {vIsAlreadyDeclared=true; break;}
			}
			if(!vIsAlreadyDeclared){//Ce serveur n'a pas encoré été référencé
				this.fListServer.push(vNewServer);
				vNewServer.addItemsListener(this);
			}
		}
	} catch(e){ut.debug(e);}
}


desk.activateUriObject = function(pUriObject, pMainView){
	var vMainView = pMainView || this.fCurrentMainView;
	if(vMainView.fUriObject) vMainView.fUriObject.removeUpdateListener(this);
	vMainView.fUriObject = pUriObject;

	this.fPoolRequest.length = 0;

	vMainView.removeAttribute("currenturl");
	if(pUriObject != null) {
		window.setCursor("wait");
		pUriObject.addUpdateListener(this);
		pUriObject._deskWspMainView = vMainView;
		pUriObject.activate(this.setUriObjectActivated, this);
	} else {


		vMainView.webNavigation.loadURI("about:blank", 0, null, null, null);
		vMainView.removeAttribute("currenturl");
	}
}


desk.setUriObjectActivated = function(pUriObject){
try{
	if(pUriObject._deskWspMainView.fUriObject == pUriObject) {

		var vUrl = pUriObject.getMainView();
		pUriObject._deskWspMainView.setAttribute("currenturl", vUrl);


		var vTab = this.fMainViewTabs.firstChild;
		var vPanel = pUriObject._deskWspMainView.previousSibling;
		while(vPanel){
			vTab = vTab.nextSibling;
			vPanel = vPanel.previousSibling;
		}
		this.xRefreshTab(vTab, pUriObject);
		
		pUriObject._deskWspMainView.webNavigation.loadURI(vUrl, 0, null, null, null);

		window.setCursor("auto");

		if(pUriObject._deskWspMainView == this.fCurrentMainView){

			var vUri = pUriObject.getUri();
			var vCdWsp = ut.getWspFromUri(vUri);
			var vWsp = this.getWsp(pUriObject.getDataProvider(), vCdWsp);
			if(vWsp != null){

				this.addToHisto(vWsp.fWspView.fDataProvider, vUri);				

				this.selWsp(vWsp);
				vWsp.fWspView.selectUri(vUri);
				if(this.fItemnetMgrDesc && this.fItemnetMgrDesc.fDataProvider == vWsp.fDataProvider) this.fItemNetTree.selectUri(vUri);
				if(vWsp.fDataProvider == this.fOutlineView.fDataProvider) this.fOutlineView.selectUri(vUri);
			}
		}
	}
}catch(e){ut.debug(e);}
}


desk.getCurrentUriObject = function(){
	return this.fCurrentMainView.fUriObject;
}


desk.handleUriObjectUpdate = function(pUriObject, pUri, pEventType){
	if(pUriObject._deskWspMainView.fUriObject == pUriObject) {
		var vMainView = pUriObject.getMainView();
		if(vMainView != pUriObject._deskWspMainView.getAttribute("currenturl")) {
			this.setUriObjectActivated(pUriObject);
			/*
			var vCanUnload = true;
			try{vCanUnload = pUriObject._deskWspMainView.contentWindow.canUnload(true);}catch(e){}
			if(vCanUnload){

				this.setUriObjectActivated(pUriObject);
			} else {

			}
			*/
		} else {
			var vIdx = desk.getTabIdxWithUri(pUri, pUriObject.getDataProvider());
			if(vIdx>=0) this.xRefreshTab(this.fMainViewTabs.getItemAtIndex(vIdx), pUriObject);
		}
	}
}
desk.xRefreshTab = function(pTab, pUriObject) {
	var vIcon = null;
	if(pUriObject.uriType=="item") {

		var vItem = pUriObject.getItem();
		try{
			var vPack = packMgr.getPack(vItem.documentElement.getAttribute("pack"));
			vIcon = ut.getUrlIcon(vPack.getIcon(vItem.documentElement.getAttribute("model"), pUriObject.getUriResSlash()), vItem.documentElement.firstChild.getAttribute("status"));
		}catch(e){}
	}
	pTab.setAttribute("image", vIcon || "");
	pTab.setAttribute("label", ut.getLeafFromUri(pUriObject.getUri()));
	var vCdWsp = ut.getWspFromUri(pUriObject.getUri());
	pTab.setAttribute("desc", vCdWsp + (vCdWsp!=pUriObject.getUri() ? " - " + ut.getItemPathFromUri(pUriObject.getUri()) : ""));
	pTab.removeAttribute("dirty");
}


desk.getWsp = function(pDataProvider, pCdWsp){
	if(this.fCurrentWsp && this.fCurrentWsp.getAttribute("wspCode") == pCdWsp && this.fCurrentWsp.fDataProvider==pDataProvider) return this.fCurrentWsp;
	var vWsp = this.fRootWsps.firstChild;
	while(vWsp) {
		if(vWsp.nodeType==1 && vWsp.getAttribute("wspCode") == pCdWsp && vWsp.fDataProvider==pDataProvider) return vWsp;
		vWsp = vWsp.nextSibling;
	}
	return null;
}


desk.addTab = function(pFocusTab){
try{
	var vNewTab = this.fMainViewTabs.appendItem("");

	vNewTab.setAttribute("crop", "right");
	vNewTab.setAttribute("flex", "1");
	var vNewMainView = this.fCurrentMainView.cloneNode(true);
	this.fMainViewPanels.appendChild(vNewMainView);


	if(pFocusTab) this.fMainViewTabs.selectedItem = vNewTab;
	return vNewMainView;
} catch(e){ut.debug("desk.addTab : "+e);}
}

desk.onSelectTab = function(){
	if( ! this.fIsInit) return;

	this.fCurrentMainView = this.fMainViewPanels.selectedPanel;
	var vUriObject = this.fCurrentMainView.fUriObject;
	if(vUriObject){
		var vDataProvider = vUriObject.getDataProvider();
		var vUri = vUriObject.getUri();
		this.addToHisto(vDataProvider, vUri);	
		var vCdWsp = ut.getWspFromUri(vUri);

		if(vUriObject._deskWspUriUpdated){

			var vEvent = vUriObject._deskWspUriUpdated;
			while(vEvent) {
				if( (vEvent.fEventType == Components.interfaces.scIUriListener.EVENT_TYPE_UPDT || 
					vEvent.fEventType == Components.interfaces.scIUriListener.EVENT_TYPE_REMOVE ) &&
					vEvent.fUri == vUri
					) {

					if(desk.canUnloadCurrentView(true) || ut.confirm("Cet item a été modifié par ailleurs, nous vous conseillons de récupérer cette nouvelle version.", "Modification concurrente", "Perdre mes modifs et recharger", "Préserver mes modifs")) {

						desk.activateUriObject(ut.createUriObjectByUri(vDataProvider, vUri));
						break;
					}
				} else {

					vUriObject.handleUriUpdate(vDataProvider, vCdWsp, vEvent.fUri, vEvent.fEventType, vEvent.fAuthor);
				}
				vEvent = vEvent.fNext;
			}
			delete vUriObject._deskWspUriUpdated;
		}
		var vWsp = this.getWsp(vDataProvider, vCdWsp);
		if(vWsp != null){
			this.selWsp(vWsp);
			vWsp.fWspView.selectUri(vUri);
			if(this.fItemnetMgrDesc && this.fItemnetMgrDesc.fDataProvider == vWsp.fDataProvider) this.fItemNetTree.selectUri(vUri);
			if(vWsp.fDataProvider == this.fOutlineView.fDataProvider) this.fOutlineView.selectUri(vUri);
		}
	}
}

desk.onCloseTab = function(pSilentMode){
	try{
		if( ! this.fMainViewTabs.firstChild.nextSibling) {

			if(this.canUnloadCurrentView(pSilentMode)){

				this.fCurrentMainView.contentWindow.canUnload = function(pSilentMode){return true;}
				if(desk.fCurrentWsp) {

					this.clickWsp(this.fCurrentWsp);

				} else {

					this.loadUriObjectByUri(null, null, ";replace;");
				}
			}
			return false;
		}
		if(this.canUnloadCurrentView(pSilentMode)){
			var vPanel = this.fMainViewPanels.selectedPanel;
			var vTab = this.fMainViewTabs.selectedItem;
			var vTabIdx = this.fMainViewTabs.selectedIndex;
			var vNextIdx = vTab.nextSibling ? vTabIdx : vTabIdx-1;

			vTab._selected = false;
			this.fMainViewPanels.removeChild(vPanel);
			this.fMainViewTabs.removeItemAt(vTabIdx);
			this.fMainViewTabs.selectedIndex = vNextIdx;
			return true;
		}
		return false;
	}catch(e){
		ut.debug("desk.onCloseTab : " + e);
		return false;
	}
}

desk.getTabIdxWithUri = function(pUri, pDataProvider){
	var vMainView = this.fMainViewPanels.firstChild;
	var vIdx = 0;
	while(vMainView){
		if(vMainView.fUriObject && vMainView.fUriObject.getUri() == pUri){
			if(pDataProvider){
				if(pDataProvider.getWspServer().getId() == vMainView.fUriObject.getDataProvider().getWspServer().getId()) return vIdx;
			}else{
				return vIdx;
			}
		} 
		vMainView = vMainView.nextSibling;
		vIdx++;
	}
	return -1;
}

desk.removeTabOfWsp = function(pServerId, pCdWsp){
	try{
		var vMainView = this.fMainViewPanels.firstChild;
		while(vMainView){
			var vNext = vMainView.nextSibling;
			if(vMainView.fUriObject && vMainView.fUriObject.getDataProvider().getWspServer().getId() == pServerId){
				var vUri = vMainView.fUriObject.getUri();
				var vCdWsp = ut.getWspFromUri(vUri);
				if(vCdWsp == pCdWsp) {

					document.getElementById("oMainViews").selectedPanel = vMainView;
					this.onCloseTab(true);
				}
			}
			vMainView = vNext;
		}
	} catch(e){
		ut.debug("deskwsp.js > removeTabOfWsp : " + e);
		return false;
	}
}

desk.onCloseRightPanel = function(){
	this.fItemNetTree.reset();
	this.xResetRightPanel();
	this.fRightPanel.collapsed = true;
	document.getElementById("oSplitterRightPanel").collapsed = true;
}
desk.onRefreshRightPanel = function(){
	if(this.fItemnetMgrDesc) this.fItemnetMgrDesc.refreshAll();
	if(this.fItemnetMgrAsc) this.fItemnetMgrAsc.refreshAll();
	this.fOutlineView.refreshAll(this.fOutlineView.fDataProvider == vCurrUri.fDataProvider ? vCurrUri.getUri() : null);
}

desk.onCloseBottomPanel = function(){
	this.xResetBottomPanel();
	document.getElementById("oBottomPanel").collapsed = true;
	document.getElementById("oSplitterBottomPanel").collapsed = true;
}
desk.openSearchPanel = function(pFromUriObject){
	document.getElementById("oBottomPanel").collapsed = false;
	document.getElementById("oSplitterBottomPanel").collapsed = false;
	search.initSearchPanel(pFromUriObject || desk.getCurrentUriObject());
}
desk.toggleSearchPanel = function(pFromUriObject){
	if(document.getElementById("oBottomPanel").collapsed) {
		this.openSearchPanel();
	} else {
		search.closeSearchPanel();
	}
}



desk.handleUriUpdate = function(pDataProvider, pWspCd, pUri, pEventType, pAuthor){
	var vMainView = this.fMainViewPanels.firstChild;
	while(vMainView){

		try {
			if(vMainView.fUriObject && vMainView.fUriObject.getDataProvider() == pDataProvider && (!pAuthor || vMainView.fUriObject.getIdAuthor() != pAuthor)){

				if(vMainView == this.fCurrentMainView){

					if( pEventType != Components.interfaces.scIUriListener.EVENT_TYPE_STATUS &&
						pUri == vMainView.fUriObject.getUri()
						) {

						if(desk.canUnloadCurrentView(true)) {


							window.setTimeout(function(){
								desk.activateUriObject(ut.createUriObjectByUri(pDataProvider, pUri));
							}, 0);
						} else {
							function asynchAsk(pMainView){
								if( ! ut.confirm("Cet item a été modifié par ailleurs, nous vous conseillons de récupérer cette nouvelle version.", "Modification concurrente", "Perdre mes modifs et recharger", "Enregistrer mes modifications dans un item en conflit")) {

									try {
										var vNewUriObject = pMainView.fUriObject.createUriObjectItemForConflict();
										desk.requestForCurrentView({request:"saveAs", newUriObject:vNewUriObject});
									} catch(e) {
										ut.alert("L\'enregistrement de l\'item en conflit a échoué, vous devrez resaisir vos dernières modifications.", "Echec à l\'enregistrement de l\'item en conflit");
										ut.debug(e);
									}
								}

								try{
									window.setTimeout(function(){
										desk.activateUriObject(ut.createUriObjectByUri(pDataProvider, pMainView.fUriObject.getUri()));
									}, 0);
								}catch(e){
									ut.debug(e);
								}
								delete pMainView.fConcurrentQPending;
							}
							if(!vMainView.fConcurrentQPending) {
								vMainView.fConcurrentQPending = true;
								setTimeout(asynchAsk, 0, vMainView);//Appel asynchrone pour ne pas bloquer une connection en cours.
							}
						}
					} else {
						vMainView.fUriObject.handleUriUpdate(pDataProvider, pWspCd, pUri, pEventType, pAuthor);
					}
				} else {

					if(pEventType != Components.interfaces.scIUriListener.EVENT_TYPE_STATUS &&
						pUri == vMainView.fUriObject.getUri()
						) {

						vMainView.fUriObject._deskWspUriUpdated = {
							fUri : pUri,
							fEventType : pEventType,
							fAuthor : pAuthor,
							fMain : true
						}
					} else if(vMainView.fUriObject.isUriUpdateHandled(pUri, pAuthor)) {

						if( ! vMainView.fUriObject._deskWspUriUpdated || ! vMainView.fUriObject._deskWspUriUpdated.fMain) {

							vMainView.fUriObject._deskWspUriUpdated = {
								fUri : pUri,
								fEventType : pEventType,
								fAuthor : pAuthor,
								fNext : vMainView.fUriObject._deskWspUriUpdated
							}
						}
					}
				}
			}
		} catch(e){ut.debug("desk.handleUriUpdate failed for mainView:"+vMainView.fUriObject+"\n"+e)}
		vMainView = vMainView.nextSibling;
	}
	var vWsp = this.getWsp(pDataProvider, pWspCd);

	if(vWsp && vWsp.fWspView) vWsp.fWspView.refreshUri(pUri, pAuthor);
}


desk.handleWspRegUpdated = function(pTypeEvent, pIdServer, pWsp){

try {
	var vIsComplete = true;
	if(pWsp != null) {

		if(pTypeEvent == "create") {
			if(pWsp.isActive()) {

				this.xAddWsp(pWsp);
			}
		} else {

			var vWspNode = this.fRootWsps.firstChild;
			while(vWspNode) {
				if(pWsp == vWspNode.fWspRegistered) break;
				vWspNode = vWspNode.nextSibling;
			}
			if(pTypeEvent == "update" || pTypeEvent == "focus") {
				if(pWsp.isActive()) {
					if(vWspNode) {

						if( ! pWsp.getDataProvider().isLocal()) {
							vWspNode.setAttribute("serverTitle", pWsp.getTitleServer());
						}
						vWspNode.setAttribute("wspComment", pWsp.getComment());
						vWspNode.reload();

						var vWspTabId = this.getTabIdxWithUri(vWspNode.getAttribute("wspCode"), pWsp.getDataProvider());
						if(vWspTabId>=0){
							this.fMainViewTabs.selectedIndex = vWspTabId;
							this.activateUriObject(new UriObjectWsp(vWspNode.getAttribute("wspCode"), vWspNode.fDataProvider));
						}
						if(pTypeEvent == "focus") this.selWsp(vWspNode);
					} else {


						this.xAddWsp(pWsp);
					}
				} else {

					if(vWspNode) this.xRemoveWsp(vWspNode);
				}
			} else if(pTypeEvent == "remove") {
				if(vWspNode) this.xRemoveWsp(vWspNode);
			} else if(pTypeEvent == "unload") {
				if(vWspNode) vIsComplete = this.saveAllViews(pWsp.getCode());

				if(vIsComplete) this.removeTabOfWsp(pWsp.getServer().getId(), pWsp.getCode());
			}
		} 
	} else {//on est sur un serveur
		if(pTypeEvent == "update") {

			var vWspNode = this.fRootWsps.firstChild;
			while(vWspNode) {
				if(vWspNode.fWspRegistered.getIdServer() == pIdServer) {
					if( ! vWspNode.fWspRegistered.getDataProvider().isLocal()) {
						vWspNode.setAttribute("serverTitle", vWspNode.fWspRegistered.getTitleServer());
					}


					vWspNode.reload();
				}
				vWspNode = vWspNode.nextSibling;
			}
		} else if(pTypeEvent == "remove") {

			var vWspNode = this.fRootWsps.firstChild;
			var vWspListToRemove = [];
			while(vWspNode) {
				if(vWspNode.fWspRegistered.getIdServer() == pIdServer) {
					vWspListToRemove.push(vWspNode);
				}
				vWspNode = vWspNode.nextSibling;
			}
			for(var ii=0;ii<vWspListToRemove.length;ii++){
				this.xRemoveWsp(vWspListToRemove[ii]);
			}
		} else if(pTypeEvent == "unload") {
			var vWspNode = this.fRootWsps.firstChild;
			while(vWspNode) {
				if(vWspNode.fWspRegistered.getIdServer() == pIdServer) {
					var vCurrentWspIsUnloaded = this.saveAllViews(vWspNode.getAttribute("wspCode"));
					if(!vCurrentWspIsUnloaded){
						vIsComplete = false;
						break;
					}else{

						this.removeTabOfWsp(vWspNode.fWspRegistered.getServer().getId(), vWspNode.getAttribute("wspCode"));
					}
				}
				vWspNode = vWspNode.nextSibling;
			}
		}
	}
	return vIsComplete;
	} catch(e){
		ut.debug("deskwsp.js > handleWspRegUpdated : " + e);
		return false;
	}
}

desk.prepareActionCtx = function(pMenu){
	ut.setContextActions(pMenu, this.fCurrentWsp.fWspView.fDataProvider, this.getCurrentUriObject().getUri(), this.getCurrentUriObject());
}

desk.canCloseDesk = function(pSilentMode){
try {
	if(this.canUnloadCurrentView(pSilentMode)){

		var vPanel = this.fMainViewPanels.firstChild;
		var vCanUnload;

		var vCurrentMainView = this.fCurrentMainView;
		while(vPanel){
			if(vPanel != vCurrentMainView) {
				vCanUnload = true;
				try{vCanUnload = vPanel.contentWindow.canUnload(true);}catch(e){}
				if(!vCanUnload) {
					if( ! pSilentMode){

						var vIdx = 0;
						for(var vPrev = vPanel.previousSibling; vPrev; vPrev = vPrev.previousSibling){vIdx++;}
						this.fMainViewTabs.selectedIndex = vIdx;
						try{vCanUnload = vPanel.contentWindow.canUnload();}catch(e){}
					}
					if(!vCanUnload) return false;
				}
			}
			vPanel = vPanel.nextSibling;
		}
	} else {
		return false;
	}
	return true;
} catch(e){
	ut.debug("desk.canCloseDesk:::"+e, "Close failed");
	return false;
}
}

desk.QueryInterface = function(pIId){
	if (!pIId.equals(Components.interfaces.nsISupports) &&
		!pIId.equals(Components.interfaces.scIUriListener) &&
		!pIId.equals(Components.interfaces.scIWspRegListener))
		throw Components.results.NS_ERROR_NO_INTERFACE;
	return this;
}



desk.showItems = function(pItemList){
	try{
		var vHasShowItem = false;
		if(pItemList) {
			for each (var vUri in pItemList.split(";")) {
				var vIdx = vUri ? vUri.indexOf("|") : -1;
				if(vIdx<0) continue;
				var vIsSelected = (vUri[0]=="*");
				var vUrlServer = vUri.substring(vIdx+1);
				var vUriTab = vUri.substring( vIsSelected ? 1 : 0, vIdx);
				var vCdWsp = ut.getWspFromUri(vUriTab);

				var vWsp = desk.fRootWsps.firstChild;
				while(vWsp) {

					if(vWsp.nodeType==1 && vWsp.getAttribute("wspCode") == vCdWsp && vWsp.fDataProvider.getIniUrl() == vUrlServer) break;
					vWsp = vWsp.nextSibling;
				}
				if(vWsp) {

					desk.loadUriObjectByUri(vWsp.fDataProvider, vUriTab, !vHasShowItem ? "" : vIsSelected ? ";newtab;" : ";newtabBehind;");
					vHasShowItem = true;
				}
			}
		}
		return vHasShowItem;
	} catch(e){ut.debug(e);}
}


desk.xWsp_xInitWsps = function(){
try{
	desk.fWspRegistry = Components.classes["@scenari.com/wspregistryservice;1"].getService(Components.interfaces.scIWspRegistryService);
	desk.fWspRegistry.addWspRegListener(desk);

	var vWspList = desk.fWspRegistry.getEnabledWsps();
	var vLen = vWspList.Count();
	
	var vRootNode = desk.fRootWsps;
	while(vRootNode.hasChildNodes()) vRootNode.removeChild(vRootNode.lastChild);
	
	if(vLen==0) {

		desk.showWelcomeScreen(desk.fWspRegistry.getDisabledWsps().Count()==0);
		return;
	}
	
	var vWsps = [];
	for(var i = 0; i < vLen; i++) {
		vWsps.push(desk.xCreateWsp(vWspList.GetElementAt(i).QueryInterface(Components.interfaces.scIWsp)));
	}
	vWsps.sort(desk.xSortWsps);
	

	var vWspBlock = null;
	var vCdWspBlock = null;
	try { vCdWspBlock = ut.fPrefs.getCharPref("scenari.deskWsp.currentWsp"); }catch(e){}
	ut.fPrefs.setCharPref("scenari.deskWsp.currentWsp", "");
	for each(var vBlock in vWsps) {
		vRootNode.appendChild(vBlock);
		if(vBlock.getAttribute("wspCode") == vCdWspBlock) vWspBlock = vBlock;
	}
	desk.selWsp(vWspBlock);
	

	vCmdLinehandler = window.arguments[0].QueryInterface(Components.interfaces.nsICommandLine);
	var vListTabs = null;
	try { 
		vListTabs = ut.fPrefs.getCharPref("scenari.deskWsp.currentTabs");
		ut.fPrefs.setCharPref("scenari.deskWsp.currentTabs", "");//cleanup
	}catch(e){}
	if(vCmdLinehandler.findFlag("showItem", true)>-1) vListTabs+=vCmdLinehandler.handleFlagWithParam("showItem", true);
	

	window.setTimeout(function(){
		var vFirstTab = !desk.showItems(vListTabs);

		if(vFirstTab) {
			desk.activateUriObject((desk.fCurrentWsp) ? new UriObjectWsp(desk.fCurrentWsp.getAttribute("wspCode"), desk.fCurrentWsp.fDataProvider) : null);
		}
	}, 100);
	
} catch(e){ut.debug(e);}
}



function deskWspViewOnSelect(pXblView){
	if( ! pXblView || ! ("getUriObject" in pXblView) ) return;
	var vCurrentUriObject = desk.getCurrentUriObject();
	var vNewUriObject = pXblView.getUriObject();

	if(vNewUriObject && (!vCurrentUriObject || vNewUriObject.getUri()!=vCurrentUriObject.getUri())){

		var vIdx = desk.getTabIdxWithUri(vNewUriObject.getUri(), vNewUriObject.getDataProvider());

		if(vIdx>=0) {
			desk.fMainViewTabs.selectedIndex = vIdx;
			return;
		}
		if(pXblView.metaKeys == 1) {

			desk.addTab(true);
		} else if(pXblView.metaKeys == 4) {

			if( ! desk.canUnloadCurrentView()) return;
		} else {

			if( ! desk.canUnloadCurrentView(true)) desk.addTab(true);
		}
		desk.activateUriObject(vNewUriObject);
	}
}


function deskWspViewOnReloadItem(pEvent){
	var vWspView = pEvent.target.fWspView;
	if( ! ("getUriObject" in vWspView) ) return;
	var vCurrentUriObject = desk.getCurrentUriObject();
	var vNewUriObject = vWspView.getUriObject();
	if(vNewUriObject && vCurrentUriObject && vNewUriObject.getUri()==vCurrentUriObject.getUri()){
		if( ! desk.canUnloadCurrentView()) return;
		desk.activateUriObject(vNewUriObject);
	}
}