

function InstallMgr(){
	try{

		this.fInstallElt = document.getElementById("idBtnInstaller");
		this.fFieldPath = document.getElementById("idInstallPathInput");
		this.fRowsTraceXpi = document.getElementById("idInstallShowXpi");
		this.fRowsTraceJar = document.getElementById("idInstallShowJar");
		this.fElementToInstall = null;
		this.fListInstalls = [];
		this.fIsRebootNecessary = false;
		this.fPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
		this.fWspReg = Components.classes["@scenari.com/wspregistryservice;1"].getService(Components.interfaces.scIWspRegistryService);
		this.fSilentMode = false;
		this.fCanAskForReboot = true;
		this.fPackConfFileName = "installpack.xml";
		this.fFolderTmp = ut.fMozDirs.get("TmpD", Components.interfaces.nsIFile);
		this.fFolderTmp.append("scPk");

		this.fInstallProperties = new Object();
		this.fInstallProperties.xpi = new Object();
		this.fInstallProperties.xpi.canInstall = true;
		this.fInstallProperties.xpi.modeInstall = "forbidden";
		this.fInstallProperties.jar = new Object();
		this.fInstallProperties.jar.canInstall = true;
		this.fInstallProperties.server = null;//local|distant|null
		var winParam = window.arguments ? window.arguments[0] : null;
		if(winParam && winParam.wspServer){
			this.fInstallProperties.server 		 = "distant";
			this.fInstallProperties.wspServer 	 = winParam.wspServer;
			this.fInstallProperties.dataProvider = this.fInstallProperties.wspServer.getDataProvider();
			this.fInstallProperties.xpi.canInstall = null; //choix laissé à l'utilisateur si besoin
		}else if(wspUt._CanCreateServerLocal){
			this.fInstallProperties.server= "local";
			this.fInstallProperties.wspServer = this.fWspReg.addServer(this.fPrefs.getCharPref("scenari.urlServerLocal"), "", "", null);// si le serveur local n'a pas été créé, on le crée
			this.fInstallProperties.dataProvider = this.fInstallProperties.wspServer.getDataProvider();
		}
		if(!this.fInstallProperties.wspServer) this.fInstallProperties.jar.canInstall = false;
		this.fCheckVersion = (winParam && winParam.checkVersion==false) ? false : true;
		if(!this.fInstallProperties.server) this.fInstallProperties.jar.canInstall = false;
		try{this.fInstallProperties.xpi.modeInstall = this.fPrefs.getCharPref("scenari.install.xpi.mode")}catch(e){}
		if(this.fInstallProperties.xpi.modeInstall == "forbidden") this.fInstallProperties.xpi.canInstall = false;


		if(document.getElementById('idInstallJar')) document.getElementById('idInstallJar').collapsed = !this.fInstallProperties.jar.canInstall;
		if(document.getElementById('idInstallXpi')) document.getElementById('idInstallXpi').collapsed = (this.fInstallProperties.xpi.modeInstall == "forbidden");
		if(!this.fInstallProperties.xpi.canInstall && !this.fInstallProperties.jar.canInstall){

			document.getElementById('idInstallError').collapsed = false;
			document.getElementById('idInstallChoice').collapsed = true;
		}

		var vPackRegSvc = Components.classes["@scenari.com/packregistryservice;1"].getService(Components.interfaces.scIPackRegistryService);
		this.fIniOptionList = null;
		var vWspTypeOptionList = vPackRegSvc.getWspOptionUiList();
		if(vWspTypeOptionList){
			var vOptionList = "";
			for(var ii = 0; ii < vWspTypeOptionList.Count(); ii++) {
				var vWspOptionUi = vWspTypeOptionList.GetElementAt(ii).QueryInterface(Components.interfaces.scIWspOptionUi);
				vOptionList += (vWspOptionUi.getUri() + ";");
			}
			this.fIniOptionList = vOptionList;
		}
	}catch(e){
		ut.debug("installMgr > initialisation : "+e);
	}
}


 InstallMgr.prototype.setSilentMode = function(pStatus){
 	this.fSilentMode = pStatus;
}


  InstallMgr.prototype.createLogFile = function(pStatus){
 	try{
		if(pStatus) {
			function fWriteTrace(pMessage){
				var vCharset = "UTF-8";
				var vOs = Components.classes["@mozilla.org/intl/converter-output-stream;1"].createInstance(Components.interfaces.nsIConverterOutputStream);
				var vInstallLog = ut.fMozDirs.get("ProfD", Components.interfaces.nsIFile);
				vInstallLog.append("scInstall.log"); 
				var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
				foStream.init(vInstallLog, 0x02 | 0x08 | 0x10, 0664, 0);
				vOs.init(foStream, vCharset, 0, 0x0000);
				vOs.writeString(pMessage, pMessage.length);
				vOs.close();
			}
			ut.debug = function(pText){fWriteTrace(pText+"\n");};
		}
	}catch(e){
		alert("installmgr.js:InstallMgr.prototype.createLogFile" + e);
		ut.debug("installmgr.js:InstallMgr.prototype.createLogFile : " + e);
	}
}
 

InstallMgr.prototype.setInstallAvailable = function(pStatus){
	if(this.fInstallElt) this.fInstallElt.disabled = ! pStatus;
	if(!pStatus) {
		this.fFieldPath ? this.fFieldPath.value = "" : null;

	}
}


InstallMgr.prototype.selectElementToInstall = function(){
	var nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	fp.init(window, "Sélectionnez un pack à installer", nsIFilePicker.modeOpen);
	var vExtPack = this.getExtensionPack();

	fp.appendFilter(ut.formatStr("Pack (*.%s)", vExtPack), "*."+vExtPack);

	var res = fp.show();
	if (res == nsIFilePicker.returnOK){
		this.setInstallAvailable(true);
		this.fElementToInstall = fp.file;
		this.fFieldPath ? this.fFieldPath.value = fp.file.path : null;
	}	
}


InstallMgr.prototype.setInstallPending = function(pInstallActive){
	this.fInstallPending = pInstallActive;
	if(this.fInstallElt){
		if(pInstallActive) {
			this.fInstallElt.setAttribute("install", "true");
		} else {
			this.fInstallElt.removeAttribute("install");
		}
	}
}
InstallMgr.prototype.refreshInstallPending = function(){
	var vIsInstallPending = false;
	var vIsInstallInError = false;
	for(var vPackage in this.fListInstalls){
		if(this.fListInstalls[vPackage]=="stInstallPending") vIsInstallPending=true;
		if(this.fListInstalls[vPackage]=="stInstallSuccessReboot") this.fIsRebootNecessary=true;
		if(this.fListInstalls[vPackage]=="stInstallError") vIsInstallInError=true;
	}
	this.setInstallPending(vIsInstallPending);
	if(!vIsInstallPending){
		this.fInstallInError = vIsInstallInError;
	}

	if(!vIsInstallPending){

		if(this.fFolderTmp && this.fFolderTmp.exists()) try {this.fFolderTmp.remove(true);}catch(e){}

		if(this.fInstallProperties.wspServer && !this.fIsRebootNecessary) this.fWspReg.fireUpdateEvent(this.fInstallProperties.wspServer.getId(), null);

		if(this.fAskForReboot && this.fIsRebootNecessary){// installation terminée
			ut.fPrefs.setCharPref("scenari.deskWsp.lastOptionListInstalled", this.fIniOptionList);
			this.fAskForReboot = false;
			if(this.fSilentMode || ut.confirm("Les installations seront prises en compte après redémarrage de l\'application. Voulez-vous redémarrer l\'application maintenant ?", null, "oui", "non")){
				var vDesk = window.opener.desk ? window.opener.desk : window.opener.parent.desk;
				if(!vDesk || vDesk.canCloseDesk(this.fSilentMode)){
					if(ut.isUnix) window.setTimeout("ut.appRestart(true, true);window.close();", 500, "");// NOTE : obligé de fermer en mode forcé car fenetre modale (pb Gecko1.9)
					else ut.appRestart(true, true);
				}
			}
		}
	}
}



InstallMgr.prototype.doInstall = function(pFileToInstall, pType){
	var vPackRegSvc         = Components.classes["@scenari.com/packregistryservice;1"].getService(Components.interfaces.scIPackRegistryService);
	var vInfoZone = document.getElementById('idInfo');
	vInfoZone ? vInfoZone.value="" : null;
	try{
		if(pFileToInstall){
			this.fAskForReboot = this.fCanAskForReboot;
			this.setInstallPending(true);
			var vExtPack = this.getExtensionPack();
			var vExtId = this.xGetComponentId(pFileToInstall, pType);
			if(pType == "pack"){

				var vPackTmpDir = this.fFolderTmp.clone();
				vPackTmpDir.append(pFileToInstall.leafName);
				if(vPackTmpDir.exists()) {vPackTmpDir.remove('true')};
				vPackTmpDir.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0777); 

				var vZipFile = pFileToInstall;
				var vZipReader = Components.classes["@mozilla.org/libjar/zip-reader;1"].createInstance(Components.interfaces.nsIZipReader);
				vZipReader.open(vZipFile);
				var vEntries = vZipReader.findEntries("*");
				while (vEntries.hasMore()) {
					var vFileName = vEntries.getNext();
					var vCurrentFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
					vCurrentFile.initWithPath(vPackTmpDir.path);
					vCurrentFile.append(vFileName);
					if(!vCurrentFile.exists()) {
						vZipReader.extract(vFileName, vCurrentFile);
					}
				}
				vZipReader.close();

				if(!this.xCheckPackCompatibility(vPackTmpDir)) {this.setInstallPending(false);return;}

				var vConfigDom = this.xGetInstallDomFile(vPackTmpDir);
				if(vConfigDom){
					var vValidComponentsList = {};
					var vUnvalidComponentsList = {};
					var vUnvalidBeanList = {"_length":0,"_names":""};
					var vBeanElt = vConfigDom.firstChild;
					if(vBeanElt.localName=="packdesc") vBeanElt = vBeanElt.firstElementChild
					while(vBeanElt) {
						if(vBeanElt.localName=="installBean"){

							var vIsValide = true; 
							
							/*
							if(vBeanElt.hasAttribute('regExpDependsOn')){
								var vInstalledPackList = this.xGetPacksIdList();
								var vRegExp = vBeanElt.getAttribute('regExpDependsOn'); 
								for(var vInstalledPackId in vInstalledPackList){
									if(vInstalledPackId.match(vRegExp)){
										vIsValide = true;
										break;
									}else{
										vIsValide = false;
									}
								}
							}else if(vBeanElt.hasAttribute('dependsOn')){
								var vInstalledPackList = this.xGetPacksIdList();
								if(!(vBeanElt.getAttribute('dependsOn') in vInstalledPackList)) vIsValide=false;
							}
							if(!vIsValide) {
								vUnvalidBeanList[vBeanElt.getAttribute('code')] = vBeanElt.getAttribute('dependsOnName');
								vUnvalidBeanList._names = vUnvalidBeanList._names ? ", "+vBeanElt.getAttribute('dependsOnName') : vBeanElt.getAttribute('dependsOnName');
								vUnvalidBeanList._length!=null ? vUnvalidBeanList._length++ : vUnvalidBeanList._length = 1;
							}
							*/
							var vComponentElt = vBeanElt.firstElementChild;
							while(vComponentElt) {
								switch (vComponentElt.localName) {
									case "component": 
										var vComponentFile = vPackTmpDir.clone();
										vComponentFile.append(vComponentElt.getAttribute('path'));
										var vComponantType = vComponentElt.getAttribute('type');
										var vComponantId = this.xGetComponentId(vComponentFile, vComponantType);
										var vComponantName = vComponentElt.hasAttribute('name') ?  vComponentElt.getAttribute('name') : vComponantId;
										this.xShowInstall(vComponantId, "stInstallPending", null, vComponantType, vComponantName);
										if(vIsValide) vValidComponentsList[vComponantId] = vComponentElt;
											else vUnvalidComponentsList[vComponantId] = vComponentElt;
										break;
									case "dependencies": 
										var vWspElt = vComponentElt.firstElementChild;
										while(vWspElt) {
											var vWspKey = vWspElt.getAttribute('key');
											var vWspName = vWspElt.hasAttribute('name') ? vWspElt.getAttribute('name') : vWspElt.getAttribute('key');
											var vMandatDependencyTypes = {'require':'', 'applyOn':''};
											if(vWspElt.nodeName=='wspType' || (vWspElt.nodeName=='wspOption' && vWspElt.getAttribute('dependency') in vMandatDependencyTypes)){
												var vWspUi = vPackRegSvc.findWspUi(vWspKey, vWspElt.getAttribute('lang'));
												if(!vWspUi){

													var vDependsBean = ut.selectSingleNode(vConfigDom, "packdesc/installBean[@key='"+vWspKey+"']");
													if(!vDependsBean){
														vUnvalidBeanList._names += vUnvalidBeanList._names!="" ? ", "+vWspName : vWspName;
														vUnvalidBeanList._length!=null ? vUnvalidBeanList._length++ : vUnvalidBeanList._length = 1;
														vIsValide = false;
													}
												}
											}
											vWspElt = vWspElt.nextElementSibling;
										}
										break;
									default:
										break;
								}
								vComponentElt = vComponentElt.nextElementSibling;
							}
						}
						vBeanElt = vBeanElt.nextElementSibling;
					}
					var vInstallUnvalidBeans = {"value":true};
					if(vUnvalidBeanList._length==0 || this.fSilentMode || ut.confirm(ut.formatStr("Certains packages (%s) sont manquants pour rendre opérationnelle cette installation.\nVoulez-vous poursuivre néanmoins l\'installation ?", vUnvalidBeanList._names), null, null, null, "Installer également les packages non opérationnels ?", vInstallUnvalidBeans) ){
						if(vInstallUnvalidBeans.value){
							for(var vComponantId in vUnvalidComponentsList){
								var vComponentFile = vPackTmpDir.clone();
								vComponentFile.append(vUnvalidComponentsList[vComponantId].getAttribute('path'));
								this.doInstall(vComponentFile, vUnvalidComponentsList[vComponantId].getAttribute('type'));
							}
						}
						for(var vComponantId in vValidComponentsList){
							var vComponentFile = vPackTmpDir.clone();
							vComponentFile.append(vValidComponentsList[vComponantId].getAttribute('path'));
							this.doInstall(vComponentFile, vValidComponentsList[vComponantId].getAttribute('type'));
						}
					}else{// cloture de tts les packages en cours d'installation
						for(var vComponantId in vUnvalidComponentsList) this.xShowInstall(vComponantId, "stInstallWarning", null, vComponantType, vComponantName);
						for(var vComponantId in vValidComponentsList) this.xShowInstall(vComponantId, "stInstallWarning", null, vComponantType, vComponantName);
					}
					this.setInstallAvailable(false);
				}else{
					this.setInstallAvailable(false);
				}
			}else if(pType == "local"){

				if(this.fInstallProperties.server == "distant" && this.fInstallProperties.xpi.canInstall == null){
					this.fInstallProperties.xpi.canInstall = ut.confirm("Voulez-vous installer également la couche graphique cliente ?", null, "oui", "non");
				}
				var gExtensionManager = Components.classes["@mozilla.org/extensions/manager;1"].getService(Components.interfaces.nsIExtensionManager);
				this.xShowInstall(vExtId, "stInstallPending", null, "local");
				if(this.fInstallProperties.xpi.canInstall){
					this.fIsRebootNecessary = true;

					var vBeanFile = pFileToInstall;
					var vZipReader = Components.classes["@mozilla.org/libjar/zip-reader;1"].createInstance(Components.interfaces.nsIZipReader);
					vZipReader.open(vBeanFile);
					var vEntries = vZipReader.findEntries("*");
					var vXpiFile = vBeanFile.parent.clone();
					vXpiFile.append(vExtId+".xpi");
					while (vEntries.hasMore()) {
						var vFileName = vEntries.getNext();
						if(vFileName.substr(vFileName.length - 4, 4) == ".xpi"){
						   if(!vXpiFile.exists()) vZipReader.extract(vFileName, vXpiFile);
						   break;
						}
					}
					vZipReader.close();


					if(this.fInstallProperties.xpi.modeInstall == 'inProfile'){
						gExtensionManager.installItemFromFile(vXpiFile, "app-profile");
					}else{//inApplication
						gExtensionManager.installItemFromFile(vXpiFile, "app-global");
					}
					this.xShowInstall(vExtId, "stInstallSuccessReboot", null, "local");

				}else{
					this.xShowInstall(vExtId, "stInstallWarning", "Extension non installée", "local");
				}
				this.setInstallAvailable(false);
			}else if(pType == "server"){
				var vPath = pFileToInstall.path;
				var vLeafName = pFileToInstall.leafName;
				this.xShowInstall(vExtId, "stInstallPending", null, "server");
				if(this.fInstallProperties.dataProvider && this.fInstallProperties.jar.canInstall){// on installe sur un serveur local ou sur un serveur distant pour lequel on possède les droits d'admin
					var vCounter = 0;
					var vInstallMgr = this;
					var cb = function (pEvent){
						if(pEvent.target.status == 500) {
							vInstallMgr.xShowInstall(vExtId, "stInstallError", null, "server");
						} else {
							vInstallMgr.xShowInstall(vExtId, "stInstallSuccess", null, "server");
						}
						vInstallMgr.refreshInstallPending();
						if(vInstallMgr.fElementToInstall && vPath == vInstallMgr.fElementToInstall.path) {

							vInstallMgr.setInstallAvailable(false);
						}

					}
					var cbErr = function (){
						if(vCounter < 10){
							ut.debug("Serveur local non ready; tentative n°"+vCounter);
							vCounter++;
							window.setTimeout(vInstallMgr.fInstallProperties.dataProvider.loadFromService, 1500, "/u/adminWsp?cdaction=InstallRes&param="+encodeURIComponent(vPath), cb, cbErr); 
						}else{
							ut.debug("Accès au serveur impossible.");
							if(!this.fSilentMode) ut.alert("L\'accès au serveur local de l\'application a échoué. Relancez l\'application.", "Echec");
							vInstallMgr.xShowInstall(vExtId, "stInstallError", null, "server");
							vInstallMgr.refreshInstallPending();
						}
					}
					if(this.fInstallProperties.dataProvider.isLocal()){//un install depuis le path local
						try{
							this.fInstallProperties.dataProvider.loadFromService("/u/adminWsp?cdaction=InstallRes&param="+encodeURIComponent(vPath), cb, cbErr);
						}catch(e){
							ut.debug("installMgr > InstallMgr.prototype.doInstall (jar) > local : " +e );
						}
					}else{// serveur distant => on y envoit un stream
						try{
							var vUrlServ = this.fInstallProperties.dataProvider.getServiceUrl("/u/adminWsp?cdaction=InstallRes&scWspResp=no");
							var vUploadFile = new UploadFile();
							var vInstallMgr = this;
							function cb(pSeverity, pCode){

								if(pSeverity<=1){//install OK. TODO : normalement, le code OK est 0... A voir
									vInstallMgr.xShowInstall(vExtId, "stInstallSuccess", null, "server");

								}else{//echec
									vInstallMgr.xShowInstall(vExtId, "stInstallError", null, "server");
								}
								vInstallMgr.refreshInstallPending();
							}
							vUploadFile.uploadAsynchFile(pFileToInstall, vUrlServ , cb);
						}catch(e){
							ut.debug("installMgr > InstallMgr.prototype.doInstall (jar) > distant : " + e);
						}
					}
				}else{
					this.xShowInstall(vExtId, "stInstallWarning", "Extension non autorisée");
				}
			}else{
				this.xShowInstall(vExtId, "stInstallError", "Extension non valide");
			}
		}else{
			throw("Aucun élément à installer.");
		}
	}catch(e){
		this.xShowInstall(this.xGetComponentId(pFileToInstall, pType), "stInstallError", "Erreur d\'installation");
		if(!this.fSilentMode) ut.alert(ut.formatStr("L\'installation de l\'extension %s est impossible.", (vLeafName ? vLeafName : "")));
		ut.debug("installmgr.js:InstallMgr.prototype.doInstall: "+ vLeafName + "; "+ e);
	}finally{
		this.setInstallAvailable(false);
		this.refreshInstallPending();
	}
}


InstallMgr.prototype.getExtensionPack = function(){
	try {
		return this.fPrefs.getCharPref("scenari.installpack.extension")
	}catch(e){
		return "wsppack";
	}
}

InstallMgr.prototype.getFileFromPath = function(pPath){
	try{
		var vFile = Components.classes["@mozilla.org/file/local;1"].getService(Components.interfaces.nsILocalFile);
		vFile.initWithPath(pPath);
		if(vFile.exists()){
			return vFile;
		}else{
			var vMess = ut.formatStr("L\'extension \'%s\' n\'existe pas.", pPath);
			if(!this.fSilentMode) ut.alert(vMess);
			throw vMess;
		}
	}catch(e){
		ut.debug("installmgr.js:InstallMgr.prototype.getFileFromPath: "+ pPath + "; "+ e);
		return null;
	}
}


InstallMgr.prototype.xCheckPackCompatibility = function(pPackDir){
	try{
		if(!this.fCheckVersion) return true;//permet de désactiver cette vérification en mode client/serveur : pas moyen de récupérer la version du scServer => l'administrateur gère
		var vInstallDom = this.xGetInstallDomFile(pPackDir);
		if(vInstallDom){
			var vPackName 			= ut.selectSingleNode(vInstallDom, '//name/text()') ? ut.selectSingleNode(vInstallDom, '//name/text()').nodeValue : "pack";
			var vScMinVersion 		= ut.selectSingleNode(vInstallDom, '//minVersion/text()') ? ut.selectSingleNode(vInstallDom, '//minVersion/text()').nodeValue : null;
			var vScMaxVersion 		= ut.selectSingleNode(vInstallDom, '//maxVersion/text()') ? ut.selectSingleNode(vInstallDom, '//maxVersion/text()').nodeValue : null;
			if(vScMinVersion && vScMaxVersion){
				var vInfo = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULAppInfo);
				var vVersionComparator = Components.classes["@mozilla.org/xpcom/version-comparator;1"].getService(Components.interfaces.nsIVersionComparator);
				var vCurrentAppVersion = vInfo.version;// NOTE : supprimer recherche via "vInfo.version" en 3.8; passer exclusivement par la pref
				try{vCurrentAppVersion = this.fPrefs.getCharPref("scenari.core.version")}catch(e){};

				if(!(vVersionComparator.compare(vCurrentAppVersion, vScMinVersion)>=0 && vVersionComparator.compare(vCurrentAppVersion, vScMaxVersion)<=0)){
					var vBrandShortName = ut.sbBrand.GetStringFromName('brandShortName');
					var vTxt = "Ce pack est incompatible avec cette version de l\'application.\nVeuillez vous en procurer une version plus récente.";
					if(!this.fSilentMode) ut.alert(vTxt);
					ut.debug(vTxt);
					return false;
				}
				return true;
			}else{// si pas de minVersion ni de maxVersion spécifiée, alors on installe qd meme le pack
				return true;
			}
		}
		return false;
	}catch(e){
		ut.debug("installmgr.js : InstallMgr.prototype.xCheckPackCompatibility (" + (vInstallFile ? vInstallFile.path : "No InstalFile") + ") : " + e);
		if(!this.fSilentMode) ut.alert(ut.formatStr("Ce fichier ne peut pas être installé dans %s.\nVeuillez vérifier sa provenance et/ou son intégrité.", ut.sbBrand.GetStringFromName('brandShortName')));
		return false;
	}
}
 
 /**
  * Vérifie la compatibilité du pack avec l'application
  */
 InstallMgr.prototype._packsConfigsFile = [];
 InstallMgr.prototype.xGetInstallDomFile = function(pPackDir){
 	try{
 		if(pPackDir.path in this._packsConfigsFile) return this._packsConfigsFile[pPackDir.path];
 		else{
	 		var vInstallFile = pPackDir.clone();
	 		vInstallFile.append(this.fPackConfFileName);
	 		if(vInstallFile.exists()){
	 			var vInstallDom = ut.getDomFromLocalFileUrl("file://"+vInstallFile.path);
	 			if(vInstallDom && vInstallDom.documentElement){
	 				this._packsConfigsFile[pPackDir.path] = vInstallDom;
	 				return vInstallDom;
	 			}else{
	 				ut.debug("Le fichier d'installation n'est pas XML valide : " + vInstallFile.path);
	 				if(!this.fSilentMode) ut.alert(ut.formatStr("Ce fichier semble être incomplet. Son installation dans %s est impossible.", ut.sbBrand.GetStringFromName('brandShortName')));
	 			}
	 		}else{// pas de fichier de configuration
	 			ut.debug("Le pack ne possède pas de fichier d'installation.");
	 			if(!this.fSilentMode) ut.alert(ut.formatStr("Ce fichier n\'est pas un pack valide pour %s.", ut.sbBrand.GetStringFromName('brandShortName')));
	 		}
 		}
 	}catch(e){
 		ut.debug("installmgr.js : InstallMgr.prototype.xGetInstallDomFile (" + (vInstallFile ? vInstallFile.path : "No InstalFile") + ") : " + e);
 		if(!this.fSilentMode) ut.alert(ut.formatStr("Ce fichier ne peut pas être installé dans %s.\nVeuillez vérifier sa provenance et/ou son intégrité.", ut.sbBrand.GetStringFromName('brandShortName')));
 	}
 }


InstallMgr.prototype.xCheckJarCompatibility = function(pJarPath){
	try{
		return true;
	}catch(e){
		ut.debug("installmgr.js:InstallMgr.prototype.xCheckJarCompatibility : " + e);
		return true;
	}
}


InstallMgr.prototype.xCheckXpiCompatibility = function(pXpiPath){
	try{
		return true;
	}catch(e){
		ut.debug("installmgr.js:InstallMgr.prototype.xCheckXpiCompatibility : " + e);
		return true;
	}
}

 /**
  * Retourne un id en fonction du nsiFile passé
  */
 InstallMgr.prototype.xGetComponentId = function(pFile, pType){
	try{
		return pFile ? (pFile.leafName + '-' + pType) : null;
 	}catch(e){
		ut.debug("installmgr.js:InstallMgr.prototype.xGetComponentId : " + e);
	}
 }
  
  
  /**
   * Retourne la liste des packs installés localement
   */
  InstallMgr.prototype.xGetPacksIdList = function(){
 	try{
 		var vPackRegSvc  = Components.classes["@scenari.com/packregistryservice;1"].getService(Components.interfaces.scIPackRegistryService);
		var vWspTypeList = vPackRegSvc.getWspTypeList();
		var vPacksIdList = {};
		for(var ii = 0; ii<vWspTypeList.Count(); ii++){
			var vWspUriAtt = ut.selectSingleNode(vWspTypeList.GetElementAt(ii).QueryInterface(Components.interfaces.nsIDOMElement), '/pack/wspType/@uri');
			if(vWspUriAtt) vPacksIdList[vWspUriAtt.nodeValue]="";
		}
		return vPacksIdList;
  	}catch(e){
 		ut.debug("installmgr.js:InstallMgr.prototype.xGetPacksIdList : " + e);
 	}
  }
  

InstallMgr.prototype.xShowInstall = function(pId, pStatus, pText, pType, pName){
	try{
		function getStatusText(pStatus){
			var vStatusText = "";
			if(pStatus == "stInstallPending"){
				vStatusText = "en cours";
			}else if(pStatus == "stInstallSuccess"){
				vStatusText = "ok";
			}else if(pStatus == "stInstallSuccessReboot"){
				vStatusText = "ok (après avoir relancé l\'application)";
			}else if(pStatus == "stInstallWarning"){
				vStatusText = "non installé";
			}else if(pStatus == "stInstallError"){
				vStatusText = "échec";
			}else{
				vStatusText = pStatus;
			}
			return vStatusText;
		}
		var vName = pName ? pName : pId;
		if(pId in this.fListInstalls){
			if(this.fListInstalls[pId]!=pStatus){
				this.fListInstalls[pId] = pStatus;
				var vObjLabel = document.getElementById(pId);
				if(vObjLabel) vObjLabel.setAttribute('status', pStatus);
				if(vObjLabel) vObjLabel.setAttribute('value', pText ? pText : getStatusText(pStatus));
			}
		}else{
			this.fListInstalls[pId] = pStatus;
			if(this.fRowsTraceXpi || this.fRowsTraceJar){
				var vObjRow = document.createElement('row');
					var vObjLabel = document.createElement('label');
						vObjLabel.setAttribute('class','clElmtInstalle');
						vObjLabel.appendChild(document.createTextNode("- " + vName));
					vObjRow.appendChild(vObjLabel);
					var vObjLabel = document.createElement('label');
						vObjLabel.setAttribute('id', pId);
						vObjLabel.setAttribute('status', pStatus);
						vObjLabel.setAttribute('value', pText ? pText : getStatusText(pStatus));
					vObjRow.appendChild(vObjLabel);
				if(pType=='local'){
					if(this.fRowsTraceXpi) this.fRowsTraceXpi.appendChild(vObjRow);
				}else if(pType=='server'){
					if(this.fRowsTraceJar) this.fRowsTraceJar.appendChild(vObjRow);
				}else{//extension non reconnue : on l'affiche dans la première zone disponible
					if(this.fRowsTraceXpi) this.fRowsTraceXpi.appendChild(vObjRow);
					else if(this.fRowsTraceXpi) this.fRowsTraceXpi.appendChild(vObjRow);
				}
			}
		}
	}catch(e){
		ut.debug("installmgr.js:InstallMgr.prototype.xShowInstall : "+ e);
	}
}

function debug(pText){
	var vConsoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
	vConsoleService.logStringMessage(pText);
}

