





















function CreatorItemFolder(pSortKey, pLabel, pIcon, pUrlHelp, pVersion, pIsOpen){
	this.isFolder = true;
	this.isOpen = pIsOpen;// true->ouvert, false->fermé , [null, non renseigné]->choix de l'ouverture par SC (cf. creatoritem.xul)
	this.fSortKey = pSortKey;
	this.fLabel = pLabel; 
	this.fIcon = pIcon;
	this.fUrlHelp = pUrlHelp;
	this.fVersion = pVersion;
}





function CreatorItem(pPack, pModel, pSortKey, pLabel, pIcon, pUrlHelp, pFileNameExt, pTypeBuilderContent, pParamsBuilderContent){
	this.fPack = pPack;
	this.fModel = pModel;
	this.fSortKey = pSortKey;
	this.fLabel = pLabel; 
	this.fIcon = pIcon;
	this.fUrlHelp = pUrlHelp;
	this.fFileNameExt = pFileNameExt ? pFileNameExt.split(",") : null;
	this.fTypeBuilderContent = pTypeBuilderContent;
	this.fParamsBuilderContent = pParamsBuilderContent;
	this.fContentType = "text/xml; charset=UTF-8";
	this.fActionOnFinish = null;
	this.fIsMultiRes = false;
}
CreatorItem.prototype.getFileNameField = function (pDocument, pCurrentName){
	var vRoot = pDocument.createElement("hbox");
	vRoot.setAttribute("align", "center");
	var vLabel = vRoot.appendChild(pDocument.createElement("description"));
	vLabel.setAttribute("value", "Nom de l\'item :");
	var vInput = vRoot.appendChild(pDocument.createElement("textbox"));
	vInput.setAttribute("style", "width:250px");
	var vName = this.getDefaultFileName(pDocument, pCurrentName);
	if(vName){
		var vIdx = (this.fFileNameExt) ? vName.lastIndexOf(".") : -1;
		vInput.setAttribute("value", (vIdx>=0) ? vName.substring(0, vIdx) : vName);
	}
	if(this.fFileNameExt){
		if(this.fFileNameExt.length == 1) {
			var vDesc = pDocument.createElement("description");
			vDesc.setAttribute("value", this.fFileNameExt[0]);
			vDesc.setAttribute("style", "-moz-margin-start:0px; -moz-padding-start:0px; font-style:bold;");
			vRoot.appendChild(vDesc);
		} else {

			alert("multi-extension du file-name non codé dans CreatorItem.getFileNameField().");
		}
	}
	return vRoot;
}


CreatorItem.prototype.getDefaultFileName = function (pDocument, pCurrentName){
	return "";
}

CreatorItem.prototype.isFileNameValid = function (pFileName){
	if(!pFileName) return false;
	if(pFileName.indexOf(".") < 0) return false;
	var vRegExp = /[+$\\\/><|?:*"~#]/;
	if (vRegExp.test(pFileName)) return false;
	if(this.fFileNameExt){
		for(var i = 0; i < this.fFileNameExt.length; i++){
			var vExt = this.fFileNameExt[i];
			if(vExt == pFileName.substring(pFileName.length-vExt.length)) return true;
		}

		return false;
	}
	return true;
}
CreatorItem.prototype.getFileName = function (pFileNameField){
	var vName = pFileNameField.getElementsByTagName("textbox")[0].value;
	if(vName && this.fFileNameExt){
		if(this.fFileNameExt.length == 1) {
			var vExt = this.fFileNameExt[0];
			if(vName.length < vExt.lenght || vName.substring(vName.length-vExt.length) != vExt)	vName += vExt;
		} else {

		}
	}
	return vName;
}
CreatorItem.prototype.isPageEditor = function (){
	return (this.fTypeBuilderContent == "xed");
}
CreatorItem.prototype.appendPageEditor = function (pWizard){
	if(this.fTypeBuilderContent == "xed") {
		var vDoc = pWizard.ownerDocument;
		var vW = vDoc.createElement("wizardpage");
		var vEd = vDoc.createElement("xedBox");
		vEd.setAttribute("orient", "vertical");
		vEd.setAttribute("flex", "1");

		vEd.setAttribute("style", "-moz-binding: url(chrome://scenarixedlib/content/core/xed.xbl.xml#xedBox);");
		vW.appendChild(vEd);
		var vPages = pWizard.wizardPages;
		pWizard.insertBefore(vW, vPages[vPages.length-1].nextSibling);
		vEd.initEditor(this.fParamsBuilderContent);
	}
}

CreatorItem.prototype.getContent = function (pWizard){
	if(this.fTypeBuilderContent == "string") {
		return this.fParamsBuilderContent;
	} else if(this.fTypeBuilderContent == "xed") {
		var vXedBox = pWizard.getElementsByTagName("xedBox");
		if(vXedBox.length==0) this.appendPageEditor(pWizard); //On force la création de l'éditeur.
		vXedBox = pWizard.getElementsByTagName("xedBox");
		if(vXedBox.length>0) {
			return vXedBox[0].fillResult();
		}
	} else if(this.fTypeBuilderContent == "url" && this.fParamsBuilderContent) {
		var vIoService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
		return vIoService.newURI(this.fParamsBuilderContent, null, null);
	}
	return null;
}

CreatorItem.prototype.getContentType = function (pWizard){
	return this.fContentType;
}
CreatorItem.prototype.getActionOnFinish = function (pWizard){
	return this.fActionOnFinish;
}
CreatorItem.prototype.getPack = function (){
	return this.fPack;
}
CreatorItem.prototype.getModel = function (){
	return this.fModel;
}






	

function CreatorItem3(pPack, pModel, pSortKey, pLabel, pIcon, pUrlHelp, pFileNameExt, pTypeBuilderContent, pParamsBuilderContent, pTemplateName, pContentType){
	this.fPack = pPack;
	this.fModel = pModel;
	this.fSortKey = pSortKey;
	this.fLabel = pLabel; 
	this.fIcon = pIcon;
	this.fUrlHelp = pUrlHelp;
	this.fFileNameExt = pFileNameExt ? pFileNameExt.split(",") : null;
	this.fTypeBuilderContent = pTypeBuilderContent;
	this.fParamsBuilderContent = pParamsBuilderContent;
	this.fContentType = pContentType || "text/xml; charset=UTF-8";
	this.fActionOnFinish = null;
	this.fIsMultiRes = false;
	this.fTemplateName = pTemplateName;
}
CreatorItem3.prototype = new CreatorItem();
CreatorItem3.prototype.getDefaultFileName = function (pDocument, pCurrentName){
	var vTemplateName = this.fTemplateName || "{folder}_{counter}";
	vTemplateName = vTemplateName.replace(/(\{folder\})/g, ut.getLeafFromUri(pDocument.defaultView.fUriParent));
	var vIdx = 1;
	var vNameFile = null;
	while(true){
		vNameFile = vTemplateName.replace(/(\{optionalCounter\})/g, ( vIdx > 1 ? "_" + ( vIdx < 10 ? "0"+vIdx : vIdx) : ""));
		vNameFile = vNameFile.replace(/(\{counter\})/g, ( vIdx < 10 ? "0"+vIdx : vIdx) );
		var vUri = pDocument.defaultView.fUriParent+"/"+vNameFile+this.fFileNameExt;
		var vItemDef = pDocument.defaultView.fDataProvider.getDomFromService("/u/vueObjet?cdaction=GetItemDef&param="+encodeURIComponent(vUri));
		var vStatus = "-99";
		if(vItemDef) vStatus = vItemDef.documentElement.getAttribute("uriRes") ? "-99" : vItemDef.documentElement.getAttribute("status");
		if(vStatus == "-99") {
			vNameFile = pCurrentName || ""; //Echec à la construction du nom.
			break;
		} else if(vStatus != "-1") {
			if(vNameFile == vTemplateName) {

				break;
			}
			vIdx++;
		} else {
			break;
		}
	}
	return vNameFile;
}





function CreatorSpaceFolder(pSortKey, pLabel, pIcon, pUrlHelp, pVersion, pIsOpen){
	this.isFolder = true;
	this.isOpen = pIsOpen;
	this.fSortKey = pSortKey;
	this.fLabel = pLabel; 
	this.fIcon = pIcon;
	this.fUrlHelp = pUrlHelp;
	this.fVersion = pVersion;
}





function CreatorSpaceXedXsl(pSortKey, pLabel, pIcon, pUrlHelp, pUrlXed, pUrlXsl){
	this.fSortKey = pSortKey;
	this.fLabel = pLabel; 
	this.fIcon = pIcon;
	this.fUrlHelp = pUrlHelp;
	this.fUrlXed = pUrlXed;
	this.fUrlXsl = pUrlXsl;
	this.isFolder = false;
}
CreatorSpaceXedXsl.prototype.isPageEditor = function (){
	return (this.fUrlXed);
}

CreatorSpaceXedXsl.prototype.appendPageEditor = function (pWizard){
	var vDoc = pWizard.ownerDocument;
	var vW = vDoc.createElement("wizardpage");
	var vEd = vW.appendChild(vDoc.createElement("xedBox"));
	vEd.setAttribute("orient", "vertical");
	vEd.setAttribute("flex", "1");
	vEd.setAttribute("style", "-moz-binding: url(chrome://scenarixedlib/content/core/xed.xbl.xml#xedBox);");
	var vPages = pWizard.wizardPages;
	pWizard.insertBefore(vW, vPages[vPages.length-1].nextSibling);
	vEd.initEditor(this.fUrlXed);
}

CreatorSpaceXedXsl.prototype.getItemsToCreate = function (pWizard, pCodeSpace, pPathSpace){
	if( ! this.fUrlXed) return null;
	var vXedBox = pWizard.getElementsByTagName("xedBox");
	if(vXedBox.length==0) this.appendPageEditor(pWizard); //On force la création de l'éditeur.
	vXedBox = pWizard.getElementsByTagName("xedBox");
	if(vXedBox.length>0) {
		var vResult = vXedBox[0].fillResult();
		if(this.fUrlXsl) {
			try {
				var vXsl = document.implementation.createDocument("", "", null);
				vXsl.async = false;
				vXsl.load(this.fUrlXsl);
				var vXsltProcessor = new XSLTProcessor();
				vXsltProcessor.importStylesheet(vXsl);
				vXsltProcessor.setParameter(null, "pSp", pPathSpace);
				vXsltProcessor.setParameter(null, "pCd", pCodeSpace);
				var vNewResult = vXsltProcessor.transformToDocument(vResult);
				return vNewResult;
			} catch(e){
				ut.debug("creator.fs > getItemsToCreate : pb a l'execution de la XSL '"+this.fUrlXsl+"': "+e);
				return null;
			}
		}else{// si pas d'XSL
			return vResult;
		}
	}
	return null;
}
