
var packMgr = {fPack:{}};


packMgr.getPack = function(pCdPack){

	if(! pCdPack) return this.fDefaultPack;
	var vPack = this.fPack[pCdPack];
	if(vPack == null) {
		try {

			var vIoService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
			var vJsPath = "chrome://"+pCdPack+"/content/pack.js";
			var vJsChannel = vIoService.newChannel(vJsPath, "UTF-8", null);
			var vIn = Components.classes["@mozilla.org/intl/converter-input-stream;1"].createInstance(Components.interfaces.nsIConverterInputStream);
			vIn.init(vJsChannel.open(), "UTF-8", vJsChannel.contentLength, "?");
			try {
				var vJsStr = {};
				vIn.readString(vJsChannel.contentLength, vJsStr);
				vJsStr = vJsStr.value;

				eval(vJsStr, this);
				var vFunc = this[pCdPack+"_init"];
				if(vFunc){
					try {
						vFunc.call(window, this);
						vPack = this.fPack[pCdPack];
					} catch(e){
						ut.debug("Echec au cours de l'initialisation du package "+pCdPack+" : "+e);
					}
				} else {
					ut.debug("Impossible de trouver la fonction javascript : "+pCdPack+"_init()");
				}
			} finally {
				vIn.close();
			}
		} catch(e){
			ut.debug("Impossible de charger la librairie javascript : "+vJsPath, +"\n"+e);
		}

	}
	return vPack ? vPack : this.fDefaultPack;
}
packMgr.isPackAvailable = function(pCdPack){
	if(this.fPack[pCdPack]) return true;
	/*
	try {this.getPack(pCdPack);} catch(e){}
	return (this.fPack[pCdPack] != null);
	*/
	var vIoService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
	var vJsPath = "chrome://"+pCdPack+"/content/pack.js";
	var vJsChannel = vIoService.newChannel(vJsPath, "UTF-8", null);
	try {
		vJsChannel.open().close();

		return true;
	} catch(e){

		return false;
	}
}
packMgr.registerPack = function(pPack){
	this.fPack[pPack.getCode()] = pPack;
}


packMgr.checkAsync = function (pDataProvider, pCdWsp){

	function cb(pEvent){
		return packMgr.xCheckDomWspInfo(pEvent.target.responseXML, pDataProvider);
	}
	try{
		pDataProvider.loadFromService("/u/adminWsp?cdaction=InfoWsp&param="+pCdWsp, cb, null);
	}catch(e){
		return null;
		ut.debug("packmgr.js packMgr.checkAsync: "+e);
	}
}


packMgr.checkSync = function (pDataProvider, pCdWsp){
	try{
		var vDom = pDataProvider.getDomFromService("/u/adminWsp?cdaction=InfoWsp&param="+pCdWsp);
		return this.xCheckDomWspInfo(vDom, pDataProvider);
	}catch(e){
		ut.debug("packmgr.js packMgr.checkSync: "+e);
		return null;
	}
}


packMgr.xCheckDomWspInfo = function (pWspInfo, pDataProvider){
	try{
		var vPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
        var vCurrentInstallMode = vPrefs.getCharPref("scenari.install.xpi.mode");
        var vPackList = "";
        
		if(pWspInfo){
			var vCliUpdtList = []; // réinitialisation de la liste des XPI à installer
            var vEsListXml = pWspInfo.getElementsByTagName("editionSheet");
            var vXpiList = new Object();
            for (var i = 0; i < vEsListXml.length; i++) {
               var vVersionComparator = Components.classes["@mozilla.org/xpcom/version-comparator;1"].getService(Components.interfaces.nsIVersionComparator);
               var vEditionSheet = vEsListXml.item(i);
               var vPackCd = vEditionSheet.getAttribute("pack");
               var vPackDom = ut.getDomFromLocalFileUrl("chrome://"+vPackCd+"/content/pack.xml");
               var vRequiredVersion = vEditionSheet.hasAttribute("version") ? vEditionSheet.getAttribute("version") : "0.0.0";
               var vCurrentVersion = (vPackDom && vPackDom.documentElement && vPackDom.documentElement.hasAttribute("version")) ? vPackDom.documentElement.getAttribute("version") : null;
               
               if(!vCurrentVersion || vVersionComparator.compare(vRequiredVersion, vCurrentVersion)!=0){// installation du pack nécessaire
                   var vPackSrvId = vPackCd + ".safe.xpi" + "#" + vRequiredVersion + "#" + vRequiredVersion; // On installe la version exacte spécifié dans le wspmeta
                   vPackList += ", "+ vPackCd + " " + vRequiredVersion ;
                   vCliUpdtList.push(pDataProvider.getServiceUrl("/u/adminWsp?cdaction=GetRes&scWspResp=no&param=" + encodeURIComponent(vPackSrvId)));
               }
            }
            
            vPackList = vPackList.substring(2);
           
    		if(vCliUpdtList.length > 0){

    			if(vCurrentInstallMode=='inProfile'){
    				this.xInstallXpis(vCliUpdtList, vPackList);
    			}else{
    				ut.alert(ut.formatStr("Les composants graphiques suivants sont manquants : \'%s\'.\nCertains items risquent de ne pas s\'afficher correctement.", vPackList));
    			}
    		}
    	}
	}catch(e){
		ut.debug("packmgr.js packMgr.xCheckDomWspInfo : " + e);
	}	
}
packMgr.xInstallXpis = function (pXpiList, pInstallName){
	var gExtensionManager = Components.classes["@mozilla.org/extensions/manager;1"].getService(Components.interfaces.nsIExtensionManager);
	var vWin = ut.openWindowWait(null, "Mise à jour de l\'atelier", "Installation des composants graphiques...");
	try {

		var vTmpFile = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("TmpD", Components.interfaces.nsIFile);
		vTmpFile.append("SCtmpXpi"+(Date.now()%10000)+".xpi");
		vTmpFile.createUnique(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 0600);
		
		function finishInstall(pInstallFailed){
			try {
				try{vTmpFile.remove(false);}catch(e){ut.debug(e);}
				if(pInstallFailed) {
					ut.alert(ut.formatStr("Le téléchargement et l\'installation des composants graphiques de l\'atelier ont échoué (%s). Votre espace de travail peut ne pas fonctionner correctement.\nVeuillez recommencer ultérieurement.", pInstallName), "Echec à la mise à jour de l\'atelier");
				} else {

					if(ut.confirm(ut.formatStr("Des composants graphiques ont été installés et seront pris en compte après redémarrage de l\'application (%s).\nVoulez-vous redémarrer l\'application maintenant ?", pInstallName), "Mise à jour de l\'atelier", "oui", "non")){
						if(ut.isUnix) window.setTimeout("ut.appRestart(true, true);window.close();", 500, "");// NOTE : obligé de fermer en mode forcé car fenetre modale (pb Gecko1.9)
						else ut.appRestart(true, true);
					}
				}
			}catch(e){
				ut.debug("packMgr.xInstallXpis.finishInstall::"+e);
			}finally{
				ut.closeWindowWait(vWin);
			}
		}
		var vIdx = 0;
		function downloadXpi() {
			if(vIdx >= pXpiList.length) {
				finishInstall();
				return;
			}
			if(vIdx>0) try{vWin.changeMessage(ut.formatStr("Téléchargement du composant manquant %s/%s...", vIdx, pXpiList.length));} catch(e){ut.debug(e);}
			var vUrl = pXpiList[vIdx++];
			if(vUrl) {

				var vIOSvc = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
				var vChannelRes = vIOSvc.newChannel(vUrl, null, null);
				
				var vOutputFile = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
				var vOutputBuffer = Components.classes["@mozilla.org/network/buffered-output-stream;1"].createInstance(Components.interfaces.nsIBufferedOutputStream);							
				vOutputFile.init(vTmpFile, 0x02 | 0x08 | 0x20, 0600, null);
				vOutputBuffer.init(vOutputFile, 8192);
				

				try {
					var vListener = {
							onStartRequest: function(pRequest, pContext) {
							},
							onDataAvailable: function (pRequest, pContext, pStream, pOffset, pCount) {
								while(pCount > 0) pCount -= vOutputBuffer.writeFrom(pStream, pCount);
							},
							onStopRequest: function(pRequest, pContext) {
								vOutputBuffer.close();
								if(Components.isSuccessCode(pRequest.status) && pRequest.QueryInterface(Components.interfaces.nsIHttpChannel).responseStatus==200) {

									gExtensionManager.installItemFromFile(vTmpFile, "app-profile");

									downloadXpi();
								} else {
									finishInstall(true);
								}
							}
						};
					vChannelRes.asyncOpen(vListener, this);
				} catch(e){
					vOutputBuffer.close();
					throw e;
				}
			}
		}
		downloadXpi();
	} catch(e){
		ut.closeWindowWait(vWin);
		ut.debug(e);
	}
}

packMgr.fDefaultPack = {};
packMgr.fDefaultPack.getCode = function(){
	return "scenaricms_default";
}
packMgr.fDefaultPack.getIcon = function(pModel, pUriRes){
	if(pModel == "itemNull") return "chrome://scenaricms/content/icon/icitemnull";
	if(pModel == "ss") return "chrome://scenaricms/content/view/ss";
	if( ! pUriRes || pUriRes == "/") {
		return "chrome://scenaricms/content/icon/icitemmono";
	} else if(pUriRes.charAt(pUriRes.length-1)=="/"){
		return "chrome://scenaricms/content/icon/icfolder";
	}
	return "chrome://scenaricms/content/icon/icres";
}

packMgr.fDefaultPack.getIconOpen = function(pModel, pUriRes){
	if(!pUriRes || pUriRes == "/") return "chrome://scenaricms/content/icon/icitemmultiOpen";
	return "chrome://scenaricms/content/icon/icfolderOpen";
}

packMgr.fDefaultPack.getTitle = function(pModel, pUriRes){
	if(pModel == "itemNull") return "Item manquant";
	if(pModel == "ss") return "Feuille de stockage";
	return pModel ? "Modèle inconnu : "+pModel : "Modèle non spécifié";
}

packMgr.fDefaultPack.getMainViewUrl = function(pModel, pUriRes){
	if(pModel == "itemNull") return "chrome://scenaricms/content/view/itemnull/itemnull.mainview.xul";
	if(pModel == "ss") return "chrome://scenaricms/content/view/ss/mainview.xul";
	return "chrome://scenaricms/content/view/itemdefault/itemdefault.mainview.xul";
}
packMgr.fDefaultPack.getPreViewUrl = function (pModel, pUriRes, pOptions){
	return null;
}
packMgr.fDefaultPack.getImageViewTransform = function (pModel, pUriRes, pOptions){
	return null;
}
packMgr.fDefaultPack.getFixedWebView = function (pModel, pUri, pUriObjectContext, pOptions) {
	return "<i style='color:grey; padding:0px 3px'>?&nbsp;"+ut.escapeXml(pUri)+"&nbsp;?</i>";
}
packMgr.fDefaultPack.getMainStreamUri = function(pModel, pUri){
	return pUri;
}
packMgr.fDefaultPack.fContentTypesBinary = ["binary"];
packMgr.fDefaultPack.getContentTypes = function(pModel, pUri){
	return this.fContentTypesBinary;
}
packMgr.fDefaultPack.isOutlineAvailable = function (pModel, pUriRes){
	return false;
}
packMgr.fDefaultPack.addCreatorItem = function(pModel, pCreatorItemMgr){};
packMgr.fDefaultPack.addCreatorSpace = function(pListSs, pCreatorSpaceMgr){};
packMgr.fDefaultPack.buildUriForImportFile = function(pUriObjectFrom, pFile) {
	var vUriParent = ut.getUriParent(pUriObjectFrom.getUri());

	var vFileName = pFile.leafName.replace(/[+$\\\/><|?:*#"~]/g, " ").replace(/^\s+/, "").replace(/\s+$/, ""); 
	return ut.addLeafToUri(vUriParent, vFileName);
}
packMgr.fDefaultPack.overrideType = function(pModel, pUriRes, pOriginalType){
	return pOriginalType;
}


packMgr.registerPack(packMgr.fDefaultPack);




function PackBase(pCode){
	this.fCode = pCode;
	this.fModels = {};
}

PackBase.prototype.getCode = function(){
	return this.fCode;
}
PackBase.prototype.getIcon = function(pModel, pUriRes){
	var vModel = this.fModels[pModel];
	var vIcon = vModel ? vModel.getIcon(pUriRes) : null;
	return (vIcon) ? vIcon : packMgr.fDefaultPack.getIcon(pModel, pUriRes);
}
PackBase.prototype.getIconOpen = function(pModel, pUriRes){
	var vModel = this.fModels[pModel];
	var vIcon = vModel ? vModel.getIconOpen(pUriRes) : null;
	return (vIcon) ? vIcon : packMgr.fDefaultPack.getIconOpen(pModel, pUriRes);
}
PackBase.prototype.getTitle = function(pModel, pUriRes){
	var vModel = this.fModels[pModel];
	var vTitle = vModel ? vModel.getTitle(pUriRes) : null;
	return (vTitle) ? vTitle : packMgr.fDefaultPack.getTitle(pModel, pUriRes);
}
PackBase.prototype.getMainViewUrl = function(pModel, pUriRes){
	var vModel = this.fModels[pModel];
	var vUri = null;
	if(vModel!=null)vUri = vModel.getMainViewUrl(pUriRes);
	return (vUri) ? vUri : packMgr.fDefaultPack.getMainViewUrl(pModel, pUriRes);
}

PackBase.prototype.getPreViewUrl = function (pModel, pUriRes, pOptions){
	var vModel = this.fModels[pModel];
	return (vModel!=null) ? vModel.getPreViewUrl(pUriRes, pOptions) : null;
}

PackBase.prototype.getImageViewTransform = function (pModel, pUriRes, pOptions){
	var vModel = this.fModels[pModel];
	return (vModel!=null) ? vModel.getImageViewTransform(pUriRes, pOptions) : null;
}

PackBase.prototype.getFixedWebView = function (pModel, pUri, pUriObjectContext, pOptions){
	var vModel = this.fModels[pModel];
	if(vModel!=null) return vModel.getFixedWebView(pUri, pUriObjectContext, pOptions);
	return packMgr.fDefaultPack.getFixedWebView(pModel, pUri, pUriObjectContext, pOptions);
}
PackBase.prototype.getMainStreamUri = function(pModel, pUri){
	var vModel = this.fModels[pModel];
	if(vModel!=null) return vModel.getMainStreamUri(pUri);
	return packMgr.fDefaultPack.getMainStreamUri(pModel, pUri);
}
PackBase.prototype.getContentTypes = function(pModel, pUri){
	var vModel = this.fModels[pModel];
	if(vModel!=null) return vModel.getContentTypes(pUri);
	return packMgr.fDefaultPack.getContentTypes(pModel, pUri);
}

PackBase.prototype.isOutlineAvailable = function (pModel, pUriRes){
	var vModel = this.fModels[pModel];
	return (vModel!=null) ? vModel.isOutlineAvailable(pUriRes) : false;
}

PackBase.prototype.addCreatorItem = function(pModel, pCreatorItemMgr){
}
PackBase.prototype.addCreatorSpace = function(pListSs, pCreatorSpaceMgr){
}
PackBase.prototype.buildUriForImportFile = packMgr.fDefaultPack.buildUriForImportFile;

PackBase.prototype.overrideType = function(pModel, pUriRes, pOriginalType){
	var vModel = this.fModels[pModel];
	return (vModel!=null) ? vModel.overrideType(pUriRes, pOriginalType) : pOriginalType;
}


PackBase.prototype.registerModel = function(pModel){
	this.fModels[pModel.getCode()] = pModel;
}



function ModelBase(pCode, pIcon, pTitle, pMainViewUrl, pPreViewUrl, pImageViewTransform, pOutlineAvailable, pContentTypes){
	this.fCode = pCode;
	this.fIcon = pIcon;
	this.fTitle = pTitle;
	this.fMainViewUrl = pMainViewUrl;
	if(pPreViewUrl) this.fPreViewUrl = pPreViewUrl;
	if(pImageViewTransform) this.fImageViewTransform = pImageViewTransform;
	if(pOutlineAvailable) this.fOutlineAvailable = true;
	if(pContentTypes) this.fContentTypes = pContentTypes;
}
ModelBase.prototype.getCode = function(){
	return this.fCode;
}
ModelBase.prototype.getIcon = function(pUriRes){
	return this.fIcon;
}
ModelBase.prototype.getIconOpen = function(pUriRes){
	return this.fIconOpen || this.fIcon;
}
ModelBase.prototype.getTitle = function(pUriRes){
	return this.fTitle;
}
ModelBase.prototype.getMainViewUrl = function(pUriRes){
	return this.fMainViewUrl;
}
ModelBase.prototype.getPreViewUrl = function (pUriRes, pOptions){
	return ("fPreViewUrl" in this) ? this.fPreViewUrl : null;
}
ModelBase.prototype.getImageViewTransform = function (pUriRes, pOptions){
	return ("fImageViewTransform" in this) ? this.fImageViewTransform : null;
}
ModelBase.prototype.getFixedWebView = function (pUri, pUriObjectContext, pOptions) {
	try {
		return "<img src=\""+this.getIcon()+"/icovalid.png\" style=\"vertical-align:middle;\">"+ ut.escapeXml(pUriObjectContext.getItemDef(pUri).documentElement.getAttribute("ti") || ut.getLeafFromUri(pUri));
	} catch(e) {
		ut.debug("ModelBase.prototype.getFixedWebView"+e);
		return "<i style='color:grey; padding:0px 3px'>?&nbsp;"+pUri+"&nbsp;?</i>";
	}
}
ModelBase.prototype.getMainStreamUri = function(pUri) {

	return pUri;
}
ModelBase.fContentTypesXml = ["text/xml"];
ModelBase.prototype.getContentTypes = function(pUri) {

	return this.fContentTypes || ModelBase.fContentTypesXml;
}
ModelBase.prototype.fOutlineAvailable = false;
ModelBase.prototype.isOutlineAvailable = function (pUriRes){
	return this.fOutlineAvailable;
}
ModelBase.prototype.overrideType = function(pUriRes, pOriginalType){
	return pOriginalType;
}



function ModelRes(pCode, pIcon, pTitle, pMainViewUrl, pPreViewUrl, pImageViewTransform, pContentTypes, pMapExtensionContentTypes){
	this.fCode = pCode;
	this.fIcon = pIcon;
	this.fTitle = pTitle;
	this.fMainViewUrl = pMainViewUrl;
	if(pPreViewUrl) this.fPreViewUrl = pPreViewUrl;
	if(pImageViewTransform) this.fImageViewTransform = pImageViewTransform;
	if(pContentTypes) this.fContentTypes = pContentTypes;
	if(pMapExtensionContentTypes) this.fMapExtensionContentTypes = pMapExtensionContentTypes;
}
ModelRes.prototype = new ModelBase();
ModelRes.prototype.overrideType = function(pUriRes, pOriginalType){
	return "itemmono";
}
ModelRes.prototype.getMainStreamUri = function(pUri) {

	var vUriRes = ut.getUriResFromUri(pUri);
	return vUriRes ? pUri : ut.addLeafToUri(pUri, ut.getLeafFromUri(pUri));
}
ModelRes.prototype.getContentTypes = function(pModel, pUri){
	if(this.fContentTypes) return this.fContentTypes;
	if(this.fMapExtensionContentTypes) {
		var vName = ut.getLeafFromUri(pUri);
		if(vName) for(var i = 0; i < this.fMapExtensionContentTypes.length; i++) {
			if(this.fMapExtensionContentTypes[i].regExpExt.match(vName)) return this.fMapExtensionContentTypes[i].ext;
		}
	}
	return packMgr.fDefaultPack.fContentTypesBinary;
}



packMgr.CreatorItemMgr = function(){
	this.fNodes = [];
	this.fCurentNode = this.fNodes;
}


packMgr.CreatorItemMgr.prototype.getCurrentFolder = function(){
	return this.fCurentNode.fPtr;
}


packMgr.CreatorItemMgr.prototype.gotoChildFolder = function(pFolder){
	var vFolder = null;
	for (var i = 0; i < this.fCurentFolder.length; i++) {
		if(this.fCurentFolder[i].fPtr.fSortKey == pFolder.fSortKey) {
			var vOldVersion = this.fCurentFolder[i].fPtr.fVersion;
			if(vOldVersion) {

				if(vOldVersion < pFolder.fVersion) {

					this.fCurentFolder[i].fPtr = pFolder;
				}//sinon on ne change rien
			}
			this.fCurentFolder = this.fCurentFolder[i];
			return;
		}
	}

	var vNewNode = [];
	vNewNode.fPtr = pFolder;
	vNewNode.fParent = this.fCurentFolder;
	this.fCurentFolder[this.fCurentFolder.length] = vNewNode;
	this.fCurentFolder = vNewNode;
	return this.fCurentFolder.fPtr;
}


packMgr.CreatorItemMgr.prototype.gotoParentFolder = function(){
	if(this.fCurentFolder.fParent) this.fCurentFolder = this.fCurentFolder.fParent;
	return this.fCurentFolder.fPtr;
}


packMgr.CreatorItemMgr.prototype.gotoRootFolder = function(){
	 this.fCurentFolder = this.fNodes;
	 return null;
}


packMgr.CreatorItemMgr.prototype.addCreatorItem = function(pCreatorItem){
	var vNewNode = {};
	vNewNode.fPtr = pCreatorItem;
	vNewNode.fParent = this.fCurentFolder;
	this.fCurentFolder[this.fCurentFolder.length] = vNewNode;
}




packMgr.CreatorItemMgr.prototype.xRemoveCreatorNode = function(pCreatorNode){
	if(!pCreatorNode) return;
	var vParent = pCreatorNode.fParent;
	if(!vParent || vParent.length==0) return;
	var i = 0;
	for (; i < vParent.length; i++) if(vParent[i] == pCreatorNode) break;
	i++;
	for (; i < vParent.length; i++) vParent[i-1] = vParent[i];
	vParent.length--;
}



packMgr.CreatorItemMgr.prototype.countCreators = function(){
	return this.xCountCreators(this.fNodes);
}



packMgr.CreatorItemMgr.prototype.sortItems = function(pNodes){
	pNodes.sort(function(pA, pB) {return pA.fPtr.fSortKey.localeCompare(pB.fPtr.fSortKey)});
	for(var i = 0; i < pNodes.length; i++){
		if(pNodes[i].fPtr.isFolder) this.sortItems(pNodes[i]);
	}
}

packMgr.CreatorItemMgr.prototype.xCountCreators = function(pNodes){
	var vRes = 0;
	for(var i=0; i < pNodes.length; i++){
		if(pNodes[i].fPtr.isFolder) {
			vRes += this.xCountCreators(pNodes[i]);
		} else {
			vRes++;
		}
	}
	return vRes
}