

var gMainPane = {
  _pane: null,

  /**
   * Initialization of this.
   */
  init: function ()
  {
    this._pane = document.getElementById("paneMain");
	scPrefMgr.updateView();
  },
  
  /**
   * Initialisation
   *	@pName = [src|gen]
   */
  initWspDir: function (pName){
  	try{
  		var radioGrp = document.getElementById(pName+"RadioGrp");
			var downloadFolder = document.getElementById(pName+"Folder");
			var saveTo = document.getElementById(pName+"SaveTo");
	    var chooseFolder = document.getElementById(pName+"ChooseFolder");
	    var defaultF = document.getElementById(pName+"Default");
	    
	    var preference = document.getElementById("scenari.wsp." + pName + ".customDir");
	    downloadFolder.disabled = !preference.value;
	    chooseFolder.disabled = !preference.value;
	    radioGrp.selectedItem = preference.value ? saveTo : defaultF;
			this.displayDirPref(pName);


	    return undefined;
	}catch(e){
		ut.debug("preferencess > pnMain > initWspDir : " + e);
	}
  },
  
	displayDirPref: function(pName){
		try{
			var vPref = document.getElementById("scenari.wsp." + pName + ".dir");
			var vBox = document.getElementById(pName+"Folder");
			if(vBox && vPref && vPref.value) vBox.value = vPref.value.path;
		}catch(e){
			ut.debug("preferences > pnMain > displayDirPref : " + e);
		}
    return undefined;
	},



	initTools: function (){
		try{
			var radioGrp = document.getElementById("toolsOORadioGrp");
			var rdEmbed = document.getElementById("toolsOOEmbed");

			var vMode = document.getElementById("scenari.tools.oo.dirMode").value ? document.getElementById("scenari.tools.oo.dirMode").value : 0;

			rdEmbed.collapsed = document.getElementById("scenari.tools.oo.embed.path").value? false : true;
			if(vMode==0)  radioGrp.selectedItem = document.getElementById("toolsOODefault");
			else if(vMode==1) radioGrp.selectedItem = rdEmbed;
			else radioGrp.selectedItem = document.getElementById("toolsOOSystem");
			document.getElementById("srcChooseFolderBox").disabled = !(vMode==2);
			document.getElementById("srcChooseFolder").disabled = !(vMode==2);
			if(document.getElementById("scenari.tools.oo.path").value) document.getElementById("srcChooseFolderBox").value = document.getElementById("scenari.tools.oo.path").value.path;
			return undefined;
		}catch(e){
			ut.debug("preferences > pnMain > initTools : " + e);
		}
	},

	displayOoDirPref: function(){
		try{
			var vPref = document.getElementById('scenari.tools.oo.path');
			var vBox = document.getElementById('srcChooseFolderBox');
			if(vBox && vPref && vPref.value) vBox.value = vPref.value.path;
		}catch(e){
			ut.debug("preferences > pnMain > OO > displayDirPref : " + e);
		}
   		return undefined;
	},

  /**
	* Choix du répertoire, enregistremet de la pref, maj de l'interface
	* @return : chaine string si erreur
	*/
	chooseOoFolder: function(){
		try{
			const nsIFilePicker = Components.interfaces.nsIFilePicker;
			var vPref = document.getElementById('scenari.tools.oo.path');
			var vBox = document.getElementById('srcChooseFolderBox');
			var vOOProgPath = null;
			var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
			const nsILocalFile = Components.interfaces.nsILocalFile;
			fp.appendFilters(nsIFilePicker.filterAll);
			if(ut.isMac){
				fp.init(window, "Veuillez choisir une application", nsIFilePicker.modeOpen);
				fp.defaultExtension = "app";
				if (fp.show() == nsIFilePicker.returnOK) {
					vOOProgPath = fp.file.QueryInterface(nsILocalFile);
					var vAppPath = vOOProgPath.path;
					vOOProgPath.append("Contents");
					vOOProgPath.append("MacOS");
					vPref.value = vOOProgPath;
					vBox.value = vOOProgPath.path;
					var vOOBinPath = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
					vOOBinPath.initWithFile(vOOProgPath); 
					vOOBinPath.append("soffice.bin");
					if(!vOOBinPath.exists()) return ut.formatStr("L\'application \'%s\' ne semble pas être une version compatible de OpenOffice.", vAppPath.substring(0,vAppPath.toLowerCase().indexOf(".app")));
				}
			} else {
				fp.init(window, "Veuillez choisir un répertoire", nsIFilePicker.modeGetFolder);
				if (vPref.value) fp.displayDirectory = vPref.value;
				if (fp.show() == nsIFilePicker.returnOK) {
					vOOProgPath = fp.file.QueryInterface(nsILocalFile);
					if(vOOProgPath.leafName!="program") vOOProgPath.append("program");
					vPref.value = vOOProgPath;
					vBox.value = vOOProgPath.path;
					if(!vOOProgPath.exists()) return ut.formatStr("L\'emplacement \'%s\' est incorrect.", vOOProgPath.path);
				}
			}
		}catch(e){
			ut.debug("preferences > pnMain > OO > chooseFolder : " + e);
		}
	},

  /**
   * Choix du répertoire, enregistremet de la pref, maj de l'interface
   * @pName = [src|gen]
   */
  chooseFolder: function (pName){
  	try{
			const nsIFilePicker = Components.interfaces.nsIFilePicker;
			var vPref = document.getElementById("scenari.wsp." + pName + ".dir");
			var vBox = document.getElementById(pName+"Folder");
			var vNewPath = null;
			var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
			const nsILocalFile = Components.interfaces.nsILocalFile;
			fp.appendFilters(nsIFilePicker.filterAll);
			fp.init(window, "Veuillez choisir un répertoire", nsIFilePicker.modeGetFolder);
			if (vPref.value) fp.displayDirectory = vPref.value;
			if (fp.show() == nsIFilePicker.returnOK) {
				vNewPath = fp.file.QueryInterface(nsILocalFile);
				vPref.value = vNewPath;
				vBox.value = vNewPath.path;
			}
		}catch(e){
			ut.debug("preferencess > pnMain > chooseFolder : " + e);
		}
  },
};
