
var transf = {}

transf.FLAVOUR_FILE = "application/x-moz-file";
transf.FLAVOUR_SCENARI_URI = "application/x-scenari-uri";
transf.FLAVOUR_SCENARI_SERVER_ID = "application/x-scenari-server-id";
transf.FLAVOUR_SCENARI_SGN = "application/x-scenari-signature";
transf.FLAVOUR_TEXT_UNICODE = "text/unicode";
transf.FLAVOUR_TEXT_URL = "text/x-moz-url";

transf.DRAGDROP_ACTION_ALL = Components.interfaces.nsIDragService.DRAGDROP_ACTION_COPY + Components.interfaces.nsIDragService.DRAGDROP_ACTION_MOVE + Components.interfaces.nsIDragService.DRAGDROP_ACTION_LINK;

transf.fDragService = Components.classes["@mozilla.org/widget/dragservice;1"].getService(Components.interfaces.nsIDragService);

transf.fClipboardService = Components.classes["@mozilla.org/widget/clipboard;1"].getService(Components.interfaces.nsIClipboard);


transf.createTransferable = function(){
	return Components.classes["@mozilla.org/widget/transferable;1"].createInstance(Components.interfaces.nsITransferable);
	
}

transf.setStringDataToTransferable = function(pTrans, pFlavour, pValue){
	try{
		if(pValue==null) pValue = "";
		var vVal = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
		vVal.data = pValue;

	    pTrans.setTransferData(pFlavour, vVal, pValue.length * 2);
	}catch(e){
		ut.debug("transf.setStringDataToTransferable : " + e);
	}
}

transf.getStringDataFromTransferable = function(pTrans, pFlavour){
	if(pTrans==null) return null;
	var vVal={};
	var vLen={};
	pTrans.getTransferData(pFlavour, vVal, vLen);
	if(vVal.value) {
		var vStr = vVal.value.QueryInterface(Components.interfaces.nsISupportsString);
		return vStr ? vStr.data.substring(0, vLen.value/2) : null;
	} else {
		return null;
	}
}

transf.isClipboardContainTextUnicode = function(){
	if( ! this.fArrayFlavourTextUnicode) {
		this.fArrayFlavourTextUnicode = new Array();
        var vString = Components.classes["@mozilla.org/supports-cstring;1"].createInstance(Components.interfaces.nsISupportsCString);
        vString.data = transf.FLAVOUR_TEXT_UNICODE;
        this.fArrayFlavourTextUnicode.push(vString);		
	}
	return this.fClipboardService.hasDataMatchingFlavors(this.fArrayFlavourTextUnicode, this.fArrayFlavourTextUnicode.length, Components.interfaces.nsIClipboard.kGlobalClipboard);
}

transf.isClipboardContainTextUrl = function(){
	if( ! this.fArrayFlavourTextUrl) {
		this.fArrayFlavourTextUrl = new Array();
        var vString = Components.classes["@mozilla.org/supports-cstring;1"].createInstance(Components.interfaces.nsISupportsCString);
        vString.data = transf.FLAVOUR_TEXT_URL;
        this.fArrayFlavourTextUrl.push(vString);		
	}
	return this.fClipboardService.hasDataMatchingFlavors(this.fArrayFlavourTextUrl, this.fArrayFlavourTextUrl.length, Components.interfaces.nsIClipboard.kGlobalClipboard);
}

transf.isClipboardContainFile = function(){
	if( ! this.fArrayFlavourFile) {
		this.fArrayFlavourFile = new Array();
        var vString = Components.classes["@mozilla.org/supports-cstring;1"].createInstance(Components.interfaces.nsISupportsCString);
        vString.data = transf.FLAVOUR_FILE;
        this.fArrayFlavourFile.push(vString);		
	}
	return this.fClipboardService.hasDataMatchingFlavors(this.fArrayFlavourFile, this.fArrayFlavourFile.length, Components.interfaces.nsIClipboard.kGlobalClipboard);
}

transf.isClipboardContainScenariUri = function(){
	if( ! this.fArrayFlavourScenariUri) {
		this.fArrayFlavourScenariUri = new Array();
        var vString = Components.classes["@mozilla.org/supports-cstring;1"].createInstance(Components.interfaces.nsISupportsCString);
        vString.data = transf.FLAVOUR_SCENARI_URI;
        this.fArrayFlavourScenariUri.push(vString);
	}
	return this.fClipboardService.hasDataMatchingFlavors(this.fArrayFlavourScenariUri, this.fArrayFlavourScenariUri.length, Components.interfaces.nsIClipboard.kGlobalClipboard);
}

transf.isClipboardContainServerId = function(){
	if( ! this.fArrayFlavourServerId) {
		this.fArrayFlavourServerId = new Array();
        var vString = Components.classes["@mozilla.org/supports-cstring;1"].createInstance(Components.interfaces.nsISupportsCString);
        vString.data = transf.FLAVOUR_SCENARI_SERVER_ID;
        this.fArrayFlavourServerId.push(vString);
	}
	return this.fClipboardService.hasDataMatchingFlavors(this.fArrayFlavourServerId, this.fArrayFlavourServerId.length, Components.interfaces.nsIClipboard.kGlobalClipboard);
}

transf.isClipboardContainFileOrScenariUri = function(){
	if( ! this.fArrayFlavourFileOrScenariUri) {
		this.fArrayFlavourFileOrScenariUri = new Array();
        var vString = Components.classes["@mozilla.org/supports-cstring;1"].createInstance(Components.interfaces.nsISupportsCString);
        vString.data = transf.FLAVOUR_SCENARI_URI;
        this.fArrayFlavourFileOrScenariUri.push(vString);
		vString = Components.classes["@mozilla.org/supports-cstring;1"].createInstance(Components.interfaces.nsISupportsCString);
        vString.data = transf.FLAVOUR_FILE;
		this.fArrayFlavourFileOrScenariUri.push(vString);
	}
	return this.fClipboardService.hasDataMatchingFlavors(this.fArrayFlavourFileOrScenariUri, this.fArrayFlavourFileOrScenariUri.length, Components.interfaces.nsIClipboard.kGlobalClipboard);
}
transf.isClipboardContainMimeType = function(pMimeType){
	var vArrayFlavour = new Array();
    var vString = Components.classes["@mozilla.org/supports-cstring;1"].createInstance(Components.interfaces.nsISupportsCString);
	vString.data = pMimeType;
	vArrayFlavour.push(vString);
	return this.fClipboardService.hasDataMatchingFlavors(vArrayFlavour, vArrayFlavour.length, Components.interfaces.nsIClipboard.kGlobalClipboard);
}
transf.isClipboardContainMimeTypes = function(pMimeTypes){
	if(!pMimeTypes) return false;
	var vArrayFlavour = new Array();
	const CSTRING = Components.classes["@mozilla.org/supports-cstring;1"];
	for(var i=0; i < pMimeTypes.length; i++) {
	    var vString = CSTRING.createInstance(Components.interfaces.nsISupportsCString);
		vString.data = pMimeTypes[i];
		vArrayFlavour.push(vString);
	}
	return this.fClipboardService.hasDataMatchingFlavors(vArrayFlavour, vArrayFlavour.length, Components.interfaces.nsIClipboard.kGlobalClipboard);
}