
 
var fWspServer;
var fDataProvider;
var fTree;
var fTreeView;
var fCurrentLogin;
var fFctCallBackUpdatePass;
function initPage(){
	try{
		fWspServer = window.arguments[0];
		fDataProvider = fWspServer.getDataProvider();
		fCurrentLogin = window.arguments[1];
		fFctCallBackUpdatePass = window.arguments[2];
		fTree = document.getElementById("userList");
		fTreeView = new WrappedTreeView(fTree.treeBoxObject.view);
		fTreeView.canChangeSelect = function(pEvent){
			if(fWaiting) return false;
			if(fDirtyStatus) {
				document.getElementById("cancelBtn").focus();
				return false;
			}
			return true;
		}
		fTree.view = fTreeView;
		
		document.getElementById("passwordCheck").addEventListener("CheckboxStateChange", togglePassword, false);
		document.getElementById("adminField").addEventListener("CheckboxStateChange", setDirtyStatus, false);
		

		waiting("Chargement en cours...");
		fDataProvider.loadFromService("/u/adminUsers?cdaction=Display", cbServer, cbServer);
	}catch(e){
		ut.debug("usermgr.js > init : " + e);
	}
}


function selectUser(){
	var vCurrentIndex = fTree.currentIndex;
	if(vCurrentIndex >= 0) {
		var vItem = fTreeView.getItemAtIndex(vCurrentIndex);

		var vList = vItem.getElementsByTagNameNS(XULNS, "treecell");

		updateFields(vList[0].getAttribute("label"), vList[1].getAttribute("label"), vList[2].getAttribute("label"), vList[4].getAttribute("label"), vList[3].getAttribute("label"));
	} else {
		resetFields();
	}
}

var fWaiting = false;
function waiting(pText){
	var vRoot = document.getElementById("listRoot");
	while(vRoot.hasChildNodes()) {
		vRoot.removeChild(vRoot.lastChild);
	}
	if( ! pText) {
		fWaiting = false;
	} else {
		fWaiting = true;
		var vItem = document.createElementNS(XULNS, "treeitem");
		var vRow = vItem.appendChild(document.createElementNS(XULNS, "treerow"));
		var vCell = document.createElementNS(XULNS, "treecell");
		vCell.setAttribute("label", pText);
		vRow.appendChild(vCell);
		vCell = document.createElementNS(XULNS, "treecell");
		vCell.setAttribute("label", "");
		vRow.appendChild(vCell);
		vCell = document.createElementNS(XULNS, "treecell");
		vCell.setAttribute("label", "");
		vRow.appendChild(vCell);
		vCell = document.createElementNS(XULNS, "treecell");
		vCell.setAttribute("label", "");
		vRow.appendChild(vCell);
		vCell = document.createElementNS(XULNS, "treecell");
		vCell.setAttribute("label", "");
		vRow.appendChild(vCell);
		vRoot.appendChild(vItem);
	}
}

function cbServer(pEvent){
	waiting(false);
	if(pEvent.target.status == 200) {
		var vRoot = document.getElementById("listRoot");
		var vListUsers = pEvent.target.responseXML.documentElement;
		var vUser = vListUsers.firstChild;
		var vIdx = 0;
		var vSelect = -1;
		while(vUser) {

			if(vUser.nodeType == 1 && vUser.localName == "user") {
				var vItem = document.createElementNS(XULNS, "treeitem");
				var vRow = vItem.appendChild(document.createElementNS(XULNS, "treerow"));
				var vCell = document.createElementNS(XULNS, "treecell");
				vCell.setAttribute("label", vUser.getAttribute("account"));
				vRow.appendChild(vCell);
				vCell = document.createElementNS(XULNS, "treecell");
				vCell.setAttribute("label", vUser.getAttribute("firstName"));
				vRow.appendChild(vCell);
				vCell = document.createElementNS(XULNS, "treecell");
				vCell.setAttribute("label", vUser.getAttribute("lastName"));
				vRow.appendChild(vCell);
				vCell = document.createElementNS(XULNS, "treecell");
				vCell.setAttribute("label", vUser.getAttribute("rights"));
				vRow.appendChild(vCell);
				vCell = document.createElementNS(XULNS, "treecell");
				vCell.setAttribute("label", vUser.getAttribute("email"));
				vRow.appendChild(vCell);
				if(vUser.hasAttribute("current")) vSelect = vIdx;
				vRoot.appendChild(vItem);
				vIdx++;
			}
			vUser = vUser.nextSibling;
		}
		fTree.view.selection.select(vSelect);
	} else {
		ut.alert("Impossible d\'accéder au serveur.", "Echec à  la connexion");
	}
}



var fDirtyStatus = false;
function setDirtyStatus(){
	if( ! fDirtyStatus) {
		document.getElementById("cancelBtn").disabled = false;
		document.getElementById("saveBtn").disabled = false;
		document.getElementById("addUserBtn").disabled = true;
		document.getElementById("deleteUserBtn").disabled = true;
		fDirtyStatus = true;
	}
}

function xLeaveDirtyStatus(){
	if(fDirtyStatus) {
		document.getElementById("cancelBtn").disabled = true;
		document.getElementById("saveBtn").disabled = true;
		document.getElementById("addUserBtn").disabled = false;

		fDirtyStatus = false;
	}
}


var fNewUserStatus = false;
function addUser(){
try{
	fNewUserStatus = true;

	fTree.view.selection.select(-1);

	document.getElementById("userEditCaption").label = "Nouvel utilisateur...";

	document.getElementById("accountField").disabled = false;
	document.getElementById("passwordCheck").disabled = true;
	document.getElementById("passwordCheck").checked = true;

	document.getElementById("addUserBtn").disabled = true;
	document.getElementById("cancelBtn").disabled = true;
	document.getElementById("saveBtn").disabled = true;
	document.getElementById("saveBtn").label = "Créer";
}catch(e){ut.debug(e);}
}

function xLeaveNewUserStatus(){
	if(fNewUserStatus) {
		document.getElementById("addUserBtn").disabled = false;
		document.getElementById("userEditCaption").label = "Utilisateur";
		document.getElementById("accountField").disabled = true;
		document.getElementById("saveBtn").label = "Enregistrer";
		document.getElementById("passwordCheck").disabled = false;
		document.getElementById("passwordCheck").checked = false;
		fNewUserStatus = false;
	}
}


function updateFields(pAccount, pLastName, pFirstName, pEmail, pRights){
	xLeaveNewUserStatus();
	document.getElementById("accountField").value = pAccount;
	document.getElementById("firstNameField").value = pLastName;
	document.getElementById("lastNameField").value = pFirstName;
	document.getElementById("eMailField").value = pEmail;
	document.getElementById("adminField").checked = (pRights.indexOf("admin")>=0);
	document.getElementById("passwordCheck").checked = false;
	document.getElementById("passwordField").value = "";
	xLeaveDirtyStatus();
	document.getElementById("deleteUserBtn").disabled = false;
}

function resetFields(){
	document.getElementById("accountField").value = "";
	document.getElementById("firstNameField").value = "";
	document.getElementById("lastNameField").value = "";
	document.getElementById("eMailField").value = "";
	document.getElementById("passwordField").value = "";
	document.getElementById("adminField").checked = false;
	xLeaveDirtyStatus();
	document.getElementById("deleteUserBtn").disabled = true;
}

function cancel(){
	selectUser();
}

function save(){
	try{
		var vAccount = document.getElementById("accountField").value;
		if( ! vAccount) {
			ut.alert("Veuillez renseigner un compte.", "Compte requis");
			document.getElementById("accountField").focus();
			return;
		}
		if( ! isId(vAccount)) {
			ut.alert("Votre compte contient des caractères interdits.", "Compte incorrect");
			document.getElementById("passwordField").focus();
			return;
		}
		if(fNewUserStatus){
			var vItem = document.getElementById("listRoot").firstChild;
			while(vItem) {
				if(vItem.firstChild.firstChild.getAttribute("label") == vAccount) {
					ut.alert("Ce compte existe déjà , choisissez un autre compte.", "Création impossible");
					return;
				}else{
					vItem = vItem.nextSibling;
				}
			}
		}
		
		var vParams = "&param=" + encodeURIComponent(vAccount);
		
		vParams += "&firstname=" + encodeURIComponent(document.getElementById("firstNameField").value);
		
		vParams += "&lastname=" + encodeURIComponent(document.getElementById("lastNameField").value);
		
		vParams += "&email=" + encodeURIComponent(document.getElementById("eMailField").value);
		
		if(document.getElementById("adminField").checked) {
			vParams += "&rights=admin";
		} else if(fCurrentLogin == vAccount) {
			ut.alert("Vous ne pouvez pas supprimer les droits d\'administration du compte avec lequel vous êtes connecté.", "Suppression des droits d\'aminstration impossible");
			vParams += "&rights=admin";
		}
		if(document.getElementById("passwordCheck").checked) {
			var vPassword = document.getElementById("passwordField").value;
			if( ! vPassword) {
				ut.alert("Veuillez renseigner un mot de passe.", "Mot de passe requis");
				document.getElementById("passwordField").focus();
				return;
			}
			if( ! isPassword(vPassword)) {
				ut.alert("Votre mot de passe contient des caractères interdits.", "Mot de passe interdit");
				document.getElementById("passwordField").focus();
				return;
			}
			if(vPassword) vParams += "&passwrd=" + encodeURIComponent(vPassword);
		}
		
		if(fNewUserStatus) {
			waiting("CrÃ©ation...");
			fDataProvider.loadFromService("/u/adminUsers?cdaction=Create"+vParams, cbServer, cbServer);
		} else if(fCurrentLogin == vAccount && vPassword && fFctCallBackUpdatePass) {
			waiting("Enregistrement...");
			var vCb = function(pEvent){
				if(pEvent.target.status == 200) {
					window.opener.setTimeout(fFctCallBackUpdatePass, 100, vPassword);

					window.close();			
				} else {
					ut.alert("L\'enregistrement a échoué. Recommencez ou contactez votre administrateur.", "Echec à la connexion");
				}
			};
			fDataProvider.loadFromService("/u/adminUsers?cdaction=Update"+vParams, vCb, vCb);
		} else {
			waiting("Enregistrement...");
			fDataProvider.loadFromService("/u/adminUsers?cdaction=Update"+vParams, cbServer, cbServer);
		}
	}catch(e){ut.debug("usermgr > save : "+e);}
}

function deleteUser(){
	var vAccount = document.getElementById("accountField").value;
	if(fCurrentLogin == vAccount) {
		ut.alert("Vous êtes actuellement connecté avec ce compte ; vous ne pouvez pas le supprimer.", "Suppression du compte en cours impossible");
		return;
	}
	
	waiting("Suppression...");
	fDataProvider.loadFromService("/u/adminUsers?cdaction=Drop&param="+encodeURIComponent(vAccount), cbServer, cbServer);
}

function togglePassword() {
	var vField = document.getElementById("passwordField");
	if(document.getElementById("passwordCheck").checked){
		vField.disabled = false;
		vField.focus();
	} else {
		vField.disabled = true;
		vField.value = "";
	}
}
