


var XULNS = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";
var HTMLNS = "http://www.w3.org/1999/xhtml";

var ut = {};
ut.stringBundleService = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService);
ut.sbBrand = ut.stringBundleService.createBundle("chrome://scenaribranding/locale/brand.properties").QueryInterface(Components.interfaces.nsIStringBundle);

ut.httpStatusCodeUnauthorized = 451; // remplace 401 pour éviter l'apparition auto de la fenetre de login


ut.alert = function(pText, pTitle, pCheckMsg, pChecked){
	var vService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
	if(pCheckMsg) {
		var vRes = {};
		vRes.value = pChecked;
		vService.alertCheck(window, pTitle ? pTitle : (ut.sbBrand.GetStringFromName('brandShortName') + " - Message"), pText, pCheckMsg, vRes);
		return vRes.value;
	} else {
		vService.alert(window, pTitle ? pTitle : (ut.sbBrand.GetStringFromName('brandShortName') + " - Message"), pText);
		return false;
	}
}


ut.alertNotification = function(pIco, pTitle, pText, pTextClickable, pListener, pListenerParam){
	var vAlertSvc = Components.classes["@mozilla.org/alerts-service;1"].getService(Components.interfaces.nsIAlertsService);
	vAlertSvc.showAlertNotification(pIco,  ut.sbBrand ? ut.sbBrand.GetStringFromName("brandShortName")+" > "+pTitle : pTitle, pText, pTextClickable , pListenerParam, pListener);
}

ut.confirm = function(pText, pTitle, pLabelOk, pLabelCancel, pCheckMsg, pChecked){
	try{
		var vService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
		var vFlag = vService.BUTTON_TITLE_IS_STRING * vService.BUTTON_POS_0 + vService.BUTTON_TITLE_IS_STRING * vService.BUTTON_POS_1;
		
		return vService.confirmEx(	window, 
									pTitle ? pTitle : "Confirmation", 
									pText,
									vFlag,
									pLabelOk || "Ok",
									pLabelCancel || "Annuler",
									null,
									pCheckMsg, 
									pChecked || {}
								  ) == 0;
	}catch(e){ut.debug("ut.confirm failed::::"+e);}
	return true;
}


ut.confirm3 = function(pText, pTitle, pLabelBtnOk, pLabelBtnCancel, pLabelBtn3, pCheckMsg, pChecked){
	try{
		var vService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
		var vFlag = vService.BUTTON_TITLE_IS_STRING * vService.BUTTON_POS_0
					+ vService.BUTTON_TITLE_IS_STRING * vService.BUTTON_POS_1
					+ vService.BUTTON_TITLE_IS_STRING * vService.BUTTON_POS_2;
		return vService.confirmEx(	window, 
									pTitle ? pTitle : "Confirmation", 
									pText,
									vFlag,
									pLabelBtnOk,
									pLabelBtnCancel,
									pLabelBtn3,
									pCheckMsg, 
									pChecked || {}
								  );
	}catch(e){ut.debug("ut.confirm3 failed::::"+e);}
	return true;
}

ut.prompt = function(pText, pTitle, pDefaultVal, pCheckMsg, pChecked){
	var vService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
	var vResCheck = {};
	vResCheck.value = pChecked;
	var vRes = {};
	vRes.value = pDefaultVal || "";
	var vBtnOk = vService.prompt(window, pTitle ? pTitle : "Question", pText, vRes, pCheckMsg, vResCheck);
	return vBtnOk ? vRes.value : null;
}

ut.writeWait = function (pBox, pMessage){
	var vDoc = (pBox.nodeType==9) ? pBox : pBox.ownerDocument;
	if(pBox.localName.toLowerCase() == "html") {
		if(pBox.body) {
			pBox = pBox.body;
		} else {
			pBox = pBox.appendChild(vDoc.createElementNS("http://www.w3.org/1999/xhtml", "body"));
		}
	}
	while(pBox.hasChildNodes()) pBox.removeChild(pBox.lastChild);
	var vDesc = vDoc.createElementNS("http://www.w3.org/1999/xhtml", "div");
	vDesc.setAttribute("style", "font-style:italic; color:grey;");
	vDesc.appendChild(vDoc.createTextNode(pMessage || "Chargement en cours..."));
	pBox.appendChild(vDesc);
}


ut.openUniqueDialog = function (pWindowType, pUrl, pName, pOptions, pExtraArgument){
	var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
  	var vModalWin = wm.getMostRecentWindow(pWindowType);
	if (vModalWin) {
    	vModalWin.focus();
    	return vModalWin;
	}else{
    	return window.openDialog(pUrl, pName, pOptions, pExtraArgument);
	}
}


ut.openWindowWait = function (pType, pTitle, pMessage){
	return window.openDialog("chrome://scenaricms/content/util/wait.xul", "", "chrome,centerscreen,resizable,dialog=no", pTitle, pMessage);
}
ut.closeWindowWait = function (pWin) {

	if(pWin) window.setTimeout(function(pWin){pWin.close();}, 10, pWin);
}


ut.getXulWin = function(pWin) {
	var vCI = Components.interfaces;
	return pWin.QueryInterface(vCI.nsIInterfaceRequestor)
		.getInterface(vCI.nsIWebNavigation)
		.QueryInterface(vCI.nsIDocShellTreeItem)
		.treeOwner
		.QueryInterface(vCI.nsIInterfaceRequestor)
		.getInterface(vCI.nsIXULWindow);
}


ut.isWindowModal = function(pWin){
	return ((ut.getXulWin(pWin || window).chromeFlags & Components.interfaces.nsIWebBrowserChrome.CHROME_MODAL) != 0);
}


ut.loadExternalURL = function(pUrl){
  if (pUrl) {
    var vIoService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
    var vUri = vIoService.newURI(pUrl, null, null);
    var vExtProtocolSvc = Components.classes["@mozilla.org/uriloader/external-protocol-service;1"].getService(Components.interfaces.nsIExternalProtocolService);
    vExtProtocolSvc.loadUrl(vUri);
  }
}


ut.openExternalLocalFile = function wspOpenExternal(pFilePath, pReveal) {
	var vFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
	vFile.initWithPath(pFilePath);
	try {
		if(pReveal) vFile.reveal(); else vFile.launch();
	} catch(e) {


		if(pReveal && ! vFile.isDirectory()) vFile = vFile.parent;
		var vUri = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService).newFileURI(vFile);
		var vProtocolSvc = Components.classes["@mozilla.org/uriloader/external-protocol-service;1"].getService(Components.interfaces.nsIExternalProtocolService);
		vProtocolSvc.loadUrl(vUri);
	}
}



ut.getXml = function(pElement){
	return pElement ? new XMLSerializer().serializeToString(pElement) : "";
}

ut.parseXml = function (pString){
	try{
		var vParser = new DOMParser();
		var vDoc = vParser.parseFromString(pString, "text/xml");
		var vResult = vDoc.documentElement;
		if (vResult.tagName!="parserError" && vResult.namespaceURI!="http://www.mozilla.org/newlayout/xml/parsererror.xml"){
			return vResult;
		}else{
			return null;
		}
	}catch(e){
		this.debug("ut.parseXml:"+e);
		return null;
	}
}


ut.getDomFromLocalFileUrl = function (pUrl){
	try{
		var vIoService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
		var vChannel = vIoService.newChannel(pUrl,null,null);
		vChannel.contentType = "text/xml";
		var vInput = vChannel.open();
		try {
			if(vChannel.contentLength > 0){//NOTE : crash brutal de xulrunner lorsque vBuf.init(xx, 0) !!
				var vBuf = Components.classes["@mozilla.org/network/buffered-input-stream;1"].createInstance(Components.interfaces.nsIBufferedInputStream);
				vBuf.init(vInput, vChannel.contentLength);
				var vParser = Components.classes["@mozilla.org/xmlextras/domparser;1"].createInstance(Components.interfaces.nsIDOMParser);
				return vParser.parseFromStream(vBuf, null, vChannel.contentLength, "text/xml");
			}else{
				return null;
			}
		} finally {
			vInput.close();
		}
	}catch(e){
		this.debug("Impossible de parser le fichier de l'URL : '"+pUrl+"': "+e);
		return null;
	}
}


ut.getDomFromHttpUrl = function(pUrl){
	try {
		var vReq = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"].createInstance(Components.interfaces.nsIXMLHttpRequest);
		vReq.open("GET", pUrl, false, null, null);
		vReq.overrideMimeType("text/xml");
		vReq.send(null);
		return vReq.responseXML;
	} catch(e){
		this.debug("getDomFromHttpUrl. Echec au chargement de : "+pUrl+" : "+e);
		return null;
	}
}


ut.fSharedXml = {};
ut.getSharedDom = function(pUrl){
	try{
		var vXml = this.fSharedXml[pUrl];
		if(vXml) return vXml;
		vXml = document.implementation.createDocument("", "", null);
		vXml.async = false;
		vXml.load(pUrl);
		this.fSharedXml[pUrl] = vXml;
		return vXml;
	} catch(e){
		this.debug("ut.getSharedDom(). Echec au chargement de : "+pUrl+" : "+e);
		return null;
	}
}


ut.execXsl = function(pXsl, pSrcNode, pDstNode, pTabParamsXsl){
	if(!pXsl) ut.debug("ut.execXsl : XSL null.");
	var vXsltProcessor = new XSLTProcessor();
	try {
		vXsltProcessor.importStylesheet(pXsl);
	} catch(e){
		ut.debug("Parsing xsl failed::"+ut.getXml(pXsl));
	}
	if(pTabParamsXsl){
		for(var ii in pTabParamsXsl){
			vXsltProcessor.setParameter("", ii, pTabParamsXsl[ii]);
		}
	}
	var vFragment = vXsltProcessor.transformToFragment(pSrcNode, (pDstNode.nodeType==9) ? pDstNode : pDstNode.ownerDocument);

	while(pDstNode.hasChildNodes()) pDstNode.removeChild(pDstNode.lastChild);
	pDstNode.appendChild(vFragment);
}


ut.selectSingleNode = function(pNodeXml, pXpath){
	if(pNodeXml==null) return null;
	var vDoc = pNodeXml.ownerDocument;
	if(vDoc==null) vDoc = pNodeXml;


	var vRes = vDoc.evaluate(pXpath, pNodeXml, vDoc.createNSResolver(vDoc.documentElement), XPathResult.FIRST_ORDERED_NODE_TYPE, null);
	return vRes.singleNodeValue;
}

ut.indentDom = function(pRoot) {
	var vWhiteSpaces = this.fWhiteSpaces;
	if(!vWhiteSpaces) {
		var vText = "\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t";
		vWhiteSpaces = [];
		for(var i = 0; i <=25; i++) vWhiteSpaces[i] = vText.substring(0, i+1);
		this.fWhiteSpaces = vWhiteSpaces;
	}
	pRoot.normalize();
	var vRoot = pRoot;
	var vDeep = 0;
	switch(vRoot.nodeType) {
		case 9 : //Document
			vRoot = pRoot.documentElement;
			if(!vRoot) return pRoot;
			break;
		case 11 : //Fragment
			vDeep = -1;
	}
	var vNode = vRoot;
	function isText(pNode){
		return (pNode.nodeType == 3 && /\S/.test(pNode.data)) || pNode.nodeType == 4;
	}
	function indent(){
		if(vNode.nodeType == 3) {

			vNode.data = vWhiteSpaces[Math.min(vDeep, 25)];
			if(vNode.nextSibling) vNode = vNode.nextSibling;
		} else {

			vNode.parentNode.insertBefore(vNode.ownerDocument.createTextNode(vWhiteSpaces[Math.min(vDeep, 25)]), vNode);
		}
	}
	var vPrevIsText = false;
	var vPreserveSpace = [false];
	while(vNode) {

		while(vNode.hasChildNodes()) {
			vDeep++;
			vPreserveSpace[vDeep] = (vDeep>1 && vPreserveSpace[vDeep-1]) ? ! (vNode.getAttribute("xml:space")=="default") : vNode.nodeType==1 && vNode.getAttribute("xml:space")=="preserve";

			vNode = vNode.firstChild;
			vPrevIsText = isText(vNode);
			if( ! vPrevIsText && ! vPreserveSpace[vDeep]){

				indent();
			}
		}

		while(vNode.nextSibling == null){
			vDeep--;

			if(vDeep>=0 &&  ! vPrevIsText && ! isText(vNode) && ! vPreserveSpace[vDeep+1]){
				if(vNode.nodeType == 3) {
					vNode.data = vWhiteSpaces[Math.min(vDeep, 25)];
				} else {
					vNode.parentNode.insertBefore(vNode.ownerDocument.createTextNode(vWhiteSpaces[Math.min(vDeep, 25)]), null);
				}
			}
			if(vNode == vRoot || vNode.parentNode == vRoot) return pRoot;
			vNode = vNode.parentNode;
			vPrevIsText = vNode.previousSibling != null && isText(vNode.previousSibling);
		}
		vNode = vNode.nextSibling;
		if(! isText(vNode)){

			if( ! vPrevIsText) {
				if(! vPreserveSpace[vDeep]) indent(); 
			} else {
				vPrevIsText = false;
			}
		} else {
			vPrevIsText = true;
		}
	}
	return pRoot;
}

ut.getFirstChildByLocalName = function (pParent, pLocalName) {
	if(!pParent) return null;
	var vCh = pParent.firstChild;
	while(vCh) {
		if(vCh.nodeType==1 && vCh.localName==pLocalName) return vCh;
		vCh = vCh.nextSibling;
	}
	return null;
}



ut.searchUriObject = function(pNode){
	while(pNode && ! ("fUriObject" in pNode)) pNode = pNode.parentNode;
	return pNode && pNode.fUriObject;
}
ut.createUriObjectByUri = function(pDataProvider, pUri){
	if( ! pUri) return null;
	if(pUri.lastIndexOf(".")>0){
		return new UriObjectItem(pUri, pDataProvider);
	} else if(pUri.lastIndexOf("/")>0){
		return new UriObjectSpace(pUri, pDataProvider);
	} else {
		return new UriObjectWsp(ut.getWspFromUri(pUri), pDataProvider);
	}
	return null;
}

ut.buildUri = function(pWsp, pSpace, pItem, pUriRes){
	var vRes = (pWsp ? pWsp+"/" : "/") +pSpace;
	if(pItem) {
		vRes += "/"+pItem;
		if(pUriRes) {
			if(pUriRes.charAt(0)=="/") vRes += pUriRes; else vRes += "/"+pUriRes;
		}
	}
	return vRes;
}
ut.getWspFromUri = function(pUri){
	if(pUri) {
		var vIdx = pUri.indexOf("/");
		if(vIdx>0){
			return pUri.substring(0, vIdx);
		}
		return pUri;
	}
	return "";
}
ut.getSpaceFromUri = function(pUri){
	if(pUri) {
		var vIdx = pUri.indexOf("/")+1;
		if(vIdx>0){
			var vIdx2 = pUri.indexOf(".", vIdx);
			if(vIdx2<0) return pUri.substring(vIdx);
			vIdx2 = pUri.lastIndexOf("/", vIdx2);
			return pUri.substring(vIdx, vIdx2);
		}
	}
	return "";
}
ut.getCodeFromUri = function(pUri){
	if(pUri) {
		var vIdx = pUri.indexOf(".", vIdx);
		if(vIdx>=0){
			var vIdx2 = pUri.lastIndexOf("/", vIdx)+1;
			var vIdx3 = pUri.indexOf("/", vIdx);
			if(vIdx3<0) vIdx3 = pUri.indexOf("#", vIdx);
			if(vIdx3<0) return pUri.substring(vIdx2);
			return pUri.substring(vIdx2, vIdx3);
		}
	}
	return "";
}
ut.getUriResFromUri = function(pUri){
	if(pUri) {
		var vIdx = pUri.indexOf(".");
		if(vIdx<=0) return "";
		vIdx = pUri.indexOf("/", vIdx);
		if(vIdx>0) {
			var vIdx2 = pUri.indexOf("#", vIdx);
			if(vIdx2<=0) return pUri.substring(vIdx);
			return pUri.substring(vIdx, vIdx2);
		}
	}
	return "";
}

ut.getLeafFromUri = function(pUri){
	if(pUri) {
		var vIdx = pUri.lastIndexOf("/");
		if(vIdx<0) return pUri;
		vIdx++;
		var vIdx2 = pUri.indexOf("#", vIdx);
		if(vIdx2<=0) return pUri.substring(vIdx);
		return pUri.substring(vIdx, vIdx2);
	}
	return "";
}
ut.getUriParent = function(pUri){
	if(pUri) {
		var vIdx = pUri.lastIndexOf("/");
		if(vIdx<0) return "";
		return pUri.substring(0, vIdx);
	}
	return "";
}
ut.addLeafToUri = function(pUriParent, pLeafName){
	return pUriParent+"/"+pLeafName;
}


ut.getItemPathFromUri = function(pUri){
	if(pUri) {
		if (pUri.length==0 || pUri.charAt(0)=="/") return pUri;
		var vIdx = pUri.indexOf("/");
		return vIdx>=0 ? pUri.substring(vIdx) : pUri;
	}
	return "";
}
ut.getUriFromItemPath = function(pCdWsp, pItemPath){
	return pCdWsp+pItemPath;
}

ut.isSubUri = function (pAncestorUri, pUri){
	var vParentLen = pAncestorUri.length;
	if(pUri.length > vParentLen && pUri.substring(0, vParentLen) == pAncestorUri) {
		var vChar = pUri.charAt(vParentLen);
		return vChar=="/";
	}
	return false;
}



ut.setContextActions = function (pNode, pDataProvider, pCurrentUri, pCurrentUriObject){
	pNode.fContextActions = {fDataProvider: pDataProvider, fUri:pCurrentUri, fUriObject:pCurrentUriObject};
}
ut.getContextActions = function (pMenuItemNode){
	while(pMenuItemNode && !("fContextActions" in pMenuItemNode)) pMenuItemNode = pMenuItemNode.parentNode;
	return pMenuItemNode ? pMenuItemNode.fContextActions : null;
}


ut.getUrlIcon = function(pPrefix, pStatus){
	switch(pStatus) {
		case 1 : return pPrefix+"/icovalid.png";
		case 2 : return pPrefix+"/icowarning.png";
		case 3 : return pPrefix+"/icoerror.png";
		case 11 : return pPrefix+"/icopending.png";
		case 12 : return pPrefix+"/icounvalid.png";
		case "1" : return pPrefix+"/icovalid.png";
		case "2" : return pPrefix+"/icowarning.png";
		case "3" : return pPrefix+"/icoerror.png";
		case "11" : return pPrefix+"/icopending.png";
		case "12" : return pPrefix+"/icounvalid.png";
	}
	return pPrefix+"/icovalid.png";
}




ut.updateCommands = function(){
	try {
		for (var i =0; i < arguments.length; i++) {
			var vCmd = arguments[i];
			var vCtrl = top.document.commandDispatcher.getControllerForCommand(vCmd);

			var vEnabled = false;
			if (vCtrl) vEnabled = vCtrl.isCommandEnabled(vCmd);
			var vNode = document.getElementById(vCmd);
			if(vNode){
				if(vEnabled) vNode.removeAttribute("disabled");
				else vNode.setAttribute("disabled", "true");
			}
		}
	} catch (e) {
		ut.debug("ut.goUpdateCommand('"+pCmd+"') en erreur.\n"+e);
	}
}

ut.doCommand = function(pCmd){
  try {
    var vCtrl = top.document.commandDispatcher.getControllerForCommand(pCmd);
    if (vCtrl && vCtrl.isCommandEnabled(pCmd)) vCtrl.doCommand(pCmd);
  } catch (e) {
    ut.debug("ut.doCommand('"+pCmd+"') en erreur.\n"+e);
  }
}

ut.fPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
ut.fMozDirs = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties);

ut.fAppPath = null;
ut.getAppPath = function() {
	if (ut.fAppPath) {
		return ut.fAppPath;
	} else {
		var vAppDirPath = null;
		try {
			vAppDirPath = ut.fPrefs.getCharPref("scenari.app.path");
			ut.fAppPath = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
			ut.fAppPath.initWithPath(vAppDirPath);
		} catch(e){
			ut.fAppPath = ut.fMozDirs.get("ARes", Components.interfaces.nsIFile).parent.parent;//répertoire bin
		}
		return ut.fAppPath;
	}
}




ut.debug = function(pText) {
	var vConsoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
	vConsoleService.logStringMessage(pText);//window.location.href+" : "+
}


ut.listProperties = function(pObj){
	var vRes = "";
	var vProp = null;
	for (vProp in pObj) {
		try {
			vRes += vProp +'(' + pObj[vProp]+ ')'+ "\n";
		} catch(e){
			vRes += vProp +' -> toString in error\n';
		}
	}
	return vRes;
}


ut.fFsRightsDefault = 0755; 


ut.fFsRightsAll = 0777; 


ut.fFsRightsUserOnly = 0700; 



ut.isWin = navigator.platform.toLowerCase().indexOf("win") != -1;


ut.isMac = navigator.platform.toLowerCase().indexOf("mac") != -1;


ut.isUnix = navigator.platform.toLowerCase().indexOf("unix") != -1 || navigator.platform.toLowerCase().indexOf("linux") != -1 || navigator.platform.toLowerCase().indexOf("sun") != -1;




ut.isClickContextMenu = function(pEvent){
	return ut.isMac ? pEvent.ctrlKey : pEvent.button == 2;
}

ut.isAccelPress = function(pEvent) {
	return ut.isMac ? pEvent.metaKey : pEvent.ctrlKey;
}



ut.getCode = function(pString, pKey){
	var vAllowedCodeChars = "1234567890abcdefghijklmnopqrstuvwxyzABSDEFGHIJKLMNOPQRSTUVWXYZ";
	if (pString.length == 0) return "";
	try{
		var vCode = "";
		var vEncodeKey = pKey? pKey : "scenari"; //Default the the key to "scenari"
		var vCodeLen = vEncodeKey.length;
		

		for (var i=0; i<vCodeLen; i++) {
			var vEncodeKey_value = "";
			var vOffset = Math.round((i)*(vEncodeKey.length/vCodeLen));
			for(var ii=vOffset; ii<vEncodeKey.length; ii++) vEncodeKey_value += vEncodeKey.charCodeAt(ii);
			for(var ii=0; ii<vOffset; ii++) vEncodeKey_value += vEncodeKey.charCodeAt(ii);
			
			var vString_value = "";
			vOffset = Math.round((i)*(pString.length/vCodeLen));
			for(var ii=vOffset; ii<pString.length; ii++) vString_value += pString.charCodeAt(ii);
			for(var ii=0; ii<vOffset; ii++) vString_value += pString.charCodeAt(ii);

			vCode += vAllowedCodeChars.charAt((i + vEncodeKey_value + vString_value) % vAllowedCodeChars.length);
		}
		return vCode;
	}catch(e){
		ut.debug("ut.prototype.encode :: "+e);
	}
}



ut.getBoolean = function(pString){
	return pString && (pString=="yes" || pString=="true" || pString=="1");
}


ut.escapeXml = function(pStr){
	var result = pStr.replace(new RegExp("&", "gm"), "&amp;").replace(new RegExp("<", "gm"), "&lt;")
	 	             .replace(new RegExp(">", "gm"), "&gt;").replace(new RegExp('"', "gm"), "&quot;")
	 	             .replace(new RegExp("'", "gm"), "&#39;");
	return result;
}


ut.appRestart = function(pReloadUi, pForce) {
	try{
		if(pReloadUi) ut.fPrefs.setBoolPref("scenari.ui.reload", true);
		var nsIAppStartup = Components.interfaces.nsIAppStartup;
		Components.classes["@mozilla.org/toolkit/app-startup;1"].getService(nsIAppStartup).quit((pForce ? nsIAppStartup.eForceQuit : nsIAppStartup.eAttemptQuit ) | nsIAppStartup.eRestart);
	}catch(e){ut.debug(e);}
}


ut.formatStr = function(pSrc /*, pReplacement1, pReplacement2 [...]*/) {
    var vArgs = arguments;
    var vIdx = 1;
    function rep(pStr, p1, p2){
        return p1=="%%" ? "%" : vArgs[(p2 ? p2 : vIdx++)];
    }
    return pSrc.replace(/(%(?:%|(?:(\d+)\$)?s))/g, rep);
};


ut.cnxLocalSvrMaxAttempts = (ut.isMac ? 25 : 15);



try {
	ut.defaultFontSize = ut.fPrefs.getCharPref("scenari.defaultFontSize");
} catch(e){
	ut.defaultFontSize = "";
}
ut.initDefaultFontSize = function() {
	try {if(ut.defaultFontSize) document.documentElement.style.fontSize = ut.defaultFontSize;} catch(e){ut.debug(e);}
}



ut.setDefaultFontSize = function(pNewVal) {
	ut.defaultFontSize = pNewVal;
	ut.fPrefs.setCharPref("scenari.defaultFontSize", pNewVal);
	if(desk) desk.doRefreshWin();
}

ut.initDefaultFontSizePopup = function(pMenuPopup) {
	var vCh = pMenuPopup.firstChild;
	while(vCh) {
		if(vCh.nodeType==1 && vCh.getAttribute("value")==ut.defaultFontSize) {
			vCh.setAttribute("checked", "true");
			return;
		}
		vCh = vCh.nextSibling;
	}
}



ut.fCurrentLang = null;
ut.getCurrentLang = function() {
	if(this.fCurrentLang == null) {
		try {
			this.fCurrentLang = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch).getCharPref("spellchecker.dictionary");
		} catch(e){
			this.fCurrentLang = "";
		}
	}
	return this.fCurrentLang;
}

ut.initDictionnariesPopup = function(pMenuPopup) {
try{
	if ( ! ("@mozilla.org/spellchecker;1" in Components.classes) ) return;
	while(pMenuPopup.hasChildNodes()) pMenuPopup.removeChild(pMenuPopup.lastChild);
	var vSpellChecker = Components.classes["@mozilla.org/spellchecker/engine;1"].getService(Components.interfaces.mozISpellCheckingEngine);
	var vList = {};
	vSpellChecker.getDictionaryList(vList, {});
	vList = vList.value;
	var vCurrLang = ut.fPrefs.getCharPref("spellchecker.dictionary");
	for each(var vKey in vList) {
		var vIt = pMenuPopup.ownerDocument.createElementNS(XULNS, "menuitem");
		vIt.setAttribute("label", vKey);
		vIt.setAttribute("type", "checkbox");
		vIt.setAttribute("value", vKey);
		if(vCurrLang == vKey) {
			vIt.setAttribute("checked", "true");
		} else {
			vIt.addEventListener("command", function(pEvent){
					try {
						ut.fPrefs.setCharPref("spellchecker.dictionary", pEvent.target.getAttribute('value'));
						if(desk) desk.doRefreshWin();
					} catch(e){ut.debug(e);}
				}, false);
		}
		pMenuPopup.appendChild(vIt);
	}
}catch(e){ut.debug(e);}
}



ut.startLocalOO = function(pURI) {
	try{
		var vOOBinPath = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
		var vUri = pURI;
		var vProcessArgs = [];
		var vOOFound = false;
		var vSeparator = ut.isWin ? "\\" : "/";
		
		var vOoDirMode = 0;
		try{vOoDirMode = ut.fPrefs.getIntPref("scenari.tools.oo.dirMode");} catch(e){};
		
		if(vOoDirMode==1){//OO embarqué
			var vOoEmbedPath = null;
			try{vOoEmbedPath = ut.fPrefs.getCharPref("scenari.tools.oo.embed.path");} catch(e){};
			if(vOoEmbedPath){ 
				vOOBinPath.initWithPath(ut.getAppPath().path + vSeparator + vOoEmbedPath);
				vOOBinPath.appendRelativePath("soffice"+(ut.isWin?".exe":""));
			}
			try{vOOFound = vOOBinPath.exists()}catch(e){}
		}else if(vOoDirMode==2){//OO sur le DD
			var vOoCustomPath = null;
			try{vOoCustomPath = ut.fPrefs.getComplexValue("scenari.tools.oo.path", Components.interfaces.nsILocalFile);} catch(e){};
			if(vOoCustomPath){
				vOOBinPath.initWithPath(vOoCustomPath.path);
				vOOBinPath.appendRelativePath("soffice"+(ut.isWin?".exe":""));
			}
			try{vOOFound = vOOBinPath.exists()}catch(e){}
		}else{// ouverture de OO par défaut
			var vEnv = Components.classes["@mozilla.org/process/environment;1"].createInstance(Components.interfaces.nsIEnvironment);
			if (vEnv.exists("UNO_PATH")){ // Si UNO_PATH est défini alors on le prends comme emplacement de OpenOffice
				ut.debug("ut.startLocalOO (UNO_PATH): starting OO from: "+vEnv.get("UNO_PATH"));
				vOOBinPath.initWithPath(vEnv.get("UNO_PATH"));
				vOOBinPath.appendRelativePath("soffice"+(ut.isWin?".exe":""));
			}else if(ut.isMac){// mac : recherche automatique dans les LaunchServices.
				var vShPath = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
				vShPath.initWithPath("/bin/sh");
				var vLsRegPath = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
				vLsRegPath.initWithPath("/System/Library/Frameworks/CoreServices.framework/Versions/A/Frameworks/LaunchServices.framework/Versions/A/Support/lsregister");
				if (!vLsRegPath.exists()) vLsRegPath.initWithPath("/System/Library/Frameworks/ApplicationServices.framework/Versions/A/Frameworks/LaunchServices.framework/Versions/A/Support/lsregister"); // 10.4
				if (vShPath.exists() && vLsRegPath.exists()){
					var vTmpPath = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
					vTmpPath.initWithPath("/tmp/locOO"+Math.round(Math.random()*10000));
					while (vTmpPath.exists()) vTmpPath.initWithPath("/tmp/locOO"+Math.round(Math.random()*10000));
					var vShProcess = Components.classes["@mozilla.org/process/util;1"].createInstance(Components.interfaces.nsIProcess);
					vShProcess.init(vShPath);
					var vArgs = [];
					vArgs.push("-c");
					vArgs.push("\""+vLsRegPath.path+"\" -dump | /usr/bin/grep -B 3 -E 'org.(open|libre)office.script' | /usr/bin/grep path: | /usr/bin/grep -o /.*$ | sort -fr > "+vTmpPath.path);
					vShProcess.run(true, vArgs, vArgs.length);
					if (vShProcess.exitValue==0 && vTmpPath.exists()){
						var vTmpStream = Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream);
						vTmpStream.init(vTmpPath,0x01,0,0);
						var vTmpJsStream = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
						vTmpJsStream.init(vTmpStream);
						for each (var vPathStr in vTmpJsStream.read(vTmpPath.fileSize).split("\012")) {
							if (vPathStr.indexOf("/Volumes") != 0 && vPathStr.indexOf("/.Trash/") == -1) {
 								vOOBinPath.initWithPath(vPathStr+"/Contents/MacOS");
								vOOBinPath.appendRelativePath("soffice");
								try{vOOFound = vOOBinPath.exists()}catch(e){}
								if (vOOFound){
									ut.debug("ut.startLocalOO (LaunchServices): OO found: "+vOOBinPath.path);
									break;
								}
							}
						}
					}
				}
			}else if(ut.isWin){// win (on interroge la base de registres)
				var vWrk = Components.classes["@mozilla.org/windows-registry-key;1"].createInstance(Components.interfaces.nsIWindowsRegKey);
				var vOOKeys = [ "Software\\OpenOffice.org\\UNO\\InstallPath",
				                "Software\\LibreOffice\\UNO\\InstallPath" ];
				var vOOLocalPath = "";
				for each (var vOOKey in vOOKeys) {
					try{
						vWrk.open(vWrk.ROOT_KEY_CURRENT_USER, vOOKey, vWrk.ACCESS_READ);
						vOOLocalPath = vWrk.readStringValue("");
					}catch(e){
						try{
							vWrk.open(vWrk.ROOT_KEY_LOCAL_MACHINE, vOOKey, vWrk.ACCESS_READ);
							vOOLocalPath = vWrk.readStringValue("");
						}catch(e){
							ut.debug("ut.startLocalOO: OO n'a pas été trouvé dans la base de registre avec la clée : "+vOOKey);
						}
					}
					if(vOOLocalPath!="") break;
				}
				if(vOOLocalPath!=""){
					vOOBinPath.initWithPath(vOOLocalPath);
					vOOBinPath.appendRelativePath("soffice.exe");
					ut.debug("ut.startLocalOO (Windows registry): OO found: "+vOOLocalPath);
				} else ut.debug("ut.startLocalOO: OO n'a pas été trouvé dans la base de registre");
				vWrk.close();
				try{vOOFound = vOOBinPath.exists()}catch(e){}
			}else if(ut.isUnix){// lin
				if (vEnv.exists("PATH")){ // Look for OO in the system path
					for each (var vPathStr in vEnv.get("PATH").split(":")) {
						try{
							var vPath = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
							vPath.initWithPath(vPathStr);
							vPath.appendRelativePath("soffice");
							if (vPath.exists()){
								while(vPath.isSymlink()) vPath.initWithPath(vPath.target);
								var vPathBin = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
								vPathBin.initWithFile(vPath.parent);
								vPathBin.appendRelativePath("soffice.bin");
								if (vPathBin.exists()){
									vPath.normalize();
									vOOBinPath.initWithFile(vPath);
									ut.debug("ut.startLocalOO (PATH): OO found: "+vOOBinPath.path);
									break;
								}					
							}
						}catch(e){}
					}
					try{vOOFound = vOOBinPath.exists()}catch(e){}
				}
				if (!vOOFound){ // use the locate command to find OO
					var vShPath = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
					vShPath.initWithPath("/bin/sh");
					if (vShPath.exists()){
						var vTmpPath = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
						vTmpPath.initWithPath("/tmp/locOO"+Math.round(Math.random()*10000));
						while (vTmpPath.exists()) vTmpPath.initWithPath("/tmp/locOO"+Math.round(Math.random()*10000));
						var vShProcess = Components.classes["@mozilla.org/process/util;1"].createInstance(Components.interfaces.nsIProcess);
						vShProcess.init(vShPath);
						var vArgs = [];
						vArgs.push("-c");
						vArgs.push("locate soffice.bin > "+vTmpPath.path);
						vShProcess.run(true, vArgs, vArgs.length);
						if (vShProcess.exitValue==0 && vTmpPath.exists()){
							var vTmpStream = Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream);
							vTmpStream.init(vTmpPath,0x01,0,0);
							var vTmpJsStream = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
							vTmpJsStream.init(vTmpStream);
							for each (var vPathStr in vTmpJsStream.read(vTmpPath.fileSize).split("\012")) {
								var vPathBin = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
								vPathBin.initWithPath(vPathStr);
								if (vPathBin.exists()){
									while(vPathBin.isSymlink()) vPathBin.initWithPath(vPathBin.target);
									var vPath = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
									vPath.initWithFile(vPathBin.parent);
									vPath.appendRelativePath("soffice");
									if (vPath.exists()){
										vPath.normalize();
										vOOBinPath.initWithFile(vPath);
										ut.debug("ut.startLocalOO (locate): OO found: "+vOOBinPath.path);
										break;
									}					
								}
							}
							vTmpJsStream.close();
							vTmpPath.remove(false);
						}
					}
					try{vOOFound = vOOBinPath.exists()}catch(e){}
				}			
				if (!vOOFound){ // look for OO in common paths
					var vPaths = [	"/opt/openoffice.org3/program",
					              	"/opt/libreoffice3.4/program",
					              	"/opt/libreoffice/program",
									"/usr/lib/openoffice/program",
									"/usr/lib/libreoffice/program",
									"/usr/lib/openoffice.org/program",
									"/usr/lib/openoffice.org3/program",
									"/usr/lib/ooo/program"
								];
					for each (var vPathStr in vPaths) {
						var vPath = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
						vPath.initWithPath(vPathStr);
						vPath.appendRelativePath("soffice.bin");
						if (vPath.exists()){
							vOOBinPath.initWithFile(vPath.parent);
							vOOBinPath.appendRelativePath("soffice");
							ut.debug("ut.startLocalOO (common path): OO found: "+vOOBinPath.path);
							break;
						}
					}
					try{vOOFound = vOOBinPath.exists()}catch(e){}
				}
			}
		}

		if(vOOFound){
			var vOOProcess = Components.classes["@mozilla.org/process/util;1"].createInstance(Components.interfaces.nsIProcess);
			vOOProcess.init(vOOBinPath);
			if(! ut.isMac) vProcessArgs.push("-nofirststartwizard");
			vProcessArgs.push(vUri);
			vOOProcess.run(false, vProcessArgs, vProcessArgs.length);
		}else{
			ut.alert("L\'application OpenOffice n\'a pu être trouvée.");
			throw ("L'application OpenOffice n'a pu être trouvée");
		}
	}catch(e){
		ut.debug("ut.startLocalOO : " + e);
	}
}

ut.filterInlineLoc = function(pString) {
	return pString.replace(/\uFFFC(?:(?:[^\uFFFC;]*;)|(?:(?:@|\?)[^\uFFFC;]*))?([^\uFFFC]*)\uFFFC/g, "$1");
}

ut.applyOverlay = function(pTargetDoc, pOverlay) {
	const SONS = "scenari.eu:overlay:1.0";
	var vInsert = pOverlay.nodeType==9 ? pOverlay.documentElement : pOverlay;
	while(vInsert && vInsert.namespaceURI==SONS) {
		switch(vInsert.localName) {
		case "insertElements" :

			var vFromNode = pTargetDoc.getElementById(vInsert.getAttribute("fromId"));
			if(vFromNode) {
				switch(vInsert.getAttribute("position")) {
				case "before" :
					var vCh = vInsert.firstElementChild;
					while(vCh) {
						vFromNode.parentNode.insertBefore(pTargetDoc.importNode(vCh, true), vFromNode);
						vCh = vCh.nextElementSibling;
					}
					break;
				case "after" :
					var vCh = vInsert.lastElementChild;
					while(vCh) {
						vFromNode.parentNode.insertBefore(pTargetDoc.importNode(vCh, true), vFromNode.nextSibling);
						vCh = vCh.previousElementSibling;
					}
					break;
				case "firstChild" :
					var vCh = vInsert.firstElementChild;
					while(vCh) {
						vFromNode.insertBefore(pTargetDoc.importNode(vCh, true), vFromNode.firstChild);
						vCh = vCh.nextElementSibling;
					}
					break;
				case "lastChild" :
					var vCh = vInsert.firstElementChild;
					while(vCh) {
						vFromNode.appendChild(pTargetDoc.importNode(vCh, true));
						vCh = vCh.nextElementSibling;
					}
					break;
				}
			}else{
				ut.debug("Element non trouvé : " + vInsert.getAttribute("fromId"));
			}
			vInsert = vInsert.nextElementSibling;
			break;
		case "overlay" :
			vInsert = vInsert.firstElementChild;
			break;
		default :
			throw "Tag "+vInsert.nodeName+" unknown.";
		}
	}
}