

function ItemnetMgr(){
	this.status = "null";
	this.fViewers = [];
}


ItemnetMgr.prototype.init = function(pDataProvider, pStartUri, pUrlService, pAscendant) {
	try {
		this.fDataProvider = pDataProvider;
		this.fStartUri = pStartUri;
		this.fAscendant = (pAscendant == true);
		this.fParamsReq = (this.fAscendant) ? "RefAsc=": "RefDesc=";
		this.fWsp = ut.getWspFromUri(pStartUri);
		this.fStartUrn = pStartUri.substring(this.fWsp.length+1);
		this.fUrlService = pUrlService || "/u/vueObjet?cdaction=GetItemNet&format=JS";
		this.refreshAll();
	} catch(e){
		ut.debug("ItemnetMgr.init : "+ pStartUri + " - " + e);
	}
}


ItemnetMgr.prototype.refreshAll = function() {
	this.status = "null";
	this.fItemnets = {};
	this.fCurrentTaf = null;
	var vRefresh = {
		execute : function(){
			var vItemMgr = this.fItemnetMgr;
			var vTaf = this;
			function cb(pEvent){
				try {
					eval(pEvent.target.responseText);
					vItemMgr.fItemnetsUpdated = ["*"];
					for(var i = 0; i< vList.length; i++){
						var vIt = vList[i];
						vItemMgr.fItemnets[vIt.urn] = vIt;
					}
				} catch(e){
					ut.debug("ItemnetMgr.refreshAll: "+e+" - "+pEvent.target.responseText);
				} finally {
					vItemMgr.xCloseTaf(vTaf);
				}
			}
			vItemMgr.fDataProvider.loadFromService(vItemMgr.fUrlService+"&param="+encodeURIComponent(vItemMgr.fStartUri+"?"+vItemMgr.fParamsReq+"&Depth=0"), cb, cb);
		},
		fItemnetMgr : this
	};
	this.xAddTaf(vRefresh);
	this.xExecCurrentTaf();
}


ItemnetMgr.prototype.getItemnetRoot  = function(pUrn) {
	return this.fItemnets[this.fStartUrn];
}


ItemnetMgr.prototype.getItemnetByUrn = function(pUrn) {
	return this.fItemnets[pUrn];
}


ItemnetMgr.prototype.getUriFromUrn = function(pUrn) {
	try {
		return this.fWsp + "/" + pUrn;
	} catch(e){
		ut.debug("ItemnetMgr.getUriFromUrn:::"+e);
	}
}


ItemnetMgr.prototype.getUrnParent = function(pUrnChild, pAfterUrn, pTyRef) {
	var vOk = ( ! pAfterUrn);
	for (var vUrnParent in this.fItemnets) {
		if(vOk) {
			var vPtr = this.fItemnets[vUrnParent].ptr;
			while(vPtr) {
				if(vPtr.urn == pUrnChild && (!pTyRef || pTyRef == vPtr.ty)) return vUrnParent;
				vPtr = vPtr.ptr;
			}
		} else if(vUrnParent == pAfterUrn){
			vOk = true;
		}
	}
	return null;
}


ItemnetMgr.prototype.getUrnFromUri = function(pUrn) {
	try {
	var vIdx = pUrn.indexOf("/");
	if(vIdx == this.fWsp.length && this.fWsp == pUrn.substring(0, vIdx)) {
		return pUrn.substring(vIdx+1);
	}
	return null;
	} catch(e){
		ut.debug("ItemnetMgr.getUrnFromUri:::"+e);
	}
}


ItemnetMgr.prototype.registerViewer = function(pItemnetViewer) {
	this.fViewers.push(pItemnetViewer);
}


ItemnetMgr.prototype.unregisterViewer = function(pItemnetViewer) {
	for(var i = 0; i < this.fViewers.length; i++) {
		if(this.fViewers[i] == pItemnetViewer) {
			this.fViewers.splice(i, 1);
			return true;
		}
	}
	return false;
}



ItemnetMgr.prototype.xAddTaf = function(pTaf) {
	var vLastTaf = this.fCurrentTaf;
	while(vLastTaf && vLastTaf.fNextTaf) vLastTaf = vLastTaf.fNextTaf;
	if(vLastTaf) {
		vLastTaf.fNextTaf = pTaf;
	} else {
		this.fCurrentTaf = pTaf;
	}
}


ItemnetMgr.prototype.xExecCurrentTaf = function(){
	var vTaf = this.fCurrentTaf;
	if(vTaf) {
		if(! vTaf.fStarted) {
			vTaf.fStarted = true;
			this.status = "working";
			var vItemnetMgr = this;
			try {

				vTaf.execute();
			} catch(e){
				vItemnetMgr.xCloseTaf(vTaf);
				ut.debug("ItemnetMgr.xExecCurrentTaf:"+e);
			}
		}
	} else {

		var vRefreshTaf = {fStarted:true};
		this.fCurrentTaf = vRefreshTaf;
		this.status = "refreshViewers";
		try{
			if(this.fItemnetsUpdated.length > 0) {
				var vL = this.fViewers.length;
				for (var i = 0; i < vL; i++) {
					try{
						this.fViewers[i].handleItemnetUpdates(this, this.fItemnetsUpdated);
					} catch(e){ut.debug("ItemnetViewer.handleItemnetUpdates: "+this.fViewers[i]+"\n"+e);}
				}
				this.fItemnetsUpdated = [];
			}
		} catch(e){
			ut.debug("ItemnetMgr.xExecCurrentTaf - refreshviewers:"+e);
		} finally {
			if(vRefreshTaf == this.fCurrentTaf) this.fCurrentTaf = vRefreshTaf.fNextTaf;
			if(this.fCurrentTaf) {
				this.xExecCurrentTaf();


			} else {
				this.status = "stable";
			}
		}
	}
	
}


ItemnetMgr.prototype.xCloseTaf = function(pTaf){
	if(pTaf==this.fCurrentTaf) this.fCurrentTaf = this.fCurrentTaf.fNextTaf;
	this.xExecCurrentTaf();
}



ItemnetMgr.prototype.handleUriUpdate = function(pDataProvider, pWspCd, pUriUpdated, pEventType, pIdAuthor){
	try {
	if(pWspCd != this.fWsp) return;
	var vUrnUpdt = pUriUpdated.substring(pWspCd.length+1);
	if(ut.getCodeFromUri(pUriUpdated) == null) {

		for (var vUrn in this.fItemnets) {
			if(ut.isSubUri(vUrnUpdt, vUrn)) {

				this.refreshAll();
				return;
			}
		}
		return;
	}
	if(pEventType==2) {

		if(this.fItemnets[vUrnUpdt]!=null) {

			this.refreshAll();
		}
		return;
	}

	if(this.fAscendant) {

		var vItemMgr = this;
		var vUpdtItInNet = vItemMgr.fItemnets[vUrnUpdt];
		function cb(pEvent){
			try {
			eval(pEvent.target.responseText);
			var vTafUpdate = {
				fItemnetMgr : vItemMgr,
				fNewItem : vList[0],
				execute : function() {
					try {
						var vItemMgr = this.fItemnetMgr;
						var vItems2Update = {};

						for (var vUrn in vItemMgr.fItemnets) {
							var vItem = vItemMgr.fItemnets[vUrn];
							var vPtr = vItem.ptr;
							while(vPtr) {
								if(vPtr.urn == this.fNewItem.urn) vItems2Update[vItem.urn] = vItem;
								vPtr = vPtr.ptr;
							}
						}

						if(vUpdtItInNet) {

							var vPtrPrev = this.fNewItem;
							var vPtr = this.fNewItem.ptr;
							while(vPtr) {
								if(vPtr.ty > 0) {
									var vItem = vItemMgr.fItemnets[vPtr.urn];
									if(vItem) vItems2Update[vItem.urn] = vItem;

									vPtrPrev.ptr = vPtr.ptr;
								}
								vPtrPrev = vPtr;
								vPtr = vPtr.ptr;
							}

							vItemMgr.fItemnetsUpdated.push(this.fNewItem);
							vItemMgr.fItemnets[this.fNewItem.urn] = this.fNewItem;
						} else {

							var vPtr = this.fNewItem.ptr;
							while(vPtr) {
								var vItem = vItemMgr.fItemnets[vPtr.urn];
								if(vItem) vItems2Update[vItem.urn] = vItem;
								vPtr = vPtr.ptr;
							}
						}

						for(var vUrn in vItems2Update) {
							var vUpdate = {
								fItemnetMgr : vItemMgr,
								fUrn2Update : vUrn,
								execute : function() {
									var vItemMgr = this.fItemnetMgr;
									var vTaf = this;
									function cb(pEvent){
										try {
											eval(pEvent.target.responseText);
											var vIt = vList[0];
											vItemMgr.fItemnetsUpdated.push(vIt);
											vItemMgr.fItemnets[vIt.urn] = vIt;
											var vPtr = vIt.ptr;
											while(vPtr) {
												if( ! vItemMgr.fItemnets[vPtr.urn]) {

													var vLoadNet = {
														fItemnetMgr : vItemMgr,
														fUrn2Load : vPtr.urn,
														execute : function() {
															var vItemMgr = this.fItemnetMgr;
															var vTaf = this;
															function cb(pEvent){
																try{
																	eval(pEvent.target.responseText);
																	for(var i = 0; i< vList.length; i++){
																		var vIt = vList[i];

																		vItemMgr.fItemnets[vIt.urn] = vIt;
																	}
																} catch(e){
																	ut.debug("load itemnet: "+e);
																} finally {
																	vItemMgr.xCloseTaf(vTaf);
																}
															}
															vItemMgr.fDataProvider.loadFromService(vItemMgr.fUrlService+"&param="+encodeURIComponent(vItemMgr.getUriFromUrn(this.fUrn2Load)+"?RefAsc="), cb, cb);						
														}
													};
													vItemMgr.xAddTaf(vLoadNet);
												}
												vPtr = vPtr.ptr;
											}
										} finally {
											vItemMgr.xCloseTaf(vTaf);
										}
									}
									vItemMgr.fDataProvider.loadFromService(vItemMgr.fUrlService+"&param="+encodeURIComponent(vItemMgr.getUriFromUrn(this.fUrn2Update)+"?RefAsc=&Depth=2"), cb, cb);
								}
							}
							vItemMgr.xAddTaf(vUpdate);
						}
					} finally {
						vItemMgr.xCloseTaf(this);
					}
				}
			};
			vItemMgr.xAddTaf(vTafUpdate);
			vItemMgr.xExecCurrentTaf();
			} catch(e){
				ut.debug("callback itemnet : "+e+"\npUriUpdated:::"+pUriUpdated+"\npEventType:::"+pEventType+"\npEvent.target.responseText:::"+pEvent.target.responseText);
			}
		}
		vItemMgr.fDataProvider.loadFromService(vItemMgr.fUrlService+"&param="+encodeURIComponent(pUriUpdated + (vUpdtItInNet ? "?RefDesc=&RefAsc=&Depth=2" : "?RefDesc=&Depth=2") ), cb, cb);		
	} else {


		for (var vUrn in this.fItemnets) {
			if(vUrnUpdt == vUrn) {

				var vUpdate = {
					execute : function() {
						var vItemMgr = this.fItemnetMgr;
						var vTaf = this;
						var vIdAuthor = this.fIdAuthor;
						function cb(pEvent){
							try {
								eval(pEvent.target.responseText);
								var vIt = vList[0];
								if(vIdAuthor) vIt.idAuthor = vIdAuthor;
								vItemMgr.fItemnetsUpdated.push(vIt);
								vItemMgr.fItemnets[vIt.urn] = vIt;
								var vPtr = vIt.ptr;
								while(vPtr) {
									if( ! vItemMgr.fItemnets[vPtr.urn]) {

										var vLoadNet = {
											fItemnetMgr : vItemMgr,
											fUrn2Update : vPtr.urn,
											execute : function() {
												var vItemMgr = this.fItemnetMgr;
												var vTaf = this;
												function cb(pEvent){
													try{
														eval(pEvent.target.responseText);
														for(var i = 0; i < vList.length; i++){
															var vIt = vList[i];

															vItemMgr.fItemnets[vIt.urn] = vIt;
														}
													} catch(e){
														ut.debug("load itemnet: "+e);
													} finally {
														vItemMgr.xCloseTaf(vTaf);
													}
												}
												vItemMgr.fDataProvider.loadFromService(vItemMgr.fUrlService+"&param="+encodeURIComponent(vItemMgr.getUriFromUrn(this.fUrn2Update)+"?RefDesc="), cb, cb);						
											}
										};
										vItemMgr.xAddTaf(vLoadNet);
									}
									vPtr = vPtr.ptr;
								}
							} catch(e){
								ut.debug("update itemnet: "+e);
							} finally{
								vItemMgr.xCloseTaf(vTaf);
							}
						}
						vItemMgr.fDataProvider.loadFromService(vItemMgr.fUrlService+"&param="+encodeURIComponent(pUriUpdated+"?RefDesc=&Depth=2"), cb, cb);
					},
					fItemnetMgr : this,
					fIdAuthor : pIdAuthor
				};
				this.xAddTaf(vUpdate);
			}
		}

		this.xExecCurrentTaf();
	}
	} catch(e) {
		ut.debug("ItemnetMgr.handleUriUpdate::: "+e);
	}
}

ItemnetMgr.prototype.QueryInterface = function(pIId){
	if (!pIId.equals(Components.interfaces.nsISupports) &&
		!pIId.equals(Components.interfaces.scIUriListener))
		throw Components.results.NS_ERROR_NO_INTERFACE;
	return this;
}