

var search = {
	
	fSearchUrl : "/u/search?cdaction=Search&param=",
	
	fMaxResults : 2000,
	
	fWspService : Components.classes["@scenari.com/wspregistryservice;1"].getService(Components.interfaces.scIWspRegistryService),
	
	initSearchPanel : function(pFromUriObject) {
	try{
		if(!this.fWspRegListener) {
			this.fWspRegListener = {
				handleWspRegUpdated : function(pTypeEvent, pIdServer, pWsp) {
					try {
						search.xFillWspList();
						search.xCheckCurrentWspInList();
					}catch(e){
						alert(e);
					}
					return true;
				},
				QueryInterface : function(pIId){
					if (!pIId.equals(Components.interfaces.nsISupports) &&
						!pIId.equals(Components.interfaces.scIWspRegListener))
					throw Components.results.NS_ERROR_NO_INTERFACE;
					return this;
				}
			}
			this.fWspService.addWspRegListener(this.fWspRegListener);
		}
		

		this.fXulSearch = document.getElementById("oSearch");
		this.fXulSearch.hidden = false;
		this.fXulSearch.fUriObject = null;
		var vResults = document.getElementById("oSearchResults");
		vResults.addEventListener("select", search.sOnSelectItem, false);

		if(!pFromUriObject) {
			var vCdWsp = this.xGetCurrentWsp();
			var vDataProv = this.xGetDataProvider();
			if(vCdWsp && vDataProv) pFromUriObject = new UriObjectWsp(vCdWsp, vDataProv);
		}
		this.xFillWspList();
		this.setRootMode("auto", pFromUriObject);
		this.xCheckCurrentWspInList();
	}catch(e){ut.debug(e)}
	},
	resetSearchPanel : function() {
		if(this.fWspRegListener) {
			this.fWspService.removeWspRegListener(this.fWspRegListener);
			this.fWspRegListener = null;
		}
	},
	closeSearchPanel : function() {

		var vCloseFct = this.fXulSearch.getAttribute("onCloseSearchPanel");
		if(vCloseFct) new Function(vCloseFct).call();
	},

	executeSearch : function() {
		try{
			
			var vFromUriObject = this.getFromUriObject();
			if( ! vFromUriObject) {
				ut.alert("Veuillez renseigner au moins un atelier dans lequel effectuer la recherche.", "Critères non spécifiés");
				return;
			}
			var vScopeExp = '<exp type="com.scenari.wsp.src.search.exp.ItemSrcType" srcTypes="12"/>';
			var vRootMode = this.getRootMode();
			if(vRootMode=="item") {
				var vFromItem = document.getElementById("oSearchFromItem");
				var vPathItem = vFromItem.path;

				if(!vPathItem) {
					ut.alert("Veuillez renseigner l\'item à partir duquel parcourir le réseau.", "Critères non spécifiés");
					return;
				}
				var vExp = document.createElementNS("", "exp");
				vExp.setAttribute("type", "com.scenari.src.search.exp.LinkDesc");
				vExp.setAttribute("path", vPathItem);
				vScopeExp += ut.getXml(vExp);
			} else if(vRootMode=="space") {
				var vFromSpace = document.getElementById("oSearchFromSpace");
				var vSpaceUri = ut.getItemPathFromUri(vFromSpace.getUri());
				var vExp = document.createElementNS("", "exp");
				vExp.setAttribute("type", "com.scenari.src.search.exp.RootFolder");
				vExp.setAttribute("path", vSpaceUri);
				vScopeExp += ut.getXml(vExp);
			}
			var vDataProv = vFromUriObject.getDataProvider();
			var vWspCd = ut.getWspFromUri(vFromUriObject.getUri());
			if(vDataProv && vWspCd) {
				try {
					document.getElementById("oSearchLabelResults").value = "Recherche en cours...";
					document.getElementById("oSearchBtn").disabled = true;
					try{
					document.getElementById("oSearchTree").cleanTree();
					}catch(e){ut.debug(e);}
					

					var vRequest;
					var vSearchPanel = this.getCurrentSearchPanelId();
					var vStart = '<request><select max="' + (this.fMaxResults+1) + '"><column dataKey="src_uri"/><column dataKey="item_title"/><column dataKey="item_status"/><column dataKey="item_sgn"/><column dataKey="item_uiPack"/><column dataKey="item_uiModel"/><column dataKey="src_lastModif"/><column dataKey="src_contentStatus"/><column dataKey="fullText_score"/></select><where><and>';
					var vEnd = '</and></where></request>';
					if(vSearchPanel=="oSearchText") {
						var vValue = document.getElementById("oSearchTextbox").value;
						if(vValue) {
							var vExp = document.createElementNS("", "exp");
							vExp.setAttribute("type", "com.scenari.src.search.exp.FullText");
							vExp.setAttribute("textSearch", vValue);
							vRequest = vStart + vScopeExp + ut.getXml(vExp) + vEnd;
						} else {
							vRequest = vStart + vScopeExp + vEnd;
						}
					} else {
						vRequest = vStart + vScopeExp + document.getElementById("oSearchReq").value + vEnd;
					}
					

					

					var vUrl = this.fSearchUrl + vWspCd + "&request=" + encodeURIComponent(vRequest);

	

					var vXulResult = document.getElementById("oSearchResults");
					vXulResult.fTextSearch = null;
					if(vSearchPanel=="oSearchText") {
						vXulResult.fTextSearch = vValue;
					}
					function sAsynchResult(pEvent){
						try{

							var vRes = JSON.parse(pEvent.target.responseText);
							document.getElementById("oSearchResults").buildTree(vDataProv, vWspCd, vRes.columns, vRes.results);
							var vCount = vRes.results.length;
							var vTextCount;
							if(vCount==0) {
								vTextCount = "Aucun résultat"
							} else if(vCount==1) {
								vTextCount = "1 item trouvé"
							} else if(vCount > search.fMaxResults) {
								vTextCount = ut.formatStr("Plus de %s items trouvés", search.fMaxResults);
							} else {
								vTextCount = ut.formatStr("%s items trouvés", vCount);
							}
							document.getElementById("oSearchLabelResults").value = vTextCount;
						}catch(e){
							document.getElementById("oSearchLabelResults").value = "";
							ut.debug(e+"\n"+pEvent.target.responseText.length+"\n"+pEvent.target.responseText);
						} finally {
							document.getElementById("oSearchBtn").disabled = false;
						}
					}
					vDataProv.loadFromService(vUrl, sAsynchResult, sAsynchResult);
				}catch(e){
					document.getElementById("oSearchBtn").disabled = false;
					document.getElementById("oSearchLabelResults").value = "";
				}
			}
		}catch(e){
			ut.debug(e);
		}
	},
	
	sOnSelectItem : function(pEvent){
		var vXulResults = document.getElementById("oSearchResults");
		var vIdx = vXulResults.fXulTree.currentIndex;
		if(vIdx>=0) {
			var vTextSearch = vXulResults.fTextSearch;
			if(vTextSearch) desk.requestForCurrentView({request:"findText", text:vTextSearch, checkCase:false}, true);
		}
	},

	xGetDataProvider : function(){
		var vMainView = desk.fCurrentMainView;
		if(vMainView) {
			var vUriObject = vMainView.fUriObject;
			if(vUriObject) {
				return vUriObject.getDataProvider();
			}
		}
		return null;
	},
	
	xGetCurrentWsp : function(){
		var vMainView = desk.fCurrentMainView;
		if( ! vMainView) return null;
		var vUriObject = vMainView.fUriObject;
		return vUriObject ? ut.getWspFromUri(vUriObject.getUri()) : null;
	},
	
	
	selectTextPanel : function(pEvent){
		document.getElementById("oSearchAdvanced").hidden=true;
		document.getElementById("oSearchText").hidden=false;
	},
	
	selectAdvancedPanel : function(pEvent){
		document.getElementById("oSearchText").hidden=true;
		document.getElementById("oSearchAdvanced").hidden=false;
	},
	
	getCurrentSearchPanelId : function(){
		if(!document.getElementById("oSearchText").hidden) return "oSearchText";
		return "oSearchAdvanced";
	},
	
	getRootMode : function(){
		return document.getElementById("oSearchRootMode").value;
	},
	
	/**
	 *  @param pMode "wsp", "space", "item" ou "auto" = analyse auto en fonction du pFromUriObject. 
	 *  @param pFromUriObject Si non null affecte la valeur, sinon reprend et modifie au besoin la valeur pérécdente.
	 */
	setRootMode : function(pMode, pFromUriObject){
		var vFromUriObject = pFromUriObject || this.getFromUriObject();
		if(pMode=="auto") {
			if(!vFromUriObject) {
				pMode = "wsp";
			} else {
				if(ut.getCodeFromUri(vFromUriObject.getUri())) {
					pMode = "item";
				} else if(ut.getSpaceFromUri(vFromUriObject.getUri())) {
					pMode = "space";
				} else {
					pMode = "wsp";
				}
			}
		}
		if(pFromUriObject) this.xSetFromUriObject(pFromUriObject, true);
		var vRootMode = document.getElementById("oSearchRootMode");
		var vFromItem = document.getElementById("oSearchFromItem");
		var vFromSpace = document.getElementById("oSearchFromSpace");
		if(pMode=="item") {
			vRootMode.selectedIndex = 2;
			vFromSpace.hidden=true;
			if(vFromUriObject) {
				vFromItem.hidden=false;
				vFromItem.fUriObject = vFromUriObject; //en cas de chgt d'atelier.
				vFromItem.setItemByUri(pFromUriObject ? pFromUriObject.getUri() : null);
			} else {
				vFromItem.hidden=true;
			}
		} else if(pMode=="space") {
			vRootMode.selectedIndex = 1;
			vFromItem.hidden=true;
			if(vFromUriObject) {
				vFromSpace.hidden=false;
				vFromSpace.fUriObject = vFromUriObject; //en cas de chgt d'atelier.
				vFromSpace.setSpaceByUri(pFromUriObject ? pFromUriObject.getUri() : null);
			} else {
				vFromSpace.hidden=true;
			}
		} else {

			vRootMode.selectedIndex = 0;
			vFromItem.hidden=true;
			vFromSpace.hidden=true;
		}
	},
	
	getFromUriObject : function(){
		return this.fXulSearch.fUriObject;
	},
	
	xSetFromUriObject : function(pFromUriObject, pNoUiRefresh){
		this.fXulSearch.fUriObject = pFromUriObject;
		if(pNoUiRefresh) return;

		var vRootMode = this.getRootMode();
		if(vRootMode=="item") {
			var vFromItem = document.getElementById("oSearchFromItem");
			if(pFromUriObject) {
				vFromItem.fUriObject = pFromUriObject; //en cas de chgt d'atelier.
				vFromItem.hidden = false;
			} else {
				vFromItem.hidden = true;
			}
		} else if(vRootMode=="space") {
			var vFromSpace = document.getElementById("oSearchFromSpace");
			if(pFromUriObject) {
				vFromSpace.fUriObject = pFromUriObject; //en cas de chgt d'atelier.
				vFromSpace.hidden = false;
			} else {
				vFromSpace.hidden = true;
			}
		}
	},
	
	xFillWspList : function(){
	try{
		var vWspList = this.fWspService.getEnabledWsps();
		var vWspArray = [];
		for(var i =0, vLen = vWspList.Count(); i < vLen; i++) {
			vWspArray.push(vWspList.GetElementAt(i).QueryInterface(Components.interfaces.scIWsp));
		}
		vWspArray.sort(this.xSortWsps);
		var vWspList = document.getElementById("oSearchWspList");
		vWspList.removeAllItems();
		for(var i =0, vLen = vWspArray.length; i < vLen; i++) {
			var vWsp = vWspArray[i];
			var vLabel;
			if(!vWsp.getDataProvider().isLocal()&& vWsp.getTitleServer()) {
				vLabel = vWsp.getCode() + " (" + vWsp.getTitleServer() + ")";
			} else {
				vLabel = vWsp.getCode();
			}
			var vItem = vWspList.appendItem(vLabel, vWsp.getCode(),  vWsp.getComment());
			vItem.setAttribute("idServer", vWsp.getIdServer());
		}
	}catch(e){ut.debug(e);}
	},
	xSortWsps : function(pWsp1, pWsp2){
		var vS1 = pWsp1.getDataProvider().isLocal() ? "" : (pWsp1.getTitleServer() || "");
		var vS2 = pWsp2.getDataProvider().isLocal() ? "" : (pWsp2.getTitleServer() || "");
		var vResServer = vS1.localeCompare(vS2);
		if(vResServer == 0) {
			return pWsp1.getCode().localeCompare(pWsp2.getCode());
		}
		return vResServer;
	},
	
	getCurrentUriSpace : function() {
		return document.getElementById("oSearchFromSpace").getSpace();
	},
	
	onSelectWsp : function(pList) {
		var vItem = pList.selectedItem;
		if(!vItem) {
			this.xSetFromUriObject(null);
			this.setRootMode('wsp', null);
		} else {
			var vCdWsp = vItem.getAttribute("value");
			var vIdServer = vItem.getAttribute('idServer');
			var vWsp = search.fWspService.getWsp(vIdServer, vCdWsp);
			if(vWsp) {
				var vWspObject = new UriObjectWsp(vWsp.getCode(), vWsp.getDataProvider());
				search.setRootMode('wsp', vWspObject);
			} else {
				this.xSetFromUriObject(null);
				this.setRootMode('wsp', null);
			}
		}
	},
	
	/** On controle que le wsp en cours est bien dans la liste des ateliers
	 * et que le popup est bien positionné
	 */
	xCheckCurrentWspInList : function(){
		var vFromUriObject = this.getFromUriObject();
		if(vFromUriObject) {

			var vCdWsp = ut.getWspFromUri(vFromUriObject.getUri());
			var vIdServer = vFromUriObject.getWspServer().getId();
			var vWspList = document.getElementById("oSearchWspList");
			var vItem = vWspList.selectedItem;
			if(vItem && vItem.getAttribute("value")==vCdWsp && vItem.getAttribute("idServer")==vIdServer) {

				return;
			}
			var vItem = vWspList.getItemAtIndex(0);
			while(vItem) {
				if(vItem.getAttribute("value")==vCdWsp && vItem.getAttribute("idServer")==vIdServer) break;
				vItem = vItem.nextSibling;
			}
			if(vItem) {

				vWspList.selectedItem = vItem;
			} else {

				vWspList.selectedIndex = -1;

				this.setRootMode("wsp", null);
				this.xSetFromUriObject(null);

			}
		}
	}
}
