

function UploadFile(){

}

UploadFile.prototype = {
	
	sIoService : Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService),
	
	/**
	 * Upload synchrone d'un fichier.
	 * Retourne un objet contenant les propriétés "status" et "statusText" de la réponse du server.
	 * 
	 * Exemple d'obtention de l'URL de la DST :
	 *  vDataServer.getSourceUrl("trav") + "/" + encodeURI("monWsp/monespace/monitem.xml");
	 */
	uploadSynchFile : function(pFile, pUrlDst){
		try {
			var vUrlDst = this.sIoService.newURI(pUrlDst, null, null);		
			var vChannel = this.sIoService.newChannelFromURI(vUrlDst).QueryInterface(Components.interfaces.nsIHttpChannel);
			var vUploadChannel = vChannel.QueryInterface(Components.interfaces.nsIUploadChannel);


			var vInputStream = this.sIoService.newChannelFromURI(this.sIoService.newFileURI(pFile)).open();
			
			var vBuf = Components.classes["@mozilla.org/network/buffered-input-stream;1"].createInstance(Components.interfaces.nsIBufferedInputStream);
			vBuf.init(vInputStream, Math.min(pFile.fileSize, 32768));
			this.fInputStream = vBuf.QueryInterface(Components.interfaces.nsIInputStream);

			vUploadChannel.setUploadStream(this.fInputStream , "application/octet-stream", -1);
			vChannel.requestMethod = "PUT";
			vChannel.notificationCallbacks = this;
			var vInputRes = vChannel.open();

			var vRes = {status:vChannel.responseStatus, statusText:vChannel.responseStatusText };
			vInputRes.close();
			return vRes;
		}catch(e){ut.debug(e);};
	},
	
	/**
	 * Upload asynchrone d'un fichier.
	 * 
	 * Exemple d'obtention de l'URL de la DST :
	 *  vDataServer.getSourceUrl("trav") + "/" + encodeURI("monWsp/monespace/monitem.xml");
	 *
	 * API de la fonction de callback :
	 * 	- pSeverity : Sevérité du problème rencontré (0 = pas de problème)
	 * 	- pCode : Code du problème rencontré (0 = pas de problème)
	 */
	uploadAsynchFile : function(pFile, pUrlDst, pCallBack){
		this.fCb = pCallBack;
		try {
			var vUrlDst = this.sIoService.newURI(pUrlDst, null, null);		
			var vChannel = this.sIoService.newChannelFromURI(vUrlDst).QueryInterface(Components.interfaces.nsIHttpChannel);
			var vUploadChannel = vChannel.QueryInterface(Components.interfaces.nsIUploadChannel);


			var vInputStream = this.sIoService.newChannelFromURI(this.sIoService.newFileURI(pFile)).open();
			
			var vBuf = Components.classes["@mozilla.org/network/buffered-input-stream;1"].createInstance(Components.interfaces.nsIBufferedInputStream);
			vBuf.init(vInputStream, Math.min(pFile.fileSize, 32768));
			this.fInputStream = vBuf.QueryInterface(Components.interfaces.nsIInputStream);

			vUploadChannel.setUploadStream(this.fInputStream, "application/octet-stream", -1);
			vChannel.requestMethod = "PUT";
			vChannel.notificationCallbacks = this;
			vChannel.asyncOpen(this, this);
		}catch(e){ut.debug(e);};
	},
		
	/**
	 * Upload synchrone d'un nsIURI.
	 * Retourne un objet contenant les propriétés "status" et "statusText" de la réponse du server.
	 * 
	 * Exemple d'obtention de l'URL de la DST :
	 *  vDataServer.getSourceUrl("trav") + "/" + encodeURI("monWsp/monespace/monitem.xml");
	 */
	uploadSynchUri : function(pUri, pUrlDst){
		try {
			var vUrlDst = this.sIoService.newURI(pUrlDst, null, null);		
			var vChannel = this.sIoService.newChannelFromURI(vUrlDst).QueryInterface(Components.interfaces.nsIHttpChannel);
			var vUploadChannel = vChannel.QueryInterface(Components.interfaces.nsIUploadChannel);


			var vInputStream = this.sIoService.newChannelFromURI(pUri).open();
			
			var vBuf = Components.classes["@mozilla.org/network/buffered-input-stream;1"].createInstance(Components.interfaces.nsIBufferedInputStream);
			vBuf.init(vInputStream, 8192);
			this.fInputStream = vBuf.QueryInterface(Components.interfaces.nsIInputStream);

			vUploadChannel.setUploadStream(this.fInputStream, "application/octet-stream", -1);
			vChannel.requestMethod = "PUT";
			vChannel.notificationCallbacks = this;
			var vInputRes = vChannel.open();

			var vRes = {status:vChannel.responseStatus, statusText:vChannel.responseStatusText };
			vInputRes.close();
			return vRes;
		}catch(e){ut.debug(e);};
	},
	
	/**
	 * Upload asynchrone d'une nsIURI.
	 * 
	 * Exemple d'obtention de l'URL de la DST :
	 *  vDataServer.getSourceUrl("trav") + "/" + encodeURI("monWsp/monespace/monitem.xml");
	 *
	 * API de la fonction de callback :
	 * 	- pSeverity : Sevérité du problème rencontré (0 = pas de problème)
	 * 	- pCode : Code du problème rencontré (0 = pas de problème)
	 */
	uploadAsynchUri : function(pUri, pUrlDst, pCallBack){
		this.fCb = pCallBack;
		try {
			var vUrlDst = this.sIoService.newURI(pUrlDst, null, null);		
			var vChannel = this.sIoService.newChannelFromURI(vUrlDst).QueryInterface(Components.interfaces.nsIHttpChannel);
			var vUploadChannel = vChannel.QueryInterface(Components.interfaces.nsIUploadChannel);
			var vInputStream = this.sIoService.newChannelFromURI(pUri).open();
			
			var vBuf = Components.classes["@mozilla.org/network/buffered-input-stream;1"].createInstance(Components.interfaces.nsIBufferedInputStream);
			vBuf.init(vInputStream, 8192);
			this.fInputStream = vBuf.QueryInterface(Components.interfaces.nsIInputStream);
			vUploadChannel.setUploadStream(this.fInputStream, "application/octet-stream", -1);
			vChannel.requestMethod = "PUT";
			vChannel.notificationCallbacks = this;
			vChannel.asyncOpen(this, this);
		}catch(e){ut.debug(e);};
	},
	
	/**
	 * Upload Asynchrone d'un stream.
	 * Exemple d'obtention de l'URL de la DST :
	 *  vDataServer.getSourceUrl("trav") + "/" + encodeURI("monWsp/monespace/monitem.xml");
	 *
	 * API de la fonction de callback :
	 * 	- pSeverity : Sevérité du problème rencontré (0 = pas de problème)
	 * 	- pCode : Code du problème rencontré (0 = pas de problème)
	 *  
	 * @param pLength nb d'octets du stream ou -1 si inconnu.
	 */
	uploadAsynchStream : function(pStream, pLength, pUrlDst, pCallBack){
		this.fCb = pCallBack;
		try {
			var vUrlDst = this.sIoService.newURI(pUrlDst, null, null);		
			var vChannel = this.sIoService.newChannelFromURI(vUrlDst).QueryInterface(Components.interfaces.nsIHttpChannel);
			var vUploadChannel = vChannel.QueryInterface(Components.interfaces.nsIUploadChannel);
			
			var vBuf = Components.classes["@mozilla.org/network/buffered-input-stream;1"].createInstance(Components.interfaces.nsIBufferedInputStream);
			vBuf.init(pStream, pLength>0 ? Math.min(pLength, 32768) : 32768);
			this.fInputStream = vBuf.QueryInterface(Components.interfaces.nsIInputStream);

			vChannel.loadFlags |= Components.interfaces.nsIRequest.LOAD_BYPASS_CACHE | Components.interfaces.nsIRequest.LOAD_TARGETED;
			vChannel.requestMethod = "PUT";
			vChannel.notificationCallbacks = this;
			vUploadChannel.setUploadStream(this.fInputStream, "application/octet-stream", pLength);
			vChannel.asyncOpen(this, this);
		}catch(e){
			ut.debug(e);
			try {pStream.close(); } catch(e){ut.debug(e);}
		};
	},
	

	getInterface: function(pIId, result){
		if (pIId.equals(Components.interfaces.nsIAuthPrompt)) {

			var vWWService = Components.classes["@mozilla.org/embedcomp/window-watcher;1"].getService(Components.interfaces.nsIWindowWatcher);
			return vWWService.getNewAuthPrompter(null);
		}
		Components.returnCode = Components.results.NS_ERROR_NO_INTERFACE;
		return null;
	},


	onStartRequest: function(request, ctxt) {

	},
	onStopRequest: function(request, ctxt, status){
		if(this.fInputStream) try {
			this.fInputStream.close();
		} catch(e){ut.debug(e);}
		var vSeverity = (((status) >> 31) & 0x1);
		var vModule = (((((status) >> 16) - 0x45) & 0x1fff));
		var vCode = ((status) & 0xffff);

		if(this.fCb) this.fCb.call(window, vSeverity, vCode);
	}, 
	
	onDataAvailable: function(request, ctxt, inStream, sourceOffset, count){

	},

	QueryInterface: function(pIId, instance){
		if (pIId.equals(Components.interfaces.nsIStreamListener) 
			|| pIId.equals(Components.interfaces.nsIInterfaceRequester) 
			|| pIId.equals(Components.interfaces.nsISupports)) {
				return this;
			}
		Components.returnCode = Components.results.NS_ERROR_NO_INTERFACE;
		return null;
	}
}



function uploadFileToUri(pLocalFile, pUriDst, pDataProvider, pCallBack, pOverwrite) {
	try {
	    var ut = window.ut; // garde une ref locale à ut dans le cas ou la window porteuse a été close pendant le traitement asynchrone
		var vListenerCopy = {
					fWin:null,
					fCallBack: pCallBack,
					fNeedRefresh: true,
					fDataProvider: pDataProvider,
					start:function(){
						this.fDataProvider.freezeItemEventsFromServer();

						if( ! ut.isWindowModal(window)) this.fWin = ut.openWindowWait("copy", "Copie en cours...", ut.formatStr("La copie de %1$s vers %2$s est en cours... Veuillez patienter.", pLocalFile.path, pUriDst));
					},
					finish:function(){
						this.fDataProvider.unfreezeItemEventsFromServer();
						if(this.fWin) ut.closeWindowWait(this.fWin);
						this.fCallBack.call(window, this.fNeedRefresh);
					},
					fCountCopy: 0,
					startOneCopy: function(pUrl){
						this.fCountCopy++;
					},
					finishOneCopy: function(pUrl){
						try{
							try{this.fWin.changeMessage(ut.formatStr("Copie de : %s", pUrl));} catch(e){}
							this.fCountCopy--;
							if(this.fCountCopy==0) this.finish();
						}catch(e){
							ut.debug("finishOneCopy: "+e);
						}
					}
				}
		if(pLocalFile.isDirectory()){
			var vReq = pDataProvider.dialogSynchWithService("/u/trav/"+encodeURI(pUriDst), "MKCOL", null, null);
			if(vReq.status==201) {
				vListenerCopy.start();
				var vChilds = pLocalFile.directoryEntries;
				var vNoChilds = true;
				while(vChilds.hasMoreElements()) {
					vNoChilds = false;
					var vChild = vChilds.getNext().QueryInterface(Components.interfaces.nsIFile);
					copyFile(vChild, ut.addLeafToUri(pUriDst, vChild.leafName), pDataProvider);
				}
				if(vNoChilds) vListenerCopy.finish();
			} else if(vReq.status==405) {
				if(pOverwrite || ut.confirm(ut.formatStr("Le dossier \'%s\' existe déjà. Souhaitez-vous vraiment supprimer intégralement le contenu de ce dossier ?", pUriDst), ut.formatStr("Remplacement du dossier actuel : %s", pUriDst), "Supprimer")) {
					var vReq = pDataProvider.dialogSynchWithService("/u/trav/"+encodeURI(pUriDst), "DELETE", null, null);

					if(vReq.status==204) {
						vListenerCopy.start();
						copyFile(pLocalFile, pUriDst, pDataProvider);
					} else if(vReq.status==403) {
						ut.alert("Il est interdit de supprimer ce dossier.", "Echec à la copie");
					} else {
						ut.alert(ut.formatStr("Une erreur est survenue durant la suppression du dossier : \n%1$s (%2$s)", vReq.statusText, vReq.status), "Erreur");
						pCallBack.call(window, true);
					}
				} else {
					pCallBack.call(window, false);
				}
			} else {
				ut.alert(ut.formatStr("Une erreur est survenue durant la copie : \n%1$s (%2$s)", vReq.statusText, vReq.status), "Erreur");
				pCallBack.call(window, true);
			}
		} else if(pLocalFile.isFile()) {

			var vReq = pDataProvider.dialogSynchWithService("/u/trav/"+encodeURI(pUriDst), "HEAD", null, null);

			if(vReq.status == 409) {
				ut.alert("Un autre item avec un code équivalent existe déjà (aux majuscules / minuscules près). Il est impossible d\'importer ce fichier.", "Import impossible");
				pCallBack.call(window, false);
			} else if(vReq.status == 500) {

				ut.alert(ut.formatStr("Il est impossible de copier le fichier \'%1$s\' à cet emplacement.", pUriDst), "Erreur");
				pCallBack.call(window, false);				
			} else if(vReq.status != 404) {
				if(pOverwrite || ut.confirm(ut.formatStr("Le fichier \'%s\' existe déjà. Souhaitez-vous vraiment le remplacer ?", pUriDst), ut.formatStr("Remplacement du fichier actuel : %s", pUriDst), "Remplacer")) {
					var vReq = pDataProvider.dialogSynchWithService("/u/trav/"+encodeURI(pUriDst), "DELETE", null, null);

					if(vReq.status==204) {
						vListenerCopy.start();
						copyFile(pLocalFile, pUriDst, pDataProvider);
					} else {
						ut.alert(ut.formatStr("Une erreur est survenue durant la suppression : \n%1$s (%2$s)", vReq.statusText, vReq.status), "Erreur");
						pCallBack.call(window, true);
					}
				} else {
					pCallBack.call(window, false);
				}
			} else {
				vListenerCopy.start();
				copyFile(pLocalFile, pUriDst, pDataProvider);
			}
		} else {

			ut.alert("Aucune source à copier n\'a pu être accédée.", "Copie impossible");
			pCallBack.call(window, false);
		}
	} catch(e){
		ut.alert("Une erreur est survenue durant la copie : \n"+e, "Erreur");
		pCallBack.call(window, true);
	}
	
	function copyFile(pLocalFile, pUriDst, pDataProvider){
		vListenerCopy.startOneCopy();
		if(pLocalFile.isDirectory()){
			function cb(pEvent){
				var vReq = pEvent.target;
				if(vReq.status == 201) {
					var vChilds = pLocalFile.directoryEntries;
					while(vChilds.hasMoreElements()) {
						var vChild = vChilds.getNext().QueryInterface(Components.interfaces.nsIFile);
						copyFile(vChild, ut.addLeafToUri(pUriDst, vChild.leafName), pDataProvider);
					}
				}
				vListenerCopy.finishOneCopy(pLocalFile.path);
			}
			function cbErr(pEvent){
				vListenerCopy.finishOneCopy(pLocalFile.path);
			}
			try {
				pDataProvider.dialogAsynchWithService("/u/trav/"+encodeURI(pUriDst), "MKCOL", null, null, cb, cbErr);
			} catch(e){
				vListenerCopy.finishOneCopy(pLocalFile.path);
			}
		} else if(pLocalFile.isFile()) {
			try{
				var vUpload = new UploadFile();
				function cb(pSeverity, pCode){
					vListenerCopy.finishOneCopy(pLocalFile.path);
				}
				vUpload.uploadAsynchFile(pLocalFile, pDataProvider.getSourceUrl("trav") + "/"+ encodeURI(pUriDst) + "?scWspResp=no", cb);
			} catch(e){
				vListenerCopy.finishOneCopy(pLocalFile.path);
			}
		} else {
			vListenerCopy.finishOneCopy(pLocalFile.path);
		}
	}
}



function uploadStreamToUri(pStream, pLength, pUriDst, pDataProvider, pCallBack, pOverwrite) {
	var vUpload = new UploadFile();
	var vWin;
	function cb(pSeverity, pCode){
		if(vWin) ut.closeWindowWait(vWin);
		pCallBack.call(window, true);
	}
	var vReq = pDataProvider.dialogSynchWithService("/u/trav/"+encodeURI(pUriDst), "HEAD", null, null);
	if(vReq.status == 409) {
		ut.alert("Un autre item avec un code équivalent existe déjà (aux majuscules / minuscules près). Il est impossible d\'importer ce fichier.", "Import impossible");
		pCallBack.call(window, false);
	} else if(vReq.status == 500) {

		ut.alert(ut.formatStr("Il est impossible de copier ce contenu à cet emplacement.", pUriDst), "Erreur");
		pCallBack.call(window, false);				
	} else if(vReq.status != 404) {
		if(pOverwrite || ut.confirm(ut.formatStr("L\'item \'%s\' existe déjà. Souhaitez-vous vraiment le remplacer ?", pUriDst), ut.formatStr("Remplacement du fichier actuel : %s", pUriDst), "Remplacer")) {
			vUpload.uploadAsynchStream(pStream, pLength, pDataProvider.getSourceUrl("trav") + "/"+ encodeURI(pUriDst) + "?scWspResp=no", cb);
		} else {
			pCallBack.call(window, false);
		}
	} else {
		if( ! ut.isWindowModal(window)) vWin = ut.openWindowWait("copy", "Copie en cours...", ut.formatStr("La copie est en cours... Veuillez patienter."));
		vUpload.uploadAsynchStream(pStream, pLength, pDataProvider.getSourceUrl("trav") + "/"+ encodeURI(pUriDst) + "?scWspResp=no", cb);
	}
}