<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" xmlns="http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul" xmlns:sc="scenari">
<xsl:template match="sc:support">
<vbox class="frm" align="start" cdgen="{sc:gen/@code}" status="{sc:gen/@status}" working="{count(sc:gen[@status='working'])}">
<xsl:apply-templates select="sc:gen" mode="title"/>
<xsl:apply-templates select="sc:presc"/>
<xsl:apply-templates select="sc:gen" mode="actions"/>
</vbox>
</xsl:template>
	

<xsl:template match="sc:presc">
<hbox style="margin-top:20px; margin-bottom:20px; -moz-margin-start:5px;" align="center" hideIfWorking="true">
<description value="Source : " style="font-weight:bold; color:darkblue;"/>
<itemview sp="{@sp}" cd="{@cd}" setSgnAllowed="true" style="-moz-binding: url('chrome://scenaricms/content/widgets/item/item.xbl.xml#edit'); -moz-margin-start:10px; "/>
</hbox>
</xsl:template>

	
<xsl:template match="sc:gen[@code]" mode="title">
<hbox align="start" style="margin:10px;">
<image class="icoGen"/>
<vbox flex="1">
<description class="title" flex="1"><xsl:value-of select="@title"/></description>
<xsl:choose>
<xsl:when test="@status='working'">
<text class="details" value="Compilation en cours..."/>
</xsl:when>
<xsl:otherwise>
<text class="details">
<xsl:choose>
<xsl:when test="@status='ok'">
<xsl:attribute name="value">Dernière compilation le <xsl:value-of select="@lastGen"/></xsl:attribute>
</xsl:when>
<xsl:when test="@status='null'">
<!-- <xsl:attribute name="value">Compilation non disponible</xsl:attribute> -->
</xsl:when>
<xsl:when test="@status='warning'">
<xsl:attribute name="value">Dernière compilation le <xsl:value-of select="@lastGen"/> (avec anomalies)</xsl:attribute>
</xsl:when>
<xsl:when test="@status='failed'">
<xsl:choose>
<xsl:when test="@reason='destinationLocked'">
<xsl:attribute name="value">Dernière compilation en échec : FERMEZ VOS FICHIERS OUVERTS ET RECOMMENCEZ.</xsl:attribute>
</xsl:when>
<xsl:otherwise>
<xsl:attribute name="value">Dernière compilation en échec (consultez les traces)</xsl:attribute>
</xsl:otherwise>
</xsl:choose>
</xsl:when>
</xsl:choose>
</text>
</xsl:otherwise>
</xsl:choose>
<hbox align="start">
<image class="imGen" collapsed="true"/>
</hbox>
</vbox>
</hbox>
</xsl:template>	

<xsl:template match="sc:gen[@code]" mode="actions">
<hbox flex="1" align="start" hideIfWorking="true">
<xsl:if test="@status != 'working'">
<button class="bBase bGen" oncommand="document.getBindingParent(this).xRefreshBlock('{@code}')" label="générer" tooltiptext="nouvelle génération" orient="vertical" pack="end"/>
<xsl:if test="@uriPub and @status!='null' and @status!='failed'">
<button class="bBase bShow" oncommand="document.getBindingParent(this).openSupport('{@uriPub}')" label="consulter" tooltiptext="consulter la dernière génération" orient="vertical" pack="end"/>
</xsl:if>
<xsl:if test="@mimeDownload and @status!='null' and @status!='failed'">
<button class="bBase bDwnld" oncommand="document.getBindingParent(this).downloadSupport('{@code}')" label="télécharger" tooltiptext="télécharger la dernière génération" orient="vertical" pack="end"/>
</xsl:if>
<xsl:if test="@localPathPub and @status!='null' and @status!='failed'">
<button class="bBase bRev" localPath="{@localPathPub}" oncommand="document.getBindingParent(this).revealSupport(this.getAttribute('localPath'))" label="révéler" tooltiptext="révéler la dernière génération" orient="vertical" pack="end"/>
</xsl:if>
<xsl:if test="@uriTraces">
<button class="bBase bLog" oncommand="document.getBindingParent(this).openTraces('{@uriTraces}')" label="rapport" tooltiptext="consulter les traces" orient="vertical" pack="end"/>
</xsl:if>
</xsl:if>
</hbox>
</xsl:template>
<xsl:template match="sc:gen" mode="actions">
<description value="Support non disponible" style="font-size:larger; font-weight:bold; font-style:italic;"/>
</xsl:template>
<xsl:template match="*"/>
</xsl:stylesheet>
