<?xml version="1.0" encoding="UTF-8"?>


<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" xmlns="http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul" xmlns:sc="scenari">
<xsl:template match="sc:support">
<vbox working="{count(sc:gen[@status='working'])}">
<xsl:apply-templates/>
</vbox>
</xsl:template>
	
<xsl:template match="sc:gen">
<box class="frm" align="start" cdgen="{@code}" status="{@status}">
<image class="icoGen"/>
<vbox flex="1" align="start">
<text class="title" value="{@title}"/>
<xsl:choose>
<xsl:when test="@status='working'">
<text class="details" value="Génération en cours..."/>
<image class="imGen"/>
</xsl:when>
<xsl:otherwise>
<text class="details">
<xsl:choose>
<xsl:when test="@status='ok'">
<xsl:attribute name="value">Dernière génération le <xsl:value-of select="@lastGen"/></xsl:attribute>
</xsl:when>
<xsl:when test="@status='null'">
									
</xsl:when>
<xsl:when test="@status='warning'">
<xsl:attribute name="value">Dernière génération le <xsl:value-of select="@lastGen"/> (avec anomalies)</xsl:attribute>
</xsl:when>
<xsl:when test="@status='failed'">
<xsl:choose>
<xsl:when test="@reason='destinationLocked'">
<xsl:attribute name="value">Dernière génération en échec : FERMEZ VOS FICHIERS OUVERTS ET RECOMMENCEZ.</xsl:attribute>
</xsl:when>
<xsl:otherwise>
<xsl:attribute name="value">Dernière génération en échec</xsl:attribute>
</xsl:otherwise>
</xsl:choose>
</xsl:when>
</xsl:choose>
</text>
<hbox align="start">
<image class="imGen" hidden="true"/>
<button class="bBase bGen" oncommand="document.getBindingParent(this).xRefreshBlock('{@code}')" label="générer" tooltiptext="nouvelle génération" orient="vertical" pack="end"/>
<xsl:if test="@uriPub and @status!='null' and @status!='failed'">
<button id="consultBtn" class="bBase bShow" oncommand="document.getBindingParent(this).openSupport('{@uriPub}')" label="consulter" tooltiptext="consulter la dernière génération" orient="vertical" pack="end"/>
</xsl:if>
<xsl:if test="@mimeDownload and @status!='null' and @status!='failed'">
<button class="bBase bDwnld" oncommand="document.getBindingParent(this).downloadSupport('{@code}')" label="télécharger" tooltiptext="télécharger la dernière génération" orient="vertical" pack="end"/>
</xsl:if>
<xsl:if test="@localPathPub and @status!='null' and @status!='failed'">
<button class="bBase bRev" localPath="{@localPathPub}" oncommand="document.getBindingParent(this).revealSupport(this.getAttribute('localPath'))" label="révéler" tooltiptext="révéler la dernière génération" orient="vertical" pack="end"/>
</xsl:if>
<xsl:if test="@uriTraces">
<button class="bBase bLog" oncommand="document.getBindingParent(this).openTraces('{@uriTraces}')" label="rapport" tooltiptext="consulter les traces" orient="vertical" pack="end"/>
</xsl:if>
</hbox>
</xsl:otherwise>
</xsl:choose>
</vbox>
			
</box>
</xsl:template>
	
<xsl:template match="*"/>
</xsl:stylesheet>
