<?xml version="1.0" encoding="UTF-8"?>


<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" xmlns:xul="http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul" xmlns:sc="scenari" xmlns:html="http://www.w3.org/1999/xhtml">
<xsl:template match="/*">
<xul:vbox>
<xul:grid flex="1">
<xul:columns>
<xul:column/>				
<xul:column flex="1"/>
</xul:columns>
<xul:rows>
<xsl:apply-templates select="sc:item/sc:cPbs/sc:pb"/>
<xul:row>
<xul:description value="Emplacement" label="true"/>
<xul:description>
<xsl:value-of select="@wsp"/>/<xsl:value-of select="sc:item/@sp"/>/<xsl:value-of select="sc:item/@cd"/><xsl:value-of select="sc:res/@urires"/>
</xul:description>
</xul:row>
<xsl:if test="sc:res/@len">
<xul:row>
<xul:description value="Taille" label="true"/>
<xul:description value="{sc:res/@len} octets"/>
</xul:row>
</xsl:if>
							
<xsl:choose>
<xsl:when test="sc:res/@updt">
<xul:row>
<xul:description value="Dernière modif." label="true"/>
<xul:description value="{sc:res/@updt}"/>
</xul:row>
</xsl:when>
<xsl:otherwise>
<xul:row style="color:red;">
<xul:description value="Dernière modif." label="true"/>
<xul:description value="Elément supprimé"/>
</xul:row>
</xsl:otherwise>
</xsl:choose>
						
<xsl:apply-templates select="sc:item/sc:attrRef"/>
<xsl:apply-templates select="sc:item/sc:attrLink"/>
</xul:rows>
</xul:grid>
</xul:vbox>
</xsl:template>
<xsl:template match="sc:pb">
<xul:row>
<xsl:choose>
<xsl:when test="@typ='Error'">
<xul:description value="Erreur" style="color:red;" label="true"/>
<xul:vbox style="color:red;">
<xul:description>
<xsl:value-of select="@msg"/>
</xul:description>
<xul:description style="font-style:italic;">
<xsl:value-of select="."/>
</xul:description>
</xul:vbox>
</xsl:when>
<xsl:otherwise>
<xul:description value="Alerte" style="color:#FFA500;" label="true"/>
<xul:vbox style="color:#FFA500;">
<xul:description label="true">
<xsl:value-of select="@msg"/>
</xul:description>
<xul:description style="font-style:italic;">
<xsl:value-of select="."/>
</xul:description>
</xul:vbox>
</xsl:otherwise>
</xsl:choose>
</xul:row>
</xsl:template>
<xsl:template match="sc:attrRef | sc:attrLink">
<xul:row>
<xsl:variable name="vNm">
<xsl:choose>
<xsl:when test="local-name(.)='attrRef'">Référence</xsl:when>
<xsl:otherwise>Lien</xsl:otherwise>
</xsl:choose>
</xsl:variable>
<xul:description value="{$vNm}" label="true">
<xsl:choose>
<xsl:when test="sc:pbs/sc:pb[@typ='Error']">
<xsl:attribute name="style">color:red;</xsl:attribute>
</xsl:when>
<xsl:when test="sc:pbs/sc:pb">
<xsl:attribute name="style">color:#FFA500;</xsl:attribute>
</xsl:when>
</xsl:choose>
</xul:description>
<xul:vbox align="start">
<xul:itemview sp="{@spPtd}" cd="{@cdPtd}" style="-moz-margin-start:4px;"/>
<xsl:for-each select="sc:pbs/sc:pb[@typ='Error']">
<xul:stack style="color:red;">
<xul:description value="-" style="left:10px" label="true"/>
<xul:vbox style="left:20px" flex="1">
<xul:description>
<xsl:value-of select="@msg"/>
</xul:description>
<xul:description>
<xsl:value-of select="."/>
</xul:description>
</xul:vbox>
</xul:stack>
</xsl:for-each>
<xsl:for-each select="sc:pbs/sc:pb[@typ!='Error']">
<xul:stack style="color:#FFA500;">
<xul:description value="-" style="left:10px" />
<xul:vbox style="left:20px" flex="1">
<xul:description label="true">
<xsl:value-of select="@msg"/>
</xul:description>
<xul:description>
<xsl:value-of select="."/>
</xul:description>
</xul:vbox>
</xul:stack>
</xsl:for-each>
</xul:vbox>
</xul:row>
</xsl:template>
<xsl:template match="*"/>
</xsl:stylesheet>
