<?xml version="1.0" encoding="UTF-8"?>


<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xul="http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul" xmlns:html="http://www.w3.org/1999/xhtml">
<xsl:output method="xml"/>
	
<xsl:param name="vLimit" select="15"/>
	
<xsl:template match="/">
<xul:box class="block" align="start">
<xsl:apply-templates/>
<xul:spacer flex="10000"/>
</xul:box>
</xsl:template>
	
<xsl:template match="*[not(node()) and not(@*)]">
<xul:description class="tag" value="&lt;{name(.)}/&gt;"/>
</xsl:template>
	
<xsl:template match="*[not(node()) and @*]">
<xul:hbox flex="1">
<xul:description class="tag" value="&lt;{name(.)}"/>
<xsl:apply-templates select="@*"/>
<xul:description class="tag" value="/&gt;" flex="10000"/>
</xul:hbox>
</xsl:template>
	
<xsl:template match="*[node() and not(@*)]">
<xul:description  class="expander" value="- &lt;{name(.)}&gt;"/>
<xul:box class="block" align="start">
<xsl:choose>
<xsl:when test="count(preceding::*) &lt; $vLimit">
<xsl:apply-templates/>
</xsl:when>
<xsl:otherwise>
<xsl:apply-templates mode="closed"/>
</xsl:otherwise>
</xsl:choose>
</xul:box>
<xul:description class="tag" value="&lt;/{name(.)}&gt;"/>
</xsl:template>
	
<xsl:template match="*[node() and @*]">
<xul:hbox flex="1">
<xul:description  class="expander" value="- &lt;{name(.)}"/>
<xsl:apply-templates select="@*"/>
<xul:description class="tag" value="&gt;" flex="10000"/>
</xul:hbox>
<xul:box class="block" align="start">
<xsl:choose>
<xsl:when test="count(preceding::*) &lt; $vLimit">
<xsl:apply-templates/>
</xsl:when>
<xsl:otherwise>
<xsl:apply-templates mode="closed"/>
</xsl:otherwise>
</xsl:choose>
</xul:box>
<xul:description class="tag" value="&lt;/{name(.)}&gt;"/>
</xsl:template>
	
<xsl:template match="text()">
<xsl:variable name="vContent" select="normalize-space(.)"/>
<xsl:if test="$vContent">
<xul:description class="text" flex="1">
<xsl:value-of select="$vContent"/>
</xul:description>
</xsl:if>
</xsl:template>
		
<xsl:template match="comment()">
<xul:description class="comment" flex="1">&lt;!-- <xsl:value-of select="."/> --&gt;</xul:description>
</xsl:template>
	
<xsl:template match="@*">
<xul:description class="attName" value="{name(.)}="/>
<xul:description class="attValue" flex="1">"<xsl:value-of select="."/>"</xul:description>
</xsl:template>

	
<xsl:template match="*[not(node()) and not(@*)]" mode="closed">
<xul:description class="tag" value="&lt;{name(.)}/&gt;"/>
</xsl:template>
	
<xsl:template match="*[not(node()) and @*]" mode="closed">
<xul:hbox flex="1">
<xul:description class="tag" value="&lt;{name(.)}"/>
<xsl:apply-templates select="@*"/>
<xul:description class="tag" value="/&gt;" flex="10000"/>
</xul:hbox>
</xsl:template>
	
<xsl:template match="*[node() and not(@*)]" mode="closed">
<xul:description  class="expander" value="+&lt;{name(.)}&gt;"/>
<xul:box class="block" align="start" hidden="true">
<xsl:apply-templates mode="closed"/>
</xul:box>
<xul:description class="tag" value="&lt;/{name(.)}&gt;" hidden="true"/>
</xsl:template>
	
<xsl:template match="*[node() and @*]" mode="closed">
<xul:hbox flex="1">
<xul:description  class="expander" value="+&lt;{name(.)}"/>
<xsl:apply-templates select="@*"/>
<xul:description class="tag" value="&gt;" flex="10000"/>
</xul:hbox>
<xul:box class="block" align="start" hidden="true">
<xsl:apply-templates mode="closed"/>
</xul:box>
<xul:description class="tag" value="&lt;/{name(.)}&gt;" hidden="true"/>
</xsl:template>
	
<xsl:template match="text()" mode="closed">
<xsl:variable name="vContent" select="normalize-space(.)"/>
<xsl:if test="$vContent">
<xul:description class="text" flex="1">
<xsl:value-of select="$vContent"/>
</xul:description>
</xsl:if>
</xsl:template>
		
<xsl:template match="comment()" mode="closed">
<xul:description class="comment" flex="1">&lt;!-- <xsl:value-of select="."/> --&gt;</xul:description>
</xsl:template>	

</xsl:stylesheet>
