



function CellBuilderLeafNameUri(pUriDataOffset, pPackDataOffset, pModelDataOffset, pItemStatusDataOffset, pAddIcon){
	this.fUriDataOffset = pUriDataOffset;
	this.fPackDataOffset = pPackDataOffset;
	this.fModelDataOffset = pModelDataOffset;
	this.fStDataOffset = pItemStatusDataOffset;
	this.fAddIcon = pAddIcon;
}
CellBuilderLeafNameUri.prototype = new CellBuilderBase();
CellBuilderLeafNameUri.prototype.getCellText = function(pILRow, pCol) {
	if("fNameUri" in pILRow) return pILRow.fNameUri;
	if(!pILRow || pILRow.fCh) return "";
	var vUri = pILRow.fDatas[this.fUriDataOffset];
	pILRow.fNameUri = vUri.substring(vUri.lastIndexOf("/")+1);
	return pILRow.fNameUri;
}
CellBuilderLeafNameUri.prototype.getImageSrc = function(pILRow, pCol) {
	if("fIconItem" in pILRow) return pILRow.fIconItem;
	if(!this.fAddIcon) return false;
	if(!pILRow || pILRow.fCh) return null;
	var vUri = pILRow.fDatas[this.fUriDataOffset];
	var vPack = pILRow.fDatas[this.fPackDataOffset];
	var vModel = pILRow.fDatas[this.fModelDataOffset];
	var vUriRes = ut.getUriResFromUri(vUri);
	var vIco = packMgr.getPack(vPack).getIcon(vModel, vUriRes);
	var vStatus = vUriRes ? 1 : (pILRow.fDatas[this.fStDataOffset] || 1);

	pILRow.fIconItem = ut.getUrlIcon(vIco, vStatus);
	return pILRow.fIconItem;
}
CellBuilderLeafNameUri.prototype.cycleHeader = function(pILTreeView, pCol) {
	var vDescOrder = pCol.element.getAttribute("sortDirection")=="ascending";
	pILTreeView.setSortedColumn(pCol,  vDescOrder ? "descending" : "ascending");
}
CellBuilderLeafNameUri.prototype.sortPoolDatas = function(pILTreeView, pSortedCol) {
	var vDatas = pILTreeView.getPoolDatas();
	var vDataOffset = this.fUriDataOffset;
	function sortNameUri(p1, p2) {
		var vUri1 = p1[vDataOffset];
		var vUri2 = p2[vDataOffset];
		if(vUri1==null) {
			if(vUri2==null) return 0;
			return -1;
		} else if(vUri2==null) {
			return 1;
		}
		var vCode1 = vUri1.substring(vUri1.lastIndexOf("/")+1);
		var vCode2 = vUri2.substring(vUri2.lastIndexOf("/")+1);
		return vCode1.localeCompare(vCode2);
	}
	if(pSortedCol.element.getAttribute("sortDirection")=="descending") {
		vDatas.sort(function(p1, p2) {return sortNameUri(p2, p1)});
	} else {
		vDatas.sort(sortNameUri);
	}
}



function CellBuilderLeafSpaceUri(pUriDataOffset, pPackDataOffset, pModelDataOffset){
	this.fUriDataOffset = pUriDataOffset;
	this.fPackDataOffset = pPackDataOffset;
	this.fModelDataOffset = pModelDataOffset;
}
CellBuilderLeafSpaceUri.prototype = new CellBuilderBase();
CellBuilderLeafSpaceUri.prototype.getCellText = function(pILRow, pCol) {
	if("fSpaceUri" in pILRow) return pILRow.fSpaceUri;
	if(!pILRow || pILRow.fCh) return "";
	var vUri = pILRow.fDatas[this.fUriDataOffset];
	pILRow.fSpaceUri = vUri.substring(0, vUri.lastIndexOf("/"));
	return pILRow.fSpaceUri;
}
CellBuilderLeafSpaceUri.prototype.cycleHeader = CellBuilderLeafNameUri.prototype.cycleHeader;
CellBuilderLeafSpaceUri.prototype.sortPoolDatas = function(pILTreeView, pSortedCol) {
	var vDatas = pILTreeView.getPoolDatas();
	var vDataOffset = this.fUriDataOffset;
	function sortNameUri(p1, p2) {
		var vUri1 = p1[vDataOffset];
		var vUri2 = p2[vDataOffset];
		if(vUri1==null) {
			if(vUri2==null) return 0;
			return -1;
		} else if(vUri2==null) {
			return 1;
		}
		var vCode1 = vUri1.substring(0, vUri1.lastIndexOf("/"));
		var vCode2 = vUri2.substring(0, vUri2.lastIndexOf("/"));
		return vCode1.localeCompare(vCode2);
	}
	if(pSortedCol.element.getAttribute("sortDirection")=="descending") {
		vDatas.sort(function(p1, p2) {return sortNameUri(p2, p1)});
	} else {
		vDatas.sort(sortNameUri);
	}
}



function CellBuilderLeafItemType(pPackDataOffset, pModelDataOffset){
	this.fPackDataOffset = pPackDataOffset;
	this.fModelDataOffset = pModelDataOffset;
}
CellBuilderLeafItemType.prototype = new CellBuilderBase();
CellBuilderLeafItemType.prototype.getCellText = function(pILRow, pCol) {
	if("fItemTypeUri" in pILRow) return pILRow.fItemTypeUri;
	if(!pILRow || pILRow.fCh) return "";
	pILRow.fItemTypeUri = this.xGetItemType(pILRow.fDatas);
	return pILRow.fItemTypeUri;
}
CellBuilderLeafItemType.prototype.cycleHeader = function(pILTreeView, pCol) {
	var vDescOrder = pCol.element.getAttribute("sortDirection")=="ascending";
	pILTreeView.setSortedColumn(pCol,  vDescOrder ? "descending" : "ascending");
}
CellBuilderLeafItemType.prototype.sortPoolDatas = function(pILTreeView, pSortedCol) {
	var vDatas = pILTreeView.getPoolDatas();
	var vCellBd = this;
	function sortNameUri(p1, p2) {
		var vVal1 = vCellBd.xGetItemType(p1);
		var vVal2 = vCellBd.xGetItemType(p2);
		if(vVal1==null) {
			if(vVal2==null) return 0;
			return -1;
		} else if(vVal2==null) {
			return 1;
		}
		return vVal1.localeCompare(vVal2);
	}
	if(pSortedCol.element.getAttribute("sortDirection")=="descending") {
		vDatas.sort(function(p1, p2) {return sortNameUri(p2, p1)});
	} else {
		vDatas.sort(sortNameUri);
	}
}
CellBuilderLeafItemType.prototype.xGetItemType = function(pDatas) {
	return packMgr.getPack(pDatas[this.fPackDataOffset]).getTitle(pDatas[this.fModelDataOffset]);
}



function CellBuilderTreeUri(pUriDataOffset, pPackDataOffset, pModelDataOffset, p3ColTransformable){
	this.fUriDataOffset = pUriDataOffset;
	this.fPackDataOffset = pPackDataOffset;
	this.fModelDataOffset = pModelDataOffset;
	if(p3ColTransformable) this.f3ColTransformable = true;
}
CellBuilderTreeUri.prototype = new CellBuilderBase();
CellBuilderTreeUri.prototype.getCellText = function(pILRow, pCol) {
	if(!pILRow) return "";
	if(pILRow.fCh) return pILRow.fSpaceName;
	var vUri = pILRow.fDatas[this.fUriDataOffset];
	return vUri.substring(0, vUri.lastIndexOf("/"));
}
CellBuilderTreeUri.prototype.buildTree = function(pILTreeView, pPrimaryCol) {


}
