<?xml version="1.0" encoding="UTF-8"?>


<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" xmlns:xul="http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul" xmlns:sc="scenari" xmlns:html="http://www.w3.org/1999/xhtml">
<xsl:param name="pWithRootTitleNode" select="'true'"/>
<xsl:param name="pWspCd"/>
<xsl:template match="outline">
<xsl:apply-templates/>
</xsl:template>
	
<xsl:template match="item[./descendant::titleNode]">
<xul:anchorItem>
<xul:refItem uri="{$pWspCd}{@uri}">
<xsl:apply-templates/>
</xul:refItem>
</xul:anchorItem>
</xsl:template>
<xsl:template match="item[cycle]">
<xul:anchorItem>
<xul:refItem uri="{$pWspCd}{@uri}">
<xul:cycle/>
</xul:refItem>
</xul:anchorItem>
</xsl:template>
<xsl:template match="item">
<xul:anchorItem>
<xul:refItem uri="{$pWspCd}{@uri}">
<xul:children>
<xul:text class="itemContentOnly" value="..."/>
</xul:children>
</xul:refItem>
</xul:anchorItem>
</xsl:template>
<xsl:template match="node">
<xul:node xp="{@xp}" name="{@name}">
<xsl:choose>
<xsl:when test="*">
<xsl:apply-templates/>
</xsl:when>
<xsl:otherwise>
<xul:titleNode title="" leaf="true"/>
</xsl:otherwise>
</xsl:choose>
</xul:node>
</xsl:template>
<xsl:template match="/outline/item/titleNode">
<xsl:if test="$pWithRootTitleNode = 'true'">
<xul:titleNode title="{@title}"/>
</xsl:if>
</xsl:template>
<xsl:template match="titleNode">
<xul:titleNode title="{@title}">
<xsl:if test="not(following-sibling::*/descendant::titleNode)">
<xsl:attribute name="leaf">true</xsl:attribute>
</xsl:if>
</xul:titleNode>
</xsl:template>
	
<xsl:template match="children">
<xul:children>
<xsl:apply-templates/>
</xul:children>
</xsl:template>
<xsl:template match="cycle">
<xul:cycle/>
</xsl:template>
<xsl:template match="itemRoot">
<xsl:attribute name="xp"><xsl:value-of select="@xp"/></xsl:attribute>
<xsl:apply-templates/>
</xsl:template>
<xsl:template match="*"/>
<xsl:template match="text()"/>
</xsl:stylesheet>
