
 

function SrvList(pMainPopupElt, pAdminWsp, pAdminSrv){
	this.fWspReg = Components.classes["@scenari.com/wspregistryservice;1"].getService(Components.interfaces.scIWspRegistryService);
	this.fMainPopupObj = pMainPopupElt;
	this.fListServer = {};
	this.fAdminWsp = pAdminWsp!=null ? pAdminWsp : true;
	this.fAdminSrv = pAdminSrv!=null ? pAdminSrv : true;
	this.init();
}

	
SrvList.prototype.init = function(){
	try{
		var vListServers = this.fWspReg.getServers();
		var vListServersLgth = vListServers.Count();
		for(var ii=0; ii < vListServersLgth; ii++){
			var vServer = vListServers.GetElementAt(ii).QueryInterface(Components.interfaces.scIWspServer);
			this.xReferenceServer(vServer);
		}

		this.xRefresh();
	}catch(e){
		ut.debug("srvlist.js > init : " + e);
	}
}

	
SrvList.prototype.xReferenceServer = function(pWspSrvObj){
	var vDataProvider = pWspSrvObj.getDataProvider();
	var vNewServer = {};
	if(vDataProvider.isLocal() && !this.fAdminWsp) return;// serveur local utile uniquement lorsqu'on est en mode adminWsp
	vNewServer.fStatus = vDataProvider.isLocal() ? "connected" : "connexionPending";//on n'actualise que les serveurs distants [connected|error|connexionPending]
	vNewServer.fUrl = vDataProvider.getIniUrl();
	vNewServer.fId = pWspSrvObj.getId();
	vNewServer.fTitle = pWspSrvObj.getTitle()!='' ? pWspSrvObj.getTitle() : vNewServer.fUrl;
	vNewServer.fDataProvider = vDataProvider;
	this.fListServer[vNewServer.fId] = vNewServer;
}




SrvList.prototype.xRefresh = function(){
	try{

		var vNbServer = 0;
		for(var vId in this.fListServer) vNbServer++;
		if(vNbServer>0) while(this.fMainPopupObj.hasChildNodes()) this.fMainPopupObj.removeChild(this.fMainPopupObj.lastChild);

		for(var vId in this.fListServer){
			this.xDrawServer(vId);
			this.xRefreshSrvStatus(vId);
		}

		if(this.fAdminSrv && !document.getElementById('idAddSrv')){
			function fAddSrv(pEvent){
				try{
					window.openDialog("chrome://scenaricms/content/wspmgr/srvdeclare/declare.xul", "", "chrome,centerscreen,modal,resizable=yes"+(ut.isMac?",dialog=no":""));
				}catch(e){
					ut.debug("SrvList.prototype.xRefresh > fAddSrv : " + e)
				}
			}
			var vSrvMenuSeparator = document.createElement('menuseparator');
				vSrvMenuSeparator.setAttribute("id", "idAddSrvSep");
			this.fMainPopupObj.appendChild(vSrvMenuSeparator);
			var vSrvMenuItem = document.createElement('menuitem');
				vSrvMenuItem.setAttribute("label", "Déclarer une nouvelle connexion...");
				vSrvMenuItem.addEventListener("command", fAddSrv, true);
				vSrvMenuItem.setAttribute("status", "srvAdd");
				vSrvMenuItem.setAttribute("id", "idAddSrv");
				vSrvMenuItem.setAttribute("class","menuitem-iconic");
				vSrvMenuItem.setAttribute("image", "chrome://scenaricms/content/wspmgr/srvlist/img/srvAdd.png");
			this.fMainPopupObj.appendChild(vSrvMenuItem);
			document.getElementById('idAddSrvSep').collapsed = (vNbServer==0);
		}
	}catch(e){
		ut.debug("srvlist.js > xRefresh : " + e);
	}
}





SrvList.prototype.xRefreshSrvStatus = function(pIdServer){
	try{
		var vSrvList = this;
		var cbOk = function(pSrvList){
			vSrvList.fListServer[pIdServer].fStatus = "connected";
			vSrvList.fListServer[pIdServer].fRights = "";
			if(pSrvList.hasAttribute('userUpdt') && pSrvList.getAttribute('userUpdt')=="true") vSrvList.fListServer[pIdServer].fRights += " userUpdt";
			if(pSrvList.hasAttribute('admin')) vSrvList.fListServer[pIdServer].fRights += " admin";

			var vList = pSrvList.getElementsByTagName("wsp");
			var vSrvWspList = {};// liste de ateliers déclarés sur le serveur

			for(var ii=0; ii<vList.length; ii++){
				var vCode = vList[ii].getAttribute("code");
				vSrvWspList[vCode] = vList[ii];
				var vWsp = wspUt._WspReg.getWsp(pIdServer, vCode);
				if(!vWsp) wspUt._WspReg.addWsp(pIdServer, vCode, null, false);
			}

			var vCurrentWspList = wspUt._WspReg.getServerWsps(pIdServer);
			for(var ii=0; ii < vCurrentWspList.Count(); ii++){
				var vCode = vCurrentWspList.GetElementAt(ii).QueryInterface(Components.interfaces.scIWsp).getCode();
				if(!(vCode in vSrvWspList)) wspUt._WspReg.removeWsp(pIdServer, vCode);
			}
			vSrvList.xDrawServer(pIdServer);
		}
		
		var cbError = function (pStatus){
			switch(pStatus) {
				case 403 :
				case ut.httpStatusCodeUnauthorized :
					vSrvList.fListServer[pIdServer].fStatus = "unauthorized";
					break;
				default : 
					vSrvList.fListServer[pIdServer].fStatus = "error";
			}
			vSrvList.xDrawServer(pIdServer);
		}
		wspUt.isDataProviderAvailable(this.fListServer[pIdServer].fDataProvider, cbOk, cbError);
	}catch(e){
		ut.debug("srvlist.js > xRefreshSrvStatus : " + e);
	}
}





SrvList.prototype.xDrawServer = function(pIdServer){
	try{
		var vSrvList = this;
		function fDisconnect(pEvent){
			try{
				wspUt.disconnectSynchSrv(wspUt._WspReg.getServer(pIdServer));
			}catch(e){
				ut.debug("SrvList.prototype.xDrawServer > fDisconnect : " + e)
			}
		}
		function fSrvConfig(pEvent){
			try{
				window.openDialog("chrome://scenaricms/content/wspmgr/srvconfig/config.xul", "", "chrome,centerscreen,modal,resizable=yes"+(ut.isMac?",dialog=no":""), wspUt._WspReg.getServer(pIdServer));
			}catch(e){
				ut.debug("SrvList.prototype.xDrawServer > fSrvConfig : " + e)
			}
		}
		function fLogin(pEvent){
			try{
				window.openDialog("chrome://scenaricms/content/wspmgr/srvconfig/login.xul", "", "chrome,centerscreen,modal,resizable=yes"+(ut.isMac?",dialog=no":""), wspUt._WspReg.getServer(pIdServer));
			}catch(e){
				ut.debug("SrvList.prototype.xDrawServer > fLogin : " + e)
			}
		}
		function fRemove(pEvent){
			try{
				wspUt.removeSynchSrv(wspUt._WspReg.getServer(pIdServer));
			}catch(e){
				ut.debug("SrvList.prototype.xDrawServer > fRemove : " + e)
			}
		}
		function fUserConf(pEvent){
			try{
				var cbPassWord = function(pNewPass) {
					wspUt._WspReg.setServerConnexionSetting(pIdServer, pNewPass);
				}
				window.openDialog('chrome://scenaricms/content/usermgr/userprofile.xul', '', 'chrome,resizable,centerscreen,dependent', wspUt._WspReg.getServer(pIdServer), cbPassWord);
			}catch(e){
				ut.debug("SrvList.prototype.xDrawServer > fUserConf : " + e)
			}
		}
		function fActivateWsp(pEvent){
			wspUt._WspReg.setActiveWsp(pEvent.target.getAttribute('srvId'), pEvent.target.getAttribute('wspId'), true);
		}
		function fUnactivateWsp(pEvent){
			if(wspUt._WspReg.fireUnloadEvent(pEvent.target.getAttribute('srvId'), pEvent.target.getAttribute('wspId'))){
				wspUt._WspReg.setActiveWsp(pEvent.target.getAttribute('srvId'), pEvent.target.getAttribute('wspId'), false);
			}
		}

		var vSrvElts = new Array();
		switch(this.fListServer[pIdServer].fStatus) {
			case "connected" :
				var vSrvMenu = document.createElement(this.fAdminSrv ? "menu" : "menuitem");
					vSrvMenu.setAttribute("srvId", pIdServer);
					vSrvMenu.setAttribute("label", this.fListServer[pIdServer].fTitle + " (connecté)");
					vSrvMenu.setAttribute("status", "srvConnected");
					vSrvMenu.setAttribute("class", this.fAdminSrv ? "menu-iconic" : "menuitem-iconic");
					vSrvMenu.setAttribute("image", "chrome://scenaricms/content/wspmgr/srvlist/img/srvConnected.png");
					if(this.fAdminWsp) vSrvMenu.setAttribute("adminWsp", true);
					if(!this.fAdminSrv) vSrvMenu.setAttribute("disabled", true);
					if(this.fAdminSrv){
						var vSrvMenuPopup = document.createElement('menupopup');
							vSrvMenuPopup.setAttribute("onpopupshowing", "event.stopPropagation();");
							vSrvMenuPopup.setAttribute("onpopuphiding", "event.stopPropagation();");
							var vSrvMenuItem = null;
							if(this.fListServer[pIdServer].fRights.indexOf("userUpdt")>=0){
								vSrvMenuItem = document.createElement('menuitem');
									vSrvMenuItem.setAttribute("label", "Mon profil...");
									vSrvMenuItem.addEventListener("command", fUserConf, true);
								vSrvMenuPopup.appendChild(vSrvMenuItem);
							}
							vSrvMenuItem = document.createElement('menuitem');
								vSrvMenuItem.setAttribute("label", "Paramétrer...");
								vSrvMenuItem.addEventListener("command", fSrvConfig, true);
							vSrvMenuPopup.appendChild(vSrvMenuItem);
							vSrvMenuItem = document.createElement('menuitem');
								vSrvMenuItem.setAttribute("label", "Déconnecter");
								vSrvMenuItem.addEventListener("command", fDisconnect, true);
							vSrvMenuPopup.appendChild(vSrvMenuItem);
							vSrvMenuSeparator = document.createElement('menuseparator');
							vSrvMenuPopup.appendChild(vSrvMenuSeparator);
							vSrvMenuItem = document.createElement('menuitem');
								vSrvMenuItem.setAttribute("label", "Supprimer");
								vSrvMenuItem.addEventListener("command", fRemove, true);
							vSrvMenuPopup.appendChild(vSrvMenuItem);
						vSrvMenu.appendChild(vSrvMenuPopup);
					}
				vSrvElts.push(vSrvMenu);

				if(this.fAdminWsp){
					var vWspList = wspUt._WspReg.getServerWsps(pIdServer);
					var vWspArray = new Array();// on passe par un tableau non associatif pour pouvoir le trier
					for(var ii=0; ii < vWspList.Count(); ii++) vWspArray.push(vWspList.GetElementAt(ii).QueryInterface(Components.interfaces.scIWsp));
					vWspArray.sort(function(p1, p2){return p1.getCode().localeCompare(p2.getCode());});
					for(var ii=0; ii<vWspArray.length;ii++){
						var vObjMenuItem = document.createElement('menuitem');
							vObjMenuItem.setAttribute("srvId", pIdServer);
							vObjMenuItem.setAttribute("wspId", vWspArray[ii].getCode());
							vObjMenuItem.setAttribute("label", vWspArray[ii].getCode());
							vObjMenuItem.setAttribute("type", "checkbox");
							vObjMenuItem.setAttribute("checked", vWspArray[ii].isActive());
							vObjMenuItem.addEventListener("command", vWspArray[ii].isActive() ? fUnactivateWsp : fActivateWsp, true);
						vSrvElts.push(vObjMenuItem);
					}
					if(vWspArray.length == 0){
						var vObjMenuItem = document.createElement('menuitem');
						vObjMenuItem.setAttribute("srvId", pIdServer);
						vObjMenuItem.setAttribute("wspId", "");
						vObjMenuItem.setAttribute("label", "Aucun atelier déclaré pour ce serveur");
						vObjMenuItem.setAttribute("disabled", true);
						vObjMenuItem.setAttribute("level", "info");
						vSrvElts.push(vObjMenuItem);
					}
				}
				break;
			case "connexionPending" :
				var vSrvMenu = document.createElement("menuitem");
					vSrvMenu.setAttribute("srvId", pIdServer);
					vSrvMenu.setAttribute("label", this.fListServer[pIdServer].fTitle + " (connexion en cours...)");
					vSrvMenu.setAttribute("status", "srvConnexionPending");
					vSrvMenu.setAttribute("class", "menuitem-iconic");
					vSrvMenu.setAttribute("image", "chrome://scenaricms/content/wspmgr/srvlist/img/srvConnexionPending.gif");
					if(this.fAdminWsp) vSrvMenu.setAttribute("adminWsp",true);
					if(!this.fAdminSrv) vSrvMenu.setAttribute("disabled", true);
				vSrvElts.push(vSrvMenu);
				break;
			case "unauthorized" :
				var vSrvMenu = document.createElement(this.fAdminSrv ? "menu" : "menuitem");
					vSrvMenu.setAttribute("srvId", pIdServer);
					vSrvMenu.setAttribute("label", this.fListServer[pIdServer].fTitle + " (non connecté)");
					vSrvMenu.setAttribute("status", "srvUnauthorized");
					vSrvMenu.setAttribute("class", this.fAdminSrv ? "menu-iconic" : "menuitem-iconic");
					vSrvMenu.setAttribute("image", "chrome://scenaricms/content/wspmgr/srvlist/img/srvUnauthorized.png");
					if(this.fAdminWsp) vSrvMenu.setAttribute("adminWsp", true);
					if(!this.fAdminSrv) vSrvMenu.setAttribute("disabled", true);
					if(this.fAdminSrv){
						var vSrvMenuPopup = document.createElement('menupopup');
							vSrvMenuPopup.setAttribute("onpopupshowing", "event.stopPropagation();");
							vSrvMenuPopup.setAttribute("onpopuphiding", "event.stopPropagation();");
							var vSrvMenuItem = document.createElement('menuitem');
								vSrvMenuItem.setAttribute("label", "Connecter...");
								vSrvMenuItem.addEventListener("command", fLogin, true);
							vSrvMenuPopup.appendChild(vSrvMenuItem);
							vSrvMenuSeparator = document.createElement('menuseparator');
							vSrvMenuPopup.appendChild(vSrvMenuSeparator);
							vSrvMenuItem = document.createElement('menuitem');
								vSrvMenuItem.setAttribute("label", "Supprimer");
								vSrvMenuItem.addEventListener("command", fRemove, true);
							vSrvMenuPopup.appendChild(vSrvMenuItem);
						vSrvMenu.appendChild(vSrvMenuPopup);
					}
				vSrvElts.push(vSrvMenu);
				break;
			default : //error
				var vSrvMenu = document.createElement(this.fAdminSrv ? "menu" : "menuitem");
					vSrvMenu.setAttribute("srvId", pIdServer);
					vSrvMenu.setAttribute("label", this.fListServer[pIdServer].fTitle + " (indisponible)");
					vSrvMenu.setAttribute("status", "srvError");
					vSrvMenu.setAttribute("class", this.fAdminSrv ? "menu-iconic" : "menuitem-iconic");
					vSrvMenu.setAttribute("image", "chrome://scenaricms/content/wspmgr/srvlist/img/srvError.png");
					if(this.fAdminWsp) vSrvMenu.setAttribute("adminWsp", true);
					if(!this.fAdminSrv) vSrvMenu.setAttribute("disabled", true);
					if(this.fAdminSrv){
						var vSrvMenuPopup = document.createElement('menupopup');
							vSrvMenuPopup.setAttribute("onpopupshowing", "event.stopPropagation();");
							vSrvMenuPopup.setAttribute("onpopuphiding", "event.stopPropagation();");
							var vSrvMenuItem = document.createElement('menuitem');
								vSrvMenuItem.setAttribute("label", "Supprimer");
								vSrvMenuItem.addEventListener("command", fRemove, true);
							vSrvMenuPopup.appendChild(vSrvMenuItem);
						vSrvMenu.appendChild(vSrvMenuPopup);
					}
				vSrvElts.push(vSrvMenu);
				break;
		}
		var vOldSrvElts  = this.fMainPopupObj.getElementsByAttribute("srvId", pIdServer);
		var vCurrentSrvItem = null;
		if(this.fAdminWsp){

			for(var ii=vOldSrvElts.length-1; ii>=0; ii--) {
				if(vOldSrvElts[ii].hasAttribute('wspId')){
					this.fMainPopupObj.removeChild(vOldSrvElts[ii]);
				} else vCurrentSrvItem = vOldSrvElts[ii];
			}
			
		}else{
			vCurrentSrvItem = vOldSrvElts[0];
		}

		if(vCurrentSrvItem)
			for(var ii=0; ii<vSrvElts.length; ii++) this.fMainPopupObj.insertBefore(vSrvElts[ii], vCurrentSrvItem);
		else for(var ii=0; ii<vSrvElts.length; ii++) this.fMainPopupObj.appendChild(vSrvElts[ii]);

		if(vCurrentSrvItem) this.fMainPopupObj.removeChild(vCurrentSrvItem);
	}catch(e){
		ut.debug("srvlist.js > xDrawServer : " + e);
	}
}