




function WspConfig(pWspObj, pWspInfoDom, pCbAfterSave){
	this._CurrentWspServer 	  = pWspObj ? pWspObj.getServer() : null;
	this._CurrentDataProvider = pWspObj ? pWspObj.getDataProvider() : null;
	this._CurrentWspObj		  = pWspObj;
	this._CurrentWspInfoDom	  = pWspInfoDom;
	this._CbAfterSave		  = pCbAfterSave;
	this._ConfBox			  = null;
	this._WspReg 			  = Components.classes["@scenari.com/wspregistryservice;1"].getService(Components.interfaces.scIWspRegistryService);
	this._existWspType		  = false;
	
	this._WspList			  = new Object();
	this._isWorking			  = false;
}

	
WspConfig.prototype.configCurrentWsptype = function(pWspConfigBox, pOnlyChangeOptions, pPreferedOptionUriList){
	try{
		this._ConfBox = pWspConfigBox;
		this._WspList	= new Object();// on réinitialise la liste des éléments
		this.xRefresh(this._CurrentWspInfoDom);

		var vCurrentWspTypeUri = this._CurrentWspInfoDom ? this._CurrentWspInfoDom.getElementsByTagName("wspType")[0].getAttribute("uri") : null;
		var vWspType = this._ConfBox.firstChild.firstChild;
		this._ConfBox.firstChild.removeAttribute("mode");//si aucun wspType ne correspond, on n'en sélectionne pas
		var vExistWspType = false;
		while(vWspType){
			if(vCurrentWspTypeUri && vWspType.hasAttribute("uri") && vWspType.getAttribute("uri")==vCurrentWspTypeUri){
				vWspType.checked = true;

			}else{//on masque tous les autres wspType
				vWspType.checked = false;
				if(pOnlyChangeOptions) vWspType.setAttribute("collapsed", true);
			}

			if(pPreferedOptionUriList){
				for(var ii=0; ii<pPreferedOptionUriList.length; ii++){
					var vOption = vWspType.findOption(pPreferedOptionUriList[ii]);
					if(vOption) vOption.setAttribute("important", true);
				}
			}
			vExistWspType = true;
			vWspType = vWspType.nextSibling;
		}

		if(!vExistWspType){
			var vLabel = document.createElement("label");
			vLabel.setAttribute("value", "Aucune option disponible");
			vLabel.setAttribute("class", "warning");
			this._ConfBox.firstChild.appendChild(vLabel);
		}

		this._ConfBox.firstChild.setAttribute("mode", "strictAlternative");//si aucun wspType ne correspond, on n'en sélectionne pas
	}catch(e){
		ut.debug("WspConfig.prototype.configWsptype : " + e);
	}
}

WspConfig.prototype.initConfigCurrentWsptype = function(){
	try{
		this.configCurrentWsptype(this._ConfBox);
		this.xRemoveDirty();
	}catch(e){
		ut.debug("WspConfig.prototype.initConfigCurrentWsptype : " + e);
	}
}

	
WspConfig.prototype.choiceWsptype = function(pWspConfigBox, pWspTypeDom){
	try{
		this._ConfBox = pWspConfigBox;
		this._WspList	= new Object();// on réinitialise la liste des éléments
		this.xRefresh(pWspTypeDom);
	}catch(e){
		ut.debug("WspConfig.prototype.choiceWsptype : " + e);
	}
}

	
WspConfig.prototype.save = function(pBtnToChangeStatus){
	try{
		var vDesk = window.opener.desk;
		if(! vDesk.closeAllViews(false)) return;//enregistrement SSi ts les items sont fermés
		this._SavePending = true;
		
		var vWspConfig = this;
		function fCbSave(vIsInstallPending, vStatus){
			if(pBtnToChangeStatus){
				pBtnToChangeStatus.setAttribute('status', vIsInstallPending ? 'savepending' : '');
				pBtnToChangeStatus.setAttribute('disabled', vIsInstallPending); 
			}
			vWspConfig._isWorking = vIsInstallPending;
			if(!vIsInstallPending){
				vWspConfig.xRemoveDirty();
				if(vStatus=="abort|wspError"){
					vWspConfig.xRefresh();//on réinitialise l'affichage
				}else if(vStatus=="success"){

					vDesk.activateUriObject(new UriObjectWsp(vWspConfig._CurrentWspObj.getCode(), vWspConfig._CurrentWspObj._CurrentDataProvider));
				}
				if(vWspConfig._CbAfterSave) vWspConfig._CurrentDataProvider.loadFromService("/u/adminWsp?cdaction=InfoWsp&param="+vWspConfig._CurrentWspObj.getCode(), vWspConfig._CbAfterSave, vWspConfig._CbAfterSave);
			}
		}
		wspUt.modifyASynchWsp(this._CurrentWspObj.getCode(), this._CurrentWspServer.getId(), this.getWspType(), fCbSave);

		
	}catch(e){
		ut.debug("WspConfig.prototype.save : " + e);
	}
}

	
WspConfig.prototype.isWorking = function(){
	return this._isWorking;
}

	
WspConfig.prototype.getWspType = function(){
	try{
		var vContent = '<?xml version="1.0" encoding="UTF-8"?>' + this._ConfBox.childNodes[0].getDeclaration();
		return vContent;
	}catch(e){
		ut.debug("WspConfig.prototype.getWspType : " + e);
	}
}

	
WspConfig.prototype.xRefresh = function(pCurrentWspType){
	try{

		var vElt = this._ConfBox.firstChild;
		while(vElt){
			this._ConfBox.removeChild(vElt);
			vElt = vElt.nextSibling;
		}
		var vEltWspConfig = document.createElement("wspConfig");
		this._ConfBox.appendChild(vEltWspConfig);
		

		this.xShowPacks();


		this.xShowWspMeta(pCurrentWspType);


		var vElt = vEltWspConfig.firstChild;
		if(!vEltWspConfig.firstChild){
			var vLabel = document.createElement("label");
			vLabel.setAttribute("value", "Aucun modèle d\'atelier disponible");
			vLabel.setAttribute("class", "warning");
			vEltWspConfig.appendChild(vLabel);
		}
				
		this._ConfBox._WspConfig = this;
	}catch(e){
		ut.debug("WspConfig.prototype.xRefresh : " + e);
	}
}
 
 /**
  *  Affiche tous les wspType/wspOption issus des packs
  */	
 WspConfig.prototype.xShowPacks = function(){
 	try{
 		var vPackRegSvc         = Components.classes["@scenari.com/packregistryservice;1"].getService(Components.interfaces.scIPackRegistryService);
 		var vEltWspConfig = this._ConfBox.firstChild;
				
		var vWspTypeList = vPackRegSvc.getWspTypeList();
		for(var ii = 0; ii<vWspTypeList.Count(); ii++){
			this._existWspType = true;
			var vWspTypeDom = vWspTypeList.GetElementAt(ii).QueryInterface(Components.interfaces.nsIDOMElement);
			var vWspTypeUri = vWspTypeDom.getAttribute("uri");
			var vWspTypeLang = vWspTypeDom.getAttribute("lang");
			
			var vWspTypeElt = document.createElement("wspType");
				vWspTypeElt.setAttribute("uri", vWspTypeUri);
				vWspTypeElt.setAttribute("title", vWspTypeDom.getAttribute("title"));
				vWspTypeElt.setAttribute("checked", true);
				
				var vWspOptionList =  vPackRegSvc.findWspOptionUiList(vWspTypeDom.getAttribute("key"), vWspTypeLang);


				var vWspOptionUiList_Ngen = [];
				var vWspOptionUiList_Nskin = [];
				var vWspOptionUiList_Next = [];
				for(var jj = 0; jj<vWspOptionList.Count(); jj++) {
					var vWspOptionUi = vWspOptionList.GetElementAt(jj).QueryInterface(Components.interfaces.scIWspOptionUi);
					switch (vWspOptionUi.getNature()) {
						case "skin": 
							vWspOptionUiList_Nskin.push(vWspOptionUi);
							break;
						case "gen": 
							vWspOptionUiList_Ngen.push(vWspOptionUi);
							break;
						default:
							vWspOptionUiList_Next.push(vWspOptionUi);
							break;
					}
				}
				function xSetDependancies(pWspOptionUi, pWspOptionElt){
					var vDependenciesList = pWspOptionUi.getWspUiDefinition().getElementsByTagName("wspOption");
					pWspOptionElt.requireUriList = {};
					pWspOptionElt.incompatibleUriList = {};
					var vDependenciesNode
					for(var mm=0; mm<vDependenciesList.length; mm++){
						var vDependenciesElt = vDependenciesList[mm];
						var vDependenciesUi = vPackRegSvc.findWspUi(vDependenciesElt.getAttribute("key"), vWspTypeLang);
						var vDependenciesId = vDependenciesUi ? vDependenciesUi.getUri() : vDependenciesElt.getAttribute("key");
						var vDependenciesName = vDependenciesUi ? (vDependenciesUi.getTitle() + vDependenciesUi.getVersion()) : vDependenciesElt.getAttribute("key");
						switch (vDependenciesElt.getAttribute("dependency")) {
							case "require": 
								pWspOptionElt.requireUriList[vDependenciesId] = vDependenciesName;
								break;
							case "incompatible": 
								pWspOptionElt.incompatibleUriList[vDependenciesId] = vDependenciesName;
								break;
							/*case "applyOn": NON utilisé ici
								vExtDefList_AplyOn.push(vDependenciesId);
								break;*/
							default:
								break;
						}
					}
				}
				function xShowOption(pWspOptionUiTab, pTitle){
					if(pWspOptionUiTab.length > 0){
						var vCategElt = document.createElement("wspCateg");
						vCategElt.setAttribute("title", pTitle);
						vCategElt.setAttribute("mode", "multiple");

						var vWspOptionTabByBaseKey = {};
						for(var kk=0; kk<pWspOptionUiTab.length; kk++){
							var vBaseKey = pWspOptionUiTab[kk].getKey().substring(0, pWspOptionUiTab[kk].getKey().lastIndexOf("-"));
							if(!vWspOptionTabByBaseKey[vBaseKey]) vWspOptionTabByBaseKey[vBaseKey] = [];
							vWspOptionTabByBaseKey[vBaseKey].push(pWspOptionUiTab[kk]);
						}
						for(var vCurrentBaseKey in vWspOptionTabByBaseKey){

							if(vWspOptionTabByBaseKey[vCurrentBaseKey].length>1){
								var vVersionCategElt = document.createElement("wspCateg");
									vVersionCategElt.setAttribute("title", vWspOptionTabByBaseKey[vCurrentBaseKey][1].getTitle());
									vVersionCategElt.setAttribute("mode", "alternative");
									for(var ll=0; ll<vWspOptionTabByBaseKey[vCurrentBaseKey].length; ll++){
										var vWspOptionUi = vWspOptionTabByBaseKey[vCurrentBaseKey][ll];
										var vLangSuffix = vWspOptionUi.getLang() ? (" ("+vWspOptionUi.getLang()+")") : "";
										var vWspOptionElt = document.createElement("wspOption");
											vWspOptionElt.setAttribute("uri", vWspOptionUi.getUri());
											vWspOptionElt.setAttribute("title", vWspOptionUi.getTitle() + " " + vWspOptionUi.getVersion() + vLangSuffix);

											xSetDependancies(vWspOptionUi, vWspOptionElt);
										vVersionCategElt.appendChild(vWspOptionElt);
									}
								vCategElt.appendChild(vVersionCategElt);

							}else{
								for(var ll=0; ll<vWspOptionTabByBaseKey[vCurrentBaseKey].length; ll++){
									var vWspOptionUi = vWspOptionTabByBaseKey[vCurrentBaseKey][ll];
									var vLangSuffix = vWspOptionUi.getLang() ? (" ("+vWspOptionUi.getLang()+")") : "";
									var vWspOptionElt = document.createElement("wspOption");
										vWspOptionElt.setAttribute("uri", vWspOptionUi.getUri());
										vWspOptionElt.setAttribute("title", vWspOptionUi.getTitle() + " " + vWspOptionUi.getVersion() + vLangSuffix);

										xSetDependancies(vWspOptionUi, vWspOptionElt);
									vCategElt.appendChild(vWspOptionElt);
								}
							}
						}
						vWspTypeElt.appendChild(vCategElt);
					}
				}
				xShowOption(vWspOptionUiList_Ngen, "Publications");
				xShowOption(vWspOptionUiList_Nskin, "Skins des publications");
				xShowOption(vWspOptionUiList_Next, "Extensions");
			
			vEltWspConfig.appendChild(vWspTypeElt);
		}
	}catch(e){
		ut.debug("WspConfig.prototype.xRefresh : " + e);
	}
}

 /**
 *  Affiche/active les wspMeta courant
 *  @param pWspTypeDom
 */	
WspConfig.prototype.xShowWspMeta = function(pWspDom){
	try{
		if(pWspDom){
			var vEltWspConfig = this._ConfBox.firstChild;
			
			var vWspTypeDom = pWspDom;
			while(vWspTypeDom.nodeName!='wspType' && vWspTypeDom.hasChildNodes()) vWspTypeDom = vWspTypeDom.firstChild;
			
			var vWspTypeUri = vWspTypeDom.getAttribute('uri');
			var vWspTypeXul = null;
			var vWspTypeXulList = vEltWspConfig.getElementsByTagName("wspType");

			for(var ii=0; ii<vWspTypeXulList.length; ii++){
				if(vWspTypeXulList[ii].getAttribute("uri") == vWspTypeUri ){
					vWspTypeXul = vWspTypeXulList[ii];
					break;
				}
			}
			

			if(vWspTypeXul){
				vWspTypeXul.checked = true;

				var vWspOptionList = vWspTypeDom.getElementsByTagName("wspOption");
				for(var ii=0; ii<vWspOptionList.length; ii++){
					var vWspOptionDom = vWspOptionList[ii];
					var vWspOptionUri = vWspOptionDom.getAttribute("uri");
					var vWspOptionXul = null;
					var vCurrentWspOptionList = vWspTypeXul.getElementsByTagName("wspOption");
					for(var jj=0; jj<vCurrentWspOptionList.length; jj++){
						if(vCurrentWspOptionList[jj].getAttribute("uri") == vWspOptionUri ){
							vWspOptionXul = vCurrentWspOptionList[jj];
							break;
						}
					}
					if(vWspOptionXul){
						vWspOptionXul.checked = true;
					}else{
						var vWspOptionElt = document.createElement("wspOption");
							vWspOptionElt.setAttribute("uri", vWspOptionDom.getAttribute("uri"));
							vWspOptionElt.setAttribute("title", vWspOptionDom.getAttribute("title"));
							vWspOptionElt.setAttribute("checked", true);
							vWspOptionElt.setAttribute("unknown", true);
							vWspOptionElt.status = "disabled";
						vWspTypeXul.appendChild(vWspOptionElt);
					}
				}

			}else{
				var vWspTypeElt = document.createElement("wspType");
					vWspTypeElt.setAttribute("uri", vWspTypeUri);
					vWspTypeElt.setAttribute("title", vWspTypeDom.getAttribute("title"));
					vWspTypeElt.setAttribute("checked", true);
					vWspTypeElt.setAttribute("unknown", true);
					vWspTypeElt.status = "disabled";
				vEltWspConfig.appendChild(vWspTypeElt);
			}
		}
	}catch(e){
		ut.debug("WspConfig.prototype.xShowWspMeta : " + e);
	}
}

	
WspConfig.prototype.xRemoveDirty = function(){

	var vEvent = document.createEvent("Events");
	vEvent.initEvent("WSPNoDirtyEvent", true, false);
	this._ConfBox.dispatchEvent(vEvent);
}

