
  



function WspMgr(pIdTree){
	this.fPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

	this.fIcoMgr = new Object();
	this.fIcoMgr.local=new Object();
	this.fIcoMgr.distant=new Object();
	this.fIcoMgr.local.actif="chrome://scenaricms/content/wspmgr/img/icoWspLocActif.png";
	this.fIcoMgr.local.inactif="chrome://scenaricms/content/wspmgr/img/icoWspLocInactif.png";
	this.fIcoMgr.local.add="chrome://scenaricms/content/wspmgr/img/icoAddWspLoc.png";
	this.fIcoMgr.local.server="chrome://scenaricms/content/wspmgr/img/icoSrvLoc.png";
	this.fIcoMgr.distant.actif="chrome://scenaricms/content/wspmgr/img/icoWspDistActif.png";
	this.fIcoMgr.distant.inactif="chrome://scenaricms/content/wspmgr/img/icoWspDistInactif.png";
	this.fIcoMgr.distant.add="chrome://scenaricms/content/wspmgr/img/icoAddWspDist.png";
	this.fIcoMgr.distant.server="chrome://scenaricms/content/wspmgr/img/icoSrvDist.png";
	this.fIcoMgr.add="chrome://scenaricms/content/wspmgr/img/icoAddSrvDist.png";
	

	this.fIdTree = pIdTree;
	this.fListServer = new Object();
	this.fCurrentInfoWsp = null;
	this.fCurrentWsp = null;
	this.fCurrentWspPropertiesObj = null;
	this.fWspReg = Components.classes["@scenari.com/wspregistryservice;1"].getService(Components.interfaces.scIWspRegistryService);
	this.fCurrentIndex = -1;	
}




WspMgr.prototype.saveListeWsp = function(){
	vResult = this.fWspReg.saveConfig();
}




WspMgr.prototype.xReferenceNewServer = function(pWspServerObj){
	try{
		var vNewServer = {};
		vNewServer.fTitle = pWspServerObj.getTitle();
		vNewServer.fIsOpen =false;
		vNewServer.fWspServer = pWspServerObj;
		vNewServer.fUrl = pWspServerObj.getUrl();
		vNewServer.fIsServerLocal = pWspServerObj.getDataProvider().isLocal();
		vNewServer.fLogin = pWspServerObj.getUser();
		vNewServer.fPassword = pWspServerObj.getPassword();
		return vNewServer;
	}catch(e){
		ut.debug("WspMgr.prototype.xReferenceNewServer : " + e);
	}
}




WspMgr.prototype.init = function(){
	this.xRefreshServerList();
	this.refreshView();
}

WspMgr.prototype.xRefreshServerList = function(){
	this.fListServer = new Object();
	var vExistLocalServer = false;
	var vListServers = this.fWspReg.getServers();
	var vListServersLgth = vListServers.Count();
	for(var ii=0; ii < vListServersLgth; ii++){
		var vServer = vListServers.GetElementAt(ii).QueryInterface(Components.interfaces.scIWspServer);
		this.fListServer[vServer.getId()] = this.xReferenceNewServer(vServer);
		if (this.fListServer[vServer.getId()].fIsServerLocal) vExistLocalServer=true;
	}

	if(!vExistLocalServer && wspUt._CanCreateServerLocal){
		var vLocalServer = this.fWspReg.addServer(wspUt._LocalServerUrl, "", wspUt._LocalServerTitle, null);
		this.xReferenceNewServer(vLocalServer);
	}
}




WspMgr.prototype.refreshView = function(){
	if(!this.fIdTree) return null; // pas d'affichage ds un arbre
	this.xRefreshServerList();
	try{

		var vObjTree = document.getElementById(this.fIdTree);
		var vTreeChildren = vObjTree.getElementsByTagName('treechildren')[0];
		var vViewIni = (vObjTree.fView) ? vObjTree.fView : vObjTree.treeBoxObject.view;
		while(vTreeChildren.hasChildNodes()) vTreeChildren.removeChild(vTreeChildren.lastChild);

		for(var vSrvId in this.fListServer){
			if (this.fListServer[vSrvId].fIsServerLocal){
				this.xDrawNewRepos(vTreeChildren, vSrvId, true);
			}
		}

		for(var vSrvId in this.fListServer){
			if (!this.fListServer[vSrvId].fIsServerLocal){
				this.xDrawNewRepos(vTreeChildren, vSrvId, false);
			}
		}
		if(wspUt._CanCreateServerDistant) this.xDrawAddRepos(vTreeChildren);

		var vNewView = new WrappedTreeView(vViewIni);
		vNewView.fContexte = this;
		vNewView.toggleOpenState = function (pRow){
			var vItem = this.fV.getItemAtIndex(pRow);
			var vCurrentSrvId = vItem.getAttribute("srvId");
			if(this.fV.isContainerOpen(pRow)) {//#### ON REFERME
				this.fV.toggleOpenState(pRow);
				var vTreeChildren = vItem.getElementsByTagName('treechildren')[0];
				while (vTreeChildren.hasChildNodes()) vTreeChildren.removeChild(vTreeChildren.lastChild);
				this.fContexte.fListServer[vCurrentSrvId].fIsOpen=false;
			} else {//#### ON OUVRE

				try{
					vItem.firstChild.firstChild.setAttribute("properties", "opening");
					var vDataProvider = vNewView.fContexte.fListServer[vCurrentSrvId].fWspServer.getDataProvider();
					var vWspServer = vNewView.fContexte.fListServer[vCurrentSrvId].fWspServer;
					var vTreeView = this;
					var vCounter = 0;
					var cb = function (pEvent){
						try {
							var vTarget = pEvent.target.QueryInterface(Components.interfaces.nsIXMLHttpRequest);


							if(vTarget.responseXML && vTarget.status == 200){
								var vListWspServer = vTarget.responseXML;

								wspMgr.xSynchRegistryServer(vCurrentSrvId, vListWspServer);
								var vListWsp = wspMgr.fWspReg.getServerWsps(vCurrentSrvId);
								var vLen = vListWsp.Count();
								var vObjTreeChildren = vItem.getElementsByTagName('treechildren')[0];
								while(vObjTreeChildren.hasChildNodes()) vObjTreeChildren.removeChild(vObjTreeChildren.lastChild);
								for(var ii=0; ii < vLen; ii++){
									var vWsp = vListWsp.GetElementAt(ii).QueryInterface(Components.interfaces.scIWsp);
									wspMgr.xDrawNewWsp(vObjTreeChildren, vWsp, wspMgr.fListServer[vCurrentSrvId].fWspServer);
								}

								if(vListWspServer.documentElement.hasAttribute('admin') && vListWspServer.documentElement.getAttribute('admin')=='true'){
									wspMgr.xDrawAddWsp(vObjTreeChildren, vDataProvider.isLocal(), vWspServer);
								} 
								vTreeView.fV.toggleOpenState(pRow);
								vTreeView.fContexte.fListServer[vCurrentSrvId].fIsOpen=true;
								vItem.firstChild.firstChild.removeAttribute("properties");
								if(vTreeView.selection.tree) vTreeView.selection.tree.invalidate();
							} else if(vDataProvider.isLocal() && vCounter < 15){
								ut.debug("Serveur local non ready; tentative n°"+vCounter);
								vCounter++;
								window.setTimeout(function(pServer, pUrl, pCb){pServer.loadFromService(pUrl, pCb, pCb);}, 1000, vDataProvider, "/u/adminWsp?cdaction=List", cb); 
							}else if(pEvent && pEvent.type=="error"){
								ut.alert(ut.formatStr("Le serveur \'%s\' ne répond pas.", vDataProvider.getIniUrl()));
								vItem.firstChild.firstChild.removeAttribute("properties");
							}else if(vTarget.status == ut.httpStatusCodeUnauthorized){
								ut.alert(ut.formatStr("Vous ne disposez pas des droits suffisants pour accéder au serveur \'%1$s\' (%2$s - %3$s).", vWspServer.getTitle(), vDataProvider.getIniUrl(), vDataProvider.getCurrentUser()));
								vItem.firstChild.firstChild.removeAttribute("properties");
							}else if(vTarget.status == 404){
								ut.alert(ut.formatStr("Le serveur \'%1$s - %2$s\' n\'a pas été trouvé.", vDataProvider.getIniUrl(), vDataProvider.getCurrentUser()));
								vItem.firstChild.firstChild.removeAttribute("properties");
							} else {
								vItem.firstChild.firstChild.removeAttribute("properties");
								throw ("server "+ (vDataProvider.isLocal() ? "local " : "distant ") +"indisponible aprés "+vCounter+" tentatives. " + vTarget ? ("statusResponse="+vTarget.responseText) : "");
							}

							WspMgrRefreshWsp(null, vWspServer.getId());
						} catch(e){
							ut.debug("WspMgr.prototype.refreshView.cb : "+e);
							vItem.firstChild.firstChild.removeAttribute("properties");
							throw (e);
						}
					}
					vDataProvider.loadFromService("/u/adminWsp?cdaction=List", cb, cb);
				}catch(e){
					vItem.firstChild.firstChild.removeAttribute("properties");
					ut.alert(ut.formatStr("La connexion au serveur \'%1$s\' (%2$s) a échoué.\n Vérifiez vos connexions réseau.", vCurrentSrvId, this.fContexte.fListServer[vCurrentSrvId].fTitle));
					ut.debug("wspmgr > refreshview > cb (impossible de charger le server '"+vCurrentSrvId+"') : "+e);
				}
			}
		};
		vObjTree.treeBoxObject.view = vNewView;
		vObjTree.fView = vNewView;

		var vListeItemServer = vObjTree.getElementsByTagName('treeitem');
		for(var ii=vListeItemServer.length-2;ii>=0;ii--){
			var vCurrentServerId = vListeItemServer[ii].getAttribute('srvId');
			if(this.fListServer[vCurrentServerId].fIsOpen) vNewView.toggleOpenState(ii);
		}

		vObjTree.view.selection.select((this.fCurrentIndex>=0) ? this.fCurrentIndex : 0);
	}catch(e){
		ut.debug("wspmgr > refreshview (Affichage de l'arbre impossible) : "+e);
	}
}




WspMgr.prototype.onNewItemSelected = function(event){
	this.fCurrentInfoWsp = null;
	this.fCurrentWsp = null;
	var vCurrentIndex = document.getElementById(this.fIdTree).currentIndex;
	if(vCurrentIndex<0) return;
	this.fCurrentIndex = vCurrentIndex;
	this.fCurrentWspPropertiesObj = null;
	var vObjZoneConfig = document.getElementById('idZoneConfig');
	var vObjTreeContentView = document.getElementById(this.fIdTree).fView;
	var vItem = vObjTreeContentView.getItemAtIndex(vCurrentIndex);
	var vWspId = vItem.getAttribute('wspId');
	var vSrvId = vItem.getAttribute('srvId');
	var vCurrentIdZoneConfig = vObjTreeContentView.getItemAtIndex(vCurrentIndex).getAttribute('idZoneConfig');
	try{
		if(vCurrentIdZoneConfig==1){// selection d'un WSP
			var vCurrentServer = this.fListServer[vSrvId];
			var vCurrentWsp = this.fWspReg.getWsp(vSrvId, vWspId);
			var vCurrentTitle = vCurrentServer.fIsServerLocal ? "Atelier local : '"+vWspId+"'" : "Atelier distant : '"+vWspId+"'";
			
			vObjZoneConfig.selectedIndex=4;
			document.getElementById('idScreenInfo').value = "Chargement en cours...";
			var vWspMgr = this;
			var vCounter=0;
			var cb = function cb(pEvent){
				try {
					var vCurrentIndex=document.getElementById(vWspMgr.fIdTree).currentIndex;
					var vObjTreeContentView = document.getElementById(vWspMgr.fIdTree).fView;
					var vItem = vObjTreeContentView.getItemAtIndex(vCurrentIndex);
					var vCurrentIdWsp = vItem.getAttribute('wspId');
					var vCurrentSrvId = vObjTreeContentView.getItemAtIndex(vCurrentIndex).getAttribute('srvId');
					if(vCurrentIdWsp==vWspId && vCurrentSrvId==vSrvId){

						var vInfoWsp = pEvent.target.responseXML.documentElement;
						vWspMgr.fCurrentInfoWsp = vInfoWsp;
						vWspMgr.fCurrentWsp = vCurrentWsp;
						var vRights = wspUt.getRights(vWspMgr.fCurrentWsp, vInfoWsp);
						var vStatus = vInfoWsp.getAttribute('status');
						if(vStatus=='noWsp' || vStatus=='noActiveWsp' || vStatus=='noRepository'){
							document.getElementById('idScreenInfoSupprimer').style.display=vRights['rAdmin'] ? "" : "none";
							document.getElementById('idScreenInfoTitre').style.display="";
							document.getElementById('idScreenInfoTitre').value=vCurrentTitle;
							document.getElementById('idScreenInfo').value="Atelier indisponible: "+vInfoWsp.getAttribute('error');
							throw ("atelier '"+ vWspId +"' indisponible (status = "+vStatus+") (error="+vInfoWsp.getAttribute('error')+").");
						}else if(vStatus=='noAccess'){
							document.getElementById('idScreenInfo').value="Vous ne possédez pas les droits de lecture sur cet atelier. Contactez votre administrateur.";
						}else if(vStatus=='init' || vStatus=='downloadRes' || vStatus=='migrating'){
							window.setTimeout(WspMgrRefreshWsp, 1000, vWspId, vSrvId);
						}else if(vStatus=='ok' || vStatus=='failed'){
							vObjZoneConfig.selectedIndex=1;
							wspMgr.setActif(vCurrentWsp.isActive()? "actif" : "inactif");//affichage du bouton actif/inactif ds le bon état
							document.getElementById("idWspError").collapsed=true;
							document.getElementById("idRemoveWsp").style.display=vRights['rAdmin'] ? "" : "none";
							document.getElementById("idTitle").value = vCurrentTitle;
							if (vStatus=='failed'){
								document.getElementById("idWspError").collapsed=false;
								document.getElementById("idWspError").childNodes[0].value = '! Atelier en erreur ! ';
								document.getElementById("idWspError").childNodes[1].value = vInfoWsp.hasAttribute('error') ? vInfoWsp.getAttribute('error') : "";
							}

							vWspMgr.fCurrentWspPropertiesObj = WspPropertiesMgr;
							WspPropertiesMgr.init(vCurrentWsp, vInfoWsp, cb);
								
						}else if(vStatus==null){
							if(vCounter<10){
								vCounter++;
								vWspMgr.fListServer[vSrvId].fWspServer.getDataProvider().loadFromService("/u/adminWsp?cdaction=InfoWsp&param="+vWspId, cb, cb);
							}else{
								ut.debug("vInfoWsp::"+ut.getXml(vInfoWsp));
								document.getElementById('idScreenInfo').value="Impossible de charger cet atelier. Réessayez ultèrieurement.";
							}
						}
					}
				} catch(e){
					ut.debug("WspMgr.onNewItemselected.cb : "+e);
				}
			}
			this.fListServer[vSrvId].fWspServer.getDataProvider().loadFromService("/u/adminWsp?cdaction=InfoWsp&param="+vWspId, cb, cb);
		}else if(vCurrentIdZoneConfig==0){// selection d'un SERVER
			var vDataProvider = this.fWspReg.getDataProvider(vSrvId);
			var vServer = this.fWspReg.getServer(vSrvId);
			vObjZoneConfig.selectedIndex=vCurrentIdZoneConfig;

			function fCb(pWspServer){
				try{
					var vCurrentIndex=document.getElementById(wspMgr.fIdTree).currentIndex;
					var vObjTreeContentView = document.getElementById(wspMgr.fIdTree).fView;
					var vItem = vObjTreeContentView.getItemAtIndex(vCurrentIndex);

					wspMgr.fListServer[pWspServer.getId()].fTitle = pWspServer.getTitle();
					wspMgr.fListServer[pWspServer.getId()].fIsOpen =false;
					wspMgr.fListServer[pWspServer.getId()].fWspServer = pWspServer;
					wspMgr.fListServer[pWspServer.getId()].fLogin = pWspServer.getUser();
					wspMgr.fListServer[pWspServer.getId()].fPassword = pWspServer.getPassword();
									
					vItem.getElementsByTagName("treecell")[0].setAttribute('label', pWspServer.getTitle());

					wspMgr.refreshView();
				}catch(e){
					ut.debug("WspMgr.prototype.onNewItemSelected > server > fCb : " + e);
				}
			}
			SrvConfigMgr.init(vServer, fCb, false);

			if(vDataProvider.isLocal()){
				document.getElementById("idRemoveSrv").style.display = "none";
				document.getElementById("idTitleSrv").value = vServer.getTitle();
			}else{
				document.getElementById("idRemoveSrv").style.display = "";
				document.getElementById("idTitleSrv").value = "Serveur distant : " + vServer.getTitle() + " (" + vDataProvider.getCurrentUser() + ")";
			}
		}else if(vCurrentIdZoneConfig==2){// ajout d'un WSP
			vObjZoneConfig.selectedIndex=vCurrentIdZoneConfig;
			var vWspMgr = this;

			function fCb(pStatus){
				document.getElementById(vWspMgr.fIdTree).view.selection.select(0);
				vWspMgr.refreshView();
			}
			WspCreateMgr.init(this.fWspReg.getServer(vSrvId), fCb);
			wspChoiceModelMgr.selectTypeModel("local");
		}else if(vCurrentIdZoneConfig==3){// ajout d'un SERVER
			vObjZoneConfig.selectedIndex=vCurrentIdZoneConfig;
			var vWspMgr = this;

			function fCb(pStatus){
				document.getElementById(vWspMgr.fIdTree).view.selection.select(0);
				vWspMgr.refreshView();
			}
			SrvDeclareMgr.init(fCb);
		}
	}catch(e){
		ut.debug("WspMgr.prototype.onNewItemSelected ("+vWspId+") : " + e);
	}
}




WspMgr.prototype.setStatusDirty = function(pIdBtnSave, pValue, pType){
	var vBtnSave = document.getElementById(pIdBtnSave);
	if(pType=='http'){
		if(pValue.indexOf('http://')==0 && pValue.length>=8){
			vBtnSave.setAttribute('disabled', false);
		}else{
			vBtnSave.setAttribute('disabled', true);
		}
	}else if(pType=='notNull'){
		if(pValue.length>0){
			vBtnSave.setAttribute('disabled', false);
		}else{
			vBtnSave.setAttribute('disabled', true);
		}
	}else{// on rend le btn  actif
		if(vBtnSave) vBtnSave.setAttribute('disabled', false);
	}
}




WspMgr.prototype.deleteWsp = function(){
	try{
		var vCurrentIndex= document.getElementById(this.fIdTree).currentIndex;
		var vItem = document.getElementById(this.fIdTree).fView.getItemAtIndex(vCurrentIndex);
		var vSrvId = vItem.getAttribute('srvId');
		var vWsp = this.fWspReg.getWsp(vSrvId, vItem.getAttribute('wspId'));
				
		var vHasBeenRemoved = wspUt.removeSynchWsp(vWsp.getServer(), vWsp.getCode());
		if(vHasBeenRemoved){
			document.getElementById(this.fIdTree).view.selection.select(0);
			this.refreshView();
		}
	}catch(e){
		ut.debug("WspMgr.prototype.deleteWsp : " + e);
	}
}




WspMgr.prototype.deleteServer = function(){
	var vCurrentIndex = document.getElementById(this.fIdTree).currentIndex;
	var vSrvId = document.getElementById(this.fIdTree).fView.getItemAtIndex(vCurrentIndex).getAttribute('srvId');
	var vIsSrvRemoved = wspUt.removeSynchSrv(this.fWspReg.getServer(vSrvId));
	if(vIsSrvRemoved){// le serveuyr a bien été supprimé
		this.fListServer[vSrvId]=null;
		delete this.fListServer[vSrvId];
		document.getElementById(this.fIdTree).view.selection.select(0);
		this.refreshView();
	}
}





WspMgr.prototype.setActif = function(pState){
	try{
		var vCurrentIndex= document.getElementById(this.fIdTree).currentIndex;
		var vItem = document.getElementById(this.fIdTree).fView.getItemAtIndex(vCurrentIndex);
		var vWspId = vItem.getAttribute('wspId');
		var vSrvId = vItem.getAttribute('srvId');
		var vCurrentServer = this.fListServer[vSrvId];
		var vImgActif = document.getElementById("idActif");
		var vObjTitle = document.getElementById("idTitle");
		var vFinalState = null;
		if(pState=="actif"){
			vFinalState="actif";
		}else if(pState=="inactif"){
			vFinalState="inactif";
		}else if(vImgActif.getAttribute("scActif")=="true"){
			vFinalState="inactif";
		}else{
			vFinalState="actif";
		}
		if(vFinalState=="inactif"){
			if(this.fWspReg.fireUnloadEvent(vSrvId, vWspId)){
				vImgActif.setAttribute("scActif", "false");
				vImgActif.className="clIcoWspInactif";
				vObjTitle.setAttribute("scActif", "false");
				this.fWspReg.setActiveWsp(vSrvId, vWspId, false);
				vItem.getElementsByTagName("treecell")[0].setAttribute('properties','clWspInactif');
				vItem.getElementsByTagName("treecell")[0].setAttribute('src', vCurrentServer.fIsServerLocal ? this.fIcoMgr.local.inactif : this.fIcoMgr.distant.inactif);
			}
		}else{
			vImgActif.setAttribute("scActif", "true");
			vImgActif.className="clIcoWspActif";
			vObjTitle.setAttribute("scActif", "true");
			this.fWspReg.setActiveWsp(vSrvId, vWspId, true);
			vItem.getElementsByTagName("treecell")[0].setAttribute('properties','clWspActif');
			vItem.getElementsByTagName("treecell")[0].setAttribute('src', vCurrentServer.fIsServerLocal ? this.fIcoMgr.local.actif : this.fIcoMgr.distant.actif);
		}
		if(this.fCurrentWspPropertiesObj) this.fCurrentWspPropertiesObj.refresh();
	}catch(e){
		ut.debug("wspmgr:setActif: "+e);
	}
}




WspMgr.prototype.getNewReposPath = function(pIniPath){
	try{
		var nsIFilePicker = Components.interfaces.nsIFilePicker;
		var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
		fp.init(window, "Sélectionnez un répertoire", nsIFilePicker.modeGetFolder);
		if(pIniPath){
			var vNsiFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
			vNsiFile.initWithPath(pIniPath);
			fp.displayDirectory = vNsiFile;
			}
		var res = fp.show();
		if (res == nsIFilePicker.returnOK){
			return fp.file.path;
		}else{
			return null;
		}
	}catch(e){
		ut.debug("WspMgr.prototype.getNewReposPath: "+e);
		return null;
	}
}





WspMgr.prototype.xSynchRegistryServer = function(pIdServer, pListWsp, pIsActifDefault){
	try{
		var vIsActifDefault = pIsActifDefault ? pIsActifDefault : false;
		var vListWsp = this.fWspReg.getServerWsps(pIdServer);
		var vListWspServer = pListWsp.getElementsByTagName('wsp');
		var vLen = vListWsp.Count();
		for(var ii=0; ii < vLen; ii++){
			var vWsp = vListWsp.GetElementAt(ii).QueryInterface(Components.interfaces.scIWsp);
			var vIsPresent = false;
			for(jj=0; jj<vListWspServer.length; jj++){
				if(vListWspServer[jj].getAttribute("code") == vWsp.getCode()) {
					vIsPresent = true;
				}
			}
			if( ! vIsPresent) {
				this.fWspReg.removeWsp(pIdServer, vWsp.getCode());
			}
		}
		
		for(var ii=0; ii < vListWspServer.length; ii++){
			var vIsPresent = false;
			for(jj=0; jj<vLen; jj++){
				var vWsp = vListWsp.GetElementAt(jj).QueryInterface(Components.interfaces.scIWsp);
				if(vListWspServer[ii].getAttribute("code") == vWsp.getCode()) {
					vIsPresent = true;
				}
			}
			if( ! vIsPresent) {
				this.fWspReg.addWsp(pIdServer, vListWspServer[ii].getAttribute("code"), null, vIsActifDefault);
			}
		}
	} catch(e){
		ut.debug("wspmgr > xSynchRegistryServer (echec à la synchro du serveur '"+pUrlServer+"'): " + e);
	}
}



WspMgr.prototype.xDrawNewRepos = function(pObjTreeChild, pIdServer, pIsLocal){
	var vObjTreeItem = document.createElement('treeitem');
		vObjTreeItem.setAttribute('container','true');
		vObjTreeItem.setAttribute('open','false');
		vObjTreeItem.setAttribute('srvId',pIdServer);
		vObjTreeItem.setAttribute('idZoneConfig',0);
		var vObjTreeRow = document.createElement('treerow');
			var vObjTreeCell = document.createElement('treecell');
				vObjTreeCell.setAttribute('src',pIsLocal ? this.fIcoMgr.local.server : this.fIcoMgr.distant.server);
				vObjTreeCell.setAttribute('label',this.fListServer[pIdServer].fTitle);
				vObjTreeRow.appendChild(vObjTreeCell);
		vObjTreeItem.appendChild(vObjTreeRow);
		vObjTreeItem.appendChild(document.createElement('treechildren'));
	pObjTreeChild.appendChild(vObjTreeItem);
}



WspMgr.prototype.xDrawAddRepos = function(pObjTreeChild){
	var vObjTreeItem = document.createElement('treeitem');
		vObjTreeItem.setAttribute('idZoneConfig',3);
		var vObjTreeRow = document.createElement('treerow');
			var vObjTreeCell = document.createElement('treecell');
				vObjTreeCell.setAttribute('src',this.fIcoMgr.add);
				vObjTreeCell.setAttribute('properties','clAdd');
				vObjTreeCell.setAttribute('label','Nouvelle connexion SCENARIserveur');
			vObjTreeRow.appendChild(vObjTreeCell);
		vObjTreeItem.appendChild(vObjTreeRow);
	pObjTreeChild.appendChild(vObjTreeItem);
}




WspMgr.prototype.xDrawNewWsp = function(pObjTreeChild, pObjWsp, pWspServer){
	var vObjTreeItem = document.createElement('treeitem');
		vObjTreeItem.setAttribute('container','true');
		vObjTreeItem.setAttribute('open','true');
		vObjTreeItem.setAttribute('wspId',pObjWsp.getCode());
		vObjTreeItem.setAttribute('srvId',pWspServer.getId());
		vObjTreeItem.setAttribute('idZoneConfig',1);
		var vObjTreeRow = document.createElement('treerow');
			var vObjTreeCell = document.createElement('treecell');
				vObjTreeCell.setAttribute('label',pObjWsp.getCode());
				var vSrc = '';
				if(pWspServer.getDataProvider().isLocal()){
					pObjWsp.isActive() ? vSrc = this.fIcoMgr.local.actif : vSrc = this.fIcoMgr.local.inactif;
				}else{
					pObjWsp.isActive() ? vSrc = this.fIcoMgr.distant.actif : vSrc = this.fIcoMgr.distant.inactif;
				}
				vObjTreeCell.setAttribute('src',vSrc);
				if( ! pObjWsp.isActive()) vObjTreeCell.setAttribute('properties','clWspInactif');
			vObjTreeRow.appendChild(vObjTreeCell);
		vObjTreeItem.appendChild(vObjTreeRow);
	pObjTreeChild.appendChild(vObjTreeItem);
}




WspMgr.prototype.xDrawAddWsp = function(pObjTreeChild, pIsLocal, pWspServer){
	var vObjTreeItem = document.createElement('treeitem');
		vObjTreeItem.setAttribute('container','true');
		vObjTreeItem.setAttribute('open','true');
		vObjTreeItem.setAttribute('wspId','addWsp');
		vObjTreeItem.setAttribute('srvId',pWspServer.getId());
		vObjTreeItem.setAttribute('idZoneConfig',2);
		var vObjTreeRow = document.createElement('treerow');
			var vObjTreeCell = document.createElement('treecell');
				vObjTreeCell.setAttribute('src',pIsLocal ? this.fIcoMgr.local.add : this.fIcoMgr.distant.add);
				vObjTreeCell.setAttribute('properties','clAdd');
				vObjTreeCell.setAttribute('label','Nouvel atelier');
			vObjTreeRow.appendChild(vObjTreeCell);
		vObjTreeItem.appendChild(vObjTreeRow);
	pObjTreeChild.appendChild(vObjTreeItem);
}
	
function WspMgrRefreshWsp(pIdWsp, pUrlServer){
	var vCurrentIndex=document.getElementById(wspMgr.fIdTree).currentIndex;
	if(vCurrentIndex<0) return;
	var vObjTreeContentView = document.getElementById(wspMgr.fIdTree).fView;
	var vItem = vObjTreeContentView.getItemAtIndex(vCurrentIndex);
	var vWspId = vItem.hasAttribute('wspId') ? vItem.getAttribute('wspId') : null;
	var vSrvId = vItem.getAttribute('srvId');
	if(vWspId == pIdWsp && vSrvId==pUrlServer) {
		wspMgr.onNewItemSelected();
	}
}



