

var wspUt  = {};


wspUt.init = function(){
	wspUt._Prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	wspUt._WspReg = Components.classes["@scenari.com/wspregistryservice;1"].getService(Components.interfaces.scIWspRegistryService);
	wspUt._LocalServerUrl = wspUt._Prefs.getCharPref("scenari.urlServerLocal").length>0 ? wspUt._Prefs.getCharPref("scenari.urlServerLocal") : null;
	wspUt._LocalServerTitle = "Ateliers locaux";

	wspUt._CanCreateServerLocal = false;
	wspUt._CanCreateServerDistant = true;
	try{wspUt._CanCreateServerDistant = wspUt._Prefs.getBoolPref("scenari.canCreateServerDistant")}catch(e){};
	var vNameRepServer = (wspUt._Prefs.getPrefType("scenari.reposCmsServerName")==32 && wspUt._Prefs.getCharPref("scenari.reposCmsServerName").length>0) ? wspUt._Prefs.getCharPref("scenari.reposCmsServerName") : null;
	if(vNameRepServer){
		var vDirService = Components.classes["@mozilla.org/file/directory_service;1"].createInstance(Components.interfaces.nsIProperties);
		var vChromeDir = vDirService.get("AChrom", Components.interfaces.nsIFile);
		var vServerDir = ut.getAppPath().clone();
		vServerDir.append(vNameRepServer);
		wspUt._CanCreateServerLocal = vServerDir.exists();
	}

	wspUt._Rights = {};
	wspUt._Rights.read 			= "Read";
	wspUt._Rights.write			= "Write";
	wspUt._Rights.updateWspType	= "UpdateWspType";
	wspUt._Rights.adminWsp		= "AdminWsp";
	wspUt._Rights.adminUsers	= "AdminUsers";
}
wspUt.init();


wspUt.createSynchWspUrl = function(pCode, pIdServer, pContentPath, pGenPath, pComment, pFctCb, pUrlWspType){
	var vWspType = null;
	try{
		var vUrlWspType = (pUrlWspType.indexOf("chrome:")==0 || pUrlWspType.indexOf("file:")==0) ? pUrlWspType : "file://"+ pUrlWspType;//Le protocole chrome ou file  peut etre déjà spécifié ou pas
		var vResult = ut.getDomFromLocalFileUrl(vUrlWspType);
		if (vResult!=null && vResult.documentElement.tagName!="parserError"){
			vWspType = ut.getXml(vResult);
		}else{
			ut.alert(pUrlWspType!='' ? ut.formatStr("Le modèle d\'atelier \'%s\' est invalide.", pUrlWspType) : "Veuillez spécifier un modèle d\'atelier.", "Echec à la création d\'un atelier");
			return;
		}
		this.createSynchWsp(pCode, pIdServer, pContentPath, pGenPath, pComment, pFctCb, vWspType);
	}catch(e){
		ut.debug("wspUt.createSynchWspUrl : " + e);
		ut.alert("Création de l\'atelier impossible.\nVérifiez les données de définition de cet l\'atelier.", "Création en échec");
		return null;
	}
}


  wspUt.createSynchWsp = function(pCode, pIdServer, pContentPath, pGenPath, pComment, pFctCb, pWspType){
	var vStatus;
	try{
		var vDataProvider = this._WspReg.getDataProvider(pIdServer);

		var vResult = vDataProvider.dialogSynchWithService("/u/adminWsp?cdaction=List", "GET", pWspType , "text/xml");
		var vIsAlreadyDefined = false;
		if(vResult && vResult.status==200 && vResult.responseXML){
			var vWspNode = vResult.responseXML.documentElement.firstElementChild;
			while(vWspNode) {
				if(vWspNode.nodeName=="wsp" && vWspNode.getAttribute("code")==pCode){
					vIsAlreadyDefined = true;
					break;
				}
				vWspNode = vWspNode.nextElementSibling;
			}
		}

		if(vIsAlreadyDefined && ut.confirm("L\'atelier a déjà été déclaré. Voulez-vous en changer sa définition ?", null, "Oui", "Non")){
			if(pWspType) vResult = vDataProvider.dialogSynchWithService("/u/adminWsp?cdaction=ModifyWspType&param="+pCode, "PUT", pWspType, "text/xml");
			if(vResult.status=="200") vResult = vDataProvider.dialogSynchWithService("/u/adminWsp?cdaction=InstallUpdates" + "&param="+pCode, "PUT", null, "text/xml");
			vStatus = vResult.status;
		}else{
			var vReq = "/u/adminWsp?cdaction=Create&param="+pCode;
			if(vDataProvider.isLocal()){// pour se protéger. A virer qd ca sera bloqué coté java
				if(pContentPath) vReq += "&contentPath="+encodeURIComponent(pContentPath);
				if(pGenPath) vReq += "&genPath="+encodeURIComponent(pGenPath);
			}
			var vResult = vDataProvider.dialogSynchWithService(vReq, "PUT", pWspType , "text/xml");
			if(vResult) vStatus = vResult.status;
			if(!vDataProvider.isLocal()){// on affecte les droits par défaut des utilisateurs : aucun
				var vUserListDom = document.createElement("access");
				var vUserDom = document.createElement("user");
					vUserDom.setAttribute("account", vDataProvider.getCurrentUser());
					vUserDom.setAttribute("rights", this._Rights.read+" "+ this._Rights.write+" "+ this._Rights.updateWspType+" "+ this._Rights.adminWsp+" "+ this._Rights.adminUsers);
				vUserListDom.appendChild(vUserDom);
				vDataProvider.dialogSynchWithService("/u/adminWsp?cdaction=SaveListUsers&param="+pCode,"PUT", ut.getXml(vUserListDom), "text/xml");
			}
		}

		this._WspReg.addWsp(pIdServer, pCode, null, true);

		ut.fPrefs.setCharPref("scenari.deskWsp.currentWsp", pCode);
		if(pFctCb) pFctCb(vStatus);
	}catch(e){
		ut.debug("wspUt.createSynchWsp : " + e);
		ut.alert("Création de l\'atelier impossible.\nVérifiez les données de définition de cet l\'atelier.", "Création en échec");
		if(pFctCb) pFctCb(vStatus);
		return null;
	}
}


wspUt.modifyASynchWsp = function(pCode, pIdServer, pWspType, pCbSavePending){
	try{
		var vDataProvider = this._WspReg.getDataProvider(pIdServer);
		if (pWspType) vDataProvider.dialogSynchWithService(	"/u/adminWsp?cdaction=ModifyWspType&param="+pCode, "PUT", pWspType, "text/xml");
		

		var vElementToInstall = true;
		var vCounter = 0;

		function cb(pEvent){
			try {
				var vResponse = pEvent.target.responseXML.documentElement;
				var vStatus = vResponse.getAttribute('status');
				if(vStatus=='noWsp' || vStatus=='noActiveWsp' || vStatus=='noRepository'){
					if(pCbSavePending) pCbSavePending(false, 'wspError');
					ut.alert("Impossible de charger cet atelier. Veuillez contacter votre administrateur.");
				}else if(vStatus=='noAccess'){
					if(pCbSavePending) pCbSavePending(false, 'wspError');
					ut.alert("Vous ne disposez pas des droits suffisants sur cet atelier.");
				}else if(vStatus=='init' || vStatus=='downloadRes' || vStatus=='migrating'){
					window.setTimeout(function(pServer, pUrl, pCb){pServer.loadFromService(pUrl, pCb, pCb);}, 2000, vDataProvider, "/u/adminWsp?cdaction=InfoWsp&param="+pCode, cb);
				}else if(vStatus=='ok' || vStatus=='failed'){
					if(vElementToInstall){
						var vIsMigratingNeeded = (vResponse.hasAttribute("isMigrationNeeded") && vResponse.getAttribute("isMigrationNeeded")=="true");
						var vExecMigration = {value:vIsMigratingNeeded};
						function cbAbort(pEvent){
							if(pCbSavePending) pCbSavePending(false, 'abort');
						}
						if(vIsMigratingNeeded){
							if(!ut.confirm("Les contenus de votre atelier doivent être mis à jour. Vous ne pourrez pas annuler cette action. Voulez-vous continuer ?", null, "Continuer", "Annuler", "Executer la mise à jour des contenus", vExecMigration)){
								vElementToInstall=false;
								vDataProvider.loadFromService("/u/adminWsp?cdaction=AbortUpdates&param="+pCode, cbAbort, cbAbort);
							}
						}
						if(vExecMigration.value){

							var vRespMigr = vDataProvider.dialogSynchWithService("/u/adminWsp?cdaction=CheckBeforeMigration&param="+pCode, "GET", null, null);
							if(vRespMigr.status==420) {
								var vErrXml = vRespMigr.responseXML;
								ut.alert("La migration est impossible :\n" + ((vErrXml && vErrXml.documentElement.hasAttribute("desc")) ? vErrXml.documentElement.getAttribute("desc") : vRespMigr.responseText), "Echec de la migration");
								vElementToInstall=false;
								vDataProvider.loadFromService("/u/adminWsp?cdaction=AbortUpdates&param="+pCode, cbAbort, cbAbort);
							}
						}
						if(vElementToInstall) vDataProvider.loadFromService("/u/adminWsp?cdaction=" + (vExecMigration.value ? "MigrateInstallUpdates" : "InstallUpdates") + "&param="+pCode, cb, cb);
						vElementToInstall=false;
					}else{//fin de l'installation
						if(pCbSavePending) pCbSavePending(false, 'success');
						wspUt._WspReg.fireUpdateEvent(pIdServer, pCode);
					}
				}else if(vStatus==null){
					if(vCounter<10){
						vCounter++;
						vDataProvider.loadFromService("/u/adminWsp?cdaction=InfoWsp&param="+pCode, cb, cb);
					}else{
						if(pCbSavePending) pCbSavePending(false);
						ut.debug("vInfoWsp:"+ut.getXml(vInfoWsp));ut.debug("counter:: "+vCounter);
						ut.alert("Impossible de charger cet atelier. Réessayez ultérieurement.");
					}
				}
			} catch(e){
				ut.debug("wspUt.modifyASynchWsp > cb : "+e);
			}
		}

		vDataProvider.loadFromService("/u/adminWsp?cdaction=InfoWsp&param="+pCode, cb, cb);


		if(pCbSavePending) pCbSavePending(true);


	}catch(e){
		ut.debug("wspUt.modifyASynchWsp : " + e);
	}
}


wspUt.removeSynchWsp = function(pWspServer, pCodeWsp, pSilentMode, pDeleteContent){
	try{
		var vCheckResult = {value : (pDeleteContent ? pDeleteContent : false)};
		var vDataProvider = pWspServer.getDataProvider();
		if(pSilentMode || ut.confirm(ut.formatStr("Voulez-vous vraiment supprimer l\'atelier \'%s\' ?", pCodeWsp), "Suppression d\'un atelier", null, null, "Supprimer également les contenus de cet atelier du disque dur", vCheckResult)){
			try{
				if(this._WspReg.fireUnloadEvent(pWspServer.getId(), pCodeWsp)){// déchargement des items, message de confirmation si dirty
					var vReq = "";
					if(vCheckResult.value){
						vReq = "/u/adminWsp?cdaction=Delete&param=" + pCodeWsp;
					}else{
						vReq = "/u/adminWsp?cdaction=Drop&param=" + pCodeWsp;
					}
					var vResult = vDataProvider.dialogSynchWithService(vReq, "PUT", null , "text/xml");
					this._WspReg.removeWsp(pWspServer.getId(), pCodeWsp);
					return true;
				}
				return false;
			}catch(e){
				ut.debug("Impossible de supprimer l'atelier '" + pCodeWsp + "': " + e);
				ut.alert(ut.formatStr("Suppression de l\'atelier \'%s\' impossible.", pCodeWsp), "Suppression en échec");
				return false;
			}
		}
	}catch(e){
		ut.debug("wspUt.removeSynchWsp : " + e);
	}
}


wspUt.getRights = function(pWspObj, pWspInfoDom){
	try{
		var vRights = new Object();

	    if(pWspObj && pWspObj.getDataProvider() &&  pWspObj.getDataProvider().isLocal()){
	    	vRights['rRead'] 		  = true;
	    	vRights['rWrite']		  = true;
			vRights['rAdminWsp']	  = true;
			vRights['rUpdateWspType'] = true;
			vRights['rAdminUsers']    = true;
			vRights['rAdmin']    	  = true;
	    }else if(pWspInfoDom){

	    	vRights['rRead'] 		  = (pWspInfoDom.hasAttribute("readWsp") && pWspInfoDom.getAttribute("readWsp")=="false") ? false : true;
	    	vRights['rWrite']		  = (pWspInfoDom.hasAttribute("writeWsp") && pWspInfoDom.getAttribute("writeWsp")=="false") ? false : true;
			vRights['rAdminWsp']	  = (pWspInfoDom.hasAttribute("adminWsp") && pWspInfoDom.getAttribute("adminWsp")=="false") ? false : true;
			vRights['rUpdateWspType'] = (pWspInfoDom.hasAttribute("updateWspType") && pWspInfoDom.getAttribute("updateWspType")=="false") ? false : true;
			vRights['rAdminUsers']    = (pWspInfoDom.hasAttribute("adminUsers") && pWspInfoDom.getAttribute("adminUsers")=="false") ? false : true;
			vRights['rAdmin']    	  = (pWspInfoDom.hasAttribute("admin") && pWspInfoDom.getAttribute("admin")=="false") ? false : true;
	    }else{
	   		vRights['rRead'] 		  = false;
	    	vRights['rWrite']		  = false;
			vRights['rAdminWsp']	  = false;
			vRights['rUpdateWspType'] = false;
			vRights['rAdminUsers']    = false;
	    }
		return vRights;		
	}catch(e){
		ut.debug("wspUt.getRights : " + e);
	}	
}



wspUt.isWspOk = function(pDataProvider, pCodeWsp, pOkCb, pErrorCb){
	var vCounter = 0;
	var vIsFirstCall = true;
	try{
		function cb(pEvent){
			try {
				if(pEvent.type!="error"){// le serveur a répondu
					if(pEvent.target.responseXML && pEvent.target.status == 200){// réponse correcte du serveur
						var vResponse = pEvent.target.responseXML.documentElement;
						var vStatus = vResponse.getAttribute('status');
						if(vStatus=='failed' || vStatus=='noWsp' || vStatus=='noActiveWsp' || vStatus=='noRepository' || vStatus=='noAccess'){
							if(pErrorCb) pErrorCb(pEvent);
						}else if(vStatus=='init' || vStatus=='downloadRes' || vStatus=='migrating'){
							window.setTimeout(function(pDataProvider, pUrl, pCb){pDataProvider.loadFromService(pUrl, pCb, pCb);}, 500, pDataProvider, "/u/adminWsp?cdaction=InfoWsp&param="+pCodeWsp, cb);
						}else if(vStatus=='ok'){
							if(pOkCb) pOkCb(pEvent);
						}else if(vStatus==null){
							if(vCounter<15){
								vCounter++;
								window.setTimeout(function(pDataProvider, pUrl, pCb){pDataProvider.loadFromService(pUrl, pCb, pCb);}, 500, pDataProvider, "/u/adminWsp?cdaction=InfoWsp&param="+pCodeWsp, cb);
							}else{
								if(pErrorCb) pErrorCb(pEvent);
							}
						}
					}else if(pEvent.target.status == ut.httpStatusCodeUnauthorized && vIsFirstCall){// on réessaye car la première interrogation du serveur peut retourner une mauvaise réponse : FF ne renseigne pas correctement le tag "Authorization" dans son entête
						vIsFirstCall = false;
						window.setTimeout(function(pDataProvider, pUrl, pCb){pDataProvider.loadFromService(pUrl, pCb, pCb);}, 100, pDataProvider, "/u/adminWsp?cdaction=InfoWsp&param="+pCodeWsp, cb);
					}else{// réponse pas ok du serveur
						if(pErrorCb) pErrorCb(pEvent);
					}
				}else{//pas de réponse du serveur
					if(vCounter < ut.cnxLocalSvrMaxAttempts){
						vCounter++;
						window.setTimeout(function(pDataProvider, pUrl, pCb){pDataProvider.loadFromService(pUrl, pCb, pCb);}, 500, pDataProvider, "/u/adminWsp?cdaction=InfoWsp&param="+pCodeWsp, cb);
					}else{
						if(pErrorCb) pErrorCb(pEvent);
					}
				}
			} catch(e){
				ut.debug("wspUt.isWspOk > cb : " + e);
				if(pErrorCb) pErrorCb(pEvent);
			}
		}
		if(pDataProvider){

			pDataProvider.loadFromService("/u/adminWsp?cdaction=InfoWsp&param="+pCodeWsp, cb, cb);
		}else{
			if(pErrorCb) pErrorCb(pEvent);
		}
	}catch(e){
		ut.debug("wspUt.isWspOk : " + e);
	}
}


wspUt.isDataProviderAvailable = function(pDataProvider, pOkCb, pErrorCb){
	try{
		var vInitCounter = 0;
		var vCounter = 0;
		var vContexte = this;
		var cb = function (pEvent){
			try {


				if(pEvent && pEvent.type!="error"){
					var vTarget = pEvent.target.QueryInterface(Components.interfaces.nsIXMLHttpRequest);
					if(vTarget && vTarget.responseXML && vTarget.status == 200){
						var vWspList = pEvent.target.responseXML;
						if(pOkCb) pOkCb(vWspList.documentElement);
					} else if(pDataProvider.isLocal() && vCounter < 15){
						ut.debug("Serveur local non ready; tentative n°" + vCounter);
						vCounter++;
						window.setTimeout(pDataProvider.loadFromService, 1000, "/u/adminWsp?cdaction=List", cb, cb);
					} else {
						if(pErrorCb) pErrorCb(vTarget.status);
						ut.debug("Le server '" + (pDataProvider.isLocal() ? "local" : pDataProvider.getWspServer().getId()) + "' est indisponible : " + vTarget.status);
					}
				}else if(pDataProvider.isLocal() && vInitCounter < ut.cnxLocalSvrMaxAttempts){// Le serveur peut ne pas répondre lors de son lancement
					ut.debug("Serveur local non ready; tentative n°" + vInitCounter);
					vInitCounter++;
					window.setTimeout(pDataProvider.loadFromService, 1000, "/u/adminWsp?cdaction=List", cb, cb);
				}else{
					if(pErrorCb) pErrorCb();
					ut.debug("Le server '" + (pDataProvider.isLocal() ? "local" : pDataProvider.getWspServer().getId()) + "' est indisponible.");
				}
			} catch(e){
				ut.debug("wspUt.isServerAvailable > cb : " + e);
			}
		}
		pDataProvider.loadFromService("/u/adminWsp?cdaction=List", cb, cb);
	}catch(e){
		ut.debug("wspUt.isServerAvailable : " + e);
	}
}


wspUt.declareASynchSrv = function(pUrl, pTitle, pLogin, pPassword, pAllWspActifs, pForce, pCb, pCbErr){
	try{
		var vCreateAlways = pForce ? pForce : false;
		
		if(this._WspReg.searchServer(pUrl, pLogin) != null && !vCreateAlways){
			ut.alert("Cette connexion serveur a déjà été déclarée.\nVeuillez spécifier un identifiant et/ou une URL différents.");
			return;
		}
		
		var vWspServer = this._WspReg.addServer(pUrl, pLogin, pTitle, pPassword);
		var vDataProvider = vWspServer.getDataProvider();
		
		var vCounter = 0;
		var cb = function (pEvent){
			try {


				if(pEvent && pEvent.type!="error" && pEvent.target.responseXML && pEvent.target.status == 200){
					if(pAllWspActifs){// on active tous les ateliers de ce serveur
						var vListWspServer = pEvent.target.responseXML;
						var vWspList = vListWspServer.getElementsByTagName("wsp");
						for(var ii=0; ii<vWspList.length; ii++){
							var vWspCode = vWspList[ii].getAttribute('code');
							wspUt._WspReg.addWsp(vWspServer.getId(), vWspCode, null, true);
						}
					}
					if(pCb) pCb(vWspServer);
				}else if(pEvent && pEvent.type!="error" && pEvent.target.status == ut.httpStatusCodeUnauthorized){
					if(vCreateAlways){
						ut.alert(ut.formatStr("Vous ne disposez pas des droits suffisants pour accéder au serveur \'%1$s\' avec l\'identifiant \'%2$s\'.", pUrl, pLogin));
						if(pCb) pCb(vWspServer);
					}else{
						if(!ut.confirm(ut.formatStr("Vous ne disposez pas des droits suffisants pour accéder au serveur \'%1$s\' avec l\'identifiant \'%2$s\'.\nVoulez-vous néanmoins enregistrer cette connexion ?", pUrl, pLogin))){
							wspUt._WspReg.removeServer(vWspServer.getId()); //pas les droits => le serveur n'est pas déclaré
							if(pCbErr) pCbErr();
						}else{
							if(pCb) pCb(vWspServer);
						}
					}
				} else if(vCounter < 5){// serveur pas prét
					ut.debug("Serveur distant non ready; tentative n°"+vCounter);
					vCounter++;
					window.setTimeout(vDataProvider.loadFromService, 1000, "/u/adminWsp?cdaction=List", cb, cb);
				}else {
					if(vCreateAlways){
						ut.alert(ut.formatStr("La connexion au serveur \'%1$s\' avec l\'identifiant \'%2$s\' a échoué. \n Vérifiez vos connexions réseau.", pUrl, pLogin));
						if(pCb) pCb(vWspServer);
					}else{
						if(!ut.confirm(ut.formatStr("La connexion au serveur \'%1$s\' avec l\'identifiant \'%2$s\' a échoué. Voulez-vous néanmoins enregistrer cette connexion ?\n Vérifiez vos connexions réseau", pUrl, pLogin))){
							wspUt._WspReg.removeServer(vWspServer.getId()); //pas les droits => le serveur n'est pas déclaré
							if(pCbErr) pCbErr();
						}else{
							if(pCb) pCb(vWspServer);
						}
					}
				}
			} catch(e){
				if(pCbErr) pCbErr();
				ut.debug("wspUt.declareASynchSrv.cb : " + e);
				throw (e);
				return null;
			}
		}
		vDataProvider.loadFromService("/u/adminWsp?cdaction=List", cb, cb);
		return vWspServer;
	}catch(e){
		if(pCbErr) pCbErr();
		ut.debug("wspUt.declareASynchSrv : " + e);
		return null;
	}
}


wspUt.removeSynchSrv = function(pWspServer, pSilentMode){
	try{
		var vCheckResult = {};
		var vDataProvider = pWspServer.getDataProvider();
		if(pSilentMode || ut.confirm(ut.formatStr("Voulez-vous vraiment supprimer le serveur \'%s\' ?", pWspServer.getTitle()), "Suppression d\'un serveur")){
			try{
				if(this._WspReg.fireUnloadEvent(pWspServer.getId(), null)){// déchargement des items, message de confirmation si dirty
					this._WspReg.removeServer(pWspServer.getId());
					return true;
				}
				return false;
			}catch(e){
				ut.debug("Impossible de supprimer le serveur '" + pWspServer.getTitle() + "': " + e);
				ut.alert(ut.formatStr("Suppression du serveur \'%s\' impossible.", pWspServer.getTitle()), "Suppression en échec");
				return false;
			}
		}
	}catch(e){
		ut.debug("wspUt.removeSynchSrv : " + e);
	}
}


wspUt.disconnectSynchSrv = function(pWspServer, pSilentMode){
	try{
		var vCheckResult = {};
		var vDataProvider = pWspServer.getDataProvider();
		if(pSilentMode || ut.confirm(ut.formatStr("Voulez-vous vraiment déconnecter le serveur  \'%s\' ?", pWspServer.getTitle()), "Suppression d\'un serveur")){
			try{
				if(this._WspReg.fireUnloadEvent(pWspServer.getId(), null)){// déchargement des items, message de confirmation si dirty
					this._WspReg.setServerConnexionSetting(pWspServer.getId(), null);
					this._WspReg.setServerSavePsswdFlag(pWspServer.getId(), false); //on supp l'enregistrement du password de ce serveur
					return true;
				}
				return false;
			}catch(e){
				ut.debug("Impossible de déconnecter le serveur '" + pWspServer.getTitle() + "': " + e);
				ut.alert(ut.formatStr("Déconnexion du serveur \'%s\' impossible.",pWspServer.getTitle()), "Déconnexion en échec");
				return false;
			}
		}
	}catch(e){
		ut.debug("wspUt.disconnectSynchSrv : " + e);
	}
}
