


function WspView(pWspRegistered, pNodeTree, pUrlService){
	this.fDataProvider = pWspRegistered.getDataProvider();
	this.fCdWsp = pWspRegistered.getCode();
	this.fWspRegistered = pWspRegistered;
	this.fNodeTree = pNodeTree;
	this.fTree = pNodeTree.treeBoxObject;
	this.fUrlService = pUrlService || "/u/trav?";

	this.filterSystemItem = true;
	
	this.fTooltip = document.getAnonymousElementByAttribute(pNodeTree.parentNode, "tt", "true");
	
	this.rowCount = 0;
	

	this.fCurrentReq = null;
	this.fIsCutting = false;
	this.fRowPopupActive = -1;
	this.fRowMouseOver = null;
	
	var vAtomService = Components.classes["@mozilla.org/atom-service;1"].getService(Components.interfaces.nsIAtomService);
	this.fInCut = vAtomService.getAtom("incut");
	this.fTmpItem = vAtomService.getAtom("tmpItem");
	this.fPopupActive = vAtomService.getAtom("popupActive");

	pNodeTree.pageUpOrDownMovesSelection = false;
	pNodeTree.addEventListener("mousedown", wspViewOnMouseDown, true);
	pNodeTree.addEventListener("click", wspViewOnClick, true);
	pNodeTree.addEventListener("mousemove", wspViewOnMouseMove, false);
	pNodeTree.addEventListener("mouseout", wspViewOnMouseOut, false);
	pNodeTree.addEventListener("draggesture", wspViewOnDragGesture, false);
	pNodeTree.addEventListener("dragexit", wspViewOnDragExit, false);
	
	this.xRefreshData();
	
	pNodeTree.view = this;
}




WspView.prototype.getUri = function(){
	var vIdx = -1;
	try {vIdx = this.selection.currentIndex;} catch(e){}
	if(vIdx >= 0) {
		var vItem = this.xGetItem(vIdx);
		return this.xGetUri(vItem);
	} else {
		return null;
	}
}


WspView.prototype.getUriObject = function(){
	var vIdx = -1;
	try {vIdx = this.selection.currentIndex;} catch(e){}
	if(vIdx >= 0) {
		var vItem = this.xGetItem(vIdx);
		if(vItem.ty == "space") {

			return new UriObjectSpace(this.xGetUri(vItem), this.fDataProvider);
		} else {

			return new UriObjectItem(this.xGetUri(vItem), this.fDataProvider);
		}
	} else {

		return null;
	}
}


WspView.prototype.refreshWsp = function(pUri){
	this.xResetStackReq();
	this.xRefreshData(pUri);
}


WspView.prototype.refreshUri = function(pUri, pAuthor){
	try{
		if(pAuthor && pAuthor==this.fIdAuthor) return; //On est au courant, l'update vient de nous 
		if( ! this.xFilterUri(pUri)) return; //Uri exclue de l'affichage.

		var vReq = this.getReqToRefreshUri(pUri);
		this.xAddReq(vReq);
	}catch(e){
		ut.debug("WspView.prototype.refreshUri"+e);
	}
}


WspView.prototype.selectUri = function(pUri){
	var vArrUri = this.xSplitUri(pUri);
	if(vArrUri.length >= 1 && vArrUri[0] == this.fCdWsp) {
		var vReq = {
			fViewMgr: this,
			fUri: pUri,
			fFindArr: vArrUri,
			execute: function(){
				try{
					if(this.fUri == this.fViewMgr.getUri()) {

						this.fViewMgr.xCloseCurrentReq(this);
					} else {

						this.fViewMgr.selection.currentIndex = -1;
						this.fViewMgr.selection.clearSelection();
						if(this.fFindArr.length > 1){
							this.fFindIdx = 1;
							this.fRow = -1;
							this.fItem = this.fViewMgr.fData;
							this.fViewMgr.xSelect(this);
						} else {
							this.fViewMgr.xCloseCurrentReq(this);
						}
					}
				}catch(e){
					this.fViewMgr.xCloseCurrentReq(this);
					ut.debug("WspView.prototype.selectUri.execute"+e);
				}
			}
		}
		this.xAddReq(vReq);
	}
}




WspView.prototype.setTree = function(pTree){
}


WspView.prototype.getCellText = function(pRow, pCol){
	return this.xGetItem(pRow).nm;
}

WspView.prototype.isSeparator = function(pRow){
	return false;
}

WspView.prototype.isEditable = function(pRow, pCol){
	return false;
}

WspView.prototype.isSorted = function(){
	return false;
}

WspView.prototype.getImageSrc = function(pRow, pCol){
	var vIt = this.xGetItem(pRow); 
	return (vIt.icO && vIt.ch) ? vIt.icO : vIt.ic;
}

WspView.prototype.getRowProperties = function(pRow, pProps){
	if(this.fRowPopupActive == pRow) pProps.AppendElement(this.fPopupActive);
}

WspView.prototype.getCellProperties = function(pRow, pCol, pProps){
	if(this.fIsCutting && this.xGetItem(pRow).isCutting) pProps.AppendElement(this.fInCut);
	if(this.xGetItem(pRow).tmpItem) pProps.AppendElement(this.fTmpItem);
}

WspView.prototype.getColumnProperties = function(pColId, pColElt, pProps){
}

WspView.prototype.hasNextSibling = function(pRow, pAfterIndex){
try{

	var vItem = this.xGetItem(pRow);
	var vArray = vItem.p.ch;
	var vNextRow = pRow + vItem.nbr;
	for (var i = vItem.i+1; i < vArray.length; i++){
		if(vNextRow >= pAfterIndex){


			return true;
		}
		vNextRow += vArray[i].nbr;
	}
	return false;
}catch(e){ut.debug("hasNextSibling : "+pRow+" :"+e);}
}






WspView.prototype.getLevel = function(pRow){
try {
	var vItemParent = this.xGetItem(pRow).p.p;
	var vLevel = 0;
	while(vItemParent){
		vLevel++;
		vItemParent = vItemParent.p;
	}
	return vLevel;
}catch(e){ut.debug("getLevel : '"+pRow+"'/'"+this.rowCount+"' : "+e);}
}
WspView.prototype.getParentIndex = function(pRow){
try{
	if(pRow<0) return -1;
	var vItem = this.xGetItem(pRow);
	if(vItem.p != this.fData){
		var vArray = vItem.p.ch;
		var vMax = vArray.length;
		var vParentRow = pRow;
		for(var i = 0; i < vMax; i++) {
			var vSibling = vArray[i];
			if(vSibling == vItem) return vParentRow - 1;
			vParentRow -= vSibling.nbr;
		}


	}
	return -1;
}catch(e){ut.debug("getParentIndex : "+pRow+" :"+e);}
}
WspView.prototype.isContainer = function(pRow){
try{
	var vItem = this.xGetItem(pRow);
	return vItem.ty!="res" && vItem.ty!="itemmono";
}catch(e){ut.debug("isContainer : "+pRow+" :"+e);}
}
WspView.prototype.isContainerOpen = function(pRow){
try{
	var vItem = this.xGetItem(pRow);
	return vItem.ch;
}catch(e){ut.debug(e);}
}
WspView.prototype.isContainerEmpty = function(pRow){
try{
	var vItem = this.xGetItem(pRow);
	return vItem.ty=="itemmono" || vItem.ty=="res" || vItem.ty=="";
}catch(e){ut.debug("isContainerEmpty : "+pRow+" :"+e);}
}
WspView.prototype.toggleOpenState = function(pRow){
	try{
		var vOldItem = this.xGetItem(pRow);
		if(!vOldItem) return;
		var vToggleReq = {
			fViewMgr : this,
			fUri : this.xGetUri(vOldItem),
			execute : function() {
				var vItemRow = {};
				var vItem = this.fViewMgr.xSearchItemByUri(this.fUri, vItemRow);
				var vRow = vItemRow.fRow;
				try {
					if(vItem) {
						if("ch" in vItem && vItem.ch!=null){
							this.fViewMgr.xResetState();

							vItem.ch = null;
							var vNbRowRemoved = vItem.nbr-1;
							if(vNbRowRemoved>0){
								this.fViewMgr.xUpdtNbr(vItem, -vNbRowRemoved);
								this.fViewMgr.fTree.rowCountChanged(vRow+1, -vNbRowRemoved);
							}
							this.fViewMgr.fTree.invalidateRow(vRow);
						} else {

							vItem.ch = [];
							this.fViewMgr.xInsertItem(vRow, vOldItem, {nm:"Chargement en cours...", ty:"", nbr:1, tmpItem:true});

							var vReq = this.fViewMgr.getReqToRefreshUri(this.fUri);
							this.fViewMgr.xAddReq(vReq, true);
						}
					}
				} finally {
					this.fViewMgr.xCloseCurrentReq(this);
				}
			}
		}
		this.xAddReq(vToggleReq, true);
	}catch(e){ut.debug("toggleOpenState : "+pRow+" :"+e);}
}



WspView.prototype.canChangeSelect = function(){
	return true;
}







WspView.prototype.getProgressMode = function (pRow, pCol){
	return 0;
}
WspView.prototype.getCellValue = function(pRow, pCol){
	return null;
}
WspView.prototype.cycleCell = function(pRow, pCol){
}
WspView.prototype.cycleHeader = function(pColId, pColElt){
}


WspView.prototype.canDrop = function(pRow, pOrientation){
	if(pOrientation != 0) return false;
	if(window.desk.isReadOnly()) return false;
	var vSession = transf.fDragService.getCurrentSession();
	return vSession.isDataFlavorSupported(transf.FLAVOUR_SCENARI_URI) || vSession.isDataFlavorSupported(transf.FLAVOUR_FILE) || vSession.isDataFlavorSupported(transf.FLAVOUR_TEXT_URL) ;
}
WspView.prototype.drop = function(pRow, pOrientation){
	try{
		if(window.desk.isReadOnly()) return;
		var vViewMgr = this;
		var vItem = (pRow >= 0) ? vViewMgr.xGetItem(pRow) : null;
		var vUriParent = vItem ? vViewMgr.xGetUri(vItem) : vViewMgr.fCdWsp;
		var vDragServ = transf.fDragService;
		var vSession = vDragServ.getCurrentSession();

		if(vSession.isDataFlavorSupported(transf.FLAVOUR_SCENARI_URI)) {
			var vTrans = transf.createTransferable();
			vTrans.addDataFlavor(transf.FLAVOUR_SCENARI_URI);
			vSession.getData(vTrans, 0);
			var vUri = transf.getStringDataFromTransferable(vTrans, transf.FLAVOUR_SCENARI_URI);
			
			vTrans = transf.createTransferable();
			vTrans.addDataFlavor(transf.FLAVOUR_SCENARI_SERVER_ID);
			vSession.getData(vTrans, 0);
			var vSrvId = transf.getStringDataFromTransferable(vTrans, transf.FLAVOUR_SCENARI_SERVER_ID);
					

			if(vUri && vSrvId && vSrvId!=vViewMgr.fDataProvider.getWspServer().getId()){
				ut.alert("La copie d\'item/espace entre deux ateliers appartenant à deux serveurs différents est impossible.\nVeuillez réaliser au préalable une copie locale de l\'item/espace.");
			}else if(vUri){
				if(! window.desk.saveAllViews(this.fCdWsp)) return;
				var vIsCut = ((vSession.dragAction & Components.interfaces.nsIDragService.DRAGDROP_ACTION_COPY) == 0);
				if(vUri == vUriParent) return; //Pas de déplacement ou copie sur lui même.
				var vUriDst = ut.addLeafToUri(vUriParent, ut.getLeafFromUri(vUri));
				if(vIsCut && vUri == vUriDst) return; //Pas de déplacement sur son père.
				var vReload = false;
				if(vIsCut) {
					if( ! ut.confirm(ut.formatStr("Confirmez le déplacement de %1$s vers %2$s", vUri, vUriDst), "Déplacements de fichiers", "Déplacer", "Annuler")) return;
					var vStatusReloadDom = vViewMgr.fDataProvider.getDomFromService("/u/adminWsp?cdaction=StatusLoadedAllItems&param="+vViewMgr.fCdWsp);
					var vStatusReload = vStatusReloadDom ? vStatusReloadDom.documentElement.getAttribute("status") : null;
					if(vStatusReload=="no" && ! ("fDontAskRelaodItems" in vViewMgr)) {





						vReload = true;
					}
				} else {
					if( ! ut.confirm(ut.formatStr("Confirmez la duplication de %1$s vers %2$s", vUri, vUriDst), "Duplication de fichiers", "Dupliquer", "Annuler")) return;
				}
				wspViewPasteUriToUri(vUri, vUriDst, vIsCut, vViewMgr, vReload);
			}
		} else if(vSession.isDataFlavorSupported(transf.FLAVOUR_FILE)) {


			for (var i = 0; i < vSession.numDropItems; ++i) {
				var vTrans = transf.createTransferable();
				vTrans.addDataFlavor(transf.FLAVOUR_FILE);
				vSession.getData(vTrans, i);
				var vObj = {};
				var vLen = {};
				vTrans.getTransferData(transf.FLAVOUR_FILE, vObj, vLen);
				var vFile = vObj.value.QueryInterface(Components.interfaces.nsIFile);
				var vUriDst = ut.addLeafToUri(vUriParent, vFile.leafName);
				uploadFileToUri(vFile, vUriDst, vViewMgr.fDataProvider, function(pUpdates){
										if(pUpdates) {
											vViewMgr.selectUri(vUriDst);

											var vIdAuthor = vViewMgr.xGetIdAuthor();
											vViewMgr.fDataProvider.dispatchUpdateUri(this.fCdWsp, vUriDst, Components.interfaces.scIUriListener.EVENT_TYPE_UPDT, vIdAuthor, false);
										}
									});
			}
		} else if(vSession.isDataFlavorSupported(transf.FLAVOUR_TEXT_URL)){
			for (var i = 0; i < vSession.numDropItems; ++i) {
				var vTrans = transf.createTransferable();
				vTrans.addDataFlavor(transf.FLAVOUR_TEXT_URL);
				vSession.getData(vTrans, i);
				var vFileUri = transf.getStringDataFromTransferable(vTrans, transf.FLAVOUR_TEXT_URL);
				if (vFileUri.substr(0,7) != "file://") return;
				var vFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
				vFile.initWithPath(vFileUri.substring(7));
				
				var vUriDst = ut.addLeafToUri(vUriParent, vFile.leafName);
				uploadFileToUri(vFile, vUriDst, vViewMgr.fDataProvider, function(pUpdates){
										if(pUpdates) {
											vViewMgr.selectUri(vUriDst);

											var vIdAuthor = vViewMgr.xGetIdAuthor();
											vViewMgr.fDataProvider.dispatchUpdateUri(this.fCdWsp, vUriDst, Components.interfaces.scIUriListener.EVENT_TYPE_UPDT, vIdAuthor, false);
										}
									});
			}
		}
	}catch(e){ut.debug("WspView.drop : "+pRow+" :"+e);}
} 









WspView.prototype.setCellText = function(){
}







WspView.prototype.xAddReq = function(pReq, pPriorityMax){
	var vLastReq = this.fCurrentReq;
	if(vLastReq && !pPriorityMax) {
		while(vLastReq.fNextReq) vLastReq = vLastReq.fNextReq;
	}
	if(vLastReq) {
		pReq.fNextReq = vLastReq.fNextReq;
		vLastReq.fNextReq = pReq;
	} else {

		this.fCurrentReq = pReq;
	}
	this.xExecCurrentReq();
}


WspView.prototype.xExecCurrentReq = function(){
	if(this.fCurrentReq && ! this.fCurrentReq.fStarted) {


		this.fCurrentReq.fStarted = true;
		try {
			this.fCurrentReq.execute();
		} catch(e){
			this.xCloseCurrentReq(this.fCurrentReq);
			ut.debug("WspView.prototype.xExecCurrentReq:"+e);
		}
	}
}


WspView.prototype.xCloseCurrentReq = function(pReq){
	if(this.fCurrentReq && pReq==this.fCurrentReq) {
		this.fCurrentReq = this.fCurrentReq.fNextReq;

	} else {
		ut.debug("pReq not equal to nextReq. pReq=\n"+ut.listProperties(pReq)+"\n\nWspView.fCurrentReq:::\n"+ut.listProperties(this.fCurrentReq));
	}
	this.xExecCurrentReq();
}

WspView.prototype.xResetStackReq = function(){
	this.fCurrentReq = null;
}

WspView.prototype.getReqToRefreshUri = function(pUri){
	return new WspViewReqToRefreshUri(this, pUri);
}


WspView.prototype.xResetState = function(){
	this.fLastItemRow = -1;
	this.fLastItem = null;
	this.fRowMouseOver = null;

}

WspView.prototype.xGetItem = function(pRow){
	if(pRow == this.fLastItemRow) return this.fLastItem;
	if(pRow < 0) return this.fData;
	
	var vRow = pRow;
	var vList = this.fData.ch;
	
	var vAgain;
	do{
		vAgain = false;
		for each(var vCh in vList){
			if(vRow == 0) {
				this.fLastItemRow = pRow;
				this.fLastItem = vCh;
				return this.fLastItem;
			}
			var vNbRow = vCh.nbr;
			if(vNbRow>vRow) {

				vRow --;
				vList = vCh.ch;
				vAgain = true;
				break;
			}
			vRow -= vNbRow;

		}
	} while(vAgain);
	return this.fData;
}

WspView.prototype.xGetUriSel = function(){
	var vIdx = this.selection.currentIndex;
	if(vIdx>=0) {
		return this.xGetUri(this.xGetItem(vIdx));
	}
	return null;
}

WspView.prototype.xGetPathSel = function(){
	var vIdx = this.selection.currentIndex;
	if(vIdx>=0) {
		return this.xGetPath(this.xGetItem(vIdx));
	}
	return null;
}

WspView.prototype.xUpdtNbr = function(pItemFrom, pOffset){
	while(pItemFrom){
		pItemFrom.nbr += pOffset;

		pItemFrom = pItemFrom.p;
	}
	this.rowCount += pOffset;
}

WspView.prototype.xReplaceItem = function(pRow, pOldItem, pNewItem){
	var vUriSel = this.xGetUriSel();
	this.xResetState();
	this.xInitItem(pOldItem.p, pNewItem, pOldItem.i);
	var vOldNbRow = pOldItem.nbr;

	if(pOldItem.p) {
		pOldItem.p.ch[pOldItem.i] = pNewItem;
		delete pOldItem.p; //Purge mémoire
	} else {
		this.fData = pNewItem;
	}
	var vNewNbRow = pNewItem.nbr;
	this.xUpdtList(pNewItem.p, pRow, vOldNbRow, vNewNbRow, vUriSel);
}
WspView.prototype.xInsertItem = function(pParentRow, pParentItem, pNewItem){
	try{
		var vUriSel = this.xGetUriSel();
		this.xResetState();

		var vList = pParentItem.ch;


		var vOldNbr =  pParentItem.nbr;
		var vTmpPos = vList.length;
		this.xInitItem(pParentItem, pNewItem, vTmpPos);
		vList[vTmpPos] = pNewItem;
		vList.sort(this.xSortItem);
		for(var i = 0; i <= vTmpPos; i++) {
			vList[i].i = i;
		}
		this.xUpdtList(pParentItem, pParentRow, vOldNbr, vOldNbr+pNewItem.nbr, vUriSel);
		return pParentRow + pNewItem.i;
	}catch(e){ut.debug(e);}
}

WspView.prototype.xRemoveItem = function(pRow, pOldItem){
	var vUriSel = this.xGetUriSel();
	this.xResetState();

	var vList = pOldItem.p.ch;
	var vNbr =  pOldItem.nbr;
	var vLimit = vList.length-1;
	for(var i = pOldItem.i; i < vLimit; i++) {
		vList[i] = vList[i+1];
		vList[i].i = i;
	}
	vList.length = vLimit;
	this.xUpdtList(pOldItem.p, pRow, vNbr, 0, vUriSel);
	delete pOldItem.p; //Purge mémoire
}

WspView.prototype.xUpdtList = function(pItemParent, pRow, pOldNbRow, pNewNbRow, pUriSel){
	var vDelta = pNewNbRow - pOldNbRow;
	var vRowAfter = pRow + pOldNbRow;
	if(vDelta==0){
		if(pRow>=0) this.fTree.invalidateRow(pRow);
		this.fTree.invalidateRange(pRow, vRowAfter);
	} else {
		this.xUpdtNbr(pItemParent, vDelta);
		if(pRow>=0) this.fTree.invalidateRow(pRow);
		this.fTree.invalidateRange(pRow, vRowAfter);
		this.fTree.rowCountChanged(vRowAfter, vDelta);
	}
	var vIdx = this.selection.currentIndex;
	if(vIdx >= this.rowCount) {
		this.selection.currentIndex = this.rowCount -1;
	} else {
		if(vIdx >= 0) {
			var vItem = this.xGetItem(vIdx);
			var vNewUriSel = this.xGetUri(vItem);
			if(vNewUriSel != pUriSel) {
				var vRes = {};
				this.xSearchItemByUri(pUriSel, vRes);
				if(vRes.fRow >=0) {

					this.xSelRow(vRes.fRow);
				} else {

					var vEvent = document.createEvent("Events");
					vEvent.initEvent("select", true, false);
					this.fNodeTree.dispatchEvent(vEvent);
				}
			}
		}
	}
}

WspView.prototype.xSortItem = function(p1, p2){
	var vT1 = p1.nm.toLowerCase();
	var vT2 = p2.nm.toLowerCase();
	return vT1 < vT2 ? -1 : vT1 > vT2 ? 1 : 0;
}

WspView.prototype.xInitItem = function(pParent, pNewItem, pIdx){
try {
	pNewItem.p = pParent;
	pNewItem.i = pIdx;
	this.xComputeItemFields(pNewItem);
	if("ch" in pNewItem){
		var i = 0;
		for each(var vCh in pNewItem.ch) {
			this.xInitItem(pNewItem, vCh, i++);
		}
	}
}catch(e){ut.debug("WspView.xInitItem: "+e);}
}

WspView.prototype.xComputeItemFields = function(pNewItem){
	var vIc = null;
	var vIcO = null;
	var vStatus = pNewItem.st;
	if(pNewItem.ty=="space") {
		var vWspTypeUi = this.fWspRegistered.getWspTypeUi();
		if(vWspTypeUi) {
			vIc = vWspTypeUi.getSpaceFolderIconUrl();
			vIcO = vWspTypeUi.getSpaceFolderOpenIconUrl() || "";
		}
	} else if(pNewItem.ty){
		var vPack = packMgr.getPack(pNewItem.pa);
		var vUriRes = this.xGetUriRes(pNewItem);
		pNewItem.ty = vPack.overrideType(pNewItem.mo, vUriRes, pNewItem.ty);
		if(pNewItem.ty=="itemnull") {
			var vWspTypeUi = this.fWspRegistered.getWspTypeUi();
			vIc = vWspTypeUi ? vWspTypeUi.getItemNullFolderIconUrl() : null;
		} else {

			vIc = vPack.getIcon(pNewItem.mo, vUriRes);
			if(pNewItem.ty=="itemmulti" || pNewItem.ty=="folder" )vIcO = vPack.getIconOpen(pNewItem.mo, vUriRes) || "";
			if(vUriRes) vStatus = 1;
		}
	}
	if( ! vIc && pNewItem.ty) vIc = "chrome://scenaricms/content/icon/ic" + pNewItem.ty;
	if(vIcO == "" && pNewItem.ty) vIcO = "chrome://scenaricms/content/icon/ic" + pNewItem.ty + "Open";
	if(vIc) pNewItem.ic = ut.getUrlIcon(vIc, vStatus);
	if(vIcO) pNewItem.icO = ut.getUrlIcon(vIcO, vStatus);
}

WspView.prototype.xResetTreeMessage = function(pMessage){
	var vOldRowCount = this.rowCount;
	
	this.fData = {nm:this.fCdWsp, ty:"wsp", nbr:2, ch:[{nm:pMessage, ty:"", nbr:1}]};
	this.fData.ch[0].p = this.fData;
	this.fData.ch[0].i = 0;
	
	this.xResetState();
	this.rowCount = 1;
	if(vOldRowCount <= 0) {
		this.fTree.rowCountChanged(0, 1);
	} else if(vOldRowCount > 1) {
		this.fTree.rowCountChanged(1, 1-vOldRowCount);
	}
	if(vOldRowCount > 0) this.fTree.invalidateRow(0);
}

WspView.prototype.xResetTreeEmpty = function(pMessage){
	var vOldRowCount = this.rowCount;
	this.fData = {nm:this.fCdWsp, ty:"wsp", nbr:1, ch:[]};	
	this.xResetState();
	this.rowCount = 0;
	if(vOldRowCount > 0) {
		this.fTree.rowCountChanged(0, -vOldRowCount);
	}
}

WspView.prototype.xRefreshData = function(pUri){

	this.xResetTreeMessage("Chargement en cours.");
	var vReq = {
		fUri: pUri,
		fViewMgr: this,
		execute: function(){
			var sWspView = this.fViewMgr;
			var sUri = this.fUri;
			var sCurrentReq = this;

			function cb(pEvent){
				try{
					if(!(sCurrentReq == sWspView.fCurrentReq)) return; //ut.debug(ut.listProperties(sCurrentReq)+"\n"+ut.listProperties(sWspView.fCurrentReq));

					if(pEvent.target.status == 200){
						var vOldRowC = sWspView.rowCount;

						eval(pEvent.target.responseText);
						sWspView.xFilterNewData(vItem);
						sWspView.xResetState();
						sWspView.fData = vItem;
						sWspView.xInitItem(null, sWspView.fData, -1);
						sWspView.xUpdtNbr(null, sWspView.fData.nbr);
						sWspView.rowCount = sWspView.fData.nbr - 1;
						if(vOldRowC > sWspView.rowCount) {
							sWspView.fTree.rowCountChanged(sWspView.rowCount, sWspView.rowCount - vOldRowC);
						} else if(vOldRowC < sWspView.rowCount) {
							sWspView.fTree.rowCountChanged(vOldRowC, sWspView.rowCount - vOldRowC);
						}
						sWspView.fTree.invalidate();
						if(sUri) sWspView.selectUri(sUri);


						var vWspBlockNode= sWspView.fNodeTree;
						while(vWspBlockNode && vWspBlockNode.localName!='wspBlock') vWspBlockNode = vWspBlockNode.parentNode;
						
						if(!vWspBlockNode || vWspBlockNode.localName!='wspBlock' || vWspBlockNode.isOpen())
							packMgr.checkSync(sWspView.fDataProvider, sWspView.fCdWsp); 
					}else if(pEvent.target.status == 404){


						sWspView.xResetTreeEmpty();
					} else {
						ut.debug("WspView.prototype.xRefreshData.cb.statusResp:"+pEvent.target.status);
						sWspView.xRequestWspStatus();
					}
					sWspView.xCloseCurrentReq(sCurrentReq);
				}catch(e){
					ut.debug("WspView.prototype.xRefreshData.cb:"+e);
					sWspView.xCloseCurrentReq(sCurrentReq);
					sWspView.xRequestWspStatus();
				}
			}
			function cbErr(pEvent){

				sWspView.xCloseCurrentReq(sCurrentReq);
				sWspView.xRequestWspStatus();
			}
			sWspView.fDataProvider.loadFromService(sWspView.fUrlService+"cdaction=PROPFIND_ALL&Depth=1&PathRes="+encodeURIComponent("/"+sWspView.fCdWsp), cb, cbErr);			
		}
	};
	this.xAddReq(vReq);
}


WspView.prototype.xRequestWspStatus = function(){
	var vReq = {
		fViewMgr: this,
		execute: function(){
			var sWspView = this.fViewMgr;
			var sCurrentReq = this;
			var vCountCheck = 0;
			function cb(pEvent){

				if(!(sCurrentReq == sWspView.fCurrentReq)) return;
				try{
					if(pEvent.type!="error"){
						vCountCheck++;
						var vDoc = pEvent.target.responseXML;
						var vReqStatus = pEvent.target.status;

						if(vDoc){
							var vWspStatus = vDoc.documentElement.getAttribute("status");
							if(vWspStatus == "ok") {
								sWspView.xRefreshData();
							} else if(vWspStatus == "failed") {
								var vMsg = "Atelier en erreur !";
								if(vDoc.documentElement.hasAttribute("error")) vMsg += (" - " + vDoc.documentElement.getAttribute("error"));
								sWspView.xResetTreeMessage(vMsg);
							} else if(vWspStatus == "noRepository") {
								sWspView.xResetTreeMessage("Serveur inaccessible !");
							} else if(vWspStatus == "noWsp" || vWspStatus == "noActiveWsp") {
								sWspView.xResetTreeMessage("Atelier supprimé !");
							} else if(vWspStatus == "downloadRes") {
								var vPercent = vDoc.evaluate("/infoWsp/downloads/realeased/@percent", vDoc, null, 2, null).stringValue;
								sWspView.xResetTreeMessage(ut.formatStr("Téléchargements : %s%% réalisé.", vPercent));
								window.setTimeout(wspViewRefreshStatus, 1000, sWspView);
							}else if(vWspStatus == "migrating"){
								sWspView.xResetTreeMessage("Migration de l\'atelier en cours."+"......".substring(0, vCountCheck % 5));
								window.setTimeout(wspViewRefreshStatus, 500, sWspView);
							} else if(vWspStatus == "init") {
								sWspView.xResetTreeMessage("Chargement en cours."+"......".substring(0, vCountCheck % 5));
								window.setTimeout(wspViewRefreshStatus, 500, sWspView);
							} else if(vWspStatus == "noAccess" || vReqStatus == ut.httpStatusCodeUnauthorized) {
								var vMsg = "Vous ne disposez pas des droits d\'accès à cet atelier. \nVeuillez vous authentifier.";
								if(vDoc.documentElement.hasAttribute("error")) vMsg += (" - " + vDoc.documentElement.getAttribute("error"));
								sWspView.xResetTreeMessage(vMsg);
							} else {
								ut.debug("WspView.prototype.xRequestWspStatus unknown:::"+vWspStatus);
							}
						}else{// pas de réponse XML du serveur
							cbErr(pEvent);
						}
					}else{
						cbErr(pEvent);
					}
					sWspView.xCloseCurrentReq(sCurrentReq);
				}catch(e){
					ut.debug("WspView.prototype.xRequestWspStatus > cb : " + e);
					sWspView.xCloseCurrentReq(sCurrentReq);
					sWspView.xResetTreeMessage("Serveur inaccessible !");
				}
			}
			var vCountCheck = 0;

			function cbErr(pEvent){
				if(!(sCurrentReq == sWspView.fCurrentReq)) return;

				vCountCheck++;
				try{
					if(sWspView.fDataProvider.isLocal()) {
						if(vCountCheck > ut.cnxLocalSvrMaxAttempts) {
							sWspView.xResetTreeMessage("Echec au lancement des ateliers locaux !");
							ut.alert("Le lancement d\'une partie de l\'application a échoué. Quittez et relancez l\'application ultérieurement.", "Echec au lancement des ateliers locaux");
							sWspView.xCloseCurrentReq(sCurrentReq);
						} else {
							ut.debug(vCountCheck % 5);
							sWspView.xResetTreeMessage("Chargement en cours."+".....".substring(0, vCountCheck % 5));
							window.setTimeout(function() {sWspView.fDataProvider.loadFromService("/u/adminWsp?cdaction=InfoWsp&param="+sWspView.fCdWsp, cb, cbErr);}, 1000);
						}
					} else {
						var vTarget = pEvent.target.QueryInterface(Components.interfaces.nsIXMLHttpRequest);
						if(pEvent && pEvent.type!='error'){
							switch(vTarget.status) {
								case 403 :
								case ut.httpStatusCodeUnauthorized :// pb de droit
									sWspView.xResetTreeMessage("Serveur déconnecté ! Veuillez vous identifier.");
									break;
								default : // autre pb
									sWspView.xResetTreeMessage("Atelier inaccessible !");
							}
						}else{
							sWspView.xResetTreeMessage("Atelier inaccessible !");
						}
						sWspView.xCloseCurrentReq(sCurrentReq);
					}
				}catch(e){
					ut.debug("WspView.prototype.xRequestWspStatus > cbErr : " + e);
					sWspView.xCloseCurrentReq(sCurrentReq);
					sWspView.xResetTreeMessage("Serveur inaccessible !");
				}
			}
			sWspView.fDataProvider.loadFromService("/u/adminWsp?cdaction=InfoWsp&param="+sWspView.fCdWsp, cb, cbErr);			
		}
	};
	this.xAddReq(vReq);
}

WspView.prototype.xGetPath = function(pItem){
	var vName = "";
	while(pItem){
		vName = "/"+ pItem.nm + vName;
		pItem = pItem.p;
	}
	return vName;
}

WspView.prototype.xGetUri = function(pItem){
	var vName = "";
	while(pItem.ty != "space"){
		vName = "/"+ pItem.nm + vName;
		pItem = pItem.p;
	}
	while(pItem.p.ty == "space"){
		vName = "/"+ pItem.nm + vName;
		pItem = pItem.p;
	}
	vName = pItem.p.nm + "/" + pItem.nm + vName;
	return vName;
}
WspView.prototype.xGetUriRes = function(pItem){
	var vName = (pItem.ty == "folder") ?  "/" : "";
	while(pItem.ty == "folder" || pItem.ty == "res"){
		vName = "/"+ pItem.nm + vName;
		pItem = pItem.p;
	}
	return vName;
}

WspView.prototype.xSelect = function(pReq, pJustRefresh){
	try{

		var vRow = pReq.fRow;
		var vNewRow = vRow;
		var vItem = pReq.fItem;
		var vIdx = pReq.fFindIdx;
		for(; vIdx < pReq.fFindArr.length; vIdx++){
			var k = 0;
			var vNbCh = vItem.ch ? vItem.ch.length : 0;
			for(; k < vNbCh; k++){
				var vChild = vItem.ch[k];
				if(vChild.nm == pReq.fFindArr[vIdx]){
					vRow = vRow + 1;
					vNewRow = vRow;
					vItem = vChild;

					break;
				}
				vRow = vRow + vChild.nbr;
			}
			if(k >= vNbCh) {


				if(pJustRefresh && vIdx==pReq.fFindIdx) {


					this.selection.currentIndex = -1;
					this.selection.clearSelection();
					this.xCloseCurrentReq(pReq);
					return;
				}
				pReq.fItem = vItem;
				pReq.fRow = vNewRow;
				pReq.fFindIdx = vIdx;

				if(vNewRow>=0) this.fTree.invalidateRow(vNewRow);
				var sReq = pReq;
				function cb(pEvent){

					wspViewOnloadItem(pEvent, sReq);
				}

				this.fDataProvider.loadFromService(this.fUrlService+"cdaction=PROPFIND_ALL&Depth=1&PathRes="+encodeURIComponent(this.xGetPath(vItem)), cb, cb);
				return;
			}
		}

		this.xSelRow(vNewRow);
		this.xCloseCurrentReq(pReq);

		if(vItem.ty == "space" && ! vItem.ch && pReq.fFindArr) this.toggleOpenState(vNewRow);
	}catch(e){
		ut.debug("WspView.prototype.xSelect="+e);
		this.xCloseCurrentReq(pReq);
	}
}

WspView.prototype.xSelRow = function(pRow){
	if(this.selection.currentIndex != pRow) {

		this.selection.currentIndex = pRow;
		this.selection.select(pRow);
	}
	this.fTree.ensureRowIsVisible(pRow);
	if(this.fRowMouseOver == pRow){
		this.xHideTooltip();
	}
}

WspView.prototype.xSearchItemByUri = function(pUri, pReturnData){
	var vArr = this.xSplitUri(pUri);
	var vItem = this.fData;
	var vRow = -1;

	for(var i = 1; i < vArr.length; i++){
		var k=0;
		var vNbCh = vItem.ch ? vItem.ch.length : 0;
		for(; k < vNbCh; k++){
			var vChild = vItem.ch[k];
			if(vChild.nm == vArr[i]){
				vRow++;
				vItem = vChild;

				break;
			}
			vRow += vChild.nbr;
		}
		if(k >= vNbCh) {

			vItem = null;
			break;
		}
	}
	if(pReturnData){
		pReturnData.fRow = (vItem) ? vRow : -1;
		pReturnData.fItem = vItem;
	}
	return vItem;
}


WspView.prototype.xSplitUri = function(pUri){
	return pUri.split("/");
}


WspView.prototype.xGetIdAuthor = function(){
	if(!this.fIdAuthor) this.fIdAuthor = this.fDataProvider.newIdAuthor();
	return this.fIdAuthor;
}


WspView.prototype.xGetInfo = function(pItem){
	var vVar={val:""};
	this.xWriteInfo(pItem, vVar, 0);
	return vVar.val;
}

WspView.prototype.xWriteInfo = function(pItem, pVar, pLevel){
	for(var j = 0; j < pLevel; j++) pVar.val += "\t";
	pVar.val += "("+pLevel+")"+pItem.nm+"["+pItem.nbr+"]"+"\n";
	if(pItem.ch){
		for(var i = 0; i < pItem.ch.length; i++) {
			if(pItem.ch[i].p != pItem){
				pVar.val += "probleme ref parents ";
			}
			this.xWriteInfo(pItem.ch[i], pVar, pLevel+1);
		}
	}
}
WspView.prototype.xFilterNewData = function(pItem){
	if(this.filterSystemItem) {
		var vLenCh = pItem.ch.length;
		for(var i = 0; i < vLenCh; i++) {
			var vNm = pItem.ch[i].nm;
			if(vNm.charAt(0)=="~") {
				for(var k = i+1; k < vLenCh; k++) pItem.ch[k-1] = pItem.ch[k];
				pItem.ch.length = --vLenCh;
				i--;
				pItem.nbr--;
			}
		}
	}
}
WspView.prototype.xFilterUri = function(pUri){
	if(this.filterSystemItem) {

		var vIdx = pUri.indexOf('/');
		if(vIdx > 0) return ! (pUri.charAt(vIdx+1)=="~");
	}
	return false;
}


WspView.prototype.xHideTooltip = function(){
	if(this.fShowPopupTimeout) {
		window.clearTimeout(this.fShowPopupTimeout);
		this.fShowPopupTimeout = 0;
	}
	this.fTooltip.lastChild.setAttribute("src", ""); //Pour interrompre toute animation en cours dans la preview.
	this.fTooltip.hidePopup();
}


function wspViewOnloadItem(pEvent, pReq){
	try{


		var vView = pReq.fViewMgr;
		if(pReq == vView.fCurrentReq) {
			if(pEvent.target.status == 200) {

				try {
					eval(pEvent.target.responseText);
					if(pReq.fItem == vView.fData) vView.xFilterNewData(vItem);
				} catch(e){
					ut.debug("wspViewOnloadItem e1 row="+pReq.fRow+"  -pReq.fItem:"+pReq.fItem+"  -pEvent.target.responseText="+pEvent.target.responseText);			
				}
				try {
					if(pReq.fItem) {
						vView.xReplaceItem(pReq.fRow, pReq.fItem, vItem);
					} else {
						pReq.fRow = vView.xInsertItem(pReq.fParentRow, pReq.fParentItem, vItem);
					}
					if(vItem.ty=="res") {

						var vItemOwnerRow = pReq.fRow - vItem.i - 1;
						var vItemOwner = vItem.p;
						while(vItemOwner && vItemOwner.ty != "itemmulti") {
							vItemOwnerRow -= vItemOwner.i + 1;
							vItemOwner = vItemOwner.p;
						}
						if(vItemOwner) {
							vItemOwner.sgn = vItem.sgn;
							vItemOwner.pa = vItem.pa;
							vItemOwner.mo = vItem.mo;
							vItemOwner.dt = vItem.dt;
							vItemOwner.ti = vItem.ti;
							vItemOwner.st = vItem.st;
							vView.xComputeItemFields(vItemOwner);
							vView.fTree.invalidateRow(vItemOwnerRow);
						}
					}
				} catch(e){
					ut.debug("wspViewOnloadItem e2 row="+pReq.fRow+"  -pReq.fItem:"+pReq.fItem+"  -pEvent.target.responseText="+pEvent.target.responseText);			
				}
				try {
					if(pReq.fFindArr) {
						pReq.fItem = vItem;
						vView.xSelect(pReq, true);
					} else {
						vView.xCloseCurrentReq(pReq);
					}
				} catch(e){
					ut.debug("wspViewOnloadItem e3 row="+pReq.fRow+"  -pReq.fItem:"+pReq.fItem+"  -pEvent.target.responseText="+pEvent.target.responseText);			
				}
				return;
			} else if(pEvent.target.status == 404) {

				if(pReq.fRow >= 0) vView.xRemoveItem(pReq.fRow, pReq.fItem);
				vView.xCloseCurrentReq(pReq);
				return;
			} else {

				ut.debug("wspViewOnloadItem.resp.status unknown::"+pEvent.target.status);
				if(pReq.fItem){
					if(pReq.fItem.ty == "space") vView.toggleOpenState(pReq.fRow);
					ut.alert(ut.formatStr("Echec à l\'obtention du contenu d\'un item \'%s\'.\nVeuillez réessayer ultérieurement.", pReq.fItem.nm), "Echec de chargement");
				}
				vView.xCloseCurrentReq(pReq);
				return;
			}
		} else {
			ut.debug("wspViewOnloadItem: requests !=");
			vView.xCloseCurrentReq(pReq);
			vView.fTree.invalidateRow(pReq.fRow);
		}
	}catch(e){
		ut.debug("wspViewOnloadItem="+e);
		pReq.fViewMgr.xCloseCurrentReq(pReq);
		pReq.fViewMgr.fTree.invalidateRow(pReq.fRow);
	}
}


function wspViewRefreshStatus(pWspView){

	pWspView.xRequestWspStatus();
}


function wspViewOnMouseDown(pEvent){
	if(pEvent.originalTarget.localName != "treechildren") return;
	pEvent.stopPropagation();
}
function wspViewOnClick(pEvent){
	if(pEvent.originalTarget.localName != "treechildren") return;
	if(! ut.isClickContextMenu(pEvent)) {

		
		var vView = pEvent.originalTarget.parentNode.fView;
		vView.metaKeys = (ut.isAccelPress(pEvent) ? 1 : 0) + (pEvent.shiftKey?2:0) + (pEvent.altKey?4:0);
		
		var row = {};
		var col = {};
		var obj = {};
		var b = this.treeBoxObject;
		var vView = this.fView;
		b.getCellAt(pEvent.clientX, pEvent.clientY, row, col, obj);

		if (row.value == -1) return;
		
		if (obj.value == "twisty") {
			if (vView.currentIndex >= 0 && b.view.isContainerOpen(row.value)) {
				var parentIndex = b.view.getParentIndex(vView.currentIndex);
				while (parentIndex >= 0 && parentIndex != row.value)
				parentIndex = b.view.getParentIndex(parentIndex);
				if (parentIndex == row.value) {
					if(! vView.canChangeSelect(pEvent)) return;
					vView.select(parentIndex);
				}
			}
			b.view.toggleOpenState(row.value);
		} else {
			if(vView.selection.isSelected(row.value)) {

				var vReq = vView.getReqToRefreshUri(vView.xGetUri(vView.xGetItem(row.value)));
				vView.xAddReq(vReq, true);
				if (vView.canChangeSelect(pEvent)) {

					var vEvent = document.createEvent("Events");
					vEvent.initEvent("reloadItem", true, false);
					this.dispatchEvent(vEvent);
					b.ensureRowIsVisible(row.value);
				}
			} else {
				if (vView.canChangeSelect(pEvent)) {
					vView.selection.select(row.value);
					b.ensureRowIsVisible(row.value);
				}
			}
		}
		
		vView.metaKeys = 0;
	}
	pEvent.stopPropagation();
}



function wspViewOnDragGesture(pEvent){
	try {
		if (pEvent.originalTarget.localName == "treechildren") {

	
			var vTree = pEvent.originalTarget.parentNode;
	        var vTreeBo = vTree.treeBoxObject;
			var vRow = vTreeBo.getRowAt(pEvent.clientX, pEvent.clientY);
			var vRegion = null;
	        try {
	        	vRegion = Components.classes["@mozilla.org/gfx/region;1"].createInstance(Components.interfaces.nsIScriptableRegion);
	        	vRegion.init();
	        	var vTreeBodyBo = vTreeBo.treeBody.boxObject;
	        	var vHRow = vTreeBo.rowHeight;
				vRegion.unionRect(vTreeBodyBo.x, vTreeBodyBo.y + ( (vRow - vTreeBo.getFirstVisibleRow()) * vHRow), vTreeBodyBo.width, vHRow);
	        } catch(e) {
	          ut.debug("Error while building row region: " + e);
	          vRegion = null;
	        }
			var vItem = (vRow >= 0) ? vTree.fView.xGetItem(vRow) : null;
			if(vItem) {
				var vUri = vTree.fView.xGetUri(vItem);
				var vTrans = transf.createTransferable();
				var vSrvId = vTree.fView.fDataProvider.getWspServer().getId();
				transf.setStringDataToTransferable(vTrans, transf.FLAVOUR_SCENARI_SERVER_ID, vSrvId);
				transf.setStringDataToTransferable(vTrans, transf.FLAVOUR_SCENARI_URI, vUri);
				if(vItem.sgn) transf.setStringDataToTransferable(vTrans, transf.FLAVOUR_SCENARI_SGN, vItem.sgn);
				
				var vUrlDownload;
				if(vItem.ty == "itemmono" || vItem.ty == "res") {
					var vPack = packMgr.getPack(vItem.pa);
					vUrlDownload = vTree.fView.fDataProvider.getServiceUrl(vTree.fView.fUrlService.substring(0, vTree.fView.fUrlService.length-1) + "/" + vItem.nm + "?" + "scWspResp=no&PathRes=/"+encodeURIComponent(vPack.getMainStreamUri(vItem.mo, vUri)));					
				} else {
					vUrlDownload = vTree.fView.fDataProvider.getServiceUrl(vTree.fView.fUrlService.substring(0, vTree.fView.fUrlService.length-1) + "/" + vItem.nm + ".zip?" + "cdaction=GetAsZip&scWspResp=no&PathRes=/"+encodeURIComponent(vUri));					
				}

				transf.setStringDataToTransferable(vTrans, "text/x-moz-url", vUrlDownload); //Linux


				transf.setStringDataToTransferable(vTrans, "application/x-moz-file-promise-url", vUrlDownload); //Windows
				var vDataProvider = {
					QueryInterface : function(pIid) {

						if (pIid.equals(Components.interfaces.nsIFlavorDataProvider) || pIid.equals(Components.interfaces.nsISupports)) return this;
						ut.debug("nsFlavorDataProvider.QueryInterface:::throw Components.results.NS_NOINTERFACE"+pIid);
						throw Components.results.NS_NOINTERFACE;
					},
					getFlavorData : function(pTransferable, pFlavor, pData, pDataLen) {
						ut.debug("nsFlavorDataProvider.getFlavorData:::::::pFlavor="+pFlavor);
						if(pFlavor == "application/x-moz-file-promise") {

							/* Doit retourner le nsILocalFile.
						      var urlPrimitive = { };
						      var dataSize = { };
						      aTransferable.getTransferData("application/x-moz-file-promise-url", urlPrimitive, dataSize);
						
						      var srcUrlPrimitive = urlPrimitive.value.QueryInterface(Components.interfaces.nsISupportsString);
						

						      var dirPrimitive = {};
						      aTransferable.getTransferData("application/x-moz-file-promise-dir", dirPrimitive, dataSize);
						      var destDirectory = dirPrimitive.value.QueryInterface(Components.interfaces.nsILocalFile);
						



						
						      var attachment = null;
						      for (index in currentAttachments)
						      {
						        attachment = currentAttachments[index];
						        if (attachment.url == srcUrlPrimitive)
						          break;
						      }
						

						      if (attachment)
						      {

						        var destFilePath = messenger.saveAttachmentToFolder(attachment.contentType, attachment.url, encodeURIComponent(attachment.displayName), attachment.uri, destDirectory);
						        aData.value = destFilePath.QueryInterface(Components.interfaces.nsISupports);
						        aDataLen.value = 4;
						      }
							*/
						}
					}
				}
				var vFlavour = "application/x-moz-file-promise";

				vTrans.setTransferData(vFlavour, vDataProvider, Components.interfaces.nsIFlavorDataProvider.kFlavorHasDataProvider); //Windows				
				
				var vArrayTrans = Components.classes["@mozilla.org/supports-array;1"].createInstance(Components.interfaces.nsISupportsArray);
				vArrayTrans.AppendElement(vTrans.QueryInterface(Components.interfaces.nsISupports));
				

				vTree.fView.xHideTooltip();
				
				try {

					transf.fDragService.invokeDragSessionWithImage(pEvent.target, vArrayTrans, vRegion, transf.DRAGDROP_ACTION_ALL, null, 0, 0, pEvent, {});
				} catch(ex) {
					ut.debug(ex);
				}
	
			}
			pEvent.stopPropagation();
		}
	} catch(e){ut.debug(e)}
}
function wspViewOnDragExit(pEvent){
	try {

		var vTree = pEvent.originalTarget.parentNode;
		if(vTree.fView) vTree.fView.xHideTooltip();
	} catch(e){ut.debug(e)}
}




var WspViewShowToolTip = function (pTreeNode, pRow, pMouseY){
	try {
		var vPopUp = pTreeNode.fView.fTooltip;
		if(pRow >= 0 && pRow != pTreeNode.currentIndex) {
			vPopUp.hidePopup();
			var vItem = pTreeNode.fView.xGetItem(pRow);
			if(vItem.ty=="itemmono" || vItem.ty=="itemmulti") { 
				var vBoxTree = pTreeNode.boxObject;
				vPopUp.maxWidth = 2000;
				var vUriRes = pTreeNode.fView.xGetUriRes(vItem);
				var vPack = packMgr.getPack(vItem.pa);
	
				var vField = vPopUp.firstChild;
				if(vItem.ti) {
					vField.value = vItem.ti;
					vField.hidden = false;
				} else {
					vField.hidden = true;
				}
	
				vField = vField.nextSibling;
				if(vItem.pa) {
					vField.value = vPack.getTitle(vItem.mo, vUriRes);
				} else {
					vField.value = "Item";
				}
	
				vField = vField.nextSibling;
				if(vItem.dt) {
					var vDt = new Date(vItem.dt);
					vField.value = vDt.toLocaleDateString() + " - " + vDt.toLocaleTimeString();
				} else {
					vField.value = "";
				}
				
				vField = vField.nextSibling;
				var vPreviewUrl = vPack.getPreViewUrl(vItem.mo, vUriRes, null);
				if(vPreviewUrl) {
					vField.fUriObject = new UriObjectItem(pTreeNode.fView.xGetUri(vItem), pTreeNode.fView.fDataProvider, vItem.pa, vItem.mo);
					vField.setAttribute("src", "");
					vField.setAttribute("src", vPreviewUrl);
					vField.hidden = false;
				} else {
					vField.setAttribute("src", "");
					vField.hidden = true;
				}
				

				var vHRow = pTreeNode.treeBoxObject.rowHeight;
				vPopUp.openPopup(pTreeNode, "overlap", vBoxTree.width-10, (Math.floor((pMouseY-vBoxTree.y) / vHRow) * vHRow) - 20, false, false);
			}
		}
	}catch(e){ut.debug(e)}
}
function wspViewOnMouseMove(pEvent){
try{
	var vTree = pEvent.originalTarget.parentNode;
	if( ! vTree.treeBoxObject) return;
	var vRow = vTree.treeBoxObject.getRowAt(pEvent.clientX, pEvent.clientY);
	if(vRow != vTree.fView.fRowMouseOver) {
		vTree.fView.fRowMouseOver = vRow;
		vTree.fView.xHideTooltip();
		vTree.fView.fShowPopupTimeout = window.setTimeout(WspViewShowToolTip, 500, vTree, vRow, pEvent.clientY);
	}
}catch(e){ut.debug(e)}
}

function wspViewOnMouseOut(pEvent){
	var vTree = pEvent.originalTarget.parentNode;
	if(vTree.fView != null) {
		vTree.fView.fRowMouseOver = null;
		vTree.fView.xHideTooltip();
	}
}




function wspViewOnPopupShowing(pWspView, pEvent){
	var vRow = pWspView.fTree.getRowAt(pEvent.clientX, pEvent.clientY);
	var vItem = (vRow >= 0) ? pWspView.xGetItem(vRow) : null;

	var vPopup = pEvent.target;
	var vDoc = vPopup.ownerDocument;
	while(vPopup.hasChildNodes()) vPopup.removeChild(vPopup.lastChild);
	ut.setContextActions(vPopup, pWspView.fDataProvider, vItem ? pWspView.xGetUri(vItem): pWspView.fCdWsp , null);
	var vMenu;
	if(vItem==null) {

		if(! window.desk.isReadOnly()){
			vMenu = vPopup.appendChild(vDoc.createElement("menuitem"));
			vMenu.setAttribute("label", "Coller");
			vMenu.setAttribute("oncommand", "wspViewPaste(event);");
			if(! transf.isClipboardContainFileOrScenariUri()) vMenu.setAttribute("disabled", "true");
		}
		if("openSearchPanel" in desk) {
			vMenu = vPopup.appendChild(vDoc.createElement("menuitem"));
			vMenu.setAttribute("label", "Rechercher...");
			vMenu.setAttribute("oncommand", "desk.openSearchPanel();");
		}
		if(! window.desk.isReadOnly()){
			vPopup.appendChild(vDoc.createElement("menuseparator"));
			vMenu = vPopup.appendChild(vDoc.createElement("menuitem"));
			vMenu.setAttribute("label", "Ajouter un espace...");
			vMenu.setAttribute("oncommand", "wspViewCreateSpace(event);");
		}
		if(!window.desk.isReadOnly() || pWspView.fDataProvider.isLocal()) vPopup.appendChild(vDoc.createElement("menuseparator"));
		if(pWspView.fDataProvider.isLocal()) {
			vMenu = vPopup.appendChild(vDoc.createElement("menuitem"));
			vMenu.setAttribute("label", "Révéler dans le système de fichier");
			vMenu.setAttribute("oncommand", "wspViewReveal(event);");
		}
		vMenu = vPopup.appendChild(vDoc.createElement("menuitem"));
		vMenu.setAttribute("label", "Récupérer un zip de l\'atelier");
		vMenu.setAttribute("oncommand", "wspViewDownloadZip(event);");
		pWspView.fRowPopupActive = -2;
		return true;
	}
	/*vMenu = vPopup.appendChild(vDoc.createElement("menuitem"));
	vMenu.setAttribute("label", "Afficher");
	vMenu.setAttribute("type", "openuri");
	vMenu.setAttribute("default", "true");*/
	vMenu = vPopup.appendChild(vDoc.createElement("menuitem"));
	vMenu.setAttribute("label", "Copier");
	vMenu.setAttribute("oncommand", "wspViewCopy(event);");
	if(! window.desk.isReadOnly()){
		vMenu = vPopup.appendChild(vDoc.createElement("menuitem"));
		vMenu.setAttribute("label", "Couper");
		vMenu.setAttribute("oncommand", "wspViewCut(event);");
		vMenu = vPopup.appendChild(vDoc.createElement("menuitem"));
		vMenu.setAttribute("label", "Coller");
		vMenu.setAttribute("oncommand", "wspViewPaste(event);");
		if(! transf.isClipboardContainFileOrScenariUri()) vMenu.setAttribute("disabled", "true");
	}
	if("openSearchPanel" in desk) {
		vMenu = vPopup.appendChild(vDoc.createElement("menuitem"));
		vMenu.setAttribute("label", "Rechercher...");
		vMenu.setAttribute("oncommand", "wspViewOpenSearchPanel(event);");
	}
	if(! window.desk.isReadOnly()){
		vPopup.appendChild(vDoc.createElement("menuseparator"));
		vMenu = vPopup.appendChild(vDoc.createElement("menuitem"));
		vMenu.setAttribute("label", "Renommer");
		vMenu.setAttribute("oncommand", "wspViewRenameUri(event);");
		vMenu = vPopup.appendChild(vDoc.createElement("menuitem"));
		vMenu.setAttribute("label", "Supprimer");
		vMenu.setAttribute("oncommand", "wspViewDeleteUri(event);");
	}
	if(vItem.ty == "space") {
		if(! window.desk.isReadOnly()){
			vPopup.appendChild(vDoc.createElement("menuseparator"));
			vMenu = vPopup.appendChild(vDoc.createElement("menuitem"));
			vMenu.setAttribute("label", "Ajouter un espace...");
			vMenu.setAttribute("oncommand", "wspViewCreateSpace(event);");
			if(! window.desk.isReadOnly()){
				vMenu = vPopup.appendChild(vDoc.createElement("menuitem"));
				vMenu.setAttribute("label", "Ajouter un item...");
				vMenu.setAttribute("oncommand", "wspViewCreateItem(event);");
			}
		}
	} else if(vItem.ty.indexOf("item")==0) {
		var vSep = false;
		if(window.desk.isLoadUriObjectOptionAvailable("itemnet")) {
			vPopup.appendChild(vDoc.createElement("menuseparator"));
			vSep = true;
			vMenu = vPopup.appendChild(vDoc.createElement("menuitem"));
			vMenu.setAttribute("label", "Afficher le réseau d\'items");
			vMenu.setAttribute("oncommand", "wspViewShowItemNet(event);");
		}
		if(window.desk.isLoadUriObjectOptionAvailable("outline") && packMgr.getPack(vItem.pa).isOutlineAvailable(vItem.mo)) {
			if(!vSep) vPopup.appendChild(vDoc.createElement("menuseparator"));
			vMenu = vPopup.appendChild(vDoc.createElement("menuitem"));
			vMenu.setAttribute("label", "Afficher le plan");
			vMenu.setAttribute("oncommand", "wspViewShowOutline(event);");
		}
	}
	var vSep = false;
	if(pWspView.fDataProvider.isLocal() && (vItem.ty == "itemmono" || vItem.ty == "space" || vItem.ty == "itemmulti" || vItem.ty == "res" || vItem.ty == "folder")) {
		vPopup.appendChild(vDoc.createElement("menuseparator"));
		vSep = true;
		vMenu = vPopup.appendChild(vDoc.createElement("menuitem"));
		vMenu.setAttribute("label", "Révéler dans le système de fichier");
		vMenu.setAttribute("oncommand", "wspViewReveal(event);");
		if(vItem.ty == "itemmono" || vItem.ty == "res") {
			vMenu = vPopup.appendChild(vDoc.createElement("menuitem"));
			vMenu.setAttribute("label", "Ouvrir dans l\'éditeur par défaut du système");
			vMenu.setAttribute("oncommand", "wspViewLaunch(event);");
		}
	}
	if(!vSep) vPopup.appendChild(vDoc.createElement("menuseparator"));
	vMenu = vPopup.appendChild(vDoc.createElement("menuitem"));
	vMenu.setAttribute("label", "Récupérer un zip");
	vMenu.setAttribute("oncommand", "wspViewDownloadZip(event);");
	
	pWspView.fRowPopupActive = vRow;
	return true;
}

function wspViewOnPopupHiding(pWspView, pEvent){
	pWspView.fRowPopupActive = -1;
}

function wspViewCreateSpace(pEvent){
	var vViewMgr = wspViewGetWspView(pEvent.target).fViewMgr;
	var vCtx = ut.getContextActions(pEvent.target);
	creator.createSpace(vCtx.fDataProvider, vCtx.fUri, -1, function(pDataProvider, pUri){if(pUri) vViewMgr.selectUri(pUri)});
}

function wspViewCreateItem(pEvent){
	var vViewMgr = wspViewGetWspView(pEvent.target).fViewMgr;
	var vCtx = ut.getContextActions(pEvent.target);
	function cb(pDataProvider, pUri) {
		if(pUri) vViewMgr.selectUri(pUri);
	}
	creator.createItem(vCtx.fDataProvider, vCtx.fUri, null, null, vViewMgr.xGetIdAuthor(), cb, null, null);
}

function wspViewShowItemNet(pEvent){
	var vCtx = ut.getContextActions(pEvent.target);
	window.desk.loadUriObjectByUri(vCtx.fDataProvider, vCtx.fUri, ";itemnet;");
}

function wspViewShowOutline(pEvent){
	var vCtx = ut.getContextActions(pEvent.target);
	window.desk.loadUriObjectByUri(vCtx.fDataProvider, vCtx.fUri, ";outline;");
}

function wspViewReveal(pEvent){
	var vCtx = ut.getContextActions(pEvent.target);
	if( ! vCtx.fDataProvider.isLocal()) return; //Impossible si le serveur n'est pas local.
	var vViewMgr = wspViewGetWspView(pEvent.target).fViewMgr;
	var vItemTy = "wsp";
	if(vViewMgr.fRowPopupActive != -2) {
		var vIdx = (vViewMgr.fRowPopupActive>=0) ? vViewMgr.fRowPopupActive : vViewMgr.selection.currentIndex;
		if(vIdx<0) return;
		var vItem = vViewMgr.xGetItem(vIdx);
		vItemTy = vItem.ty;
	}
	if(vItemTy == "space" || vItemTy == "wsp") {
		var vFilePath = vCtx.fDataProvider.getDomFromService("/u/adminWsp?cdaction=GetSpacePath&param="+encodeURIComponent(vCtx.fUri)).documentElement.getAttribute("path");	
	} else {
		var vFilePath = vCtx.fDataProvider.getTextFromService("/u/vueObjet?cdaction=GetFilePath&param="+encodeURIComponent(vCtx.fUri));
	}
	if(vFilePath) ut.openExternalLocalFile(vFilePath, true);
}

function wspViewDownloadZip(pEvent) {
try {
	var vCtx = ut.getContextActions(pEvent.target);
	var vWspView = wspViewGetWspView(pEvent.target);
	var vViewMgr = vWspView.fViewMgr;
	var vUrl = vViewMgr.fDataProvider.getServiceUrl(vViewMgr.fUrlService+"cdaction=GetAsZip&scWspResp=no&PathRes=/"+encodeURIComponent(vCtx.fUri));
	var vFrm = document.getAnonymousElementByAttribute(vWspView, "anonid", "iframe");
	vFrm.webNavigation.loadURI(vUrl, 0, null, null, null);
}catch(e){ut.debug("wspViewDownloadZip::"+e);}
}

function wspViewLaunch(pEvent){
	var vCtx = ut.getContextActions(pEvent.target);
	var vFilePath = vCtx.fDataProvider.getTextFromService("/u/vueObjet?cdaction=GetFilePath&param="+window.encodeURIComponent(vCtx.fUri));
	if(vFilePath) ut.openExternalLocalFile(vFilePath, false);
}

function wspViewCopy(pEvent){
	try{
		var vCtx = ut.getContextActions(pEvent.target);
		var vTrans = transf.createTransferable();
		var vSrvId = vCtx.fDataProvider.getWspServer().getId();
		transf.setStringDataToTransferable(vTrans, transf.FLAVOUR_SCENARI_SERVER_ID, vSrvId);
		transf.setStringDataToTransferable(vTrans, transf.FLAVOUR_SCENARI_URI, vCtx.fUri);
		
		var vViewMgr = wspViewGetWspView(pEvent.target).fViewMgr;
		var vIdx = (vViewMgr.fRowPopupActive>=0) ? vViewMgr.fRowPopupActive : vViewMgr.selection.currentIndex;
		if(vIdx>=0) {
			var vItem = vViewMgr.xGetItem(vIdx);
			if(vItem && vItem.sgn) {
				transf.setStringDataToTransferable(vTrans, transf.FLAVOUR_SCENARI_SGN, vItem.sgn);
			}
		}
		transf.setStringDataToTransferable(vTrans, transf.FLAVOUR_TEXT_UNICODE, vCtx.fUri);
		transf.fClipboardService.setData(vTrans, null, 1);
	} catch(e) {ut.debug(e);}
}

function wspViewCut(pEvent){
	try{
		if(window.desk.isReadOnly()) return;
		var vViewMgr = wspViewGetWspView(pEvent.target).fViewMgr;
		var vIdx = (vViewMgr.fRowPopupActive>=0) ? vViewMgr.fRowPopupActive : vViewMgr.selection.currentIndex;
		if(vIdx<0) return;
		var vItem = vViewMgr.xGetItem(vIdx);
		var vTrans = transf.createTransferable();
		var vSrvId = vViewMgr.fDataProvider.getWspServer().getId();
		transf.setStringDataToTransferable(vTrans, transf.FLAVOUR_SCENARI_SERVER_ID, vSrvId);
		transf.setStringDataToTransferable(vTrans, transf.FLAVOUR_SCENARI_URI, vViewMgr.xGetUri(vItem));
		if(vItem.sgn) transf.setStringDataToTransferable(vTrans, transf.FLAVOUR_SCENARI_SGN, vItem.sgn);
		transf.setStringDataToTransferable(vTrans, transf.FLAVOUR_TEXT_UNICODE, vViewMgr.xGetPath(vItem));
		var vOwner = {
			fItem : vItem,
			fViewMgr : vViewMgr,
			LosingOwnership : function(pTransf) {
				this.fItem.isCutting = false;
				this.fViewMgr.fIsCutting = false;
				var vItem = this.fItem;
				var vRow = 0;
				for(var vItem = this.fItem; vItem; vItem = vRow.p) vRow += vItem.i+1;
				try{this.fViewMgr.fTree.invalidateRow(vRow);}catch(e){};
			},
			QueryInterface : function(pIId) {
		        if (!pIId.equals(Components.interfaces.nsISupports) &&
		            !pIId.equals(Components.interfaces.nsIClipboardOwner))
		            throw Components.results.NS_ERROR_NO_INTERFACE;
		        return this;
		    }
		}
		transf.fClipboardService.setData(vTrans, vOwner, 1);
		vViewMgr.fIsCutting = true;
		vItem.isCutting = true;
		vViewMgr.fTree.invalidateRow(vIdx);
	} catch(e) {ut.debug(e);}
}

function wspViewPaste(pEvent) {
try{
	if(window.desk.isReadOnly()) return;
	var vViewMgr = wspViewGetWspView(pEvent.target).fViewMgr;
	var vIdx = (vViewMgr.fRowPopupActive==-1) ? vViewMgr.selection.currentIndex : vViewMgr.fRowPopupActive;

	var vTrans = transf.createTransferable();
	var vItem = (vIdx<0) ? null : vViewMgr.xGetItem(vIdx);
	var vUriParent = vItem ? vViewMgr.xGetUri(vItem) : vViewMgr.fCdWsp;
	if(vIdx>=0 && !vViewMgr.isContainer(vIdx)) vUriParent = vUriParent.substring(0, vUriParent.lastIndexOf("/"));
	if(transf.isClipboardContainScenariUri()) {
		vTrans.addDataFlavor(transf.FLAVOUR_SCENARI_URI);
		transf.fClipboardService.getData(vTrans, 1);
		var vUri = transf.getStringDataFromTransferable(vTrans, transf.FLAVOUR_SCENARI_URI);
		vTrans = transf.createTransferable();
		vTrans.addDataFlavor(transf.FLAVOUR_SCENARI_SERVER_ID);
		transf.fClipboardService.getData(vTrans, 1);
		var vSrvId = transf.getStringDataFromTransferable(vTrans, transf.FLAVOUR_SCENARI_SERVER_ID);

		if(vUri && vSrvId && vSrvId!=vViewMgr.fDataProvider.getWspServer().getId()){
			ut.alert("La copie d\'item/espace entre deux ateliers appartenant à deux serveurs différents est impossible.\nVeuillez réaliser au préalable une copie locale de l\'item/espace.");
		}else if(vUri){
			if(! window.desk.saveAllViews(vViewMgr.fCdWsp)) return;
			var vIsCut = false;
			if(vViewMgr.fIsCutting && ut.getWspFromUri(vUri)==vViewMgr.fCdWsp){
				var vItemSrc = vViewMgr.xSearchItemByUri(vUri);
				if(vItemSrc && vItemSrc.isCutting) vIsCut = true;
			}
			var vUriDst = (vUri!=vUriParent) ? ut.addLeafToUri(vUriParent, ut.getLeafFromUri(vUri)) : vUriParent;

			var vReload = false;
			if(vIsCut) {
				var vStatusReloadDom = vViewMgr.fDataProvider.getDomFromService("/u/adminWsp?cdaction=StatusLoadedAllItems&param="+vViewMgr.fCdWsp);
				var vStatusReload = vStatusReloadDom ? vStatusReloadDom.documentElement.getAttribute("status") : null;
				if(vStatusReload=="no" && ! ("fDontAskRelaodItems" in vViewMgr)) {





					vReload = true;
				}
			}
			wspViewPasteUriToUri(vUri, vUriDst, vIsCut, vViewMgr, vReload);
		}
	} else if(transf.isClipboardContainFile()) {
		vTrans.addDataFlavor(transf.FLAVOUR_FILE);
		transf.fClipboardService.getData(vTrans, 1);
		var vObj = {};
		var vLen = {};
		vTrans.getTransferData(transf.FLAVOUR_FILE, vObj, vLen);
		var vFile = vObj.value.QueryInterface(Components.interfaces.nsIFile);
		
		var vUriDst = ut.addLeafToUri(vUriParent, vFile.leafName);
		uploadFileToUri(vFile, vUriDst, vViewMgr.fDataProvider, function(pUpdates){
								if(pUpdates) {
									vViewMgr.selectUri(vUriDst);

									var vIdAuthor = vViewMgr.xGetIdAuthor();
									vViewMgr.fDataProvider.dispatchUpdateUri(vViewMgr.fCdWsp, vUriDst, Components.interfaces.scIUriListener.EVENT_TYPE_UPDT, vIdAuthor, false);
								}
							});
	} else if(transf.isClipboardContainTextUnicode()) { // Sous Linux les paths sont passés comme un string avec un \n entre chaque path.
		vTrans.addDataFlavor(transf.FLAVOUR_TEXT_UNICODE);
		transf.fClipboardService.getData(vTrans, 1);
		var vClipCo = transf.getStringDataFromTransferable(vTrans, transf.FLAVOUR_TEXT_UNICODE);
		var vFileUri = vClipCo.split("\n");
		for (var i = 0; i < vFileUri.length; i++) {
			if (vFileUri[i].length > 0) {
				var vFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
				try {
					vFile.initWithPath(vFileUri[i]);
					if (vFile.exists()) {
						var vUriDst = ut.addLeafToUri(vUriParent, vFile.leafName);
						uploadFileToUri(vFile, vUriDst, vViewMgr.fDataProvider, function(pUpdates){
												if(pUpdates) {
													vViewMgr.selectUri(vUriDst);

													var vIdAuthor = vViewMgr.xGetIdAuthor();
													vViewMgr.fDataProvider.dispatchUpdateUri(vViewMgr.fCdWsp, vUriDst, Components.interfaces.scIUriListener.EVENT_TYPE_UPDT, vIdAuthor, false);
												}
											});
					}
				} catch(e){}
			}
		}
	} else {
		var vSrcMimes = [];
		var vMimesAllowed = vViewMgr.fExtItemsMimeTypeAllowed;

		if(vMimesAllowed) for (var i = 0; i < vMimesAllowed.length; i++) {
			if(transf.isClipboardContainMimeType(vMimesAllowed[i])) {
				vSrcMimes.push(vMimesAllowed[i]);
			}
		}
		if(vSrcMimes.length > 0) {



			function cbCreateItem(pDataProv, pUri){
			try{

				if(!pUri) return;
				
				var vUriObjNew = new UriObjectItem(pUri, pDataProv);
				vUriObjNew.activateSynch();
				var vItemTypes = packMgr.getPack(vUriObjNew.getPack()).getContentTypes(vUriObjNew.getModel(), pUri);
				var vContentType = null; 
				for each (var vSrcMime in vSrcMimes) {
					if(vItemTypes.indexOf(vSrcMime) >=0 ) vContentType = vSrcMime;
				}
				
				var vTrans = transf.createTransferable();
				vTrans.addDataFlavor(vContentType);
				transf.fClipboardService.getData(vTrans, 1);
				var vStream = {};
				var vBadLength = {}
				vTrans.getTransferData(vContentType, vStream, vBadLength);

				vStream.value.QueryInterface(Components.interfaces.nsIInputStream);

			

				function cbDataSended(pOk) {
					vViewMgr.selectUri(pUri);
				}
				uploadStreamToUri(vStream.value, -1, pUri, pDataProv, cbDataSended, true);
			}catch(e){ut.debug(e);}
			}
			
			vViewMgr.xCreateItemFromStream(vUriParent, vSrcMimes, cbCreateItem);
		}
	}
} catch(e){ut.debug(e);}
}

WspView.prototype.fExtItemsMimeTypeAllowed = ["image/png", "image/gif"];
WspView.prototype.xCreateItemFromStream = function (pUriParent, pSrcMimeTypes, pCallBackCreateItem){
	creator.createItem(this.fDataProvider, pUriParent, null, false, -1, pCallBackCreateItem, "", null, pSrcMimeTypes);
}

function wspViewPasteUriToUri(pUriSrc, pUriDst, pDeleteSrc, pViewMgr, pReloadWsp) {
	var vMethod = pDeleteSrc ? "MOVE" : "COPY";

	var vUri = pUriSrc;
	var vUriDst = pUriDst;
	if(pUriSrc == pUriDst) {
		var vCurrentName = ut.getLeafFromUri(pUriDst);
		var vNewName = ut.prompt("Indiquez le nouveau nom", "Duplication", vCurrentName);
		vNewName = vNewName.replace(/^\s+/, "").replace(/\s+$/, ""); //trim
		if(!ut.getCodeFromUri(vUri) && !isSpaceName(vNewName) || vNewName == vCurrentName) return false;
		vUriDst = pUriDst.substring(0, pUriDst.length-vCurrentName.length)+vNewName;

	}
	var vParams = "/u/trav?cdaction="+vMethod+"&PathRes=/"+encodeURIComponent(pUriSrc);
	vParams += "&PathDest=/"+encodeURIComponent(vUriDst);
	var vWin;

	var vViewMgr = pViewMgr;
	function cb(pEvent){
		var vReq = pEvent.target;
		ut.closeWindowWait(vWin);
		if(vReq.status==201 || vReq.status==204){
			vViewMgr.selectUri(vUriDst);
			if(vMethod == "MOVE") {
				vViewMgr.fIsCutting = false;
				vViewMgr.refreshUri(vUri);
			}

			var vIdAuthor = vViewMgr.xGetIdAuthor();
			vViewMgr.fDataProvider.dispatchUpdateUri(vViewMgr.fCdWsp, vUriDst, Components.interfaces.scIUriListener.EVENT_TYPE_UPDT, vIdAuthor, false);
			if(vMethod == "MOVE") vViewMgr.fDataProvider.dispatchUpdateUri(vViewMgr.fCdWsp, vUri, Components.interfaces.scIUriListener.EVENT_TYPE_REMOVE, vIdAuthor, false);
		} else if(vReq.status==412) {
			if(ut.confirm(ut.formatStr("La destination de la copie \'%s\' existe déjà. Souhaitez-vous vraiment supprimer cette destination ?", vUriDst), "Remplacement de : "+vUriDst, "Supprimer")) {
				vParams += "&Overwrite=T";
				vViewMgr.fDataProvider.dialogAsynchWithService(vParams, "GET", null, null, cb, cb);
			}
			return;
		} else if(vReq.status == 500) {

			ut.alert(ut.formatStr("Il est impossible de copier \'%1$s\' vers \'%2$s\'.", pUriSrc, pUriDst), "Erreur");
		} else if(vReq.status==ut.httpStatusCodeUnauthorized) {
			ut.alert("Vous ne disposez pas des autorisations nécessaires pour réaliser cette copie.", "Echec à la copie");
		} else {
			ut.alert(ut.formatStr("Une erreur est survenue durant la copie : \n%1$s (%2$s)", vReq.statusText, vReq.status), "Erreur");
		}
	}
	if(vMethod == "COPY" || ! pReloadWsp) {
		vWin = ut.openWindowWait("copy", pDeleteSrc ? "Déplacement en cours..." : "Copie en cours...", ut.formatStr("La copie de %1$s vers %2$s est en cours... Veuillez patienter.", pUriSrc, vUriDst));
		vViewMgr.fDataProvider.dialogAsynchWithService(vParams, "GET", null, null, cb, cb);
	} else {

		vWin = ut.openWindowWait("", "Chargement en cours", "Chargement préalable de l\'atelier...");
		function cbLoadItems(pEvent){
			ut.closeWindowWait(vWin);
			vWin = ut.openWindowWait("copy", "Déplacement en cours...", ut.formatStr("La copie de %1$s vers %2$s est en cours... Veuillez patienter.", pUriSrc, vUriDst));
			vViewMgr.fDataProvider.dialogAsynchWithService(vParams, "GET", null, null, cb, cb);
		}
		vViewMgr.fDataProvider.dialogAsynchWithService("/u/adminWsp?cdaction=ActivateModeLoadAllItems&param="+vViewMgr.fCdWsp, "GET", null, null, cbLoadItems, cbLoadItems);
	}
}

function wspViewDeleteUri(pEvent) {
	if(window.desk.isReadOnly()) return;
	var vViewMgr = wspViewGetWspView(pEvent.target).fViewMgr;
	if(! window.desk.saveAllViews(vViewMgr.fCdWsp)) return;
	var vCtx = ut.getContextActions(pEvent.target);
	if(ut.confirm(ut.formatStr("Confirmez la suppression définitive de :\n%s", vCtx.fUri), "Suppression", "Supprimer")){
		var vWin = ut.openWindowWait("suppr", "Suppression en cours...", ut.formatStr("La suppression de \'%s\' est en cours... Veuillez patienter.", vCtx.fUri));
		function cb(pEvent){
			var vReq = pEvent.target;
			try {
				if(vReq.status==204) {
					vCtx.fDataProvider.dispatchUpdateUri(vViewMgr.fCdWsp, vCtx.fUri, Components.interfaces.scIUriListener.EVENT_TYPE_REMOVE, -1, false);
				} else if(vReq.status==404) {

					vViewMgr.refreshUri(vCtx.fUri);
				} else if(vReq.status==ut.httpStatusCodeUnauthorized) {
					ut.alert("Vous ne disposez pas des autorisations nécessaires pour réaliser cette suppression.", "Echec à la suppression");
				} else {
					ut.alert(ut.formatStr("Une erreur est survenue durant la suppression : \n%1$s (%2$s)", vReq.statusText, vReq.status), "Echec à la suppression");
				}
			}catch(e){
				ut.debug("wspview > wspViewDeleteUri : " + e);
			} finally{
				ut.closeWindowWait(vWin);
			}
		}
		vCtx.fDataProvider.dialogAsynchWithService("/u/trav/"+encodeURI(vCtx.fUri), "DELETE", null, null, cb, cb);
	}
}

function wspViewOpenSearchPanel(pEvent) {
	var vCtx = ut.getContextActions(pEvent.target);
	desk.openSearchPanel(ut.createUriObjectByUri(vCtx.fDataProvider, vCtx.fUri));
}

function wspViewRenameUri(pEvent) {
	if(window.desk.isReadOnly()) return;
	if(! window.desk.saveAllViews(wspViewGetWspView(pEvent.target).fViewMgr.fCdWsp)) return;
	var vCtx = ut.getContextActions(pEvent.target);
	var vUri = vCtx.fUri;
	var vIdx = vUri.lastIndexOf("/");
	var vFile = vUri.substring(vIdx+1);
	var vPrefixPath = vUri.substring(0, vIdx+1);
	var vNewFile = ut.prompt("Indiquez le nouveau nom : ", "Renommage", vFile);
	if(vNewFile && vNewFile != vFile){
		vNewFile = vNewFile.replace(/^\s+/, "").replace(/\s+$/, ""); //trim
		if( ! ut.getUriResFromUri(vUri)){

			if( ! ut.getCodeFromUri(vUri)){

				if(!isSpaceName(vNewFile)){
					window.setTimeout(wspViewRenameUri, 0, pEvent);
					return;
				}
			} else {

				if(vNewFile.indexOf(".")<0){
					ut.alert("Le renommage n\'a pas été réalisé car un code d\'item doit impérativement contenir une extension : \'.xml\', \'.txt\', etc.", "Anomalie de saisie");
					window.setTimeout(wspViewRenameUri, 0, pEvent);
					return;
				}
			}
		}
		
		var vNewUri = vPrefixPath + vNewFile;
		var vViewMgr = wspViewGetWspView(pEvent.target).fViewMgr;
		
		var vParams = "/u/trav?cdaction=MOVE&PathRes=/"+encodeURIComponent(vUri);
		vParams += "&PathDest=/"+encodeURIComponent(vNewUri);
		var vWin = null;
		

		function cb(pEvent){
			var vReq = pEvent.target;
			try {
				if(vReq.status==201 || vReq.status==204) {

					vViewMgr.selectUri(vNewUri);

					var vIdAuthor = -1; //vViewMgr.xGetIdAuthor(); -1 pour que ce wspView se mette aussi à jour.
					vViewMgr.fDataProvider.dispatchUpdateUri(vViewMgr.fCdWsp, vNewUri, Components.interfaces.scIUriListener.EVENT_TYPE_UPDT, vIdAuthor, false);
					vViewMgr.fDataProvider.dispatchUpdateUri(vViewMgr.fCdWsp, vUri, Components.interfaces.scIUriListener.EVENT_TYPE_REMOVE, vIdAuthor, false);
				} else {
					if(vReq.status==207) {
						ut.alert("Certains fichiers ou dossiers n\'ont pu être déplacés. La source n\'a donc pas été intégralement supprimée.", "Echec partiel du renommage");
					} else if(vReq.status==412) {
						ut.alert(ut.formatStr("Un fichier nommé \'%s\' existe déjà.", vNewFile), "Renommage impossible");
					} else if(vReq.status==ut.httpStatusCodeUnauthorized) {
						ut.alert("Vous ne disposez pas des autorisations nécessaires pour effectuer ce renommage.", "Echec au renommage");
					} else {
						if(vReq.status==409 && ut.isWin && vUri.toLowerCase() == vNewUri.toLowerCase()) {
							ut.alert(ut.formatStr("Le renommage avec un simple changement de casse (minuscule/majuscule) est impossible.\nProcédez en 2 renommages successifs.", vReq.statusText, vReq.status), "Echec au renommage");
						} else {
							ut.alert(ut.formatStr("Une erreur est survenue durant le renommage : \n%1$s (%2$s)", vReq.statusText, vReq.status), "Echec au renommage");
						}
					}

					var vIdAuthor = -1; //vViewMgr.xGetIdAuthor(); -1 pour que ce wspView se mette aussi à jour.
					vViewMgr.fDataProvider.dispatchUpdateUri(vViewMgr.fCdWsp, vNewUri, Components.interfaces.scIUriListener.EVENT_TYPE_UPDT, vIdAuthor, false);
					vViewMgr.fDataProvider.dispatchUpdateUri(vViewMgr.fCdWsp, vUri, Components.interfaces.scIUriListener.EVENT_TYPE_UPDT, vIdAuthor, false);
				}
			} finally{
				ut.closeWindowWait(vWin);
			}
		}
				
		var vStatusReload = vViewMgr.fDataProvider.getDomFromService("/u/adminWsp?cdaction=StatusLoadedAllItems&param="+vViewMgr.fCdWsp).documentElement.getAttribute("status");
		if(vStatusReload=="no" && ! ("fDontAskRelaodItems" in vViewMgr)) {






				vWin = ut.openWindowWait("", "Chargement en cours", "Chargement préalable de l\'atelier...");
				function cbLoadItems(pEvent){
					ut.closeWindowWait(vWin);
					vWin = ut.openWindowWait("copy", "Changement de nom en cours...", ut.formatStr("Le changement de nom de \'%1$s\' en \'%2$s\' est en cours... Veuillez patienter.", vUri, vNewUri));
					vViewMgr.fDataProvider.dialogAsynchWithService(vParams, "GET", null, null, cb, cb);
				}
				vViewMgr.fDataProvider.dialogAsynchWithService("/u/adminWsp?cdaction=ActivateModeLoadAllItems&param="+vViewMgr.fCdWsp, "GET", null, null, cbLoadItems, cbLoadItems);
				return;

		}
		vWin = ut.openWindowWait("copy", "Changement de nom en cours...", ut.formatStr("Le changement de nom de \'%1$s\' en \'%2$s\' est en cours... Veuillez patienter.", vUri, vNewUri));
		vViewMgr.fDataProvider.dialogAsynchWithService(vParams, "GET", null, null, cb, cb);
	}
}

function wspViewGetWspView(pNodeFrom) {
	while(pNodeFrom && ! pNodeFrom.fViewMgr) pNodeFrom = pNodeFrom.parentNode;
	return pNodeFrom;
}




function WspViewReqToRefreshUri(pViewMgr, pUri){
	this.fViewMgr = pViewMgr;
	this.fUri = pUri;
}
WspViewReqToRefreshUri.prototype.execute = function(){

	try{
		var sReq = this;
		function cb(pEvent){ wspViewOnloadItem(pEvent, sReq); }
		var vArr = this.fViewMgr.xSplitUri(this.fUri);
		var vItem = this.fViewMgr.fData;
		var vRow = -1;
		for(var i = 1; i < vArr.length; i++){
			var vName = vArr[i];
			var k = 0;
			if(! vItem.ch) {
				if(vItem.ty=="space") {

					vItem = null;
					break;
				} else {

					break;
				}
			}
			var vNbCh = vItem.ch.length;
			var vRowParent = vRow;
			for(; k < vNbCh; k++){
				var vChild = vItem.ch[k];
				if(vChild.nm == vName){
					vRow++;
					vItem = vChild;

					break;
				}
				vRow += vChild.nbr;
			}
			if(k >= vNbCh) {


				this.fItem = null;
				this.fParentItem = vItem;
				this.fParentRow = vRowParent;
				this.fViewMgr.fDataProvider.loadFromService(this.fViewMgr.fUrlService+"cdaction=PROPFIND_ALL&Depth=0&PathRes="+encodeURIComponent(this.fViewMgr.xGetPath(vItem)+"/"+vName), cb, cb);
				return;
			}
		}
		if(vItem){
			this.fItem = vItem;

			this.fRow = vRow;
			this.fViewMgr.fTree.invalidateRow(vRow);
			if(vItem.ch || vItem.ty=="itemmulti" || vItem.ty=="res") {
				this.fViewMgr.fDataProvider.loadFromService(this.fViewMgr.fUrlService+"cdaction=PROPFIND_ALL&Depth=1&PathRes="+encodeURIComponent(this.fViewMgr.xGetPath(vItem)), cb, cb);
			} else {
				this.fViewMgr.fDataProvider.loadFromService(this.fViewMgr.fUrlService+"cdaction=PROPFIND_ALL&Depth=0&PathRes="+encodeURIComponent(this.fViewMgr.xGetPath(vItem)), cb, cb);
			}

		} else {
			this.fViewMgr.xCloseCurrentReq(this);
		}
	}catch(e){
		ut.debug("WspView.prototype.refreshUri.execute"+e);
		this.fViewMgr.xCloseCurrentReq(this);
	}
}
