














var XEDNS = "http://www.utc.fr/ics/scenari/v3/editing";
var XULNS = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";
var SVGNS = "http://www.w3.org/2000/svg";
var HTMLNS = "http://www.w3.org/1999/xhtml";


const XEDSaveEvent = "XEDSave";


const XEDStatusInitEvent = "XEDStatusInit";


const XEDStatusClosedEvent = "XEDStatusClosed";


const XEDStatusDirtyEvent = "XEDStatusDirty";


const XEDStatusNotDirtyEvent = "XEDStatusNotDirty";


const XEDDataChangeEvent = "XEDDataChange";


const XEDDataRemoveEvent = "XEDDataRemove";


const XEDDirtyEditFieldEvent = "XEDDirtyEditField";


const XEDAppendBlockEvent = "XEDAppendBlock";


const XEDFocusEvent = "XEDFocus";



const XEDUndefinedNodeInsertedEvent = "XEDUndefinedNodeInserted";

var xed = {};








xed.getBind = function(pNode){
	while(pNode && ! (pNode.hasAttributeNS(XEDNS, "bind"))) {
		pNode = pNode.parentNode;
		if(pNode.fIsEditor) return null;
	}
	return pNode;
}


xed.getParentBind = function(pNode){
	pNode = (pNode!=null) ? pNode.parentNode : null;
	if(pNode.fIsEditor) return null;
	while(pNode && ! (pNode.hasAttributeNS(XEDNS, "bind"))) {
		pNode = pNode.parentNode;
		if(pNode.fIsEditor) return null;
	}
	return pNode;
}


xed.getNextBind = function(pNode){
	var vNode = pNode;
	while(vNode && ! (vNode.hasAttributeNS(XEDNS, "bind"))){
		if(vNode.firstChild) {
			vNode = vNode.firstChild;
		} else if(vNode.nextSibling) {
			vNode = vNode.nextSibling;
		} else if(vNode.parentNode != pNode.parentNode){
			vNode = vNode.parentNode;
		} else {
			vNode = null;
		}
	}
	return vNode;
}


xed.getEditor = function(pNode){
	while(pNode!=null && ! ( "fEditor" in pNode)) pNode = pNode.parentNode;
	return pNode ? pNode.fEditor : null;
}


xed.isBindReadOnly = function(pNode){
	while(pNode) {
		if("isReadOnly" in pNode) return pNode.isReadOnly;
		if(pNode.hasAttributeNS(XEDNS, "bind")) return false;
		pNode = pNode.parentNode;
		if(pNode.fIsEditor) return false;
	}
	return false;
}


xed.getToolBar = function(pNode, pKeyToolbar){
	while(pNode!=null) {
		if("getToolBar" in pNode) {
			var vRes = pNode.getToolBar(pKeyToolbar);
			if(vRes != null) return vRes;
		}
		if(pNode.fIsEditor) return null;
		pNode = pNode.parentNode;
	}
	return null;
}


xed.getXedContent = function(pNode){
	while(pNode!=null && ! ( "fIsRootEditor" in pNode) && pNode.fIsRootEditor != true) pNode = pNode.parentNode;
	return pNode;
}


xed.getDefaultTitle = function(pDstNode, pDstBind) {
	var vTitle = pDstNode.getAttribute("title");
	if( ! vTitle) {
		if(!pDstBind) pDstBind = xed.getBind(pDstNode);
		vTitle = pDstBind.getAttributeNS(XEDNS, "title") || pDstBind.getAttributeNS(XEDNS, "name");
	}
	return vTitle;
}

 
xed.isStructuralBindModel = function (pModelNode){
	if(!pModelNode) return false;
	var vBind = pModelNode.getAttributeNS(XEDNS, "bind");
	return (vBind == "element" || vBind == "subtree" || vBind == "text" || vBind == "choice" || vBind == "sequence" || vBind == "elementSubtree");
}

 
xed.containContentBind = function (pDstNode){
	if(!pDstNode) return false;
	var vBind = pDstNode.getAttributeNS(XEDNS, "bind");
	if(vBind && (vBind != "current")) return true;
	var vNode = pDstNode.firstChild;
	while(vNode) {
		if(vNode.nodeType == 1) {
			var vBind = vNode.getAttributeNS(XEDNS, "bind");
			if(vBind && (vBind != "current")) return true;
		}
		if(vNode.hasChildNodes()) {
			vNode = vNode.firstChild;
		} else {
			while(!vNode.nextSibling) {
				vNode = vNode.parentNode;
				if(vNode == pDstNode) return false;
			}
			vNode = vNode.nextSibling;
		}
	}
	return false;
}

 
xed.isElementBindModel = function (pModelNode){
	if(!pModelNode) return false;
	var vBind = pModelNode.getAttributeNS(XEDNS, "bind");
	return (vBind == "element" || vBind == "subtree" || vBind == "elementSubtree" || vBind == "undefinedElement");
}


 
xed.isDocumentBindModel = function (pModelNode){
	if(!pModelNode) return false;
	return pModelNode.getAttributeNS(XEDNS, "bind") == "document";
}

 
xed.isAnonymousBindModel = function (pNode){
	if(!pNode) return false;
	var vBind = pNode.getAttributeNS(XEDNS, "bind");
	return (vBind == "comment" || vBind == "undefinedElement" || vBind == "undefinedAttribute" || vBind == "undefinedText" || vBind == "undefinedFragment");
}


xed.isChoice = function(pNode){
	return pNode && (pNode.getAttributeNS(XEDNS, "bind")=="choice" || (pNode.namespaceURI==XEDNS && pNode.localName=="choice"));
}

xed.isChoiceDirective = function(pModel){
	return pModel && pModel.namespaceURI == XEDNS && pModel.localName=="choice";
}

 
xed.isDirectiveModel = function (pModelNode){
	if(!pModelNode) return false;
	return pModelNode.namespaceURI == XEDNS;
}


xed.getRealCardBind = function (pDstBind){
try {
	if(!pDstBind) return "1";
	var vModel = pDstBind.fModelBind;
	if(!vModel) return "1";

	var vEditor = xed.getEditor(pDstBind);
	var vIdxModelRef = null;
	var vModelRef = null;
	var vRef = null;
	if(pDstBind.fModelRef && pDstBind.fModelRef.length > 0) {
		vIdxModelRef = pDstBind.fModelRef.length-1;
		vModelRef = pDstBind.fModelRef[vIdxModelRef--];
		vRef = vEditor.resolveModelRef(vModelRef);
	}

	
	var vFinalCard = "1";
	var vCard;
	while(vModel) {
		vCard = vModel.getAttributeNS(XEDNS, "card") || "1";

		while(vRef == vModel) {
			if(vModelRef.hasAttributeNS(XEDNS, "card")) vCard = vModelRef.getAttributeNS(XEDNS, "card") || "1";
			vModel = vModelRef;
			vModelRef = (vIdxModelRef>=0) ? pDstBind.fModelRef[vIdxModelRef--] : null;
			vRef = (vModelRef) ? vEditor.resolveModelRef(vModelRef) : null;
		}


		if(vCard=="*") {
			return "*";
		} else if(vCard != "1") {
			if(vCard=="+" && vFinalCard=="?") {
				return "*";
			} else if(vCard=="?" && vFinalCard=="+") {
				return "*";
			} else {
				vFinalCard = vCard;
			}
		}

		vModel = vModel.parentNode;
		if(vModel) {
			if(vModel.namespaceURI != XEDNS) {
				if(vModel.getAttributeNS(XEDNS, "bind") != "choice") vModel = null;
			} else {
				if(vModel.localName != "choice") vModel = null;
			}
		}
	}
	return vFinalCard;
}catch(e){"xed.getRealCardBind:"+e}
}



xed.lookForDstWithProp = function(pDstFrom, pPropertyName){

	var vRoot = pDstFrom;
	while(vRoot && vRoot.nodeType==1 &&  ! vRoot.hasAttributeNS(XEDNS, "bind")) {
		if(pPropertyName in vRoot) return vRoot;
		vRoot = vRoot.parentNode;
	}
	if(vRoot && vRoot.nodeType==1) {
		if(pPropertyName in vRoot) return vRoot;
		if(! vRoot.hasChildNodes()) return null;
		var sPropertyName = pPropertyName;
		var vTw = vRoot.ownerDocument.createTreeWalker(vRoot, NodeFilter.SHOW_ELEMENT, function(pNode){
				if(pNode.hasAttributeNS(XEDNS, "bind")) return NodeFilter.FILTER_REJECT;
				return (sPropertyName in pNode) ? NodeFilter.FILTER_ACCEPT : NodeFilter.FILTER_SKIP;
			}, false);
		var vRes = vTw.firstChild();
		vTw = null; //memLeak
		return vRes;
	}
	return null;
}


xed.isInEmptyContext = function(pDst) {
	var vParentDst = pDst;
	while(vParentDst) {
		if(vParentDst.fIsEditor) return false;
		if(vParentDst.hasAttribute("empty")) return true;
		vParentDst = vParentDst.parentNode;
	}
	return false;
}


xed.createTwPhysicalDstBindNodes = function(pBindDst) {
	var vTw = pBindDst.ownerDocument.createTreeWalker(xed.getXedContent(pBindDst), NodeFilter.SHOW_ELEMENT, xed.filterTwPhysicalDstBindNodes, false);
	vTw.currentNode = pBindDst;
	return vTw;
}


xed.filterTwPhysicalDstBindNodes = function(pNode) {
	var vBind = pNode.getAttributeNS(XEDNS, "bind");
	if(!vBind) return NodeFilter.FILTER_SKIP;
	switch(vBind) {
		case "element":
		case "subtree":
		case "undefinedElement":
		case "plugin":
		case "attribute":
		case "undefinedAttribute":
		case "text":
		case "undefinedText":
		case "document":
			return NodeFilter.FILTER_ACCEPT;
	}
	if(pNode.fIsRootEditor) return NodeFilter.FILTER_ACCEPT;
	return NodeFilter.FILTER_SKIP;
}


xed.filterTwDstBindNodes = function(pNode) {
	return pNode.hasAttributeNS(XEDNS, "bind") ? NodeFilter.FILTER_ACCEPT : NodeFilter.FILTER_SKIP;
}










function XedLogicDom(){
}

XedLogicDom.prototype.initFromDst = function(pDst){
try{
	this.fModel = pDst.fModelBind;
	this.fDst = pDst;
	if(xed.isAnonymousBindModel(pDst)) {


		var vDstNext = pDst.nextSibling;
		while(vDstNext && (! vDstNext.fModelBind || ! xed.isStructuralBindModel(vDstNext.fModelBind))) vDstNext = vDstNext.nextSibling;

		var vDstPrec = pDst.previousSibling;
		while(vDstPrec && (! vDstPrec.fModelBind || ! xed.isStructuralBindModel(vDstPrec.fModelBind))) vDstPrec = vDstPrec.previousSibling;
		/*xed.debug("pDst="+xed.getXml(pDst.parentNode));
		xed.debug("prec="+xed.getXml(vDstPrec));
		xed.debug("next="+xed.getXml(vDstNext));*/
		if(vDstPrec && vDstNext){
			var vLD = new XedLogicDom();
			vLD.initFromDst(vDstPrec);
			this.fRoot = vLD.fRoot;
			this.fRoot.fOriDst = pDst;
			this.fParent = this.fRoot;	//On prend le root par défaut puis on Recherche du plus petit parent commun
			var vParent = vLD; //Cas particulier : parent = previousSibling = nextSibling si on est au milieu d'une liste de  noeud de card + ou *.
			while(vParent) {
				if(vParent.isMatchDst(vDstNext)){
					this.fParent = vParent;
					break;
				}
				vParent = vParent.fParent;
			}
			this.fPreviousSibling = (this.fParent == vLD) ? this.fParent : this.fParent.fFromChild;
			this.fNextSibling = this.fPreviousSibling.getNextSibling();
			this.fFirstChild = null;
			this.fLastChild = null;
		} else if(vDstPrec || vDstNext){

			var vLD = new XedLogicDom();
			vLD.initFromDst(vDstPrec || vDstNext);
			this.fRoot = vLD.fRoot;
			this.fRoot.fOriDst = pDst;
			this.fParent = vLD.fParent; // ou vLD.fRoot ???
			this.fPreviousSibling = (vDstPrec) ? vLD : vLD.getPreviousSibling();
			this.fNextSibling = (vDstPrec) ? vLD.getNextSibling() : vLD;
			this.fFirstChild = null;
			this.fLastChild = null;
		} else {

			var vDstParent = xed.getParentBind(pDst);
			var vLD = new XedLogicDom();
			vLD.initFromDst(vDstParent);
			this.fRoot = vLD.fRoot;
			this.fRoot.fOriDst = pDst;
			this.fParent = vLD;
			this.fPreviousSibling = vLD;
			this.fNextSibling = vLD;
			this.fFirstChild = vLD.getFirstChild();
			this.fLastChild = vLD.getLastChild();
		}
	} else {

		this.fParent = new XedLogicDom();
		this.fRoot = this.fParent.initFromChildLD(this, pDst, (pDst.fModelRef) ? pDst.fModelRef.length-1 : -1);
	}
}catch(e){xed.debug("XedLogicDom.prototype.initFromDst"+e);}
}

XedLogicDom.prototype.initFromChildLD = function(pChildLD, pOriDst, pIdxRef){
	this.fFromChild = pChildLD;

	if(pIdxRef>=0){
		var vModelRef = pOriDst.fModelRef[pIdxRef];
		var vEditor = xed.getEditor(pOriDst);
		/*xed.debug("pIdxRef= "+pIdxRef);
		xed.debug("vModelRef= "+xed.getXml(vModelRef));
		xed.debug("pChildLD.fModel= "+xed.getXml(pChildLD.fModel));
		xed.debug("vEditor.resolveModelRef(vModelRef)= "+xed.getXml(vEditor.resolveModelRef(vModelRef)));*/
		if(vEditor.resolveModelRef(vModelRef) == pChildLD.fModel) {

			while( --pIdxRef >= 0 && vEditor.resolveModelRef(pOriDst.fModelRef[pIdxRef]) == vModelRef)	vModelRef = pOriDst.fModelRef[pIdxRef];

			this.fModel = vModelRef.parentNode;

			pChildLD.fModelRef = vModelRef;
		} else {

			this.fModel = pChildLD.fModel.parentNode;
		}
	} else {
		this.fModel = pChildLD.fModel.parentNode;
	}
	if(xed.isDirectiveModel(this.fModel)) {

		this.fParent = new XedLogicDom();
		this.fRoot = this.fParent.initFromChildLD(this, pOriDst, pIdxRef);

		return this.fRoot ;
	} else {

		this.fOriDst = pOriDst;
		this.fRoot = this;
		this.fParent = null;
		this.fNextSibling = null;
		this.fPreviousSibling = null;
		return this;
	}
}

XedLogicDom.prototype.initFromNextSibling = function(pNextLD, pModel, pModelRef){
	this.fNextSibling = pNextLD;
	this.fRoot = pNextLD.fRoot;
	this.fParent = pNextLD.fParent;
	this.fModel = pModel;
	if(pModelRef) this.fModelRef = pModelRef;
	this.fFirstDst = null;
	this.fLastDst = null;
	var vNextDst = null;
	var vNextsLD = pNextLD;

	while(vNextsLD) {
		vNextDst = vNextsLD.getFirstDst();
		if(vNextDst) break;
		vNextsLD = vNextsLD.getNextSibling();
	}
	var vDst = (vNextDst) ? vNextDst.previousSibling : null;
	if(!vDst) vDst = this.fRoot.fOriDst.parentNode.lastChild;
	while(vDst) {
		if(("fModelBind" in vDst) && xed.isStructuralBindModel(vDst.fModelBind)) {

			if( ! this.isMatchDst(vDst)) {

				break;
			}


			this.fFirstDst = vDst;
			if(this.fLastDst == null) this.fLastDst = vDst;
		}
		vDst = vDst.previousSibling;
	}

}

XedLogicDom.prototype.initFromPreviousSibling = function(pPrevLD, pModel, pModelRef){
	this.fPreviousSibling = pPrevLD;
	this.fRoot = pPrevLD.fRoot;
	this.fParent = pPrevLD.fParent;
	this.fModel = pModel;
	if(pModelRef) this.fModelRef = pModelRef;
	this.fFirstDst = null;
	this.fLastDst = null;
	var vPrevDst = null;
	var vPrevsLD = pPrevLD;
	while(vPrevsLD) {
		vPrevDst = vPrevsLD.getLastDst();
		if(vPrevDst) break;
		vPrevsLD = vPrevsLD.getPreviousSibling(); 
	}
	
	var vDst = (vPrevDst) ? vPrevDst.nextSibling : null;
	if(!vDst) vDst = this.fRoot.fOriDst.parentNode.firstChild;
	while(vDst) {
		if(("fModelBind" in vDst) && xed.isStructuralBindModel(vDst.fModelBind)) {

			if( ! this.isMatchDst(vDst)) break;

			this.fLastDst = vDst;
			if(this.fFirstDst == null) this.fFirstDst = vDst;
		}
		vDst = vDst.nextSibling;
	}
}


XedLogicDom.prototype.getXedAttribute = function(pLocalName){
	var vModel = this.fModelRef || this.fModel;
	while(vModel) {
		if(vModel.hasAttributeNS(XEDNS, pLocalName)) {
			return vModel.getAttributeNS(XEDNS, pLocalName);
		} else {
			if(vModel.namespaceURI==XEDNS && vModel.localName=="ref") {

				vModel = xed.getEditor(this.fRoot.fOriDst).resolveModelRef(vModel);
			} else return "";
		}
	}
	return "";
}


XedLogicDom.prototype.getAttribute = function(pLocalName){
	var vModel = this.fModelRef || this.fModel;
	while(vModel) {
		if(vModel.hasAttribute(pLocalName)) {
			return vModel.getAttribute(pLocalName);
		} else {
			if(vModel.namespaceURI==XEDNS && vModel.localName=="ref") {

				vModel = xed.getEditor(this.fRoot.fOriDst).resolveModelRef(vModel);
			} else return "";
		}
	}
	return "";
}


XedLogicDom.prototype.hasXedAttribute = function(pLocalName){
	var vModel = this.fModelRef || this.fModel;
	while(vModel) {
		if(vModel.hasAttributeNS(XEDNS, pLocalName)) {
			return true;
		} else {
			if(vModel.namespaceURI==XEDNS && vModel.localName=="ref") {

				vModel = xed.getEditor(this.fRoot.fOriDst).resolveModelRef(vModel);
			} else return false;
		}
	}
	return false;
}


XedLogicDom.prototype.hasAttribute = function(pLocalName){
	var vModel = this.fModelRef || this.fModel;
	while(vModel) {
		if(vModel.hasAttribute(pLocalName)) {
			return true;
		} else {
			if(vModel.namespaceURI==XEDNS && vModel.localName=="ref") {

				vModel = xed.getEditor(this.fRoot.fOriDst).resolveModelRef(vModel);
			} else return false;
		}
	}
	return false;
}


XedLogicDom.prototype.getCard = function(){
	if( ! ("fCard" in this)) {
		this.fCard = "1";
		var vModel = this.fModelRef || this.fModel;
		while(vModel) {
			if(vModel.hasAttributeNS(XEDNS, "card")) {
				this.fCard = vModel.getAttributeNS(XEDNS, "card");
				break;
			} else {
				if(vModel.namespaceURI==XEDNS && vModel.localName=="ref") {

					vModel = xed.getEditor(this.fRoot.fOriDst).resolveModelRef(vModel);
				} else break;
			}
		}
	}
	return this.fCard;
}


XedLogicDom.prototype.getRealCard = function(){
	var vFinalCard = this.getCard();
	if(vFinalCard == "*") return "*";
	var vParent = this.getParentNode();
	while(vParent && xed.isChoiceDirective(vParent.getModel())){
		var vCard = vParent.getCard();
		if(vCard=="*") {
			return "*";
		} else if(vCard != "1") {
			if(vCard=="+" && vFinalCard=="?") {
				return "*";
			} else if(vCard=="?" && vFinalCard=="+") {
				return "*";
			} else {
				vFinalCard = vCard;
			}
		}
		vParent = vParent.getParentNode();
	}
	return vFinalCard;
}


XedLogicDom.prototype.isMatchDst = function(pDst){
	var vModel = pDst.fModelBind;
	var vIdxRef = (pDst.fModelRef) ? pDst.fModelRef.length-1 : -1;
	var vEditor = xed.getEditor(pDst);

	while( ! (vModel == this.fModel)) {

		if(vIdxRef<0){
			vModel = vModel.parentNode;
		} else {

			var vModelRef = pDst.fModelRef[vIdxRef];
			if(vEditor.resolveModelRef(vModelRef) == vModel) {
				while( --vIdxRef >= 0 && vEditor.resolveModelRef(pDst.fModelRef[vIdxRef]) == vModelRef) {

					vModelRef = pDst.fModelRef[vIdxRef];
				}

				vModel = vModelRef.parentNode;
			} else {

				vModel = vModel.parentNode;
			}
		}
		if( ! vModel || ! xed.isChoiceDirective(vModel)){

			return false;
		}
	}


	

	if(!this.fModelRef) return true;
	

	var vModelRefs = [this.fModelRef];
	var vLastRef = this.fModelRef;
	while(true) {
		vLastRef = vEditor.resolveModelRef(vLastRef);
		if(!vLastRef || ! (vLastRef.namespaceURI == XEDNS && vLastRef.localName == "ref")) break;
		vModelRefs.push(vLastRef);
	}
	

	var i = vModelRefs.length-1;
	if(i > vIdxRef) return false;
	for(; i >=0; i--) if(vModelRefs[i] != pDst.fModelRef[vIdxRef--]) return false;

	return true;
}


XedLogicDom.prototype.isEqualDst = function(pDst){
	if(!pDst) return false;
	var vDstModel = pDst.fModelBind;
	if(vDstModel != this.fModel) return false;
	var vDstRefs = (pDst.fModelRef !=null && pDst.fModelRef.length > 0) ? pDst.fModelRef : null;
	if(! this.fModelRef && ! vDstRefs) return true;
	if(this.fModelRef && vDstRefs) {

		var vLastRef = this.fModelRef;
		var vIdxDstRef = vDstRefs.length - 1;
		var vEditor = xed.getEditor(pDst);
		while(vLastRef && vIdxDstRef >= 0) {
			if(vDstRefs[vIdxDstRef] != vLastRef) return false;
			vLastRef = vEditor.resolveModelRef(vLastRef);
			vIdxDstRef--;
		}
		return true;
	}

	return false;
}

XedLogicDom.prototype.getModel = function(){
	return this.fModel;
}

XedLogicDom.prototype.getRoot = function(){
	return this.fRoot;
}

XedLogicDom.prototype.getParentNode = function(){
	return this.fParent;
}

XedLogicDom.prototype.getPreviousSibling = function(){
try{
	if (!("fPreviousSibling" in this)) {

		var vModelRef = null;
		var vEditor = xed.getEditor(this.fRoot.fOriDst);
		var vSiblingModel = this.fModelRef ? this.fModelRef.previousSibling : this.fModel.previousSibling;
		while(vSiblingModel){
			if(vSiblingModel.nodeType == 1) {
				var vNameModel = (vSiblingModel.namespaceURI != XEDNS) ? null : vSiblingModel.localName;
				while(vNameModel == "ref") {
					if(!vModelRef) vModelRef = vSiblingModel; //On mémorise le 1er ref.
					vSiblingModel = vEditor.resolveModelRef(vSiblingModel);
					vNameModel = (vSiblingModel.namespaceURI != XEDNS) ? null : vSiblingModel.localName;
				}
				if(xed.isStructuralBindModel(vSiblingModel) || vNameModel=="choice") break; //|| vNameModel=="sequence" 
				if(vModelRef) {
					vSiblingModel = vModelRef;
					vModelRef = null;
				}
			}
			vSiblingModel = vSiblingModel.previousSibling;
		}
		if(vSiblingModel) {


			this.fPreviousSibling = new XedLogicDom();
			this.fPreviousSibling.initFromNextSibling(this, vSiblingModel, vModelRef);
		} else {

			this.fPreviousSibling = null;
			this.fParent.fFirstChild = this;
		}
	}
	return this.fPreviousSibling;
}catch(e){xed.debug("XedLogicDom.prototype.getPreviousSibling="+e);}
}

XedLogicDom.prototype.getNextSibling = function(){
	if (!("fNextSibling" in this)) {
		var vModelRef = null;
		var vEditor = xed.getEditor(this.fRoot.fOriDst);
		var vSiblingModel = this.fModelRef ? this.fModelRef.nextSibling : this.fModel.nextSibling;
		while(vSiblingModel){
			if(vSiblingModel.nodeType == 1) {
				var vNameModel = (vSiblingModel.namespaceURI != XEDNS) ? null : vSiblingModel.localName;
				while(vNameModel == "ref") {
					if(!vModelRef) vModelRef = vSiblingModel; //On mémorise le 1er ref.
					vSiblingModel = vEditor.resolveModelRef(vSiblingModel);
					vNameModel = (vSiblingModel.namespaceURI != XEDNS) ? null : vSiblingModel.localName;
				}
				if(xed.isStructuralBindModel(vSiblingModel) || vNameModel=="choice") break; //|| vNameModel=="sequence" 
				if(vModelRef) {
					vSiblingModel = vModelRef;
					vModelRef = null;
				}
			}
			vSiblingModel = vSiblingModel.nextSibling;
		}
		if(vSiblingModel) {
			this.fNextSibling = new XedLogicDom();
			this.fNextSibling.initFromPreviousSibling(this, vSiblingModel, vModelRef);
		} else {
			this.fNextSibling = null;
			this.fParent.fLastChild = this;
		}
	}
	return this.fNextSibling;
}

XedLogicDom.prototype.getFirstChild = function(){
	if (!("fFirstChild" in this)) {
		if("fFromChild" in this) {

			var vPrev = this.fFromChild;
			while(vPrev) vPrev = vPrev.getPreviousSibling();
		} else {

			this.xBuildChilds();
		}
	}
	return this.fFirstChild;
}

XedLogicDom.prototype.getLastChild = function(){
	if (!("fLastChild" in this)) {
		if("fFromChild" in this) {

			var vNext = this.fFromChild;
			while(vNext) vNext = vNext.getNextSibling();
		} else {

			this.xBuildChilds();
		}
	}
	return this.fLastChild;
}

XedLogicDom.prototype.xBuildChilds = function(){
try{
	if(! this.fModel){
		this.fFirstChild = null;
		this.fLastChild = null;
		return;
	}
	var vChild = this.fModel.firstChild;
	this.fFirstChild = null;
	var vPrevLDChild = null;
	var vLDChild = null;
	var vFirstDstToAffect;
	if("fDst" in this) {

	 	vFirstDstToAffect = this.fDst.firstChild;
		while (vFirstDstToAffect && ! ( ("fModelBind" in vFirstDstToAffect) && xed.isStructuralBindModel(vFirstDstToAffect.fModelBind) )) {
			vFirstDstToAffect = vFirstDstToAffect.nextSibling;
		}
	} else {
		vFirstDstToAffect = this.fFirstDst;
	}
	var vEditor = xed.getEditor(this.fRoot.fOriDst);
	while(vChild) {
		if(vChild.nodeType==1) {
			var vDirective = (vChild.namespaceURI == XEDNS) ? vChild.localName : null;
			var vModel = vChild;
			while(vDirective == "ref") {
				vModel = vEditor.resolveModelRef(vModel);
				vDirective = (vModel.namespaceURI == XEDNS) ? vModel.localName : null;
			}
			if(vDirective || vModel.hasAttributeNS(XEDNS, "bind")) {

				vPrevLDChild = vLDChild;
				vLDChild = new XedLogicDom();
				vLDChild.fPreviousSibling = vPrevLDChild;
				vLDChild.fNextSibling = null;
				if(vPrevLDChild) vPrevLDChild.fNextSibling = vLDChild; else this.fFirstChild = vLDChild;
				vLDChild.fModel = vModel;
				if( ! (vModel == vChild)) vLDChild.fModelRef = vChild;
				vLDChild.fParent = this;
				vLDChild.fRoot = this.fRoot;
				vLDChild.fFirstDst = null;
				vLDChild.fLastDst = null;
				while(vFirstDstToAffect && vLDChild.isMatchDst(vFirstDstToAffect)){
					if(vLDChild.fFirstDst == null) vLDChild.fFirstDst = vFirstDstToAffect;
					vLDChild.fLastDst = vFirstDstToAffect;
					vFirstDstToAffect = vFirstDstToAffect.nextSibling;
					while (vFirstDstToAffect && ! ( ("fModelBind" in vFirstDstToAffect) && xed.isStructuralBindModel(vFirstDstToAffect.fModelBind) )) {
						vFirstDstToAffect = vFirstDstToAffect.nextSibling;
					}
				}
			}
		}
		vChild = vChild.nextSibling;
	}
	this.fLastChild = vLDChild;
}catch(e){xed.debug("XedLogicDom.xBuildChilds::"+e);}
}

XedLogicDom.prototype.getFirstDst = function(){
	if( ! ("fFirstDst" in this)){
		if("fDst" in this) {

			this.fFirstDst = this.fDst;
		} 
		else if("fFromChild" in this) {

			var vCh = this.fFromChild;
			while("fFromChild" in vCh) vCh = vCh.fFromChild;
			this.fFirstDst = vCh.fDst;
		}
		if(this.fFirstDst) {




			var vDst = this.fFirstDst.previousSibling;
			while(vDst) {
				if(("fModelBind" in vDst) && xed.isStructuralBindModel(vDst.fModelBind)) {


					if( ! this.isMatchDst(vDst)) break;

					this.fFirstDst = vDst;
				}
				vDst = vDst.previousSibling;
			}
			
		} else {
			this.fFirstDst = null;
			var vChild = this.getFirstChild();

			while(vChild) {
				var vFirstDst = vChild.getFirstDst();
				if(vFirstDst) {
					this.fFirstDst = vFirstDst;
					break;
				}
				vChild = vChild.getNextSibling();
			}
		}
	}
	return this.fFirstDst;
}

XedLogicDom.prototype.getLastDst = function(){
	if( ! ("fLastDst" in this)){
		if("fDst" in this) {

			this.fLastDst = this.fDst;
		} 
		else if("fFromChild" in this) {

			var vCh = this.fFromChild;
			while("fFromChild" in vCh) vCh = vCh.fFromChild;
			this.fLastDst = vCh.fDst;
		}
		if(this.fLastDst) {


			var vDst = this.fLastDst.nextSibling;
			while(vDst) {
				if(("fModelBind" in vDst) && xed.isStructuralBindModel(vDst.fModelBind)) {

					if( ! this.isMatchDst(vDst)) break;

					this.fLastDst = vDst;
				}
				vDst = vDst.nextSibling;
			}
		} else {
			this.fLastDst = null;
			var vChild = this.getLastChild();
			while(vChild) {
				var vLastDst = vChild.getLastDst();
				if(vLastDst) {
					this.fLastDst = vLastDst;
					break;
				}
				vChild = vChild.getPreviousSibling();
			}
		}
	}
	return this.fLastDst;
}


XedLogicDom.prototype.getInitialDst = function(){
	return this.fRoot.fOriDst;
}


XedLogicDom.prototype.getInitialStructuralLDNode = function(){
	var vChild = this.fRoot.fFromChild;
	if( ! vChild) vChild = this;
	else while(vChild.fFromChild) vChild = vChild.fFromChild;
	while(vChild && ! vChild.isStructuralModel()) {
		vChild = vChild.fParent;
	}
	return vChild;
}


XedLogicDom.prototype.isStructuralModel = function(){
	var vModel = this.fModel;
	if(vModel.namespaceURI == XEDNS) {

		return (vModel.localName=="choice");
	} else {
		return xed.isStructuralBindModel(vModel);
	}
}


XedLogicDom.prototype.isDstExist = function(){

	if("fFromChild" in this) return true;
	return (this.getFirstDst() != null);
}


XedLogicDom.prototype.getStackModelRefs = function(){
	var vEditor = xed.getEditor(this.fRoot.fOriDst);
	var vListLDRefs = null;
	var vLDNode = this;
	while(true){
		if(vLDNode.fModelRef){
			if(!vListLDRefs) vListLDRefs = [];
			vListLDRefs[vListLDRefs.length] = vLDNode.fModelRef;
		}
		vLDNode = vLDNode.fParent;
		if( ! vLDNode) break;

		if(! vLDNode.fParent) break;
	}
	var vListRefs = null;
	if(vListLDRefs){
		vListRefs = [];
		for(var i = vListLDRefs.length-1; i >= 0; i--) {
			vListRefs[vListRefs.length] = vListLDRefs[i];
			var vRef = vEditor.resolveModelRef(vListLDRefs[i]);
			while(vRef){
				if( vRef.localName == "ref" && vRef.namespaceURI == XEDNS ){
					vListRefs[vListRefs.length] = vRef;
					vRef = vEditor.resolveModelRef(vRef);
				} 
				else vRef = null;
			}
		}
	}
	return vListRefs;
}


XedLogicDom.prototype.insertInDst = function(pPosition, pNewEntryHisto, pSrcToMatch, pSrc){
	var vOriDst = this.fRoot.fOriDst;
	var vEditor = xed.getEditor(vOriDst);
	var vParentDst, vPrevDst, vNextDst;
	if(pPosition=="before") {
		vParentDst = vOriDst.parentNode;
		vPrevDst = vOriDst.previousSibling;
		vNextDst = vOriDst;
	} else if(pPosition=="after") {
		vParentDst = vOriDst.parentNode;
		vPrevDst = vOriDst;
		vNextDst = vOriDst.nextSibling;
	} else if(pPosition=="inside") {
		vParentDst = vOriDst;
		vPrevDst = vOriDst.lastChild;
		vNextDst = null;
	} else {
		xed.debug("pPosition dans XedLogicDom.insertInDst(pPosition) inconnue : "+pPosition);
	}
	var vListRefs = this.getStackModelRefs();

	vEditor.addModelBefore(this.fModel, vParentDst, vNextDst, vListRefs, pSrcToMatch, pSrc);
	vEditor.addHisto(new XEDInsertHisto(vParentDst, vPrevDst, vNextDst, pNewEntryHisto ? vOriDst : null), pNewEntryHisto);
	var vNode = vPrevDst ? vPrevDst.nextSibling : vParentDst.firstChild;
	while(vNode && ! (vNode == vNextDst)){
		var vEvent = document.createEvent("Events");
		vEvent.initEvent(XEDDataChangeEvent, true, false);
		vNode.dispatchEvent(vEvent);
		vNode = vNode.nextSibling;
	}
}

XedLogicDom.prototype.equals = function(pOtherLDNode){
	if(! pOtherLDNode) return false;


	return (pOtherLDNode.fModel == this.fModel && pOtherLDNode.fModelRef == this.fModelRef);
}

XedLogicDom.prototype.toString = function(){
	return " LDNode: ModelLié=["+xed.getXmlElt(this.fModel)+"]\nModelRef=["+xed.getXmlElt(this.fModelRef)+"]";
}




function XedInsertableAttr(pModel, pStackRef, pOriDst) {
	this.fModel = pModel;
	this.fDst = pOriDst;
	if(pStackRef && pStackRef.length>0) this.fStackRef = [].concat(pStackRef);
}
XedInsertableAttr.prototype = {
	getInitialDst : function(){return this.fDst},
	getXedAttribute : function(pLocalName){
		if(this.fStackRef) for(var i = 0; i<this.fStackRef.length; i++) if(this.fStackRef[i].hasAttributeNS(XEDNS, pLocalName)) return this.fStackRef[i].getAttributeNS(XEDNS, pLocalName);
		return this.fModel.getAttributeNS(XEDNS, pLocalName);
	},
	hasXedAttribute : function(){
		if(this.fStackRef) for(var i = 0; i<this.fStackRef.length; i++) if(this.fStackRef[i].hasAttributeNS(XEDNS, pLocalName)) return true;
		return this.fModel.hasAttributeNS(XEDNS, pLocalName);
	},
	getAttribute : function(pLocalName){
		if(this.fStackRef) for(var i = 0; i<this.fStackRef.length; i++) if(this.fStackRef[i].hasAttribute(pLocalName)) return this.fStackRef[i].getAttribute(pLocalName);
		return this.fModel.getAttribute(pLocalName);
	},
	insertInDst : function(pPosition, pNewEntryHisto){
		var vOriDst = this.fDst;
		var vEditor = xed.getEditor(this.fDst);
		var vParentDst, vPrevDst, vNextDst;
		if(pPosition=="before") {
			vParentDst = vOriDst.parentNode;
			vPrevDst = vOriDst.previousSibling;
			vNextDst = vOriDst;
		} else if(pPosition=="after") {
			vParentDst = vOriDst.parentNode;
			vPrevDst = vOriDst;
			vNextDst = vOriDst.nextSibling;
		} else if(pPosition=="inside") {
			vParentDst = vOriDst;
			vPrevDst = vOriDst.lastChild;
			vNextDst = null;
		} else {
			xed.debug("pPosition dans XedInsertableAttrinsertInDst(pPosition) inconnue : "+pPosition);
		}

		vEditor.addModelBefore(this.fModel, vParentDst, vNextDst, this.fStackRef, null, null);
		vEditor.addHisto(new XEDInsertHisto(vParentDst, vPrevDst, vNextDst, pNewEntryHisto ? vOriDst : null), pNewEntryHisto);
		var vNode = vPrevDst ? vPrevDst.nextSibling : vParentDst.firstChild;
		while(vNode && ! (vNode == vNextDst)){
			var vEvent = document.createEvent("Events");
			vEvent.initEvent(XEDDataChangeEvent, true, false);
			vNode.dispatchEvent(vEvent);
			vNode = vNode.nextSibling;
		}
	}
};



 

function XEDInsertHisto(pParentDst, pPreviousDst, pNextDst, pUndoFocus){
	this.fParentDst = pParentDst;
	this.fPrevDst = pPreviousDst;
	this.fNextDst = pNextDst;
	this.fUndoFocus = pUndoFocus;

}
XEDInsertHisto.prototype.undo = function(){

	var vNode = this.fPrevDst ? this.fPrevDst.nextSibling : this.fParentDst.firstChild;
	this.fFrag = document.createDocumentFragment();
	var vEditor = xed.getEditor(this.fParentDst);
	while(vNode && ! (vNode == this.fNextDst)){
		var vNextNode = vNode.nextSibling;
		var vEvent = document.createEvent("Events");
		vEvent.initEvent(XEDDataRemoveEvent, true, false);
		vNode.dispatchEvent(vEvent);
		this.fFrag.appendChild(vNode);
		vNode = vNextNode;
	}
	var vEvent = document.createEvent("Events");
	vEvent.initEvent(XEDDataChangeEvent, true, false);
	this.fParentDst.dispatchEvent(vEvent);
	if(this.fUndoFocus) vEditor.setFocusFrom(this.fUndoFocus);
}
XEDInsertHisto.prototype.redo = function(){
	if(this.fFrag) {
		var vNode = this.fFrag.firstChild;
		var vFirstNode = vNode;
		var vEditor = xed.getEditor(this.fParentDst);
		while(vNode) {
			var vNextNode = vNode.nextSibling;
			this.fParentDst.insertBefore(vNode, this.fNextDst);
			vEditor.execOnXedLoadDst(vNode);
			var vEvent = document.createEvent("Events");
			vEvent.initEvent(XEDDataChangeEvent, true, false);
			vNode.dispatchEvent(vEvent);
			vNode = vNextNode;
		}
		vEditor.setFocusFrom(vFirstNode);
		delete this.fFrag;
	}
}


function XEDReplaceHisto(pOldBind, pNewBind, pOldFocus, pNewFocus){
	this.fOldBind = pOldBind;
	this.fNewBind = pNewBind;
	this.fOldFocus = pOldFocus;
	this.fNewFocus = pNewFocus;
}
XEDReplaceHisto.prototype.undo = function(){
	var vEditor = xed.getEditor(this.fNewBind);
	vEditor.ensureNodeVisible(this.fNewBind, true); //On décollapse au besoin et force la visibilité totale

	this.fNewBind.parentNode.insertBefore(this.fOldBind, this.fNewBind);
	this.fNewBind.parentNode.removeChild(this.fNewBind);
	vEditor.execOnXedLoadDst(this.fOldBind);
	var vEvent = document.createEvent("Events");
	vEvent.initEvent(XEDDataChangeEvent, true, false);
	this.fOldBind.dispatchEvent(vEvent);
	if(this.fOldFocus) vEditor.setFocusFrom(this.fOldFocus);
}
XEDReplaceHisto.prototype.redo = function(){
	var vEditor = xed.getEditor(this.fOldBind);
	vEditor.ensureNodeVisible(this.fOldBind, true); //On décollapse au besoin et force la visibilité totale

	this.fOldBind.parentNode.insertBefore(this.fNewBind, this.fOldBind);
	this.fOldBind.parentNode.removeChild(this.fOldBind);
	vEditor.execOnXedLoadDst(this.fNewBind);
	var vEvent = document.createEvent("Events");
	vEvent.initEvent(XEDDataChangeEvent, true, false);
	this.fNewBind.dispatchEvent(vEvent);
	if(this.fNewFocus) vEditor.setFocusFrom(this.fNewFocus);
}



function XEDUpdateValHisto(pNode, pOldVal, pNewVal){
	this.fNode = pNode;
	this.fOldVal = pOldVal;
	this.fNewVal = pNewVal;
}
XEDUpdateValHisto.prototype.undo = function(){
	this.fNode.updateVal(this.fOldVal, true);
	xed.getEditor(this.fNode).setFocus(this.fNode);
}
XEDUpdateValHisto.prototype.redo = function(){
	this.fNode.updateVal(this.fNewVal, true);
	xed.getEditor(this.fNode).setFocus(this.fNode);
}






xed.fillPopupTransforms = function(pPopup, pBind, pTransformsSrc){
try{
	var vEditor= xed.getEditor(pBind);
	var vListTransforms = pTransformsSrc.split(",");
	var vAdded = false;
	
	var vUrl;
	for (var i = 0; i < vListTransforms.length; i++) {
		var vUriOption = vListTransforms[i];
		if( ! vUriOption) continue;
		var vIdx = vUriOption.indexOf("#");
		if(vIdx == 0){

			vUrl = pBind.fModelBind.ownerDocument.documentURI;
		} else if(vIdx > 0) {

			vUrl = vUriOption.substring(0, vIdx);
		}//Sinon : on préserve l'url précédente.
		var vId = (vIdx >= 0) ? vUriOption.substring(vIdx+1) : vUriOption;
		var vTransform = vEditor.resolveModel(vUrl, vId);
		if(vTransform) {
			var vOtpion = vTransform.firstChild;
			while (vOtpion) {
				if(vOtpion.nodeType == 1 && vOtpion.localName == "option") {

					var vExcl = vOtpion.firstChild;
					while (vExcl) {
						if(vExcl.nodeType == 1 && vExcl.localName == "exclude") {
							var vAtts = vExcl.attributes;
							for(var j = 0; j < vAtts.length; j++) {
								if(pBind.getAttributeNS(vAtts[j].namespaceURI, vAtts[j].localName) != vAtts[j].nodeValue) break;
							}
							if(j == vAtts.length) break; //tous les attributs ont matchés, on exclut.
						}
						vExcl = vExcl.nextSibling;
					}
					if(vExcl == null) {

						var vItemMenu = document.createElement("menuitem");
						vItemMenu.setAttribute("label", vOtpion.getAttributeNS(XEDNS, "title"));
						pPopup.appendChild(vItemMenu);
						vItemMenu.fOption = vOtpion;
						vAdded = true;
					}
				}
				vOtpion = vOtpion.nextSibling;
			}
		}
	}
	if(vAdded) {
		pPopup.setAttribute("oncommand", "event.stopPropagation(); xed.xOnCommandTransform(event);");
		pPopup.fBind = pBind;
	}
	return vAdded;
} catch(e){this.debug("xed.fillPopupTransforms : "+e);}
}

xed.xOnCommandTransform = function (pEvent){
	try{
		if(pEvent.currentTarget.fBind && pEvent.originalTarget.fOption) {
			window.setTimeout(xed.execTransform, 10, pEvent.currentTarget.fBind, pEvent.originalTarget.fOption);
			pEvent.stopPropagation();
		}
	} catch(e){"xed.xOnCommandTransform : "+this.debug(e);}
}
xed.execTransform = function (pBind, pOption){
try{

	
	var vEditor = xed.getEditor(pBind);

	var vUrlXsl = pOption.getAttributeNS(XEDNS, "srcxsl") || pOption.parentNode.getAttributeNS(XEDNS, "srcxsl");
	var vDebug = pOption.getAttributeNS(XEDNS, "debug")=="true" || pOption.parentNode.getAttributeNS(XEDNS, "debug")=="true";
	try {
		var vXsl = document.implementation.createDocument("", "", null);
		vXsl.async = false;
		vXsl.load(vUrlXsl);
		var vXsltProcessor = new XSLTProcessor();
		vXsltProcessor.importStylesheet(vXsl);
	} catch(e){
		xed.alert("Echec de la transformation demandée.", "Anomalie dans le modèle de l\'éditeur");
		xed.debug("La xsl '"+vUrlXsl+"' définie dans la transformation d'id '"+pOption.ownerDocument.documentURI+"#"+pOption.parentNode.getAttributeNS(XEDNS, "id")+"' n'a pu être chargée :"+e);
	}

	var vParam = pOption.firstChild;
	while (vParam) {
		if(vParam.nodeType == 1 && vParam.localName == "parameter") {
			vXsltProcessor.setParameter(vParam.getAttributeNS(XEDNS, "ns"), vParam.getAttributeNS(XEDNS, "name"), vParam.getAttributeNS(XEDNS, "value"));
		}
		vParam = vParam.nextSibling;
	}

	var vRoot = pBind;

	var vNewDoc = document.implementation.createDocument("", "", null);
	var vSrc = vNewDoc;



	var vRootSrc = pOption.getAttributeNS(XEDNS, "addRootSrc") || pOption.parentNode.getAttributeNS(XEDNS, "addRootSrc");
	if(vRootSrc) {
		vSrc = vNewDoc.createElement(vRootSrc);
		vNewDoc.appendChild(vSrc);
	}
	vEditor.fillResult(vSrc, vRoot);
	if(vDebug) xed.debug("src before transform:\n"+xed.getXml(vSrc));


	var vNewSrc = vXsltProcessor.transformToFragment(vSrc, vNewDoc);
	if(vDebug) xed.debug("src after transform:\n"+xed.getXml(vNewSrc));
	vXsltProcessor.reset();

	vEditor.insertFragment(vNewSrc, vRoot, "replace", true);
	
}catch(e){"xed.execTransform : "+this.debug(e);}
}




function XedXpWalker(pEditor){
	this.fEditor = pEditor;
	this.fRootContent = pEditor.fContent;
	this.fTwBindNode = xed.createTwPhysicalDstBindNodes(this.fRootContent);

	this.fTwBindNode.firstChild();
}


XedXpWalker.prototype.execXp = function(pXp) {
try {
	if(!pXp || pXp.length==0) return;
	var vXpParts = pXp.split("/");
	var vLen = vXpParts.length
	for (var i = 0; i < vLen; i++) {
		if(! this.xExecXpPart(vXpParts[i], i, vXpParts)) {
			if(i==0) return null;
			var vPath = vXpParts[i++];
			for (; i < vLen; i++) vPath += "/"+vXpParts[i];
			return vPath;
		}

	}
	return  "";
} catch(e){xed.debug("XedXpWalker.execXp : " + pXp + "\n" +e);}
}
XedXpWalker.prototype.getCurrentNode = function() {
	return this.fTwBindNode.currentNode;
}

XedXpWalker.prototype.xExecXpPart = function(pXpPart, pOffset, pXpParts) {

	if(pXpPart=="") {
		if(pOffset==0) {

			return this.gotoRootDocument();
		}

		return true;
	} else {
		var vQName = pXpPart;
		if(vQName.charAt(0)=='@') {
			return this.gotoAttr(vQName.substring(1));
		} else {
			var vNumber = 1;
			var vIdx1 = pXpPart.indexOf('[');
			if(vIdx1 >= 0) {
				var vIdx2 = pXpPart.indexOf(']', vIdx1);
				vNumber = parseInt(pXpPart.substring(vIdx1+1, vIdx2>0 ? vIdx2 : pXpPart.length));
				vQName = pXpPart.substring(0, vIdx1);
			}

			var vCurr = this.fTwBindNode.currentNode;
			if( ! this.gotoChildElt(vQName)) return false;

			for (;vNumber > 1; vNumber--) {
				if( ! this.gotoNextSiblingElt(vQName)) {
					this.fTwBindNode.currentNode = vCurr;
					return false;
				}
			}
		}
		return true;
	}
}

XedXpWalker.prototype.setCurrDst = function(pDst) {

	while(pDst) {
		if(xed.filterTwPhysicalDstBindNodes(pDst)==NodeFilter.FILTER_ACCEPT) {
			this.fTwBindNode.currentNode = pDst;
			return;
		}
		pDst = pDst.parentNode;
	}

	this.gotoRootDocument();
}

XedXpWalker.prototype.gotoRootDocument = function() {
	this.fTwBindNode.currentNode = this.fRootContent;
	return this.fTwBindNode.firstChild();
}

XedXpWalker.prototype.gotoChildElt = function(pQName) {
	if( ! this.fTwBindNode.firstChild()) return false;

	while( ! this.isCurrentMatchElt(pQName)) {
		if( ! this.fTwBindNode.nextSibling()) {

			this.fTwBindNode.parentNode();
			return false;
		}
	}
	return true;
}

XedXpWalker.prototype.isCurrentMatchElt = function(pQName) {
	var vBind = this.fTwBindNode.currentNode;
	switch(vBind.getAttributeNS(XEDNS, "bind")) {
		case "element":


			if(vBind.getAttributeNS(XEDNS, "name") == pQName) {
				if(this.fEditor.isDstExportable(vBind)) return true;
			}
			break;
		case "subtree":
		case "undefinedElement":
			var vXml = vBind.fValue;
			if( ! vXml) return false;
			var vNm = pQName;
			var vNs = null;
			if(this.fEditor.isNsActive) {
				var vIdx = pQName.indexOf(":");
				var vPrefix = vIdx>=0 ? pQName.substring(0, vIdx): null;
				var vLocalNm = vIdx>=0 ? pQName.substring(vIdx+1): pQName;
				var vNs = xed.lookupNamespaceUriInDst(vBind, vPrefix);

				return (vXml.localName == vLocalNm && vXml.namespaceURI == vNs);
			} else {
				return (vXml.nodeName == pQName);
			}
	}
	return false;
}

XedXpWalker.prototype.gotoNextSiblingElt = function(pQName) {
	if( ! this.fTwBindNode.nextSibling()) return false;
	var vCurr = this.fTwBindNode.currentNode;
	while( ! this.isCurrentMatchElt(pQName)) {
		if( ! this.fTwBindNode.nextSibling()) {

			this.fTwBindNode.currentNode = vCurr;
			return false;
		}
	}
	return true;
}


XedXpWalker.prototype.gotoAttr = function(pQName) {
	if( ! this.fTwBindNode.firstChild()) return false;

	while( ! this.isCurrentMatchAttr(pQName)) {
		if( ! this.fTwBindNode.nextSibling()) {

			this.fTwBindNode.parentNode();
			return false;
		}
	}
	return true;
}
XedXpWalker.prototype.isCurrentMatchAttr = function(pQName) {
	var vBind = this.fTwBindNode.currentNode;
	switch(vBind.getAttributeNS(XEDNS, "bind")) {
		case "attribute":


			return vBind.getAttributeNS(XEDNS, "name") == pQName;
		case "undefinedAttribute":
			var vBindNm = vBind.getAttributeNS(XEDNS, "name");
			var vIdx = vBindNm.indexOf(":");
			if(vIdx>0) vBindNm = vBindNm.substring(vIdx+1);
			var vNm = pQName;
			var vNs = null;
			if(this.fEditor.isNsActive) {
				var vIdx = pQName.indexOf(":");
				var vPrefix = vIdx>=0 ? pQName.substring(0, vIdx): null;
				var vLocalNm = vIdx>=0 ? pQName.substring(vIdx+1): pQName;
				var vNs = xed.lookupNamespaceUriInDst(vBind, vPrefix);

				return (vBindNm == vLocalNm && vBind.getAttributeNS(XEDNS, "ns") == vNs);
			} else {
				return (vBindNm == pQName);
			}
		case "element":
		case "plugin":

	}
	return false;
}






xed.fPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

xed.alert = function(pText, pTitle, pCheckMsg, pChecked){
	var vService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
	if(pCheckMsg) {
		var vRes = {};
		vRes.value = pChecked;
		vService.alertCheck(window, pTitle ? pTitle : "Message", pText, pCheckMsg, vRes);
		return vRes.value;
	} else {
		vService.alert(window, pTitle ? pTitle : "Message", pText);
		return false;
	}
}


xed.confirm = function(pText, pTitle, pLabelOk, pLabelCancel, pCheckMsg, pChecked){
	try{
		var vService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
		var vFlag = vService.BUTTON_TITLE_IS_STRING * vService.BUTTON_POS_0 + vService.BUTTON_TITLE_IS_STRING * vService.BUTTON_POS_1;
		
		return vService.confirmEx(	window, 
									pTitle ? pTitle : "Confirmation", 
									pText,
									vFlag,
									pLabelOk || "Ok",
									pLabelCancel || "Annuler",
									null,
									pCheckMsg, 
									pChecked || {}
								  ) == 0;
	}catch(e){xed.debug("xed.confirm failed::::"+e);}
	return true;
}

xed.prompt = function(pText, pTitle, pDefaultVal, pCheckMsg, pChecked){
	var vService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
	var vResCheck = {};
	vResCheck.value = pChecked;
	var vRes = {};
	vRes.value = pDefaultVal || "";
	var vBtnOk = vService.prompt(window, pTitle ? pTitle : "Question", pText, vRes, pCheckMsg, vResCheck);
	return vBtnOk ? vRes.value : null;
}


xed.debug = function(pText) {
	var vConsoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
	vConsoleService.logStringMessage(pText);//window.location.href+" : "+
}

xed.getSharedDom = function(pUrl) {
	var vXmlCache = Components.classes["@scenari.com/sharedres;1"].getService(Components.interfaces.scISharedRes).getSharedDom(pUrl);
	return vXmlCache.cloneNode(true);
}


xed.getXml = function(pElement){
	return pElement ? new XMLSerializer().serializeToString(pElement) : "";
}
xed.getXmlElt = function(pElement){
	if( ! pElement || pElement.nodeType != 1) return "<notElt:"+pElement+">";
	var vS = "<"+pElement.nodeName;
	var vAtts = pElement.attributes;
	for (var i = 0; i < vAtts.length; i++) {
		var vAtt = vAtts.item(i);
		vS += " "+vAtt.nodeName+"=\""+vAtt.nodeValue+"\"";
	}
	return vS+( (pElement.firstChild)? ">...</>" : "/>");
}
xed.getArrayXmlElt = function(pArray){
	if(!pArray) return "NULL";
	var vS = "[\n";
	for (var i = 0; i < pArray.length; i++) {
		vS += xed.getXmlElt(pArray[i])+"\n";
	}
	return vS+"]";
}


xed.formatStr = function(pSrc /*, pReplacement1, pReplacement2 [...]*/) {
    var vArgs = arguments;
    var vIdx = 1;
    function rep(pStr, p1, p2){
        return p1=="%%" ? "%" : vArgs[(p2 ? p2 : vIdx++)];
    }
    return pSrc.replace(/(%(?:%|(?:(\d+)\$)?s))/g, rep);
};

xed.destroyBinding = function(pNode) {
	try {
		if("destroy" in pNode) {
			pNode.destroy();
		}
	} catch(e){xed.debug("destroyNode failed : "+pNode.localName+"\n"+e);}
	return NodeFilter.FILTER_ACCEPT;
}
xed.destroyBindings = function(pNode) {
	if(!pNode) return;
	xed.destroyBinding(pNode);
	if(pNode.hasChildNodes()) {
		var vTw = pNode.ownerDocument.createTreeWalker(pNode, NodeFilter.SHOW_ELEMENT, xed.destroyBinding, false);
		while(vTw.nextNode());
		vTw = null; //memLeak
	}
}


xed.pasteFromClipboard = function(pBind, pPos, pHisto, pPreserveUndefinedElement) {
	xed.getEditor(pBind).pasteFromClipboard(pBind, pPos, pHisto, pPreserveUndefinedElement);
}


xed.setTemporaryNotif = function(pEditor, pMsg, pKeyNotif, pPriority, pButtons){
	var vNotifBox = pEditor.getNotificationBox();
	var vNotif = vNotifBox.getNotificationWithValue(pKeyNotif);
	if(vNotif) vNotif.close();
	vNotif = vNotifBox.appendNotification(pMsg, pKeyNotif, null, pPriority, pButtons);
	if(pButtons) {
		var vBtns = vNotif.getElementsByTagNameNS(XULNS, "button");
		for(var i = 0; i < pButtons.length; i++) if(pButtons[i].className) vBtns[i].className = pButtons[i].className;
	}

	window.setTimeout(function(){vNotif.close()}, pButtons ? 15000 : 5000);
}


xed.escapeComment = function(pText){
	if(!pText) return pText;
	return pText.replace(/(-\~*)-/g, "$1~-");
}

xed.unescapeComment = function(pText){
	if(!pText) return pText;
	return pText.replace(/(-\~*)\~-/g, "$1-")
}

xed.indentDom = function(pRoot)  {
	var vWhiteSpaces = this.fWhiteSpaces;
	if(!vWhiteSpaces) {
		var vText = "\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t";
		vWhiteSpaces = [];
		for(var i = 0; i <=25; i++) vWhiteSpaces[i] = vText.substring(0, i+1);
		this.fWhiteSpaces = vWhiteSpaces;
	}
	pRoot.normalize();
	var vRoot = pRoot;
	var vDeep = 0;
	switch(vRoot.nodeType) {
		case 9 : //Document
			vRoot = pRoot.documentElement;
			if(!vRoot) return pRoot;
			break;
		case 11 : //Fragment
			vDeep = -1;
	}
	var vNode = vRoot;
	function isText(pNode){
		return (pNode.nodeType == 3 && /\S/.test(pNode.data)) || pNode.nodeType == 4;
	}
	function indent(){
		if(vNode.nodeType == 3) {

			vNode.data = vWhiteSpaces[Math.min(vDeep, 25)];
			if(vNode.nextSibling) vNode = vNode.nextSibling;
		} else {

			vNode.parentNode.insertBefore(vNode.ownerDocument.createTextNode(vWhiteSpaces[Math.min(vDeep, 25)]), vNode);
		}
	}
	var vPrevIsText = false;
	var vPreserveSpace = [false];
	while(vNode) {

		while(vNode.hasChildNodes()) {
			vDeep++;
			vPreserveSpace[vDeep] = (vDeep>1 && vPreserveSpace[vDeep-1]) ? ! (vNode.getAttribute("xml:space")=="default") : vNode.nodeType==1 && vNode.getAttribute("xml:space")=="preserve";
			vNode = vNode.firstChild;
			vPrevIsText = isText(vNode);
			if( ! vPrevIsText && ! vPreserveSpace[vDeep]){

				indent();
			}
		}

		while(vNode.nextSibling == null){
			vDeep--;

			if(vDeep>=0 && ! vPrevIsText && ! isText(vNode) && ! vPreserveSpace[vDeep+1]){
				if(vNode.nodeType == 3) {
					vNode.data = vWhiteSpaces[Math.min(vDeep, 25)];
				} else {
					vNode.parentNode.insertBefore(vNode.ownerDocument.createTextNode(vWhiteSpaces[Math.min(vDeep, 25)]), null);
				}
			}
			if(vNode.parentNode == vRoot) return pRoot;
			vNode = vNode.parentNode;
			vPrevIsText = vNode.previousSibling != null && isText(vNode.previousSibling);
		}
		vNode = vNode.nextSibling;
		if(! isText(vNode)){

			if( ! vPrevIsText) {
				if(! vPreserveSpace[vDeep]) indent(); 
			} else {
				vPrevIsText = false;
			}
		} else {
			vPrevIsText = true;
		}
	}
	return pRoot;
}

xed.lookupNamespaceURI = function(pModel, pPrefix) {
	if(pPrefix == "xml") return "http://www.w3.org/XML/1998/namespace";
	return pModel.lookupNamespaceURI(pPrefix);
}
xed.lookupNamespaceUriInDst = function(pDst, pPrefix) {
	while(pDst) {
		var vNs = pDst.getAttributeNS(XEDNS, "ns");
		if(vNs) {

			var vName = pDst.getAttributeNS(XEDNS, "name");
			if(vName) {
				var vIdx = vName.indexOf(":");
				if( ! pPrefix) {

					if(vIdx < 0) return vNs;	
				} else {

					if(vIdx>0 && pPrefix == vName.substring(0, vIdx)) return vNs;	
				}
			}
		}
		if(pDst.fModelBind) {

			vNs = xed.lookupNamespaceURI(pDst.fModelBind, pPrefix);
			if(vNs) return vNs;
		}

		do{
			pDst = xed.getParentBind(pDst);
		}while(pDst && ! xed.isElementBindModel(pDst));
	}
}


xed.listProperties = function(pObj){
	var vRes = "";
	var vProp = null;
	for (vProp in pObj) {
		try {
			vRes += vProp +'[' + pObj[vProp]+ ']'+ "\n";
		} catch(e){
			vRes += vProp +' -> toString in error\n';
		}
	}
	return vRes;
}

xed.createSubtreeRoot = function(pBind) {
	var vDoc = xed.getEditor(pBind).getDocSrc();
	var vNs = pBind.getAttributeNS(XEDNS, "ns");
	var vNm = pBind.getAttributeNS(XEDNS, "name") || "root";
	return (vNs) ? vDoc.createElementNS(vNs, vNm) : vDoc.createElement(vNm);
}

xed.insertUndefinedElement = function(pEditor, pParent, pNextSibling, pUndefinedSrc) {
	var vElt = pParent.ownerDocument.createElementNS(XULNS, "undefinedHiddenBox");
	vElt.setAttribute("hidden", "true");
	vElt.setAttributeNS(XEDNS, "bind", "undefinedElement");
	vElt.fEditor = pEditor;
	vElt.fValue = pUndefinedSrc;
	pParent.insertBefore(vElt, pNextSibling);
	var vEvent = vElt.ownerDocument.createEvent("Events");
	vEvent.initEvent(XEDUndefinedNodeInsertedEvent, true, false);
	vElt.dispatchEvent(vEvent);
	return vElt;
}
xed.insertUndefinedAttribute = function(pEditor, pParent, pNextSibling, pUndefinedAtt) {
	var vElt = pParent.ownerDocument.createElementNS(XULNS, "undefinedHiddenBox");
	vElt.setAttribute("hidden", "true");
	vElt.setAttributeNS(XEDNS, "bind", "undefinedAttribute");
	vElt.fEditor = pEditor;

	if(pUndefinedAtt.namespaceURI) vElt.setAttributeNS(XEDNS, "ns", pUndefinedAtt.namespaceURI);
	vElt.setAttributeNS(XEDNS, "name", pUndefinedAtt.nodeName);
	vElt.fValue = pUndefinedAtt.nodeValue;
	pParent.insertBefore(vElt, pNextSibling);
	var vEvent = document.createEvent("Events");
	vEvent.initEvent(XEDUndefinedNodeInsertedEvent, true, false);
	vElt.dispatchEvent(vEvent);
	return vElt;
}
xed.insertUndefinedText = function(pEditor, pParent, pNextSibling, pText) {
	var vElt = pParent.ownerDocument.createElementNS(XULNS, "undefinedHiddenBox");
	vElt.setAttribute("hidden", "true");
	vElt.setAttributeNS(XEDNS, "bind", "undefinedText");
	vElt.fEditor = pEditor;
	vElt.fValue = pText;
	pParent.insertBefore(vElt, pNextSibling);
	var vEvent = document.createEvent("Events");
	vEvent.initEvent(XEDUndefinedNodeInsertedEvent, true, false);
	vElt.dispatchEvent(vEvent);
	return vElt;
}


xed.isClickContextMenu = function(pEvent){
	return (pEvent.button == 2 || pEvent.metaKey);
}


xed.showButtonMenu = function(pPopup, pButton){
	pPopup.openPopup(pButton, "after_start" , 0 , 0 , true, true);
}


xed.createPopupMenu = function(){
	var vPopup = document.createElementNS(XULNS, "menupopup");
	vPopup.setAttribute("style", "-moz-binding:url(chrome://scenarixedlib/content/libUiBase/widgets/xedUiBase.xbl.xml#xedPopup);");
	return vPopup;
}


xed.createPopupMenuData = function(){
	var vPopup = document.createElementNS(XULNS, "menupopup");
	vPopup.setAttribute("style", "-moz-binding:url(chrome://scenarixedlib/content/libUiBase/widgets/xedUiBase.xbl.xml#xedPopup);");
	vPopup.setAttribute("datalook", "true");
	return vPopup;	
}


xed.addItemPopup = function(pXedPopup, pLabel, pCmd, pDisabled, pIcon) {
	var vItem = document.createElementNS(XULNS, "menuitem");
	if(pLabel) vItem.setAttribute("label", pLabel);
	vItem.fCmd = pCmd;
	if(pDisabled) vItem.setAttribute("disabled", pDisabled);
	if(pIcon) {
		vItem.setAttribute("class","menuitem-iconic");
		vItem.setAttribute("image", pIcon);
	}
	pXedPopup.appendChild(vItem);
	return vItem;
}



xed.getRelativePath = function(pParent, pChild){
	var vRes = [];
	var vCursor = pChild;
	while(vCursor != pParent) {
		var vOffset = 0;
		var vPrev = vCursor.previousSibling;
		while(vPrev!=null) {
			vOffset++;
			vPrev = vPrev.previousSibling;
		}
		vRes[vRes.length] = vOffset;
		vCursor = vCursor.parentNode;
	}
	return vRes;
}


xed.getChildFromRelativePath = function(pParent, pRelativePath, pLastParent){
	var vCh = pParent;
	for(var i = pRelativePath.length-1; i >=0 ; i--) {
		var vNext = vCh.firstChild;
		var vOffset = pRelativePath[i];
		while(vCh && vOffset>0) {
			vOffset--;
			vNext = vNext.nextSibling;
		}
		if(vNext) vCh = vNext;
		else if(pLastParent) break;
		else return null;
	}
	return vCh;
}


xed.buildXp = function(pNode, pFrom){
	if(!pNode) return null;
	var vNode = (pNode.nodeType==3) ? pNode.parentNode : pNode;
	var vXp = "";
	if(vNode.nodeType==2) {
		vXp = "@"+vNode.nodeName
		vNode = vNode.parentNode;
	}
	while(vNode && vNode.nodeType==1 && vNode != pFrom) {
		var vCount = 1;
		var vPrev = vNode.previousSibling;
		while(vPrev) {
			if(vPrev.nodeName == vNode.nodeName) vCount++;
			vPrev = vPrev.previousSibling;
		}
		vXp = vNode.nodeName + (vCount>1 ? "["+vCount+"]/" : "/") + vXp;
		vNode = vNode.parentNode;
	}
	if(vNode && vNode.nodeType==9) vXp = "/" + vXp;
	return vXp;
}


xed.createRegExpFind = function(pText, pCaseSensitive) {
	return new RegExp(pText.replace(/([\\\^\$\*\+\?\.\(\)\|\[\]\{\}])/g, "\\$1"), pCaseSensitive ? "" :"i");
}




xed.fMaxSpellSuggestions = 5;

xed.addSpellcheckSuggestionsPopup = function(pXedNode, pEditor, pPopup, pRangeParent, pRangeOffset){
	var vEditor = pEditor;
	var vRangeParent = pRangeParent;
	var vRangeOffset = pRangeOffset;
	var vXedNode = pXedNode;
	if( ! vRangeParent) return -1;
	var vInlineSpellcheck = vEditor.getInlineSpellChecker(false);
	if(!vInlineSpellcheck) return -1;

	var vRangeWord = vInlineSpellcheck.getMisspelledWord ?  vInlineSpellcheck.getMisspelledWord(pRangeParent, pRangeOffset) : vInlineSpellcheck.getMispelledWord(pRangeParent, pRangeOffset);
	if(!vRangeWord) return -1;
	var vSpellChecker = vInlineSpellcheck.spellChecker;
	vXedNode.fMisspelledWord = vRangeWord.toString();
	if( ! vSpellChecker.CheckCurrentWord(vXedNode.fMisspelledWord)) return -1;
	for (var i = 0; i < this.fMaxSpellSuggestions; i ++) {
		var vSuggestion = vSpellChecker.GetSuggestedWord();
		if( ! vSuggestion) return i;
		var vItem = xed.addItemPopup(pPopup, vSuggestion);
		vItem.setAttribute("style", "font-weight:bold;");
		vItem.addEventListener("command", function(pEvent) { 
				vInlineSpellcheck.replaceWord(vRangeParent, vRangeOffset, pEvent.originalTarget.getAttribute("label"));
				while(vXedNode && ! ("setDirty" in vXedNode)) vXedNode = vXedNode.parentNode;
				if(vXedNode) vXedNode.setDirty(true);
				pEvent.stopPropagation();
			}, true);
	}
	return i-1;
}



xed.fCurrentLang = null;
xed.getCurrentLang = function() {
	if(this.fCurrentLang == null) {
		try {
			this.fCurrentLang = xed.fPrefs.getCharPref("spellchecker.dictionary");
		} catch(e){
			this.fCurrentLang = "";
		}
	}
	return this.fCurrentLang;
}

xed.isMac = navigator.platform.toLowerCase().indexOf("mac") != -1;
xed.isWin = navigator.platform.toLowerCase().indexOf("win") != -1;


xed.isAccelPress = function(pEvent) {
	return xed.isMac ? pEvent.metaKey : pEvent.ctrlKey;
}


xed.onKeyPressInput = function(pEvent, pInputField, pXblOwner) {
	var vCar = pEvent.charCode;
	if(pXblOwner.isReadOnly) {
		if(xed.isAccelPress(pEvent)) switch(vCar) {
			case 120 : // X
			case 118 : // V
				pEvent.cancelBubble = true;
				pEvent.preventDefault();
		}
		return;
	}
	if(vCar > 0) {

		if(xed.isAccelPress(pEvent)) {
			switch(vCar) {
				case 118 : // V
				case 120 : // X
					pEvent.cancelBubble = true;
					pXblOwner.setDirty(true);
					break;
				case 121 : // Y

					var vCmdDispatcher = pXblOwner.ownerDocument.commandDispatcher;
					var vController = vCmdDispatcher.getControllerForCommand("cmd_redo");
					if( vController!=null && vController.isCommandEnabled("cmd_redo") ) {
						pEvent.cancelBubble = true;
						pXblOwner.setDirty(true);
					}
					break;
				case 122 : // Z

					var vCmdDispatcher = pXblOwner.ownerDocument.commandDispatcher;
					var vController = vCmdDispatcher.getControllerForCommand("cmd_undo");
					if( vController!=null && vController.isCommandEnabled("cmd_undo") ) {
						pEvent.cancelBubble = true;
						pXblOwner.setDirty(true);
					}
					break;
				case 32 : // espace
					if(pEvent.shiftKey) {

						var vEditor = pInputField.QueryInterface(Components.interfaces.nsIDOMNSEditableElement).editor.QueryInterface(Components.interfaces.nsIPlaintextEditor);
						vEditor.beginTransaction();
						try{
							var vSel = vEditor.selection;
							if( ! vSel.isCollapsed){
								this.deleteSelection(0);
								this.controlSelection(vSel);
							}
							vRange = vSel.getRangeAt(0);
							var vNode = vRange.startContainer;
							var vStart = vRange.startOffset;
							if(vNode.nodeType==3) {
								var vTrans = {
									doTransaction : function(){
										vNode.insertData(vStart, String.fromCharCode(0xA0));
										vSel.collapse(vNode, vStart+1);
									},
									undoTransaction : function(){
										vNode.deleteData(vStart, 1);
										vSel.collapse(vNode, vStart);
									},
									redoTransaction : function(){
										this.doTransaction();
									},
									isTransient : false,
									merge : function(pTrans){return false;}
								}
								vEditor.doTransaction(vTrans);
							}
						} finally {
							vEditor.endTransaction();
						}
					} else {

						pXblOwner.showContextMenu(pEvent);
					}
					break;
			}
		} else {
			pXblOwner.setDirty(true);
			if(xed.getCurrentLang().indexOf("fr") >= 0 && pXblOwner.getAttribute("frenchPonct")!="false") {

				switch(vCar) {
					case 58 : //:
					case 59 : //;
					case 63 : //?
					case 33 : { //!
						var vEditor = pInputField.QueryInterface(Components.interfaces.nsIDOMNSEditableElement).editor.QueryInterface(Components.interfaces.nsIPlaintextEditor);
						try {
							var vSel = vEditor.selection;
							var vRange = vSel.getRangeAt(0);
							var vNode = vRange.startContainer ;
							var vStart = vRange.startOffset;
							vEditor.beginTransaction();
							try {
								if( ! vSel.isCollapsed) vEditor.deleteSelection(0);
								var vPrevCharCode = vNode.data.charCodeAt(vStart - 1);

								if( vCar==58 && /\bmailto$|\b(ht|s?f)tp(s?)$/.test(vNode.data) ) return;
								var vTrans = {
									doTransaction : function(){
										if(vPrevCharCode == 32 || vPrevCharCode == 160) {
											vNode.replaceData(vStart-1, 1, String.fromCharCode(0xA0, vCar)); //0xA0
											vSel.collapse(vNode, vStart+1);
										} else {
											vNode.insertData(vStart, String.fromCharCode(0xA0, vCar)); //0xA0
											vSel.collapse(vNode, vStart+2);
										}
										var vInlineSpellcheck = vEditor.getInlineSpellChecker(false);
										if(vInlineSpellcheck) vInlineSpellcheck.spellCheckAfterEditorChange (
											1001,
											vSel,
											vNode,
											vStart,
											null,0,null,0);
									},
									undoTransaction : function(){
										if(vPrevCharCode == 32) vNode.replaceData(vStart-1, 2, " ");
										else vNode.deleteData(vStart, 2);
										vSel.collapse(vNode, vStart);
									},
									redoTransaction : function(){
										this.doTransaction();
									},
									isTransient : false,
									merge : function(pTrans){return false;}
								}
								vEditor.doTransaction(vTrans);
								pEvent.preventDefault();
							} finally {
								vEditor.endTransaction();
							}

						}catch(e){xed.debug(e);}
					}
				}
			}
		}
	} else {
		var vKey = pEvent.keyCode;
		switch(vKey){
			case 35 : //Fin de ligne
			case 36 : //Début de ligne
			case 37 : //event.DOM_VK_LEFT
			case 38 : //event.DOM_VK_UP
			case 39 : //event.DOM_VK_RIGHT
			case 40 : //event.DOM_VK_DOWN
				pEvent.cancelBubble = true;
				var vEditor = pInputField.QueryInterface(Components.interfaces.nsIDOMNSEditableElement).editor.QueryInterface(Components.interfaces.nsIPlaintextEditor);
				var vInlineSpellcheck = vEditor.getInlineSpellChecker(false);
				if(vInlineSpellcheck && vInlineSpellcheck.HandleNavigationEvent) {
					try {
						if(vKey!=37 && vKey!=39) {
							vInlineSpellcheck.HandleNavigationEvent(pEvent, true, 0);
						} else {
							vInlineSpellcheck.HandleNavigationEvent(pEvent, false, vKey==39 ? 1 : -1);
						}
					}catch(e){xed.debug(e);}
				}
				break;
			case 8  : //DOM_VK_BACK_SPACE
			case 46 : //DOM_VK_DELETE
				pXblOwner.setDirty(true);
				break;
			case 13 : //DOM_VK_RETURN
			case 14 : //DOM_VK_ENTER
				pXblOwner.onReturn(pEvent);
				break;
		}
	}
}

xed.fireXedFocusEvent = function(pFrom){

	var vEvent = document.createEvent("Events");
	vEvent.initEvent("XEDFocus", true, false);
	pFrom.dispatchEvent(vEvent);
}


function XEDInputController(pInput, pXblOwner){
	this.fInput = pInput;
	if(pXblOwner) this.fXblOwner = pXblOwner;
}
XEDInputController.prototype.supportsCommand = function(pCmd){
	return pCmd == "cmd_copy" || pCmd == "cmd_cut" || pCmd == "cmd_paste";
}
XEDInputController.prototype.isCommandEnabled = function(pCmd){
	var vEditor = this.fInput.QueryInterface(Components.interfaces.nsIDOMNSEditableElement).editor.QueryInterface(Components.interfaces.nsIPlaintextEditor);
	if(pCmd == "cmd_paste") return vEditor.isDocumentEditable && xed_transf.isClipboardContainTextUnicode();
	if(pCmd == "cmd_cut" && vEditor.isDocumentEditable) return false;
	return this.fInput.selectionStart != this.fInput.selectionEnd;
}
XEDInputController.prototype.doCommand = function(pCmd){
try {
	var vEditor = this.fInput.QueryInterface(Components.interfaces.nsIDOMNSEditableElement).editor.QueryInterface(Components.interfaces.nsIPlaintextEditor);
	if(pCmd == "cmd_paste") {
		vEditor.paste(1);
		if(this.fXblOwner) this.fXblOwner.setDirty(true);
		return;
	}



	var vSel = vEditor.selection;
	if(vSel.isCollapsed) return;
	var vRange = vSel.getRangeAt(0);
	var vStartNode = vRange.startContainer;
	var vEndNode = vRange.endContainer;
	
	var vResult = "";
	
	if(vStartNode == vEndNode && vStartNode.nodeType==3) {
		vResult = vStartNode.substringData(vRange.startOffset, vRange.endOffset - vRange.startOffset);
	} else {
		var vTw = vStartNode.ownerDocument.createTreeWalker(vRange.commonAncestorContainer, NodeFilter.SHOW_ELEMENT|NodeFilter.SHOW_TEXT|NodeFilter.SHOW_CDATA_SECTION, null, true);
		var vCurrNode = vTw.currentNode;
		while(vCurrNode && vCurrNode != vStartNode) vCurrNode = vTw.nextNode();
		
		if(vCurrNode == vStartNode) {
			if(vStartNode.nodeType==3) {
				vResult += vStartNode.substringData(vRange.startOffset, vStartNode.length - vRange.startOffset);
				vCurrNode = vTw.nextNode();
			} else {
				vCurrNode = vTw.currentNode = vStartNode.childNodes.item(vRange.startOffset);
			}
		}
		
		var vStopNode = vEndNode;
		if(vEndNode.nodeType==1) vStopNode = vEndNode.childNodes.item(vRange.endOffset);
		
		while(vCurrNode && vCurrNode != vStopNode) {
			if(vCurrNode.nodeType==3) {
				vResult += vCurrNode.data;
			} else {
				switch(vCurrNode.localName) {
					case "br" :
					case "div" :
					case "p" :
						vResult += xed.isWin ? "\r\n" : "\n";
				}
			}
			vCurrNode = vTw.nextNode();
		}
		if(vCurrNode == vEndNode) {
			if(vEndNode.nodeType==3) vResult += vEndNode.substringData(0, vRange.endOffset);
		}
	}
	
	if(vResult) {
		var vTrans = xed_transf.createTransferable();
		xed_transf.setStringDataToTransferable(vTrans, xed_transf.FLAVOUR_TEXT_UNICODE, vResult);
		xed_transf.fClipboardService.setData(vTrans, null, 1);
	}
	
	if(pCmd == "cmd_cut") {
		vEditor.deleteSelection(0);
		if(this.fXblOwner) this.fXblOwner.setDirty(true);
	}
}catch(e){xed.debug(e);}
}
XEDInputController.prototype.onEvent = function(pEvent){}

XEDInputController.prototype.destroy = function(pEvent){
	delete this.fXblOwner;
	delete this.fInput;
}
XEDInputController.prototype.QueryInterface = function(pIID) {
  if (pIID.equals(Components.interfaces.nsIController) || pIID.equals(Components.interfaces.nsISupports)) return this;
  throw Components.results.NS_NOINTERFACE;
}




var xed_transf = {}

xed_transf.FLAVOUR_FILE = "application/x-moz-file";
xed_transf.FLAVOUR_TEXT_UNICODE = "text/unicode";
xed_transf.FLAVOUR_XMLATTR_NAME = "application/x-xed-xmlattr-name";
xed_transf.FLAVOUR_XMLATTR_NS = "application/x-xed-xmlattr-ns";
xed_transf.FLAVOUR_TEXT_XML = "text/xml";

xed_transf.DRAGDROP_ACTION_ALL = Components.interfaces.nsIDragService.DRAGDROP_ACTION_COPY + Components.interfaces.nsIDragService.DRAGDROP_ACTION_MOVE + Components.interfaces.nsIDragService.DRAGDROP_ACTION_LINK;

xed_transf.fDragService = Components.classes["@mozilla.org/widget/dragservice;1"].getService(Components.interfaces.nsIDragService);

xed_transf.fClipboardService = Components.classes["@mozilla.org/widget/clipboard;1"].getService(Components.interfaces.nsIClipboard);


xed_transf.createTransferable = function(){
	return Components.classes["@mozilla.org/widget/transferable;1"].createInstance(Components.interfaces.nsITransferable);
}

xed_transf.setStringDataToTransferable = function(pTrans, pFlavour, pValue){
	if(pValue==null) pValue = "";
	var vVal = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
	vVal.data = pValue;
    pTrans.setTransferData(pFlavour, vVal, pValue.length * 2);
}

xed_transf.getStringDataFromTransferable = function(pTrans, pFlavour){
	if(pTrans==null) return null;
	var vVal={};
	var vLen={}
	try {
		pTrans.getTransferData(pFlavour, vVal, vLen);
		if(vVal.value) {
			var vStr = vVal.value.QueryInterface(Components.interfaces.nsISupportsString);
			return vStr ? vStr.data.substring(0, vLen.value/2) : null;
		}
	} catch(e) {
		return null;
	}
}
xed_transf.isClipboardContainTextUnicode = function(){
	if( ! this.fArrayFlavourTextUnicode) {
		this.fArrayFlavourTextUnicode = new Array();
        var vString = Components.classes["@mozilla.org/supports-cstring;1"].createInstance(Components.interfaces.nsISupportsCString);
        vString.data = xed_transf.FLAVOUR_TEXT_UNICODE;
        this.fArrayFlavourTextUnicode.push(vString);		
	}
	return this.fClipboardService.hasDataMatchingFlavors(this.fArrayFlavourTextUnicode, this.fArrayFlavourTextUnicode.length, Components.interfaces.nsIClipboard.kGlobalClipboard);
}
xed_transf.isClipboardContainTextXml = function(){
	if( ! this.fArrayFlavourTextXml) {
		this.fArrayFlavourTextXml = new Array();
        var vString = Components.classes["@mozilla.org/supports-cstring;1"].createInstance(Components.interfaces.nsISupportsCString);
        vString.data = xed_transf.FLAVOUR_TEXT_XML;
        this.fArrayFlavourTextXml.push(vString);		
	}
	return this.fClipboardService.hasDataMatchingFlavors(this.fArrayFlavourTextXml, this.fArrayFlavourTextXml.length, Components.interfaces.nsIClipboard.kGlobalClipboard);
}
xed_transf.isClipboardContainXmlAttr = function(){
	if( ! this.fArrayFlavourXmlAttr) {
		this.fArrayFlavourXmlAttr = new Array();
        var vString = Components.classes["@mozilla.org/supports-cstring;1"].createInstance(Components.interfaces.nsISupportsCString);
        vString.data = xed_transf.FLAVOUR_XMLATTR_NAME;
        this.fArrayFlavourXmlAttr.push(vString);		
	}
	return this.fClipboardService.hasDataMatchingFlavors(this.fArrayFlavourXmlAttr, this.fArrayFlavourXmlAttr.length, Components.interfaces.nsIClipboard.kGlobalClipboard);
}